<?xml version="1.0" encoding="UTF-8"?>
<!--
Licensed Materials - Property of IBM
(c) Copyright IBM Corporation 2009. All Rights Reserved.

Note to U.S. Government Users Restricted Rights:  Use,
duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.
-->
<xsl:stylesheet version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
 xmlns="http://jazz.net/xmlns/prod/jazz/jtp/0.6/"
 xmlns:dc="http://purl.org/dc/terms/"
 xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
>
	<xsl:import href="LineBreaks.xsl"/>
    <xsl:param name="practiceDescriptionText"/>
    <xsl:param name="languageText"/>
    
    <xsl:output method="html" version="1.0" encoding="UTF-8"
     doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN"
     doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
     indent="yes"/>
    
    <xsl:template match="/Practice">
        <xsl:variable name="sections" select="presentation[1]/section"/>
        <xsl:variable name="practiceDescription" select="dc:description"/>
        <html>
            <head>
                <style type="text/css">
                    body {overflow: auto; margin-top: 0px; font-family: Verdana, Helvetica, Arial, sans-serif; font-size: 75%; background-color:transparent;}
                    .intro { padding-bottom: 3px; margin-bottom:0px; border-width: 0px; font-weight: bold;}
                    .intro_spacing_only {padding-bottom: 3px; margin-bottom:0px; border-width: 0px;}
                    .nowrap {white-space:nowrap;}
                </style>
                <style type="text/css">
                    .secondaryLink {color: #85852C;}
                </style>
            </head>
            <body>
                <p class="intro">
                    <xsl:value-of select="$practiceDescriptionText"/>
                </p>
                <xsl:call-template name="lineBreak">
                    <xsl:with-param name="stringToBeBreakLine" select="$practiceDescription"/>
                </xsl:call-template>
            </body>
        </html>
    </xsl:template>
</xsl:stylesheet>