/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

dojo.provide("com.ibm.team.repository.web.client.internal.ExternalLicenseClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() {

com.ibm.team.repository.web.client.internal.ExternalLicenseClient = {
	
	EXTERNAL_PROVIDER_SERVICE_URI: "com.ibm.team.repository.service.jts.external.licensing.internal.IExternalLicenseServiceProviderAdminRestService",	
	
	GET_REGISTERED_PROVIDERS: "getRegisteredProviders",
	GET_STATUS: "getStatus",

	getRegisteredProviders: function(responseHandler) {
		this._invokeService(responseHandler, this.GET_REGISTERED_PROVIDERS, this.EXTERNAL_PROVIDER_SERVICE_URI);
	},
	
	getStatus: function(responseHandler, args) {
		this._invokeService(responseHandler, this.GET_STATUS, this.EXTERNAL_PROVIDER_SERVICE_URI, args);
	},

	_invokeService: function(responseHandler, method, service, args) {
		var serviceRequest = new com.ibm.team.repository.web.transport.ServiceRequest(service, method, args);
		com.ibm.team.repository.web.transport.TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
};

})();
