/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("jazz.client.xhr"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.PracticeElement"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.RequestInterceptor"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.BootstrapProperties"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.client.internal.RestApis"); //$NON-NLS-1$
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var PROCESSDESCRIPTION_HEADER = "<ProcessDescription xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/terms/\" xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" rdf:about=\"\" xml:lang=\"en\"> \r\n"; //$NON-NLS-1$
	var PRACTICE_ITEM = "<practice dc:title=\"${title}\" rdf:resource=\"${resource}\"/>"; //$NON-NLS-1$
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient;
	var PracticeElement = com.ibm.team.process.authoring.web.common.common.internal.PracticeElement;
	var JTS_URI_ROOT = getJtsRoot();
	var RestApis = com.ibm.team.process.authoring.web.common.client.internal.RestApis;
	var JTS_PROCESS_AUTHORING_ROOT = JTS_URI_ROOT + ProcessAuthoringConstants.PROCESS_AUTHORING_URI_PART;
/*
 * Examples Vaules: (RestApis == com.ibm.team.process.authoring.web.common.client.internal.RestApis)
 * 
 * RestApis.PRACTICES_URL                    : "https://clmwb4.ibm.com:9443/jazz/process-authoring/practices",
 * RestApis.PROCESS_DESCRIPTION_URL          : "https://clmwb4.ibm.com:9443/jazz/process-authoring/descriptions",	 
 * RestApis.FILE_URL                         : "https://clmwb4.ibm.com:9443/jazz/process-authoring/file",
 * RestApis.PRACTICE_LIBRARY_URL             : "https://clmwb4.ibm.com:9443/jazz/process-authoring/libraries/shared",
 * RestApis.ASSOCIATIONS_URL                 : "https://clmwb4.ibm.com:9443/jazz/process-authoring/associations",
 * RestApis.LICENSE_URL                      : "https://clmwb4.ibm.com:9443/jazz/process-authoring/license"
 *
 * */
	ProcessAuthoringClient.getPracticeElement = function(args) {
		var headers = {
			"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
		};
		if (args.lastModified) {
			headers[ProcessAuthoringConstants.HEADER_IF_MODIFIED_SINCE] = args.lastModified;
		}
		
		jazz.client.xhrGet({
			preventCache: true,
			url: args.url,
			headers: headers,
			handleAs: "xml", //$NON-NLS-1$
			error: args.error,
			load: args.load
		});
	};
	
	ProcessAuthoringClient.getPracticeElementOwner = function(args) {
		var headers = {
			"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
		};
		if (args.lastModified) {
			headers[ProcessAuthoringConstants.HEADER_IF_MODIFIED_SINCE] = args.lastModified;
		}
		
		jazz.client.xhrGet({
			preventCache: true,
			url: args.url,
			headers: headers,
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.getResource = function(args) {
	
		var headers = {
			"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
		};
		
		if (args.lastModified) {
			headers[ProcessAuthoringConstants.HEADER_IF_MODIFIED_SINCE] = args.lastModified;
		}
		
		return jazz.client.xhrGet({
			preventCache: true,
			url: args.url,
			headers: headers,
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.getPractice = function(args) {
		return ProcessAuthoringClient.getResource(args);
	};
	
	ProcessAuthoringClient.handleLock = function(args) {
		var pdata;
		var url;
		var lockElement = args.lockRequest ? "<locked-by/>\r\n" : " <locked-by  rdf:resource=\"\"/>\r\n"; //$NON-NLS-1$ //$NON-NLS-2$
		if (args.updatePractice) {
			pdata = "<Practice " + //$NON-NLS-1$
			"xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" " + //$NON-NLS-1$
			"xmlns:dc=\"http://purl.org/dc/terms/\" " + //$NON-NLS-1$
			"xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" " + //$NON-NLS-1$
			"rdf:about=\"\" " + //$NON-NLS-1$
			"xml:lang=\"en\"> " + //$NON-NLS-1$
			lockElement +
			"</Practice>"; //$NON-NLS-1$
			url = ProcessAuthoringClient.getJtsPracticeUrl() + "/" + args.itemId + "?updateType=partial&byForce=" + args.byForce; //$NON-NLS-1$ //$NON-NLS-2$
		} else {
			pdata = PROCESSDESCRIPTION_HEADER + //$NON-NLS-1$
			lockElement +
			"</ProcessDescription>"; //$NON-NLS-1$
			url = ProcessAuthoringClient.getJtsProcessDescriptionUrl() + "/" + args.itemId + "?updateType=partial&byForce=" + args.byForce; //$NON-NLS-1$ //$NON-NLS-2$
		}
		jazz.client.xhrPut({
			url: url,
			headers: {
				"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Content-Type": "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Accept": "application/xml", //$NON-NLS-1$ //$NON-NLS-2$
				"ETag": args.ETag + " undefined" //$NON-NLS-1$ //$NON-NLS-2$
			},
			handleAs: "json", //$NON-NLS-1$
			putData: pdata,
			error: args.error,
			load: args.load
		});
	};
	
	ProcessAuthoringClient.updatePractice = function(args) {
    	args['url'] = ProcessAuthoringClient.getJtsPracticeUrl() + "/" + args.practiceId; //$NON-NLS-1$ //$NON-NLS-2$
    	this.updatePracticeWithURL(args);
    };
	
	ProcessAuthoringClient.updatePracticeWithURL = function(args) {
    	var url = args.url + "?updateType=partial"; //$NON-NLS-1$
    	if(args.language) {
			url = url + "&lang=" + args.language; //$NON-NLS-1$
		}
    	jazz.client.xhrPut({
    		url: url,
    		headers: {
    			"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
    			"Content-Type": "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
    			"Accept": "application/xml", //$NON-NLS-1$ //$NON-NLS-2$
    			"ETag": args.ETag //$NON-NLS-1$
    		},
    		handleAs: "json", //$NON-NLS-1$
    		putData: args.putData,
    		error: args.error,
    		load: args.load
    	});
    };
	
	ProcessAuthoringClient.createSharedPractice = function(args) {		
		var pdata = "<Practice " + //$NON-NLS-1$
		"xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" " + //$NON-NLS-1$
		"xmlns:dc=\"http://purl.org/dc/terms/\" " + //$NON-NLS-1$
		"xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" " + //$NON-NLS-1$
		"rdf:about=\"\" " + //$NON-NLS-1$
		"xml:lang=\"en\"> " + //$NON-NLS-1$
		"<shared>true</shared>" + //$NON-NLS-1$
		"<dc:language>en</dc:language> " + //$NON-NLS-1$
		"<presentation-type>structure</presentation-type>" + //$NON-NLS-1$
		"<dc:title>" + //$NON-NLS-1$
		UIHelper.escapeXML(args.title) +
		"</dc:title> " + //$NON-NLS-1$
		"<dc:description>" + //$NON-NLS-1$
		UIHelper.escapeXML(args.description) +
		"</dc:description>" + //$NON-NLS-1$
		"<locked-by  rdf:resource=\"\"/>" + //$NON-NLS-1$
		"<presentation rdf:parseType=\"Literal\">" + //$NON-NLS-1$
		"</presentation>" + //$NON-NLS-1$
		"</Practice>"; //$NON-NLS-1$
		return jazz.client.xhrPost({
			url: ProcessAuthoringClient.getJtsPracticeLibraryUrl(),
			headers: {
				"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Content-Type": "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
			},
			handleAs: "xml", //$NON-NLS-1$
			postData: pdata,
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.createPrivatePractice = function(args) {
		args['processDescriptionUrl'] = ProcessAuthoringClient.getJtsProcessDescriptionUrl() + "/" + args.processDescriptionId; //$NON-NLS-1$ //$NON-NLS-2$
		this.createPrivatePracticeWithProcessDescriptionURL(args);
	}
	
	ProcessAuthoringClient.createPrivatePracticeWithProcessDescriptionURL = function(args) {
		var pdata = "<Practice " + //$NON-NLS-1$
		"xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" " + //$NON-NLS-1$
		"xmlns:dc=\"http://purl.org/dc/terms/\" " + //$NON-NLS-1$
		"xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" " + //$NON-NLS-1$
		"rdf:about=\"\" " + //$NON-NLS-1$
		"xml:lang=\"" + //$NON-NLS-1$
		args.language +
		"\"> " + //$NON-NLS-1$ //$NON-NLS-2$
		"<presentation-type>structure</presentation-type>" + //$NON-NLS-1$
		"<dc:title>" + //$NON-NLS-1$
		UIHelper.escapeXML(args.name) +
		"</dc:title> " + //$NON-NLS-1$
		"<dc:description>" + //$NON-NLS-1$
		UIHelper.escapeXML(args.description) +
		"</dc:description>" + //$NON-NLS-1$
		"<presentation rdf:parseType=\"Literal\">" + //$NON-NLS-1$
		"</presentation>" + //$NON-NLS-1$
		"</Practice>"; //$NON-NLS-1$
		jazz.client.xhrPost({
			url: args.processDescriptionUrl,
			headers: {
				"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Content-Type": "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Accept": "application/xml", //$NON-NLS-1$ //$NON-NLS-2$
				"ETag": args.ETag //$NON-NLS-1$
			},
			handleAs: "json", //$NON-NLS-1$
			postData: pdata,
			error: args.error,
			load: args.load
		});
	};
	
	ProcessAuthoringClient.postPracticeElement = function(args) {
	
		var deferred = jazz.client.xhrPost({
			url: args.url,
			headers: {
				ETag: args.ETag
			},
			contentType: "application/xml; charset=utf-8", //$NON-NLS-1$
			handleAs: "json", //$NON-NLS-1$
			postData: args.postData,
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.updatePracticeElement = function(args) {
		var deferred = jazz.client.xhrPut({
			url: args.url,
			contentType: "application/xml; charset=utf-8", //$NON-NLS-1$
			headers: {
				Accept: "application/json", //$NON-NLS-1$
				ETag: args.ETag
			},
			
			handleAs: "json", //$NON-NLS-1$
			putData: args.putData,
			load: args.load,
			error: args.error
		});
	};
	
	/**
	 * Deletes a process description.
	 * 
	 * @param {Object} args the arguments with following properties:
	 *                     uri: the process description URI
	 *                     load: the load callback function
	 *                     error: the error callback function
	 */
	ProcessAuthoringClient.deleteProcessDescription = function(args) {
		var url = args.uri;
		url = url + "?deferred=true"; //$NON-NLS-1$
		jazz.client.xhrDelete({
			url: url,
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.deletePractice = function(args) {
		var url = args.uri ? args.uri : ProcessAuthoringClient.getJtsPracticeUrl() + "/" + args.practiceId; //$NON-NLS-1$
		jazz.client.xhrDelete({
			url: url,
			headers: {
				ETag: args.ETag //$NON-NLS-1$
			},
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};

	/**
	 * Gets the process descriptions for a specified owner.
	 * 
	 * @param {Object} args the arguments with the following properties 
	 * 			ownerUrl (required) : the URL of the owner whose process descriptions to be fetched (required)
	 * 			viewType (optional) : the type of presentation for the process descriptions, valid values are reference, description, structure
	 * 			load: load handler
	 * 			error: error handler
	 */
	ProcessAuthoringClient.getProcessDescriptionsForOwner = function(args) {
		if (!args.ownerUrl) {
			console.error("ownerUrl is a required property of the specified arguments"); //$NON-NLS-1$
		}
		var viewTypeParameter = ""; //$NON-NLS-1$
		if (args.viewType) {
			viewTypeParameter = "&view=" + args.viewType; //$NON-NLS-1$
		}
		return jazz.client.xhrGet({
			url: ProcessAuthoringClient.getJtsProcessDescriptionUrl() + "?owner=" +  //$NON-NLS-1$
			     args.ownerUrl + viewTypeParameter,  //$NON-NLS-1$ 
			headers: {
				Accept: "application/xml" //$NON-NLS-1$
			},
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.checkAssociateSharedProcessDescriptionForProcessArea = function(args) {
		return jazz.client.xhrHead({
			url: ProcessAuthoringClient.getJtsAssociationUrl() + dojo.string.substitute("?target=${targetUrl}", args), //$NON-NLS-1$
			headers: {
				Accept: "application/xml" //$NON-NLS-1$
			},
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.checkAssociationForProcessDescription = function(args) {
		return jazz.client.xhrHead({
			url: ProcessAuthoringClient.getJtsAssociationUrl() + dojo.string.substitute("?source=${sourceUrl}", args), //$NON-NLS-1$ //$NON-NLS-2$
			headers: {
				Accept: "application/xml" //$NON-NLS-1$
			},
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	/**
	 * This is to fetch process template info. The template REST API is defined at 
	 *  https://jazz.net/wiki/bin/view/Main/DraftTeamProcessRestApi#GET_template
	 *  
	 * @param {templateURL} args
	 */
	ProcessAuthoringClient.fetchTemplateInfo = function(args) {
		jazz.client.xhrGet({
			url: args.url,
			headers: {
				Accept: "application/xml" //$NON-NLS-1$
			},
			handleAs: "xml", //$NON-NLS-1$
			load: args.load
		})
	};
	
	ProcessAuthoringClient.createProcessDescriptionForProcessTemplate = function(args) {
		args.title = UIHelper.escapeXML(args.title);
		args.description = UIHelper.escapeXML(args.description);
		
		var postData = "<ProcessDescription xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/terms/\" xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" rdf:about=\"\" " + //$NON-NLS-1$ 
		"xml:lang=\"${language}\"> \r\n" +  //$NON-NLS-1$
		"<dc:title>${title}</dc:title>\r\n" + //$NON-NLS-1$
		"<dc:description>${description}</dc:description>\r\n" + //$NON-NLS-1$
		"<presentation-type>description</presentation-type>\r\n" + //$NON-NLS-1$
		"<owner rdf:resource=\"${ownerUrl}\"/>" + //$NON-NLS-1$
		"</ProcessDescription>"; //$NON-NLS-1$
		postData = dojo.string.substitute(postData, args);
		jazz.client.xhrPost({
			url: ProcessAuthoringClient.getProcessDescriptionsUrl(), 
			headers: {
				Accept: "application/xml" //$NON-NLS-1$
			},
			handleAs: "xml", //$NON-NLS-1$
			postData: postData,
			error: function(err) {
				args.errorCallback(err);
			},
			load: function(data, ioArgs) {
				var location = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
				args.successCallback(location, ioArgs.xhr.getResponseHeader("Etag")); //$NON-NLS-1$
			}
		});
	};
	
	//need to change field for owner to integrated url later
	ProcessAuthoringClient.createProcessDescriptionForProcessArea = function(args) {
		args.title = UIHelper.escapeXML(args.title);
		args.description = UIHelper.escapeXML(args.description);
		
		var postData = "<ProcessDescription xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/terms/\" xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" rdf:about=\"\" " + //$NON-NLS-1$ 
		"xml:lang=\"${language}\"> \r\n" +  //$NON-NLS-1$
		"<dc:title>${title}</dc:title>\r\n" + //$NON-NLS-1$
		"<dc:description>${description}</dc:description>\r\n" + //$NON-NLS-1$
		"<presentation-type>structure</presentation-type><locked-by rdf:resource=\"\"/>\r\n" + //$NON-NLS-1$
		"<owner rdf:resource=\"${ownerUrl}\"/>" + //$NON-NLS-1$
		"</ProcessDescription>"; //$NON-NLS-1$
		postData = dojo.string.substitute(postData, args);
		jazz.client.xhrPost({
			url: ProcessAuthoringClient.getProcessDescriptionsUrl(),
			headers: {
				Accept: "application/xml" //$NON-NLS-1$
			},
			handleAs: "xml", //$NON-NLS-1$
			postData: postData,
			error: args.errorCallback,
			load: function(data, ioArgs) {
				var location = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
				args.successCallback(location, ioArgs.xhr.getResponseHeader("Etag")); //$NON-NLS-1$
			}
		});
	};
	
	ProcessAuthoringClient.createSharedProcessDescription = function(args) {
		// TODO: add implementation of invoking create shared process description service
		args.header = PROCESSDESCRIPTION_HEADER;
		args.title = UIHelper.escapeXML(args.title);
		args.description = UIHelper.escapeXML(args.description);
		
		var postData = "${header}" + //$NON-NLS-1$
		"<dc:title>${title}</dc:title>\r\n" + //$NON-NLS-1$
		"<dc:description>${description}</dc:description>\r\n" + //$NON-NLS-1$
		"<shared>${isPublished}</shared>\r\n" + //$NON-NLS-1$
		"<presentation-type>structure</presentation-type><locked-by rdf:resource=\"\"/>\r\n" + //$NON-NLS-1$
		"</ProcessDescription>"; //$NON-NLS-1$
		postData = dojo.string.substitute(postData, args);
		jazz.client.xhrPost({
			url: ProcessAuthoringClient.getJtsPracticeLibraryUrl(),
			headers: {
				'Content-Type': "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				'Accept': "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
			},
			handleAs: "xml", //$NON-NLS-1$
			postData: postData,
			error: function(err, ioArgs) {
				var licenseWarning = UIHelper.getLicenseWarning(ioArgs);
				if(licenseWarning) {
					err.headerMessage = licenseWarning;
				}
				args.errorCallback(err);
			},
			load: function(data, ioArgs) {
				var location = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
				args.successCallback(location, ioArgs.xhr.getResponseHeader("Etag")); //$NON-NLS-1$
			}
		});
	};
	
	ProcessAuthoringClient.updateProcessDescriptionPracitceList = function(args) {
		var pdata = "<ProcessDescription xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/terms/\" xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" rdf:about=\"\" xml:lang=\"${language}\"> \r\n"+  //$NON-NLS-1$
					"<presentation-type>description</presentation-type>\r\n" + //$NON-NLS-1$
		            "<owner rdf:resource=\"${owner}\"/>\r\n"; //$NON-NLS-1$
		pdata = dojo.string.substitute(pdata, args);
		
		var practicesNum = 0;
		
		dojo.forEach(args.practiceList, function(practice) {
			pdata += dojo.string.substitute("<practice shared=\"${0}\" dc:title=\"${1}\" rdf:resource=\"${2}\"/> \r\n", [practice.shared, UIHelper.escapeXML(practice.name), practice.url]); //$NON-NLS-1$
			practicesNum++;
		}, this);
		
		if (practicesNum === 0) {
			pdata += "<practice rdf:resource=\"\" />\r\n"; //$NON-NLS-1$	
		}
		
		pdata += "</ProcessDescription>"; //$NON-NLS-1$
		jazz.client.xhrPut({
			url: ProcessAuthoringClient.getJtsProcessDescriptionUrl() + dojo.string.substitute("/${itemId}?updateType=partial&lang=${language}", args), //$NON-NLS-1$ //$NON-NLS-2$
			headers: {
				"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Content-Type": "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"ETag": args.ETag //$NON-NLS-1$
			},
			handleAs: "text", //$NON-NLS-1$
			putData: pdata,
			error: args.error,
			load: args.load
		});
	};


	//input: title, description, owner, ETag
	ProcessAuthoringClient.updateProcessDescription = function(args) {
		var url = ProcessAuthoringClient.getJtsProcessDescriptionUrl() + dojo.string.substitute("/${itemId}", args); //$NON-NLS-1$
		args['url'] = url; //$NON-NLS-1$
		this.updateProcessDescriptionWithURL(args);
	};
	
	/**
	 * @param {Object} args: url - the URL of the process description
	 */
	ProcessAuthoringClient.updateProcessDescriptionWithURL = function(args) {
		//process description in PLM, need to add share element
		var pdata = "<ProcessDescription xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/terms/\" xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" rdf:about=\"\" xml:lang=\"${language}\"> \r\n" + //$NON-NLS-1$
			"<presentation-type>description</presentation-type>\r\n" + //$NON-NLS-1$		
			"<default>${isDefault}</default>\r\n" +	//$NON-NLS-1$
			"<owner rdf:resource=\"${owner}\"/>\r\n" + //$NON-NLS-1$
			"<shared>${isPLMShared}</shared>\r\n";	//$NON-NLS-1$	
		if (args.title !== null && args.description !== null) {
			args.title = UIHelper.escapeXML(args.title);
			args.description = UIHelper.escapeXML(args.description);
			pdata += "<dc:title>${title}</dc:title>\r\n" + //$NON-NLS-1$
			"<dc:description>${description}</dc:description>\r\n"; //$NON-NLS-1$
		}
		
		pdata = dojo.string.substitute(pdata, args);
		var practicesNum = 0;
		
		dojo.forEach(args.practiceList, function(practice) {
			pdata += dojo.string.substitute("<practice shared=\"${0}\" dc:title=\"${1}\" rdf:resource=\"${2}\"/> \r\n", [practice.shared, UIHelper.escapeXML(practice.name), practice.url]); //$NON-NLS-1$
			practicesNum++;
		}, this);
				
		if (practicesNum === 0) {
			pdata += "<practice rdf:resource=\"\" />\r\n"; //$NON-NLS-1$	
		}
		
		pdata += "</ProcessDescription>"; //$NON-NLS-1$
		jazz.client.xhrPut({
			url: args.url + dojo.string.substitute("?updateType=partial&lang=${language}", args), //$NON-NLS-1$ //$NON-NLS-2$
			headers: {
				"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Content-Type": "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"ETag": args.ETag //$NON-NLS-1$
			},
			handleAs: "text", //$NON-NLS-1$
			putData: pdata,
			error: args.error,
			load: args.load
		});
	};
	
	ProcessAuthoringClient.deleteAssociation = function(args) {
		jazz.client.xhrDelete({
			url: args.associationURL,
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.getAssociation = function(args) {
		var headers = {
			"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
		};
		
		if (args.lastModified) {
			headers[ProcessAuthoringConstants.HEADER_IF_MODIFIED_SINCE] = args.lastModified;
		}
		
		return jazz.client.xhrGet({
			preventCache: true,
			url: args.url,
			headers: headers,
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.createAssociation = function(args) {
		var pdata = "<Association " + //$NON-NLS-1$
		"xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" " + //$NON-NLS-1$
		"xmlns:dc=\"http://purl.org/dc/terms/\" " + //$NON-NLS-1$
		"xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" " + //$NON-NLS-1$
		"rdf:about=\"\">" + //$NON-NLS-1$
		"<source rdf:resource=\"" + //$NON-NLS-1$
		args.sourceUrl +
		"\"/>" + //$NON-NLS-1$
		"<targets>" + //$NON-NLS-1$
		"  <target rdf:resource=\"" + //$NON-NLS-1$
		args.targetUrl +
		"\" dc:title=\"" + //$NON-NLS-1$
		UIHelper.escapeXML(args.targetName) +
		"\"/>" + //$NON-NLS-1$
		"</targets>" + //$NON-NLS-1$
		"</Association>"; //$NON-NLS-1$
		return jazz.client.xhrPost({
			url: ProcessAuthoringClient.getJtsAssociationUrl() + "/", //$NON-NLS-1$
			headers: {
				"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Content-Type": "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
			},
			handleAs: "xml", //$NON-NLS-1$
			postData: pdata,
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.updateAssociation = function(args) {
		var newTargetsString = ""; //$NON-NLS-1$
		dojo.forEach(args.newTargets, function(target) {
			newTargetsString += "  <target rdf:resource=\"" + //$NON-NLS-1$
			target.url +
			"\" dc:title=\"" + //$NON-NLS-1$
			UIHelper.escapeXML(target.title) +
			"\"/>"; //$NON-NLS-1$
		}, this);
		var pdata = "<Association " + //$NON-NLS-1$
		"xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" " + //$NON-NLS-1$
		"xmlns:dc=\"http://purl.org/dc/terms/\" " + //$NON-NLS-1$
		"xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" " + //$NON-NLS-1$
		"rdf:about=\"\">" + //$NON-NLS-1$
		"<source rdf:resource=\"" + //$NON-NLS-1$
		args.sourceUrl +
		"\"/>" + //$NON-NLS-1$
		"<targets>" + //$NON-NLS-1$
		newTargetsString +
		"</targets>" + //$NON-NLS-1$
		"</Association>"; //$NON-NLS-1$
		jazz.client.xhrPut({
			url: args.associationURL,
			headers: {
				"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Content-Type": "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"ETag": args.ETag //$NON-NLS-1$
			},
			handleAs: "json", //$NON-NLS-1$
			putData: pdata,
			error: args.error,
			load: args.load
		});
	};
	
	ProcessAuthoringClient.searchPracticeByTitle = function(args) {
		var headers = {
			"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
		};
		
		if (args.lastModified) {
			headers[ProcessAuthoringConstants.HEADER_IF_MODIFIED_SINCE] = args.lastModified;
		}
		
		return jazz.client.xhrGet({
			preventCache: true,
			url: ProcessAuthoringClient.getJtsPracticeUrl() + "?searchString=" + encodeURIComponent(args.searchString), //$NON-NLS-1$
			headers: headers,
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.searchProcessDescriptionByTitle = function(args) {
		var headers = {
			"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
		};
		
		if (args.lastModified) {
			headers[ProcessAuthoringConstants.HEADER_IF_MODIFIED_SINCE] = args.lastModified;
		}
		
		return jazz.client.xhrGet({
			preventCache: true,
			url: ProcessAuthoringClient.getJtsProcessDescriptionUrl() + "?searchString=" + encodeURIComponent(args.searchString), //$NON-NLS-1$
			headers: headers,
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.getAllSharedPractices = function(args) {
		var headers = {
			"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
		};
		
		if (args.lastModified) {
			headers[ProcessAuthoringConstants.HEADER_IF_MODIFIED_SINCE] = args.lastModified;
		}
		
		return jazz.client.xhrGet({
			preventCache: true,
			url: ProcessAuthoringClient.getJtsPracticeUrl(),
			headers: headers,
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.getAllPLMProcessDescriptions = function(args) {
		args.requestQueryParam = "includePrivate=true"; //$NON-NLS-1$
		ProcessAuthoringClient._getAllProcessDescriptions(args);
	};
	
	ProcessAuthoringClient.getAllProcessDescriptions = function(args) {
		//default is shared process description
		if (!args.isPrivate) {
			args.isPrivate = false;
		}
		
		args.requestQueryParam = "private="+args.isPrivate; //$NON-NLS-1$
		ProcessAuthoringClient._getAllProcessDescriptions(args);
	};
	
	ProcessAuthoringClient._getAllProcessDescriptions = function(args) {
		var headers = {
			"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
		};
		
		if (args.lastModified) {
			headers[ProcessAuthoringConstants.HEADER_IF_MODIFIED_SINCE] = args.lastModified;
		}
		
		return jazz.client.xhrGet({
			preventCache: true,
			url: ProcessAuthoringClient.getJtsProcessDescriptionUrl() + dojo.string.substitute("?${requestQueryParam}", args), //$NON-NLS-1$
			headers: headers,
			handleAs: "xml", //$NON-NLS-1$
			error: args.error,
			load: args.load
		});
	};
	
	ProcessAuthoringClient.getProcessDescription = function(args) {
		var headers = {
			"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
		};
		
		if (args.lastModified) {
			headers[ProcessAuthoringConstants.HEADER_IF_MODIFIED_SINCE] = args.lastModified;
		}
		
		return jazz.client.xhrGet({
			preventCache: true,
			url: args.resourceURL,
			headers: headers,
			handleAs: "xml", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.getFrontingApplicaitonURIRoot = function(args) {
		return jazz.client.xhrGet({
			preventCache: true,
			url: args.resourceURL,
			handleAs: "json", //$NON-NLS-1$
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.getPracticeLibraryLicenseInfo = function(args) {
		var pdata = "<OperationIds>"; //$NON-NLS-1$
		
		dojo.forEach(args.operationIds, function(operationId) {
			pdata += dojo.string.substitute("<OperationId>${0}</OperationId>\r\n", [operationId]); //$NON-NLS-1$
		}, this);
		
		pdata += "</OperationIds>"; //$NON-NLS-1$
		
		return jazz.client.xhrPost({
			url: RestApis.LICENSE_URL + "/", //$NON-NLS-1$
			headers: {
				"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Content-Type": "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
				"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
			},
			handleAs: "json", //$NON-NLS-1$
			postData: pdata,
			load: args.load,
			error: args.error
		});
	};
	
	ProcessAuthoringClient.createPracticeElementLanguage = function(args) {
	
		ProcessAuthoringClient.getPracticeElement({
			'url': args.resource + "?lang=" + args.language, //$NON-NLS-1$ //$NON-NLS-2$
			'load': function(data, ioArgs) { //$NON-NLS-1$
				var ETag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
				var pdata = "<PracticeElement xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/terms/\" xml:lang=\"" + args.language + "\"><presentation-type>description</presentation-type><dc:title>"; //$NON-NLS-1$ //$NON-NLS-2$
				pdata += UIHelper.escapeXML(args.title);
				pdata += "</dc:title><dc:description>"; //$NON-NLS-1$
				pdata += UIHelper.escapeXML(args.description);
				pdata += "</dc:description>"; //$NON-NLS-1$
				pdata += "</PracticeElement>"; //$NON-NLS-1$
				jazz.client.xhrPut({
					url: args.resource + "?updateType=partial&lang=" + args.language, //$NON-NLS-1$
					headers: {
						"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
						"Content-Type": "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
						"Accept": "application/xml", //$NON-NLS-1$ //$NON-NLS-2$
						"ETag": ETag //$NON-NLS-1$
					},
					handleAs: "xml", //$NON-NLS-1$
					putData: pdata,
					error: args.error,
					load: args.load
				});
			}
		});
	};
	
	ProcessAuthoringClient.createProcessDescriptionLanguage = function(args) {
		ProcessAuthoringClient.getProcessDescription({
			'resourceURL': args.resource + "?lang=" + args.language, //$NON-NLS-1$ //$NON-NLS-2$
			'load': function(data, ioArgs) { //$NON-NLS-1$
				var practices = UIHelper.getElementsByTagNameNS(data, ProcessAuthoringConstants.NAMESPACE_JTP, ProcessAuthoringConstants.XMLELEMENT_PRACTICE);
				var practiceXML = ""; //$NON-NLS-1$
				dojo.forEach(practices, function(practice) {
					var title = UIHelper.getNodeDcTitle(practice);
					var resource = UIHelper.getNodeResource(practice);
					practiceXML += dojo.string.substitute(PRACTICE_ITEM, {
						'title': UIHelper.escapeXML(title), //$NON-NLS-1$
						'resource': resource //$NON-NLS-1$
					});
				}, this);
				
				var pd = new PracticeElement({
					xml: data
				});
				var title = pd.title;
				var description = pd.description;
				var ETag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
				var postData = "<ProcessDescription xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/terms/\" xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" rdf:about=\"\" xml:lang=\"" + args.language + "\"> \r\n" + //$NON-NLS-1$ //$NON-NLS-2$
				"<dc:title>" + //$NON-NLS-1$
				UIHelper.escapeXML(title) +
				"</dc:title>" + //$NON-NLS-1$ 
				"<dc:description>" + //$NON-NLS-1$
				UIHelper.escapeXML(description) +
				"</dc:description>" + //$NON-NLS-1$ 
				"<presentation-type>description</presentation-type>" + //$NON-NLS-1$
				"<owner rdf:resource=\"" + //$NON-NLS-1$ 
					args.owner +
				"\"/>\r\n" + //$NON-NLS-1$ 
				practiceXML +
				"</ProcessDescription>"; //$NON-NLS-1$
				jazz.client.xhrPut({
					url: args.resource + "?updateType=partial&lang=" + args.language, //$NON-NLS-1$
					headers: {
						"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
						"Content-Type": "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
						"ETag": ETag //$NON-NLS-1$
					},
					handleAs: "text", //$NON-NLS-1$
					putData: postData,
					error: args.error,
					load: args.load
				});
			},
			'error': args.error //$NON-NLS-1$
		});
	};
	
	ProcessAuthoringClient.createPracticeLanguage = function(args) {
		ProcessAuthoringClient.getPracticeElement({
			'url': args.resource + "?lang=" + args.language, //$NON-NLS-1$ //$NON-NLS-2$
			'load': function(data, ioArgs) { //$NON-NLS-1$
				var ETag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
				var pdata = "<Practice " + //$NON-NLS-1$
				"xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" " + //$NON-NLS-1$
				"xmlns:dc=\"http://purl.org/dc/terms/\" " + //$NON-NLS-1$
				"xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" " + //$NON-NLS-1$
				"rdf:about=\"\" " + //$NON-NLS-1$
				"xml:lang=\"" + //$NON-NLS-1$
				args.language +
				"\"> " + //$NON-NLS-1$ //$NON-NLS-2$
				"<presentation-type>structure</presentation-type>" + //$NON-NLS-1$
				"<dc:title>" + //$NON-NLS-1$
				UIHelper.escapeXML(args.title) +
				"</dc:title>" + //$NON-NLS-1$  //$NON-NLS-2$
				"<dc:description>" + //$NON-NLS-1$
				UIHelper.escapeXML(args.description) +
				"</dc:description>" + //$NON-NLS-1$ //$NON-NLS-2$
				"</Practice>"; //$NON-NLS-1$
				jazz.client.xhrPut({
					url: args.resource + "?updateType=partial&lang=" + args.language, //$NON-NLS-1$
					headers: {
						"Accept-Charset": "UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
						"Content-Type": "application/xml;charset=UTF-8", //$NON-NLS-1$ //$NON-NLS-2$
						"Accept": "application/xml", //$NON-NLS-1$ //$NON-NLS-2$
						"ETag": ETag //$NON-NLS-1$
					},
					handleAs: "xml", //$NON-NLS-1$
					putData: pdata,
					error: args.error,
					load: args.load
				});
			},
			'error': args.error //$NON-NLS-1$
		});
	};
	
	ProcessAuthoringClient.getAttachmentsByPractice = function(args) {
		var headers = {
			"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
		};
		if (args.lastModified) {
			headers[ProcessAuthoringConstants.HEADER_IF_MODIFIED_SINCE] = args.lastModified;
		}
		
		jazz.client.xhrGet({
			preventCache: true,
			url: args.url, //$NON-NLS-1$
			headers: headers,
			handleAs: "xml", //$NON-NLS-1$
			error: args.error,
			load: args.load
		});
	};
	
	ProcessAuthoringClient.getAttachment = function(args) {
		var headers = {
			"Accept": "application/xml" //$NON-NLS-1$ //$NON-NLS-2$
		};
		if (args.lastModified) {
			headers[ProcessAuthoringConstants.HEADER_IF_MODIFIED_SINCE] = args.lastModified;
		}
		jazz.client.xhrGet({
			preventCache: true,
			url: args.url, //$NON-NLS-1$
			headers: headers,
			handleAs: "xml", //$NON-NLS-1$
			error: args.error,
			load: args.load
		});
	};
	
	ProcessAuthoringClient.deleteAttachment = function(args) {
		jazz.client.xhrDelete({
			preventCache: true,
			url: args.url, //$NON-NLS-1$
			headers: {
				Accept: "application/xml" //$NON-NLS-1$
			},
			handleAs: "xml", //$NON-NLS-1$
			error: args.error,
			load: args.load
		});
	};
	
	ProcessAuthoringClient.getJtsUriRoot = function(args) {
		return JTS_URI_ROOT;
	}
	
	ProcessAuthoringClient.getJtsProcessAuthoringRoot = function(args) {
		return JTS_PROCESS_AUTHORING_ROOT;
	}
	
	ProcessAuthoringClient.getFileServiceUrl = function() {
	    return net.jazz.ajax.contextRoot() + RestApis.FILE_URL.substring(net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL.length);
	}
	
	ProcessAuthoringClient.getJtsFileServiceUrl = function() {
		if (RestApis.FILE_URL.indexOf(JTS_URI_ROOT) == 0) {
			return RestApis.FILE_URL;
		} else {
			return JTS_URI_ROOT + RestApis.FILE_URL.substring(net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL.length);
		}
	}
	
	ProcessAuthoringClient.getProcessDescriptionsUrl = function() {
	    return RestApis.PROCESS_DESCRIPTION_URL;
	}
	
	ProcessAuthoringClient.getJtsProcessDescriptionUrl = function() {
		if (RestApis.PROCESS_DESCRIPTION_URL.indexOf(JTS_URI_ROOT) == 0) {
			return RestApis.PROCESS_DESCRIPTION_URL;
		} else {
			return JTS_URI_ROOT + RestApis.PROCESS_DESCRIPTION_URL.substring(net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL.length);
		}
	}
	
	ProcessAuthoringClient.isProcessDescriptionURL = function(url) {
		if (url) {
			if (url.indexOf(ProcessAuthoringClient.getJtsProcessDescriptionUrl()) === 0) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	ProcessAuthoringClient.isPracticeURL = function(url) {
		if (url) {
			if (url.indexOf(ProcessAuthoringClient.getJtsPracticeUrl()) === 0) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	ProcessAuthoringClient.getPracticeUrl = function() {
	    return RestApis.PRACTICES_URL;
	}
	
	ProcessAuthoringClient.getJtsPracticeUrl = function() {
		if (RestApis.PRACTICES_URL.indexOf(JTS_URI_ROOT) == 0) {
			return RestApis.PRACTICES_URL;
		} else {
			return JTS_URI_ROOT + RestApis.PRACTICES_URL.substring(net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL.length);
		}
	}
	
	ProcessAuthoringClient.getJtsPracticeLibraryUrl = function() {
		if (RestApis.PRACTICE_LIBRARY_URL.indexOf(JTS_URI_ROOT) == 0) {
			return RestApis.PRACTICE_LIBRARY_URL;
		} else {
			return JTS_URI_ROOT + RestApis.PRACTICE_LIBRARY_URL.substring(net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL.length);
		}
	}
	
	ProcessAuthoringClient.getJtsAssociationUrl = function() {
		if (RestApis.ASSOCIATIONS_URL.indexOf(JTS_URI_ROOT) == 0) {
			return RestApis.ASSOCIATIONS_URL;
		} else {
			return JTS_URI_ROOT + RestApis.ASSOCIATIONS_URL.substring(net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL.length);
		}
	}
	
	function getJtsRoot() {
		var discoverySvcUrl = net.jazz.ajax.BootstrapProperties.DISCOVERYSERVICE_URL;
		var index = discoverySvcUrl.lastIndexOf('/'); //$NON-NLS-1$
		if(index == discoverySvcUrl.length - 1) {
			index = discoverySvcUrl.lastIndexOf('/', index); //$NON-NLS-1$
		}
		return discoverySvcUrl.substring(0, index);
	}
	
	/**
	 * Add language parameter for resource URLs.
	 * @param {Array} resourceURLs contains all the resource URLs.
	 * @param {String} language the language string, e.g. "en".
	 * @return an array that contains all the resource URLs with its language parameter.
	 */
	ProcessAuthoringClient.addLanguageParameterInURLs = function(resourceURLs, language) {
		var resourceURLsWithLang = new Array();
		for (var i = 0; i < resourceURLs.length; i++) {
			resourceURLsWithLang.push(resourceURLs[i] + "?lang=" + language); //$NON-NLS-1$
		}
		return resourceURLsWithLang;
	}
	
	/**
	 * Parse a bulk response in to a map of content ID (the ID of a part request in the bulk request) to response object.
	 * 
	 * The response object has the following properties:
	 *    {number} contentId: response ID
	 *    {number} contentLength: response body's length (value of Content-Length header)
	 *    {string} body: response body
	 *    {number} status: response status code
	 *    response headers that can be access with response[{HeaderNameInLowerCase}] if they are available
	 *             
	 * @param {Object} boundary the boundary used in the bulk request
	 * @param {Object} data the response data
	 * @param {Object} ioArgs additional arguments that xhr passed to the on load function
	 * @return a map of content ID to response object
	 */
    ProcessAuthoringClient.parseBulkResponse = function(boundary, data, ioArgs) {
		var partResponses = {};
		var boundaryPrefix = "--" + boundary; //$NON-NLS-1$
    	var pos = 0;
    	var length = data ? data.length : 0;
    	while (pos < length) {
    		pos = data.indexOf(boundaryPrefix, pos); // look for next --boundary occurrence
    		if (pos < 0) 
    			break;
    		pos += boundaryPrefix.length; // skip --boundary prefix
    		var endBoundary = pos;
    		pos = data.indexOf("\r\n", pos); // look for next CRLF //$NON-NLS-1$
    		if (pos > endBoundary && (data.charAt(pos - 2) == '-') && (data.charAt(pos - 1) == '-')) //$NON-NLS-1$ //$NON-NLS-2$
    			break; // final --boundary-- 
    		if (pos < 0) 
    			break;
    		pos += 2; // skip CRLF
    		var partResponse = {};
    		partResponse.contentLength = -1;
    		var numOfEmptyLines = 0;
    		while (pos < length) {
    			var lineStart = pos;
    			pos = data.indexOf("\r\n", pos); // look for next CRLF //$NON-NLS-1$
    			if (pos < 0) 
    				break;
    			if (data.indexOf(boundaryPrefix, lineStart) == lineStart) { // reached next part
    				pos = lineStart; // rewind a little bit
    				break;
    			}
    			if (pos == lineStart) {
    				// another CRLF, this is an empty line
    				numOfEmptyLines++;
    				if (numOfEmptyLines == 2) {
    					// this is the beginning of response body
    					pos += 2; // skip CRLF
    					break;
    				}
    			} else {
    				// parse part response status or header
    				for (var i = lineStart; i < pos; i++) {
    					var c = data.charAt(i);
    					if (c == ' ' || c == ':') { //$NON-NLS-1$ //$NON-NLS-2$
    						var headerName = dojo.trim(data.substring(lineStart, i)).toLowerCase();
    						if (c == ' ') { //$NON-NLS-1$
    							if (headerName.indexOf("http/") == 0) { //$NON-NLS-1$
    								var j = data.indexOf(' ', i + 1); // find end of status code //$NON-NLS-1$
    								if (j < 0 || j > pos) 
    									j = pos; // no reason was available
    								var status = data.substring(i + 1, j);
    								partResponse.status = status;
    							}
    						} else if (c == ':') { //$NON-NLS-1$
    							var valueStart = i + 2;
    							var headerValue = valueStart < pos ? data.substring(valueStart, pos) : ""; //$NON-NLS-1$
    							if (headerName == "content-id") { //$NON-NLS-1$
    								partResponse.contentId = headerValue;
    							} else if (headerName == "content-length") { //$NON-NLS-1$
    								partResponse.contentLength = headerValue;
    							} else {
    								partResponse[headerName] = headerValue;
    							}
    						}
    						break;
    					}
    				}
    			}
    			pos += 2; // skip CRLF
    		}
    		if (numOfEmptyLines == 2) {
    			if (partResponse.contentLength != -1) {
    				partResponse.body = data.substr(pos, partResponse.contentLength);
    			} else {
    				var bodyEnd = data.indexOf(boundaryPrefix + "\r\n", pos); //$NON-NLS-1$
    				if (bodyEnd == -1) {
    					bodyEnd = data.indexOf(boundaryPrefix + "--", pos); //$NON-NLS-1$
    				}
    				if (bodyEnd == -1) {
    					break;
    				}
    				partResponse.body = data.substring(pos, bodyEnd);
    			}
    		}
    		if (partResponse.contentId) {
    			partResponses[partResponse.contentId] = partResponse;
    		}
    	}
		return partResponses;
    }
	
	/**
	 * Fetches resources in bulk.
	 * 
	 * @param {array of string} resourceURLs the URL of
	 * @param {function} successCallback the callback function on success, this function has the following parameters:
	 *     responses: array of responses corresponding to the specified resource URLs, 
	 *         the response object at index i in the responses array is for the resource URL at index i in the resourceURLs array.
	 *         The response object has the following properties:
	 *             {number} contentId: response ID
	 *             {number} contentLength: response body's length (value of Content-Length header)
	 *             {string} body: response body
	 *             {number} status: response status code
	 *             response headers that can be access with response[{HeaderNameInLowerCase}] if they are available
	 *     ioArgs: forwarded from the load function of xhr call
	 * @param {function} errorCallback the callback function on error, it the error handler for xhr call
	 */
	ProcessAuthoringClient.fetchResources = function(resourceURLs, modifiedSince, successCallback, errorCallback) {
        // TODO: there must be a limit for number of resources to fetch per each bulk request, fetchResources must be chained in order 
		// to fetch all resources if the number of resources exceeds the limit.
		var boundary = "batch"; //$NON-NLS-1$
		var headers = {
			"Content-Type": "multipart/http;version=1.1;msgtype=request;boundary=" + boundary //$NON-NLS-1$ //$NON-NLS-2$
		};
		
		if (modifiedSince) {
			headers[ProcessAuthoringConstants.HEADER_IF_MODIFIED_SINCE] = modifiedSince;
		}
		
		var postData = ""; //$NON-NLS-1$
		for (var i = 0; i < resourceURLs.length; i++) {
			postData += 
				"--" + boundary + "\r\n" + //$NON-NLS-1$  //$NON-NLS-2$
				"Content-ID: " + i + "\r\n" + //$NON-NLS-1$ //$NON-NLS-2$
				"\r\n" + //$NON-NLS-1$
				"GET " + resourceURLs[i] + " HTTP/1.1\r\n" //$NON-NLS-1$ //$NON-NLS-2$
				;
		}
		postData += "--" + boundary + "--"; //$NON-NLS-1$  //$NON-NLS-2$
		var load = function(data, ioArgs) {
			var partResponses = new Array(resourceURLs.length);
			var responseMap = ProcessAuthoringClient.parseBulkResponse(boundary, data, ioArgs);
			for (var i = 0; i < resourceURLs.length; i++) {
				partResponses[i] = responseMap[i];
			}
			successCallback(partResponses, ioArgs);
		};
		return jazz.client.xhrPost({
			preventCache: true,
			url: JTS_URI_ROOT + "/bulk", //$NON-NLS-1$
			headers: headers,
			postData: postData,
			load: load,
			error: errorCallback
		});
	}

})();
