/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.common.internal.ProcessUtils");//$NON-NLS-1$
	com.ibm.team.process.web.common.internal.ProcessUtils = {
	
		/**
		 * Normalize the file name, replace the invalid characters into char '_'
		 *
		 * @param {String} fileName the file name
		 */
		normalizeFileName: function(fileName){
			fileName = fileName.replace(/<|>|:|%|#|\\|\/|\"|\*|\?|\||&/g, "_"); //$NON-NLS-1$
			fileName = this._normalizeSpacesAndDots(fileName);
			return fileName;
		},
		
		_normalizeSpacesAndDots: function(str){
		
			var normalize = function(str){
				str = str.substring(0, str.length - 1);
				str = str + "_"; //$NON-NLS-1$
				return str;
			};
			
			if (!str) {
				return str;
			}
			
			str = str.replace(/\.{2}/g, "__");//$NON-NLS-1$ //replace .. with __
			var c = str.charAt(str.length - 1);
			if (c != ' ' && c != '.') { //$NON-NLS-1$ //$NON-NLS-2$ //processId doesn't end with . or ' '
				return str;
			} else if (c === ' ') { //$NON-NLS-1$ //processId ends with ' '
				str = normalize(str);
				return str;
			}
			
			var k = 0;
			for (var i = 0; i < str.length; i++) {
				if (str.charAt(i) === ' ' || str.charAt(i) === '.') {//$NON-NLS-1$ //$NON-NLS-2$
					k++;
				} else {
					break;
				}
			}
			if (k === str.length) { //processId contains only . and ' '
				str = normalize(str);
				return str;
			}
			
			k = str.lastIndexOf(' '); //$NON-NLS-1$
			if (k < 0) {
				return str;
			}
			var count = 0;
			for (var i = k; i < str.length; i++) {
				if (str.charAt(i) === '.') { //$NON-NLS-1$
					count++;
				}
			}
			if (count === (str.length - k - 1)) { //processId ends with ' '.....
				str = normalize(str);
				return str;
			}
			
			return str;
		},
		
		/**
		 * Public: Returns true if the obj does not contain any
		 * properties defined in it.
		 * 
		 * @returns {true|false}
		 */
		isEmptyObject : function(obj) {
			for ( var prop in obj) {
				if (Object.prototype.hasOwnProperty.call(obj, prop)) {
					return false;
				}
			}
			return true;
		}
	};
})();
