/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("jazz.app.internal.GlobalizationPreferences");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.ui.ButtonGroup");
dojo.require("jazz.app.i18n");

dojo.requireLocalization("jazz.app.internal", "GlobalizationPreferencesMessages");

dojo.declare("jazz.app.internal.GlobalizationPreferences", [dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("jazz.app","internal/templates/GlobalizationPreferences.html"),
	widgetsInTemplate: true,
	
	constructor: function(args) {
		this.messages = dojo.i18n.getLocalization("jazz.app.internal", "GlobalizationPreferencesMessages");
	},

    postCreate: function(){
		if (jazz.app.i18n.isBidiEnabled()) {
			this._bSupport.checked = true;
			dojo.removeAttr(this._bSelect, "disabled");
			dojo.addClass(this.domNode, "bidiEnabled");
			this._bSelect.selectedIndex = 0;
			
			var btd = jazz.app.i18n.getBaseTextDir();
			if (btd){
				for (var i=0; i<this._bSelect.options.length; i++){
					if (this._bSelect.options[i].value == btd){
						this._bSelect.selectedIndex = i;
						break;
					}
				}
			}
		}
		var clndr = jazz.app.i18n.getCalendar();
		this._cSelect.selectedIndex = 0;
		if (clndr){
			for (var i=0; i<this._cSelect.options.length; i++){
				if (this._cSelect.options[i].value == clndr){
					this._cSelect.selectedIndex = i;
					break;
				}
			}
		}
	},
	_onBidiSupportClick: function(e) {
		var checked = dojo.attr(this._bSupport,"checked");
		if (checked){
			dojo.removeAttr(this._bSelect, "disabled");
		} else {
			dojo.attr(this._bSelect, "disabled", "disabled");
		}
		dojo.toggleClass(this.domNode, "bidiEnabled", checked);
	},
	_onOK: function(e) {
		jazz.app.i18n.setBidiEnabled(this._bSupport.checked);
		jazz.app.i18n.setCalendar(this._cSelect.options[this._cSelect.selectedIndex].value);
		if (this._bSupport.checked){
			jazz.app.i18n.setBaseTextDir(this._bSelect.options[this._bSelect.selectedIndex].value);
		}
 		this._onCancel(e);
	},
	_onCancel: function(e) {
		dojo.stopEvent(e);
		this.dialog.close();
	}
});
})();