/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ensemble.internal.wizards.ExportWidgetWizardStep2");

/*
 * Imports 
 */
dojo.require("dojo.i18n");

dojo.require("jazz.ui.wizard.WizardStep");
dojo.require("dijit.form.SimpleTextarea");

dojo.require("jazz.ensemble.internal.util.WidgetCodeSnippetGenerator");

dojo.requireLocalization("jazz.ensemble.internal", "Messages");

(function() {

/*
* Aliases 
*/
var WizardStep = jazz.ui.wizard.WizardStep;
var WidgetCodeSnippetGenerator = jazz.ensemble.internal.util.WidgetCodeSnippetGenerator;

/*
 * Constants 
 */


/*
 * Class
 */
dojo.declare("jazz.ensemble.internal.wizards.ExportWidgetWizardStep2",
		[dijit._Widget, dijit._Templated, WizardStep], {

	// Properties //----------------------------------------------------------->

	// ------------------------------------------------------------------------>

	/*
	 * Templates
	 */	
	templatePath: dojo.moduleUrl("jazz.ensemble", "internal/wizards/templates/ExportWidgetWizardStep2.html"),
	widgetsInTemplate: true,
	
	/*
 	 * @param Object args
 	 * 
 	 * @return ExportWidgetWizardStep2
 	 */
	constructor: function(args) {
	
		this.messages = dojo.i18n.getLocalization("jazz.ensemble.internal", "Messages");
		
		this.stepTitle = this.messages.wizardsGetCodeSnippet; 

	},

	/*
 	 * @param void
 	 * 
 	 * @return void
 	 * @overrides super
 	 */	
	postCreate: function() {

		this.inherited(arguments);

		// Instance Variables //----------------------------------------------->

	
		// Initialization //--------------------------------------------------->
		
	},

	/*
 	 * @param void
 	 * 
 	 * @return Boolean
 	 * @overrides super
 	 */	
	canFinish: function() {
		return true;
	},	

	/*
 	 * @param void
 	 * 
 	 * @return void
 	 * @overrides super
 	 */	
	focusStep: function() {
		
		var state = this.context.state;
		var width = this.context.width;
		var height = this.context.height;
		
		if (!state) {
			// TODO: Error
			console.error('951');
			return;
		}
		
		var codeSnippet = WidgetCodeSnippetGenerator.getCode(state, width, height);
		
		if (!codeSnippet) {
			// TODO: Error
			console.error('952');
			return;
		}
		
		// Disable spell-checking feature in FF
		this._textArea.domNode.spellcheck = false;
		this._textArea.domNode.style.width = "536px";
		this._textArea.set('value', codeSnippet);
		
		// TEST
		// TODO: Enable on debug=true
		//console.log(WidgetCodeSnippetGenerator.debugState(state));
		
	},
	
	/*
 	 * @param void
 	 * 
 	 * @return void
 	 * @overrides super
 	 */		
	destroy: function() {

		
		this.inherited(arguments);
	}

});

})();
