SET CURRENT SCHEMA CONFIG;

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=6);

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=7);

UPDATE CONFIG.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0' WHERE INFO_ID=7;

INSERT INTO CONFIG.SYSCONFIG_INFO SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM CONFIG.SYSCONFIG_INFO WHERE INFO_ID=8);

CREATE TABLE RIODS.EXECRESULT_CATEGORY_LOOKUP(EXECUTION_RESULT_ID INTEGER NOT NULL, TEST_CATEGORY_ID INTEGER NOT NULL) ;
ALTER TABLE RIODS.EXECRESULT_CATEGORY_LOOKUP ADD CONSTRAINT EXECRESCATE_PK PRIMARY KEY(EXECUTION_RESULT_ID, TEST_CATEGORY_ID);
ALTER TABLE RIODS.EXECRESULT_CATEGORY_LOOKUP ADD CONSTRAINT EXECRESCATE_FK1 FOREIGN KEY (EXECUTION_RESULT_ID) REFERENCES RIODS.EXECUTION_RESULT(EXECUTION_RESULT_ID);
ALTER TABLE RIODS.EXECRESULT_CATEGORY_LOOKUP ADD CONSTRAINT EXECRESCATE_FK2 FOREIGN KEY (TEST_CATEGORY_ID) REFERENCES RIODS.TEST_CATEGORY(TEST_CATEGORY_ID);
ALTER TABLE RIODS.EXECRES_REQUEST_LOOKUP ADD LINK_TYPE VARCHAR(255) DEFAULT 'Unassigned' NOT NULL;
ALTER TABLE RIODS.EXECRES_REQUEST_LOOKUP DROP CONSTRAINT EXECRGREQ_PK;
ALTER TABLE RIODS.EXECRES_REQUEST_LOOKUP ADD CONSTRAINT EXECRGREQ_PK PRIMARY KEY(REQUEST_ID, EXECUTION_RESULT_ID, LINK_TYPE);
ALTER TABLE RIODS.EXECSTEPRES_REQUEST_LOOKUP ADD LINK_TYPE VARCHAR(255) DEFAULT 'Unassigned' NOT NULL;
ALTER TABLE RIODS.EXECSTEPRES_REQUEST_LOOKUP DROP CONSTRAINT EXCSTRSREQUELK_PK;
ALTER TABLE RIODS.EXECSTEPRES_REQUEST_LOOKUP ADD CONSTRAINT EXCSTRSREQUELK_PK PRIMARY KEY(EXECUTION_STEP_RESULT_ID, REQUEST_ID, LINK_TYPE);
ALTER TABLE RIODS.EXECUTION_RESULT ADD POINTS_DEFERRED INTEGER DEFAULT 0 NOT NULL;
ALTER TABLE RIODS.EXECUTION_RESULT ADD POINTS_TOTAL INTEGER DEFAULT 0 NOT NULL;
CREATE TABLE RIODS.EXECWORKITEM_CATEGORY_LOOKUP(EXECWORKITEM_ID INTEGER NOT NULL, TEST_CATEGORY_ID INTEGER NOT NULL) ;
ALTER TABLE RIODS.EXECWORKITEM_CATEGORY_LOOKUP ADD CONSTRAINT EXWKICATEIT_PK PRIMARY KEY(EXECWORKITEM_ID, TEST_CATEGORY_ID);
ALTER TABLE RIODS.EXECWORKITEM_CATEGORY_LOOKUP ADD CONSTRAINT EXWKITCATE_FK1 FOREIGN KEY (EXECWORKITEM_ID) REFERENCES RIODS.EXECUTION_WORKITEM(EXECWORKITEM_ID);
ALTER TABLE RIODS.EXECWORKITEM_CATEGORY_LOOKUP ADD CONSTRAINT EXWKITCATE_FK2 FOREIGN KEY (TEST_CATEGORY_ID) REFERENCES RIODS.TEST_CATEGORY(TEST_CATEGORY_ID);
ALTER TABLE RIODS.EXECWORKITEM_REQUEST_LOOKUP ADD LINK_TYPE VARCHAR(255) DEFAULT 'Unassigned' NOT NULL;
ALTER TABLE RIODS.EXECWORKITEM_REQUEST_LOOKUP DROP CONSTRAINT EXWKITREQUE_PK;
ALTER TABLE RIODS.EXECWORKITEM_REQUEST_LOOKUP ADD CONSTRAINT EXWKITREQUE_PK PRIMARY KEY(EXECWORKITEM_ID, REQUEST_ID, LINK_TYPE);
ALTER TABLE RIODS.ITERATION ADD DESCRIPTION VARCHAR(255);
ALTER TABLE RIODS.REQUEST ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIODS.REQUEST ADD DUE_DATE TIMESTAMP;
ALTER TABLE RIODS.REQUEST ADD CONSTRAINT REQUEST_FK20 FOREIGN KEY (CREATOR_ID) REFERENCES RIODS.RESOURCE(RESOURCE_ID);
ALTER TABLE RIODS.REQUEST_CATEGORY ADD PROJECT_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIODS.REQUEST_CATEGORY ADD CONSTRAINT REQUECAT_FK1 FOREIGN KEY (PROJECT_ID) REFERENCES RIODS.PROJECT(PROJECT_ID);
ALTER TABLE RIODS.REQUEST_TESTCASE_LOOKUP ADD LINK_TYPE VARCHAR(255) DEFAULT 'Unassigned' NOT NULL;
ALTER TABLE RIODS.REQUEST_TESTCASE_LOOKUP DROP CONSTRAINT REQUTCASE_PK;
ALTER TABLE RIODS.REQUEST_TESTCASE_LOOKUP ADD CONSTRAINT REQUTCASE_PK PRIMARY KEY(REQUEST_ID, TESTCASE_ID, LINK_TYPE);
CREATE TABLE RIODS.REQUEST_TESTPLAN_LOOKUP(REQUEST_ID INTEGER NOT NULL, TESTPLAN_ID INTEGER NOT NULL, LINK_TYPE VARCHAR(255) DEFAULT 'Unassigned' NOT NULL) ;
ALTER TABLE RIODS.REQUEST_TESTPLAN_LOOKUP ADD CONSTRAINT REQTP_PK PRIMARY KEY(REQUEST_ID, TESTPLAN_ID, LINK_TYPE);
ALTER TABLE RIODS.REQUEST_TESTPLAN_LOOKUP ADD CONSTRAINT REQTP_FK1 FOREIGN KEY (REQUEST_ID) REFERENCES RIODS.REQUEST(REQUEST_ID);
ALTER TABLE RIODS.REQUEST_TESTPLAN_LOOKUP ADD CONSTRAINT REQTP_FK2 FOREIGN KEY (TESTPLAN_ID) REFERENCES RIODS.TESTPLAN(TESTPLAN_ID);
CREATE TABLE RIODS.REQUEST_TESTSCRIPT_LOOKUP(REQUEST_ID INTEGER NOT NULL, TESTSCRIPT_ID INTEGER NOT NULL, LINK_TYPE VARCHAR(255) DEFAULT 'Unassigned' NOT NULL) ;
ALTER TABLE RIODS.REQUEST_TESTSCRIPT_LOOKUP ADD CONSTRAINT REQTSC_PK PRIMARY KEY(REQUEST_ID, TESTSCRIPT_ID, LINK_TYPE);
ALTER TABLE RIODS.REQUEST_TESTSCRIPT_LOOKUP ADD CONSTRAINT REQTSC_FK1 FOREIGN KEY (REQUEST_ID) REFERENCES RIODS.REQUEST(REQUEST_ID);
ALTER TABLE RIODS.REQUEST_TESTSCRIPT_LOOKUP ADD CONSTRAINT REQTSC_FK2 FOREIGN KEY (TESTSCRIPT_ID) REFERENCES RIODS.TESTSCRIPT(TESTSCRIPT_ID);
CREATE TABLE RIODS.REQUEST_TESTSUITE_LOOKUP(REQUEST_ID INTEGER NOT NULL, TESTSUITE_ID INTEGER NOT NULL, LINK_TYPE VARCHAR(255) DEFAULT 'Unassigned' NOT NULL) ;
ALTER TABLE RIODS.REQUEST_TESTSUITE_LOOKUP ADD CONSTRAINT REQTSU_PK PRIMARY KEY(REQUEST_ID, TESTSUITE_ID, LINK_TYPE);
ALTER TABLE RIODS.REQUEST_TESTSUITE_LOOKUP ADD CONSTRAINT REQTSU_FK1 FOREIGN KEY (REQUEST_ID) REFERENCES RIODS.REQUEST(REQUEST_ID);
ALTER TABLE RIODS.REQUEST_TESTSUITE_LOOKUP ADD CONSTRAINT REQTSU_FK2 FOREIGN KEY (TESTSUITE_ID) REFERENCES RIODS.TESTSUITE(TESTSUITE_ID);
CREATE TABLE RIODS.REQUEST_TYPE_BINDING(REQUEST_TYPE_BINDING_ID INTEGER NOT NULL, NAME VARCHAR(255) DEFAULT 'Request Type Binding Name Missing' NOT NULL, REFERENCE_ID VARCHAR(50), EXTERNAL_ID VARCHAR(100), PROJECT_ID INTEGER DEFAULT -1 NOT NULL, REQUEST_TYPE_ID INTEGER DEFAULT -1 NOT NULL, URL VARCHAR(2048), EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL, EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL, SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL, REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL, ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL) ;
CREATE INDEX RIODS.REQTBING_IDX2 ON RIODS.REQUEST_TYPE_BINDING(EXTERNAL_ID);
CREATE INDEX RIODS.REQTBING_IDX3 ON RIODS.REQUEST_TYPE_BINDING(EXTERNAL_KEY2);
CREATE INDEX RIODS.REQTBING_IDX4 ON RIODS.REQUEST_TYPE_BINDING(EXTERNAL_KEY1, SOURCE_ID);
CREATE INDEX RIODS.REQTBING_IDX5 ON RIODS.REQUEST_TYPE_BINDING(EXTERNAL_KEY2, SOURCE_ID);
CREATE INDEX RIODS.REQTBING_IDX6 ON RIODS.REQUEST_TYPE_BINDING(ISSOFTDELETED);
ALTER TABLE RIODS.REQUEST_TYPE_BINDING ADD CONSTRAINT REQTBING_PK PRIMARY KEY(REQUEST_TYPE_BINDING_ID);
ALTER TABLE RIODS.REQUEST_TYPE_BINDING ADD CONSTRAINT REQTBING_FK1 FOREIGN KEY (PROJECT_ID) REFERENCES RIODS.PROJECT(PROJECT_ID);
ALTER TABLE RIODS.REQUEST_TYPE_BINDING ADD CONSTRAINT REQTBING_FK2 FOREIGN KEY (REQUEST_TYPE_ID) REFERENCES RIODS.REQUEST_TYPE(REQUEST_TYPE_ID);
INSERT INTO RIODS.REQUEST_TYPE_BINDING(REQUEST_TYPE_BINDING_ID, NAME) VALUES(-1, 'Info not available');
ALTER TABLE RIODS.REQUICOL_TESTPLAN_LOOKUP ADD LINK_TYPE VARCHAR(255) DEFAULT 'Unassigned' NOT NULL;
ALTER TABLE RIODS.REQUICOL_TESTPLAN_LOOKUP DROP CONSTRAINT REQUICOL_TESTP_PK;
ALTER TABLE RIODS.REQUICOL_TESTPLAN_LOOKUP ADD CONSTRAINT REQUICOL_TESTP_PK PRIMARY KEY(REQUIREMENT_COLLECTION_ID, TESTPLAN_ID, LINK_TYPE);
ALTER TABLE RIODS.REQUIREMENT_REQUEST_LOOKUP ADD LINK_TYPE VARCHAR(255) DEFAULT 'Unassigned' NOT NULL;
ALTER TABLE RIODS.REQUIREMENT_REQUEST_LOOKUP DROP CONSTRAINT REQIREQ_PK;
ALTER TABLE RIODS.REQUIREMENT_REQUEST_LOOKUP ADD CONSTRAINT REQIREQ_PK PRIMARY KEY(REQUIREMENT_ID, REQUEST_ID, LINK_TYPE);
ALTER TABLE RIODS.REQUIREMENT_TESTCASE_LOOKUP ADD LINK_TYPE VARCHAR(255) DEFAULT 'Unassigned' NOT NULL;
ALTER TABLE RIODS.REQUIREMENT_TESTCASE_LOOKUP DROP CONSTRAINT REQTEST_PK;
ALTER TABLE RIODS.REQUIREMENT_TESTCASE_LOOKUP ADD CONSTRAINT REQTEST_PK PRIMARY KEY(REQUIREMENT_ID, TESTCASE_ID, LINK_TYPE);
CREATE TABLE RIODS.TESTSCRIPT_CATEGORY_LOOKUP(TESTSCRIPT_ID INTEGER NOT NULL, TEST_CATEGORY_ID INTEGER NOT NULL) ;
ALTER TABLE RIODS.TESTSCRIPT_CATEGORY_LOOKUP ADD CONSTRAINT TSCATE_PK PRIMARY KEY(TESTSCRIPT_ID, TEST_CATEGORY_ID);
ALTER TABLE RIODS.TESTSCRIPT_CATEGORY_LOOKUP ADD CONSTRAINT TSCATE_FK1 FOREIGN KEY (TESTSCRIPT_ID) REFERENCES RIODS.TESTSCRIPT(TESTSCRIPT_ID);
ALTER TABLE RIODS.TESTSCRIPT_CATEGORY_LOOKUP ADD CONSTRAINT TSCATE_FK2 FOREIGN KEY (TEST_CATEGORY_ID) REFERENCES RIODS.TEST_CATEGORY(TEST_CATEGORY_ID);
CREATE TABLE RIODS.TESTSUITELOG_CATEGORY_LOOKUP(TESTSUITELOG_ID INTEGER NOT NULL, TEST_CATEGORY_ID INTEGER NOT NULL) ;
ALTER TABLE RIODS.TESTSUITELOG_CATEGORY_LOOKUP ADD CONSTRAINT TESTSUITELOGCATE_PK PRIMARY KEY(TESTSUITELOG_ID, TEST_CATEGORY_ID);
ALTER TABLE RIODS.TESTSUITELOG_CATEGORY_LOOKUP ADD CONSTRAINT TESTSUITELOGCATE_FK1 FOREIGN KEY (TESTSUITELOG_ID) REFERENCES RIODS.TESTSUITELOG(TESTSUITELOG_ID);
ALTER TABLE RIODS.TESTSUITELOG_CATEGORY_LOOKUP ADD CONSTRAINT TESTSUITELOGCATE_FK2 FOREIGN KEY (TEST_CATEGORY_ID) REFERENCES RIODS.TEST_CATEGORY(TEST_CATEGORY_ID);
CREATE TABLE RIODS.TSTSUITEXECREC_CATEGORY_LOOKUP(TESTSUITE_EXECRECORD_ID INTEGER NOT NULL, TEST_CATEGORY_ID INTEGER NOT NULL) ;
ALTER TABLE RIODS.TSTSUITEXECREC_CATEGORY_LOOKUP ADD CONSTRAINT TSTSEXECRECCATE_PK PRIMARY KEY(TESTSUITE_EXECRECORD_ID, TEST_CATEGORY_ID);
ALTER TABLE RIODS.TSTSUITEXECREC_CATEGORY_LOOKUP ADD CONSTRAINT TSTSEXECRECCATE_FK1 FOREIGN KEY (TESTSUITE_EXECRECORD_ID) REFERENCES RIODS.TESTSUITE_EXECUTION_RECORD(TESTSUITE_EXECRECORD_ID);
ALTER TABLE RIODS.TSTSUITEXECREC_CATEGORY_LOOKUP ADD CONSTRAINT TSTSEXECRECCATE_FK2 FOREIGN KEY (TEST_CATEGORY_ID) REFERENCES RIODS.TEST_CATEGORY(TEST_CATEGORY_ID);
CREATE TRIGGER RIODS.TRG_EXECRESCATE 	AFTER UPDATE OF REC_DATETIME ON RIODS.EXECUTION_RESULT 	REFERENCING  NEW AS NEWROW 		OLD AS OLDROW 	FOR EACH ROW MODE DB2SQL      DELETE FROM RIODS.EXECRESULT_CATEGORY_LOOKUP WHERE EXECUTION_RESULT_ID=NEWROW.EXECUTION_RESULT_ID;
CREATE TRIGGER RIODS.TRG_EXWKITCATE 	AFTER UPDATE OF REC_DATETIME ON RIODS.EXECUTION_WORKITEM 	REFERENCING  NEW AS NEWROW 		OLD AS OLDROW 	FOR EACH ROW MODE DB2SQL      DELETE FROM RIODS.EXECWORKITEM_CATEGORY_LOOKUP WHERE EXECWORKITEM_ID=NEWROW.EXECWORKITEM_ID;
CREATE TRIGGER RIODS.TRG_REQTP	AFTER UPDATE OF REC_DATETIME ON RIODS.TESTPLAN	REFERENCING  NEW AS NEWROW		OLD AS OLDROW	FOR EACH ROW MODE DB2SQL     DELETE FROM RIODS.REQUEST_TESTPLAN_LOOKUP WHERE TESTPLAN_ID=NEWROW.TESTPLAN_ID;
CREATE TRIGGER RIODS.TRG_REQTSC	AFTER UPDATE OF REC_DATETIME ON RIODS.TESTSCRIPT	REFERENCING  NEW AS NEWROW		OLD AS OLDROW	FOR EACH ROW MODE DB2SQL     DELETE FROM RIODS.REQUEST_TESTSCRIPT_LOOKUP WHERE TESTSCRIPT_ID=NEWROW.TESTSCRIPT_ID;
CREATE TRIGGER RIODS.TRG_REQTSU	AFTER UPDATE OF REC_DATETIME ON RIODS.TESTSUITE	REFERENCING  NEW AS NEWROW		OLD AS OLDROW	FOR EACH ROW MODE DB2SQL     DELETE FROM RIODS.REQUEST_TESTSUITE_LOOKUP WHERE TESTSUITE_ID=NEWROW.TESTSUITE_ID;
CREATE TRIGGER RIODS.TRG_TESTSUITELOG 	AFTER UPDATE OF REC_DATETIME ON RIODS.TESTSUITELOG 	REFERENCING  NEW AS NEWROW 		OLD AS OLDROW 	FOR EACH ROW MODE DB2SQL      DELETE FROM RIODS.TESTSUITELOG_CATEGORY_LOOKUP WHERE TESTSUITELOG_ID=NEWROW.TESTSUITELOG_ID;
CREATE TRIGGER RIODS.TRG_TSCRTCATE 	AFTER UPDATE OF REC_DATETIME ON RIODS.TESTSCRIPT 	REFERENCING  NEW AS NEWROW 		OLD AS OLDROW 	FOR EACH ROW MODE DB2SQL      DELETE FROM RIODS.TESTSCRIPT_CATEGORY_LOOKUP WHERE TESTSCRIPT_ID=NEWROW.TESTSCRIPT_ID;
CREATE TRIGGER RIODS.TRG_TSTSEXECRECCATE 	AFTER UPDATE OF REC_DATETIME ON RIODS.TESTSUITE_EXECUTION_RECORD 	REFERENCING  NEW AS NEWROW 		OLD AS OLDROW 	FOR EACH ROW MODE DB2SQL      DELETE FROM RIODS.TSTSUITEXECREC_CATEGORY_LOOKUP WHERE TESTSUITE_EXECRECORD_ID=NEWROW.TESTSUITE_EXECRECORD_ID;
ALTER TABLE RIDW.F_C_EXECRESPOINTS_ITER_METRICS ADD SUM_POINTS_DEFERRED INTEGER DEFAULT 0 NOT NULL;
ALTER TABLE RIDW.F_C_EXECRESPOINTS_ITER_METRICS ADD SUM_POINTS_TOTAL INTEGER DEFAULT 0 NOT NULL;
ALTER TABLE RIDW.F_C_EXECRESPOINTS_METRICS ADD SUM_POINTS_DEFERRED INTEGER DEFAULT 0 NOT NULL;
ALTER TABLE RIDW.F_C_EXECRESPOINTS_METRICS ADD SUM_POINTS_TOTAL INTEGER DEFAULT 0 NOT NULL;
ALTER TABLE RIDW.F_C_REQUEST_AGING ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_C_REQUEST_AGING ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_C_REQUEST_AGING ADD CONSTRAINT F_C_REQ_AGD_FK11 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_C_REQUEST_CUST_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_C_REQUEST_CUST_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_C_REQUEST_CUST_METRICS ADD CONSTRAINT F_CREQCU_MET_FK22 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_C_REQUEST_FAILURE_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_C_REQUEST_FAILURE_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_C_REQUEST_FAILURE_METRICS ADD CONSTRAINT F_C_REQFL_FK7 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_C_REQUEST_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_C_REQUEST_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK22 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_C_REQUEST_REQUI_FAIL_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_C_REQUEST_REQUI_FAIL_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_C_REQUEST_REQUI_FAIL_METRICS ADD CONSTRAINT F_CREQRQF_MET_FK8 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_C_REQUEST_REQUI_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_C_REQUEST_REQUI_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_C_REQUEST_REQUI_METRICS ADD CONSTRAINT F_CREQRQU_MET_FK23 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_C_REQUEST_TPLN_AGING ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_C_REQUEST_TPLN_AGING ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_C_REQUEST_TPLN_AGING ADD CONSTRAINT F_C_REQTPLN_AG_FK10 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_C_REQUEST_TPLN_FAIL_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_C_REQUEST_TPLN_FAIL_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_C_REQUEST_TPLN_FAIL_METRICS ADD CONSTRAINT F_CREQTPF_MET_FK8 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_C_REQUEST_TPLN_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_C_REQUEST_TPLN_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_C_REQUEST_TPLN_METRICS ADD CONSTRAINT F_CREQTP_MET_FK24 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_C_REQUEST_TPLN_TURNAROUND ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_C_REQUEST_TPLN_TURNAROUND ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_C_REQUEST_TPLN_TURNAROUND ADD CONSTRAINT F_CREQTPT_MET_FK11 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_C_REQUEST_TURNAROUND ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_C_REQUEST_TURNAROUND ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_C_REQUEST_TURNAROUND ADD CONSTRAINT F_C_REQTURN_FK11 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_EXECRESPOINTS_ITER_METRICS ADD SUM_POINTS_DEFERRED INTEGER DEFAULT 0 NOT NULL;
ALTER TABLE RIDW.F_EXECRESPOINTS_ITER_METRICS ADD SUM_POINTS_TOTAL INTEGER DEFAULT 0 NOT NULL;
ALTER TABLE RIDW.F_EXECRESPOINTS_METRICS ADD SUM_POINTS_DEFERRED INTEGER DEFAULT 0 NOT NULL;
ALTER TABLE RIDW.F_EXECRESPOINTS_METRICS ADD SUM_POINTS_TOTAL INTEGER DEFAULT 0 NOT NULL;
ALTER TABLE RIDW.F_EXECRESULT_DATE_METRICS ADD SUM_POINTS_DEFERRED INTEGER DEFAULT 0 NOT NULL;
ALTER TABLE RIDW.F_EXECRESULT_DATE_METRICS ADD SUM_POINTS_TOTAL INTEGER DEFAULT 0 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_AGING ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_AGING ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_AGING ADD CONSTRAINT F_REQ_AGD_FK11 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_CLOSURE_DATE_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_CLOSURE_DATE_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_CLOSURE_DATE_METRICS ADD CONSTRAINT F_REQCDT_FK12 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_CREATION_DT_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_CREATION_DT_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK17 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_CUST_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_CUST_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_CUST_METRICS ADD CONSTRAINT F_REQCUST_MET_FK22 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_FAILURE_DT_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_FAILURE_DT_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_FAILURE_DT_METRICS ADD CONSTRAINT F_REQFAIL_DTM_FK6 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_FAILURE_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_FAILURE_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_FAILURE_METRICS ADD CONSTRAINT F_REQFL_FK6 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK20 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_REQUI_FAILDT_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_REQUI_FAILDT_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_REQUI_FAILDT_METRICS ADD CONSTRAINT F_REQREQUI_FDT_FK7 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_REQUI_FAIL_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_REQUI_FAIL_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_REQUI_FAIL_METRICS ADD CONSTRAINT F_RQRUF_MET_FK8 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_REQUI_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_REQUI_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_REQUI_METRICS ADD CONSTRAINT F_RRUI_MET_FK23 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_RESOLUTIO_DT_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_RESOLUTIO_DT_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK17 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_RES_REQUI_DT_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_RES_REQUI_DT_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_RES_REQUI_DT_METRICS ADD CONSTRAINT F_RRERD_MET_FK21 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_RES_TPLN_DT_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_RES_TPLN_DT_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_RES_TPLN_DT_METRICS ADD CONSTRAINT F_RRETD_MET_FK21 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_TPLN_AGING ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_TPLN_AGING ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_TPLN_AGING ADD CONSTRAINT F_REQTPLN_AG_FK18 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_TPLN_FAILDT_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_TPLN_FAILDT_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_TPLN_FAILDT_METRICS ADD CONSTRAINT F_REQTPLN_FDT_FK7 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_TPLN_FAIL_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_TPLN_FAIL_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_TPLN_FAIL_METRICS ADD CONSTRAINT F_RPLF_MET_FK8 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_TPLN_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_TPLN_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_TPLN_METRICS ADD CONSTRAINT F_REQTPLN_MET_FK23 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_TPLN_TURNAROUND ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_TPLN_TURNAROUND ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_TPLN_TURNAROUND ADD CONSTRAINT F_RQTPT_FK10 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUEST_TURNAROUND ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUEST_TURNAROUND ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUEST_TURNAROUND ADD CONSTRAINT F_REQTURN_FK11 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUE_CLOSE_REQUI_DT_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUE_CLOSE_REQUI_DT_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUE_CLOSE_REQUI_DT_METRICS ADD CONSTRAINT F_RCRDT_MET_FK12 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQUE_CLOSE_TPLN_DT_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQUE_CLOSE_TPLN_DT_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQUE_CLOSE_TPLN_DT_METRICS ADD CONSTRAINT F_RCTD_MET_FK12 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQU_CREATI_REQUI_DT_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQU_CREATI_REQUI_DT_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQU_CREATI_REQUI_DT_METRICS ADD CONSTRAINT F_RRDT_MET_FK21 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
ALTER TABLE RIDW.F_REQU_CREATI_TPLN_DT_METRICS ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RIDW.F_REQU_CREATI_TPLN_DT_METRICS ALTER COLUMN CREATOR_ID DROP DEFAULT;
ALTER TABLE RIDW.F_REQU_CREATI_TPLN_DT_METRICS ADD CONSTRAINT F_RCRTD_MET_FK21 FOREIGN KEY (CREATOR_ID) REFERENCES RIDW.D_RESOURCE(RESOURCE_ID);
DROP VIEW RIDW.VW_ITERATION;
CREATE VIEW RIDW.VW_ITERATION (ITERATION_ID, NAME, REFERENCE_ID, EXTERNAL_ID, ASSETREGISTRY_ID,ASSETREGISTRY_NAME,PROJECT_ID, PROJECT_NAME,PHASE_ID, PHASE_NAME,OWNER_ID,OWNER_NAME,STATUS, DESCRIPTION, START_DATE, END_DATE, EXPECTED_START_DATE, EXPECTED_END_DATE,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,EXPECTED_TOTAL_POINTS,EXPECTED_DEFECTS,EXPECTED_VALIDITY_RATE,REC_DATETIME,ISSOFTDELETED) AS (SELECT I.ITERATION_ID, I.NAME, I.REFERENCE_ID, I.EXTERNAL_ID, I.ASSETREGISTRY_ID,A.NAME,I.PROJECT_ID, P.NAME AS PROJECT_NAME,I.PHASE_ID,PH.NAME,I.OWNER_ID,R.FULL_NAME AS OWNER_NAME,I.STATUS,I.DESCRIPTION,I.START_DATE, I.END_DATE , I.EXPECTED_START_DATE, I.EXPECTED_END_DATE,I.URL,I.EXTERNAL_KEY1,I.EXTERNAL_KEY2, I.EXPECTED_TOTAL_POINTS,I.EXPECTED_DEFECTS,I.EXPECTED_VALIDITY_RATE,I.REC_DATETIME,I.ISSOFTDELETED FROM RIODS.ITERATION I JOIN RIODS.PROJECT P ON P.PROJECT_ID=I.PROJECT_ID JOIN RIODS.PHASE PH ON PH.PHASE_ID=I.PHASE_ID JOIN RIODS.RESOURCE R ON R.RESOURCE_ID=I.OWNER_ID JOIN RIODS.ASSETREGISTRY A ON A.ASSETREGISTRY_ID=I.ASSETREGISTRY_ID);
GRANT SELECT ON RIDW.VW_ITERATION TO REPUSER;
DROP VIEW RIDW.VW_REQUEST;
CREATE VIEW RIDW.VW_REQUEST (ACTIVATE_DATE, ASSIGNED_DATE, CLOSED_DATE, COMPONENT_ID, COMPONENT_NAME, CREATION_DATE, CUSTOMER_PRIORITY, DUPLICATE_DATE, EXTERNAL_ID, FIXEDINRELEASE_ID, FIXED_IN_RELEASE_NAME, IS_BLOCKING, ITERATION_ID, ITERATION_NAME, TEAM_ID, TEAM_NAME, PLANNED_WORK, ACTUAL_WORK, COMMENT_COUNT, SUBSCRIBER_COUNT, STORY_POINTS, TAGS, NAME, PLATFORM, REQUEST_PRIORITY_ID,REQUEST_PRIORITY,REQUEST_PRIORITY_EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, REFERENCE_ID, RELEASE_ID, FOUND_IN_RELEASE_NAME, REQUEST_CLASS_ID, REQUEST_CLASS, REQUEST_ID, OWNER_ID, REQUEST_RESPONSIBLE, REQUEST_SOURCE, REQUEST_STATE_ID,REQUEST_STATE,REQUEST_STATE_EXTERNAL_ID, REQUEST_RESOLUTION_ID,REQUEST_RESOLUTION, REQUEST_RESOLUTION_EXTERNAL_ID,RESOLVED_DATE, REQUEST_SEVERITY_ID, REQUEST_SEVERITY,REQUEST_SEVERITY_EXTERNAL_ID,SLOC_CHANGE, REQUEST_STATUS_ID, REQUEST_STATUS,REQUEST_STATUS_EXTERNAL_ID,SUBMIT_DATE, URL, DUE_DATE,CREATOR_ID,CREATOR_NAME,BUILD_ID,BUILD_NAME,PHASE_ID,PHASE_NAME,PROJECT_CATEGORY_ID, PROJECT_CATEGORY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,REQUEST_TYPE_ID,REQUEST_TYPE,REQUEST_TYPE_EXTERNAL_ID,REQUEST_CATEGORY_ID,REQUEST_CATEGORY_NAME,RESOLVER_ID,RESOLVER_NAME,SUMMARY,REC_DATETIME,ISSOFTDELETED) AS (SELECT R.ACTIVATE_DATE, R.ASSIGNED_DATE, R.CLOSED_DATE, R.COMPONENT_ID,C.NAME AS COMPONENT_NAME, R.CREATION_DATE, R.CUSTOMER_PRIORITY, R.DUPLICATE_DATE, R.EXTERNAL_ID, R.FIXEDINRELEASE_ID,RL.NAME AS FIXED_IN_RELEASE_NAME, R.IS_BLOCKING, R.ITERATION_ID,I.NAME AS ITERATION_NAME, R.TEAM_ID, T.NAME AS TEAM_NAME, R.PLANNED_WORK, R.ACTUAL_WORK, R.COMMENT_COUNT, R.SUBSCRIBER_COUNT, R.STORY_POINTS, R.TAGS, R.NAME, R.PLATFORM, R.REQUEST_PRIORITY_ID,RP.NAME AS REQUEST_PRIORITY, RP.EXTERNAL_ID AS REQUEST_PRIORITY_EXTERNAL_ID,R.PROJECT_ID, PJ.NAME AS PROJECT_NAME,R.REFERENCE_ID, R.RELEASE_ID, RL2.NAME AS FOUND_IN_RELEASE_NAME, R.REQUEST_CLASS_ID,RQ.NAME AS REQUEST_CLASS, R.REQUEST_ID, R.OWNER_ID,PS.FULL_NAME AS REQUEST_RESPONSIBLE, R.REQUEST_SOURCE, R.REQUEST_STATE_ID, RST.NAME AS REQUEST_STATE,RST.EXTERNAL_ID AS REQUEST_STATE_EXTERNAL_ID,R.REQUEST_RESOLUTION_ID,RRES.NAME AS REQUEST_RESOLUTION, RRES.EXTERNAL_ID AS REQUEST_RESOLUTION_EXTERNAL_ID,R.RESOLVED_DATE, R.REQUEST_SEVERITY_ID, RSEV.NAME AS REQUEST_SEVERITY, RSEV.EXTERNAL_ID AS REQUEST_SEVERITY_EXTERNAL_ID,R.SLOC_CHANGE, R.REQUEST_STATUS_ID,RSTU.NAME AS REQUEST_STATUS,RSTU.EXTERNAL_ID AS  REQUEST_STATUS_EXTERNAL_ID,R.SUBMIT_DATE, R.URL, R.DUE_DATE,R.CREATOR_ID,RES.FULL_NAME AS CREATOR_NAME,R.BUILD_ID,B.NAME AS BUILD_NAME,R.PHASE_ID,PH.NAME AS PHASE_NAME,R.PROJECT_CATEGORY_ID,PC.NAME AS PROJECT_CATEGORY_NAME,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.REQUEST_TYPE_ID,RT.NAME REQUEST_TYPE,RT.EXTERNAL_ID AS REQUEST_TYPE_EXTERNAL_ID,R.REQUEST_CATEGORY_ID,RC.NAME AS REQUEST_CATEGORY_NAME,R.RESOLVER_ID,RS.FULL_NAME AS RESOLVER_NAME,R.SUMMARY,R.REC_DATETIME,R.ISSOFTDELETED FROM RIODS.REQUEST R JOIN RIODS.ITERATION I ON I.ITERATION_ID=R.ITERATION_ID JOIN RIODS.TEAM T ON T.TEAM_ID=R.TEAM_ID JOIN RIODS.PROJECT PJ ON PJ.PROJECT_ID=R.PROJECT_ID JOIN RIODS.COMPONENT C ON C.COMPONENT_ID=R.COMPONENT_ID JOIN RIODS.RELEASE RL ON RL.RELEASE_ID=R.FIXEDINRELEASE_ID JOIN RIODS.RELEASE RL2 ON RL2.RELEASE_ID=R.RELEASE_ID JOIN RIODS.REQUEST_CLASSIFICATION RQ ON RQ.REQUEST_CLASS_ID=R.REQUEST_CLASS_ID JOIN RIODS.REQUEST_CATEGORY RC ON RC.REQUEST_CATEGORY_ID=R.REQUEST_CATEGORY_ID JOIN RIODS.BUILD B ON B.BUILD_ID=R.BUILD_ID JOIN RIODS.PHASE PH ON PH.PHASE_ID=R.PHASE_ID JOIN RIODS.PROJECT_CATEGORY PC ON PC.PROJECT_CATEGORY_ID=R.PROJECT_CATEGORY_ID JOIN RIODS.RESOURCE PS ON PS.RESOURCE_ID=R.OWNER_ID JOIN RIODS.RESOURCE RS ON RS.RESOURCE_ID=R.RESOLVER_ID JOIN RIODS.RESOURCE RES ON RES.RESOURCE_ID=R.CREATOR_ID JOIN RIODS.REQUEST_STATE RST ON RST.REQUEST_STATE_ID=R.REQUEST_STATE_ID JOIN RIODS.REQUEST_STATUS RSTU ON RSTU.REQUEST_STATUS_ID=R.REQUEST_STATUS_ID JOIN RIODS.REQUEST_PRIORITY RP ON RP.REQUEST_PRIORITY_ID=R.REQUEST_PRIORITY_ID JOIN RIODS.REQUEST_RESOLUTION RRES ON RRES.REQUEST_RESOLUTION_ID=R.REQUEST_RESOLUTION_ID JOIN RIODS.REQUEST_SEVERITY RSEV ON RSEV.REQUEST_SEVERITY_ID=R.REQUEST_SEVERITY_ID JOIN RIODS.REQUEST_TYPE RT ON RT.REQUEST_TYPE_ID=R.REQUEST_TYPE_ID);
GRANT SELECT ON RIDW.VW_REQUEST TO REPUSER;
DROP VIEW RIDW.VW_REQUICOL_TESTPLAN_LOOKUP;
CREATE VIEW RIDW.VW_REQUICOL_TESTPLAN_LOOKUP (REQUIREMENT_COLLECTION_ID, REQUIREMENT_COLLECTION_NAME, TESTPLAN_ID, TESTPLAN_NAME, LINK_TYPE) AS (SELECT RT.REQUIREMENT_COLLECTION_ID, RC.NAME AS REQUIREMENT_COLLECTION_NAME, RT.TESTPLAN_ID, T.NAME AS TESTPLAN_NAME, RT.LINK_TYPE FROM RIODS.REQUICOL_TESTPLAN_LOOKUP RT JOIN RIODS.REQUIREMENT_COLLECTION RC ON RC.REQUIREMENT_COLLECTION_ID=RT.REQUIREMENT_COLLECTION_ID JOIN RIODS.TESTPLAN T ON T.TESTPLAN_ID=RT.TESTPLAN_ID);
GRANT SELECT ON RIDW.VW_REQUICOL_TESTPLAN_LOOKUP TO REPUSER;
DROP VIEW RIDW.VW_EXECUTION_RESULT;
CREATE VIEW RIDW.VW_EXECUTION_RESULT (EXECUTION_RESULT_ID, EXECRES_CLASS_ID, EXECRES_CLASS_NAME, NAME, REFERENCE_ID, EXTERNAL_ID, VERDICT, OWNER_ID, OWNER_NAME, BUILD_ID, BUILD_NAME, ITERATION_ID, ITERATION_NAME, TESTTYPE_ID, TESTTYPE_NAME, TESCASE_ID, TESTCASE_NAME, PROJECT_ID, PROJECT_NAME, TESTSCRIPT_ID, TESTSCRIPT_NAME, START_DATE, END_DATE, POINTS_BLOCKED, POINTS_INCONCLUSIVE, MACHINE, POINTS_ATTEMPTED, POINTS_FAILED, POINTS_PASSED, POINTS_PERMFAILED, LAST_UPDATED, CREATION_DATE, SUITE_INDEX, URL, POINTS_DEFERRED, POINTS_TOTAL, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, REC_DATETIME, ISSOFTDELETED) AS (SELECT EX.EXECUTION_RESULT_ID, EX.EXECRES_CLASS_ID, EC.NAME AS EXECRES_CLASS_NAME, EX.NAME, EX.REFERENCE_ID, EX.EXTERNAL_ID, EX.VERDICT, EX.OWNER_ID, R.NAME AS OWNER_NAME, EX.BUILD_ID, B.NAME AS BUILD_NAME, EX.ITERATION_ID, I.NAME AS ITERATION_NAME, EX.TESTTYPE_ID, T.NAME AS TESTTYPE_NAME, EX.TESTCASE_ID, T1.NAME AS TESTCASE_NAME, EX.PROJECT_ID, P.NAME AS PROJECT_NAME, EX.TESTSCRIPT_ID, T2.NAME AS TESTSCRIPT_NAME, EX.START_DATE, EX.END_DATE, EX.POINTS_BLOCKED, EX.POINTS_INCONCLUSIVE, EX.MACHINE, EX.POINTS_ATTEMPTED, EX.POINTS_FAILED, EX.POINTS_PASSED, EX.POINTS_PERMFAILED, EX.LAST_UPDATED, EX.CREATION_DATE, EX.SUITE_INDEX, EX.URL,EX.POINTS_DEFERRED,EX.POINTS_TOTAL,EX.EXTERNAL_KEY1, EX.EXTERNAL_KEY2, EX.SOURCE_ID, EX.REC_DATETIME, EX.ISSOFTDELETED FROM RIODS.EXECUTION_RESULT EX JOIN RIODS.BUILD B ON B.BUILD_ID = EX.BUILD_ID JOIN RIODS.EXECRESULT_CLASSIFICATION EC ON EC.EXECRES_CLASS_ID = EX.EXECRES_CLASS_ID JOIN RIODS.ITERATION I ON I.ITERATION_ID = EX.ITERATION_ID JOIN RIODS.PROJECT P ON P.PROJECT_ID = EX.PROJECT_ID JOIN RIODS.RESOURCE R ON R.RESOURCE_ID = EX.OWNER_ID JOIN RIODS.TESTTYPE T ON T.TESTTYPE_ID = EX.TESTTYPE_ID JOIN RIODS.TESTCASE T1 ON T1.TESTCASE_ID = EX.TESTCASE_ID JOIN RIODS.TESTSCRIPT T2 ON T2.TESTSCRIPT_ID = EX.TESTSCRIPT_ID);
GRANT SELECT ON RIDW.VW_EXECUTION_RESULT TO REPUSER;
DROP VIEW RIDW.VW_REQUIREMENT_REQUEST_LOOKUP;
CREATE VIEW RIDW.VW_REQUIREMENT_REQUEST_LOOKUP (REQUEST_ID, REQUEST_NAME, REQUIREMENT_ID, REQUIREMENT_NAME, LINK_TYPE) AS ( SELECT RC.REQUEST_ID, C.NAME AS REQUEST_NAME, RC.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME, RC.LINK_TYPE FROM  RIODS.REQUIREMENT_REQUEST_LOOKUP RC JOIN RIODS.REQUIREMENT R ON R.REQUIREMENT_ID=RC.REQUIREMENT_ID JOIN RIODS.REQUEST C ON C.REQUEST_ID=RC.REQUEST_ID);
GRANT SELECT ON RIDW.VW_REQUIREMENT_REQUEST_LOOKUP TO REPUSER;
DROP VIEW RIDW.VW_REQUIREMENT_TESTCASE_LOOKUP;
CREATE VIEW RIDW.VW_REQUIREMENT_TESTCASE_LOOKUP (TESTCASE_ID, TESTCASE_NAME, REQUIREMENT_ID, REQUIREMENT_NAME, LINK_TYPE) AS ( SELECT RC.TESTCASE_ID, C.NAME AS TESTCASE_NAME, RC.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME, RC.LINK_TYPE FROM  RIODS.REQUIREMENT_TESTCASE_LOOKUP RC JOIN RIODS.REQUIREMENT R ON R.REQUIREMENT_ID=RC.REQUIREMENT_ID JOIN RIODS.TESTCASE C ON C.TESTCASE_ID=RC.TESTCASE_ID);
GRANT SELECT ON RIDW.VW_REQUIREMENT_TESTCASE_LOOKUP TO REPUSER;
DROP VIEW RIDW.VW_EXECRES_REQUEST_LOOKUP;
CREATE VIEW RIDW.VW_EXECRES_REQUEST_LOOKUP (REQUEST_ID, REQUEST_NAME, EXECUTION_RESULT_ID, EXECUTION_RESULT_VERDICT, LINK_TYPE) AS (SELECT TR.REQUEST_ID, I.NAME AS REQUEST_NAME, TR.EXECUTION_RESULT_ID, T.VERDICT AS EXECUTION_RESULT_VERDICT, TR.LINK_TYPE FROM RIODS.EXECRES_REQUEST_LOOKUP TR JOIN RIODS.REQUEST I ON I.REQUEST_ID=TR.REQUEST_ID JOIN RIODS.EXECUTION_RESULT T ON T.EXECUTION_RESULT_ID=TR.EXECUTION_RESULT_ID);
GRANT SELECT ON RIDW.VW_EXECRES_REQUEST_LOOKUP TO REPUSER;
DROP VIEW RIDW.VW_REQUEST_CATEGORY;
CREATE VIEW RIDW.VW_REQUEST_CATEGORY (REQUEST_CATEGORY_ID, EXTERNAL_ID, REFERENCE_ID, NAME, PROJECT_ID,PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS (SELECT RC.REQUEST_CATEGORY_ID, RC.EXTERNAL_ID, RC.REFERENCE_ID, RC.NAME, RC.PROJECT_ID,P.NAME AS PROJECT_NAME,RC.URL,RC.EXTERNAL_KEY1,RC.EXTERNAL_KEY2,RC.REC_DATETIME,RC.ISSOFTDELETED FROM RIODS.REQUEST_CATEGORY RC JOIN RIODS.PROJECT P ON P.PROJECT_ID=RC.PROJECT_ID);
GRANT SELECT ON RIDW.VW_REQUEST_CATEGORY TO REPUSER;
DROP VIEW RIDW.VW_TESTSCRIPT;
CREATE VIEW RIDW.VW_TESTSCRIPT (TESTSCRIPT_ID, REFERENCE_ID, EXTERNAL_ID, NAME, LAST_UPDATED, TESTSCRIPT_STATE, TYPE, OWNER_ID, OWNER_NAME, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, URL, REC_DATETIME, ISSOFTDELETED) AS (SELECT TEST.TESTSCRIPT_ID, TEST.REFERENCE_ID, TEST.EXTERNAL_ID, TEST.NAME, TEST.LAST_UPDATED, TEST.TESTSCRIPT_STATE, TEST.TYPE, TEST.OWNER_ID, R.NAME AS OWNER_NAME, TEST.EXTERNAL_KEY1, TEST.EXTERNAL_KEY2, TEST.SOURCE_ID, TEST.URL, TEST.REC_DATETIME, TEST.ISSOFTDELETED FROM RIODS.TESTSCRIPT TEST JOIN RIODS.RESOURCE R ON R.RESOURCE_ID = TEST.OWNER_ID);
GRANT SELECT ON RIDW.VW_TESTSCRIPT TO REPUSER;
DROP VIEW RIDW.VW_REQUEST_TESTCASE_LOOKUP;
CREATE VIEW RIDW.VW_REQUEST_TESTCASE_LOOKUP (REQUEST_ID, REQUEST_NAME, TESTCASE_ID, TESTCASE_NAME, LINK_TYPE) AS (SELECT RT.REQUEST_ID, R.NAME AS REQUEST_NAME,RT.TESTCASE_ID, TC.NAME AS TESTCASE_NAME, RT.LINK_TYPE FROM RIODS.REQUEST_TESTCASE_LOOKUP RT JOIN RIODS.REQUEST R ON R.REQUEST_ID =RT.REQUEST_ID JOIN RIODS.TESTCASE TC ON TC.TESTCASE_ID=RT.TESTCASE_ID);
GRANT SELECT ON RIDW.VW_REQUEST_TESTCASE_LOOKUP TO REPUSER;
DROP VIEW RIDW.VW_EXECWORKITEM_REQUEST_LOOKUP;
CREATE VIEW RIDW.VW_EXECWORKITEM_REQUEST_LOOKUP (EXECWORKITEM_ID, EXECUTION_WORKITEM_NAME, REQUEST_ID, REQUEST_NAME, LINK_TYPE) AS (SELECT  CI.EXECWORKITEM_ID, C.NAME AS EXECUTION_WORKITEM_NAME, CI.REQUEST_ID, I.NAME AS REQUEST_NAME, CI.LINK_TYPE FROM RIODS.EXECWORKITEM_REQUEST_LOOKUP CI JOIN RIODS.EXECUTION_WORKITEM C ON C.EXECWORKITEM_ID=CI.EXECWORKITEM_ID JOIN RIODS.REQUEST I ON I.REQUEST_ID=CI.REQUEST_ID);
GRANT SELECT ON RIDW.VW_EXECWORKITEM_REQUEST_LOOKUP TO REPUSER;
DROP VIEW RIDW.VW_EXECSTEPRES_REQUEST_LOOKUP;
CREATE VIEW RIDW.VW_EXECSTEPRES_REQUEST_LOOKUP (EXECUTION_STEP_RESULT_ID, EXECUTION_STEP_RESULT_NAME, REQUEST_ID, REQUEST_NAME, LINK_TYPE) AS (SELECT  CI.EXECUTION_STEP_RESULT_ID, C.NAME AS EXECUTION_STEP_RESULT_NAME, CI.REQUEST_ID, I.NAME AS REQUEST_NAME, CI.LINK_TYPE FROM RIODS.EXECSTEPRES_REQUEST_LOOKUP CI JOIN RIODS.EXECUTION_STEP_RESULT C ON C.EXECUTION_STEP_RESULT_ID=CI.EXECUTION_STEP_RESULT_ID JOIN RIODS.REQUEST I ON I.REQUEST_ID=CI.REQUEST_ID);
GRANT SELECT ON RIDW.VW_EXECSTEPRES_REQUEST_LOOKUP TO REPUSER;
DROP VIEW RIDW.VW_REQUEST_RELATIONAL_LINK;
CREATE VIEW RIDW.VW_REQUEST_RELATIONAL_LINK (REQUEST_RELATION_ID, NAME, REFERENCE_ID, EXTERNAL_ID, REQUEST1_ID, REQUEST1_NAME, REQUEST2_ID, REQUEST2_NAME, URL, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, REC_DATETIME, ISSOFTDELETED) AS (SELECT REQU.REQUEST_RELATION_ID, REQU.NAME, REQU.REFERENCE_ID, REQU.EXTERNAL_ID, REQU.REQUEST1_ID, R.NAME AS REQUEST1_NAME, REQU.REQUEST2_ID, R1.NAME AS REQUEST2_NAME, REQU.URL, REQU.EXTERNAL_KEY1, REQU.EXTERNAL_KEY2, REQU.SOURCE_ID, REQU.REC_DATETIME, REQU.ISSOFTDELETED FROM RIODS.REQUEST_RELATIONAL_LINK REQU JOIN RIODS.REQUEST R ON R.REQUEST_ID = REQU.REQUEST1_ID JOIN RIODS.REQUEST R1 ON R1.REQUEST_ID = REQU.REQUEST2_ID);
GRANT SELECT ON RIDW.VW_REQUEST_RELATIONAL_LINK TO REPUSER;
CREATE VIEW RIDW.VW_TESTSCRIPT_CATEGORY_LOOKUP (TESTSCRIPT_ID, TESTSCRIPT_NAME, TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS (SELECT TEST.TESTSCRIPT_ID, T.NAME AS TESTSCRIPT_NAME, TEST.TEST_CATEGORY_ID, TC.NAME AS TEST_CATEGORY_NAME FROM RIODS.TESTSCRIPT_CATEGORY_LOOKUP TEST JOIN RIODS.TESTSCRIPT T ON T.TESTSCRIPT_ID = TEST.TESTSCRIPT_ID JOIN RIODS.TEST_CATEGORY TC ON TC.TEST_CATEGORY_ID = TEST.TEST_CATEGORY_ID);
GRANT SELECT ON RIDW.VW_TESTSCRIPT_CATEGORY_LOOKUP TO REPUSER;
CREATE VIEW RIDW.VW_EXECWI_CATEGORY_LOOKUP (EXECWORKITEM_ID, EXECWORKITEM_NAME, TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS (SELECT EX.EXECWORKITEM_ID, EW.NAME AS EXECWORKITEM_NAME, EX.TEST_CATEGORY_ID, TC.NAME AS TEST_CATEGORY_NAME FROM RIODS.EXECWORKITEM_CATEGORY_LOOKUP EX JOIN RIODS.EXECUTION_WORKITEM EW ON EW.EXECWORKITEM_ID = EX.EXECWORKITEM_ID JOIN RIODS.TEST_CATEGORY TC ON TC.TEST_CATEGORY_ID = EX.TEST_CATEGORY_ID);
GRANT SELECT ON RIDW.VW_EXECWI_CATEGORY_LOOKUP TO REPUSER;
CREATE VIEW RIDW.VW_TSTSUITER_CATEGORY_LOOKUP (TESTSUITE_EXECRECORD_ID, TESTSUITE_EXECRECORD_NAME, TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS (SELECT TSTS.TESTSUITE_EXECRECORD_ID, TE.NAME AS TESTSUITE_EXECRECORD_NAME, TSTS.TEST_CATEGORY_ID, TC.NAME AS TEST_CATEGORY_NAME FROM RIODS.TSTSUITEXECREC_CATEGORY_LOOKUP TSTS JOIN RIODS.TEST_CATEGORY TC ON TC.TEST_CATEGORY_ID = TSTS.TEST_CATEGORY_ID JOIN RIODS.TESTSUITE_EXECUTION_RECORD TE ON TE.TESTSUITE_EXECRECORD_ID = TSTS.TESTSUITE_EXECRECORD_ID);
GRANT SELECT ON RIDW.VW_TSTSUITER_CATEGORY_LOOKUP TO REPUSER;
CREATE VIEW RIDW.VW_EXECRESULT_CATEGORY_LOOKUP (EXECUTION_RESULT_ID, EXECUTION_RESULT_NAME, TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS (SELECT EX.EXECUTION_RESULT_ID, ER.NAME AS EXECUTION_RESULT_NAME, EX.TEST_CATEGORY_ID, TC.NAME AS TEST_CATEGORY_NAME FROM RIODS.EXECRESULT_CATEGORY_LOOKUP EX JOIN RIODS.EXECUTION_RESULT ER ON ER.EXECUTION_RESULT_ID = EX.EXECUTION_RESULT_ID JOIN RIODS.TEST_CATEGORY TC ON TC.TEST_CATEGORY_ID = EX.TEST_CATEGORY_ID);
GRANT SELECT ON RIDW.VW_EXECRESULT_CATEGORY_LOOKUP TO REPUSER;
CREATE VIEW RIDW.VW_TESTSTLOG_CATEGORY_LOOKUP (TESTSUITELOG_ID, TESTSUITELOG_NAME, TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS (SELECT TEST.TESTSUITELOG_ID, T.NAME AS TESTSUITELOG_NAME, TEST.TEST_CATEGORY_ID, TC.NAME AS TEST_CATEGORY_NAME FROM RIODS.TESTSUITELOG_CATEGORY_LOOKUP TEST JOIN RIODS.TESTSUITELOG T ON T.TESTSUITELOG_ID = TEST.TESTSUITELOG_ID JOIN RIODS.TEST_CATEGORY TC ON TC.TEST_CATEGORY_ID = TEST.TEST_CATEGORY_ID);
GRANT SELECT ON RIDW.VW_TESTSTLOG_CATEGORY_LOOKUP TO REPUSER;
CREATE VIEW RIDW.VW_REQUEST_TESTPLAN_LOOKUP (REQUEST_ID, REQUEST_NAME, TESTPLAN_ID, TESTPLAN_NAME, LINK_TYPE) AS (SELECT REQU.REQUEST_ID, R.NAME AS REQUEST_NAME, REQU.TESTPLAN_ID, T.NAME AS TESTPLAN_NAME, REQU.LINK_TYPE FROM RIODS.REQUEST_TESTPLAN_LOOKUP REQU JOIN RIODS.REQUEST R ON R.REQUEST_ID = REQU.REQUEST_ID JOIN RIODS.TESTPLAN T ON T.TESTPLAN_ID = REQU.TESTPLAN_ID);
GRANT SELECT ON RIDW.VW_REQUEST_TESTPLAN_LOOKUP TO REPUSER;
CREATE VIEW RIDW.VW_REQUEST_TESTSCRIPT_LOOKUP (REQUEST_ID, REQUEST_NAME, TESTSCRIPT_ID, TESTSCRIPT_NAME, LINK_TYPE) AS (SELECT REQU.REQUEST_ID, R.NAME AS REQUEST_NAME, REQU.TESTSCRIPT_ID, T.NAME AS TESTSCRIPT_NAME, REQU.LINK_TYPE FROM RIODS.REQUEST_TESTSCRIPT_LOOKUP REQU JOIN RIODS.REQUEST R ON R.REQUEST_ID = REQU.REQUEST_ID JOIN RIODS.TESTSCRIPT T ON T.TESTSCRIPT_ID = REQU.TESTSCRIPT_ID);
GRANT SELECT ON RIDW.VW_REQUEST_TESTSCRIPT_LOOKUP TO REPUSER;
CREATE VIEW RIDW.VW_REQUEST_TESTSUITE_LOOKUP (REQUEST_ID, REQUEST_NAME, TESTSUITE_ID, TESTSUITE_NAME, LINK_TYPE) AS (SELECT REQU.REQUEST_ID, R.NAME AS REQUEST_NAME, REQU.TESTSUITE_ID, T.NAME AS TESTSUITE_NAME, REQU.LINK_TYPE FROM RIODS.REQUEST_TESTSUITE_LOOKUP REQU JOIN RIODS.REQUEST R ON R.REQUEST_ID = REQU.REQUEST_ID JOIN RIODS.TESTSUITE T ON T.TESTSUITE_ID = REQU.TESTSUITE_ID);
GRANT SELECT ON RIDW.VW_REQUEST_TESTSUITE_LOOKUP TO REPUSER;
CREATE VIEW RIDW.VW_REQUEST_TYPE_BINDING (REQUEST_TYPE_BINDING_ID, NAME, REFERENCE_ID, EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, REQUEST_TYPE_ID, REQUEST_TYPE_NAME, URL, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, REC_DATETIME, ISSOFTDELETED) AS (SELECT RT.REQUEST_TYPE_BINDING_ID, RT.NAME, RT.REFERENCE_ID, RT.EXTERNAL_ID, RT.PROJECT_ID, P.NAME AS PROJECT_NAME, RT.REQUEST_TYPE_ID, R.NAME AS REQUEST_TYPE_NAME, RT.URL, RT.EXTERNAL_KEY1, RT.EXTERNAL_KEY2, RT.SOURCE_ID, RT.REC_DATETIME, RT.ISSOFTDELETED FROM RIODS.REQUEST_TYPE_BINDING RT JOIN RIODS.PROJECT P ON P.PROJECT_ID = RT.PROJECT_ID JOIN RIODS.REQUEST_TYPE R ON R.REQUEST_TYPE_ID = RT.REQUEST_TYPE_ID);
GRANT SELECT ON RIDW.VW_REQUEST_TYPE_BINDING TO REPUSER;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
UPDATE CONFIG.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0' WHERE INFO_ID=6;
UPDATE CONFIG.SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8;