SET CURRENT SCHEMA $CONFIG_SCHEMA;

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=6);

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=7);

UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.1' WHERE INFO_ID=7;

INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=8);
INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,7 AS INT_VALUE,'2.0.1 RC1' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=18);

ALTER TABLE $NF_SCHEMA.REQUIREMENT_COLLECTION ADD COLUMN URL VARCHAR(2048);

DROP VIEW $STAR_SCHEMA.VW_REQUIREMENT_COLLECTION;

CREATE VIEW $STAR_SCHEMA.VW_REQUIREMENT_COLLECTION (REQUIREMENT_COLLECTION_ID, NAME,REFERENCE_ID,EXTERNAL_ID, PROJECT_ID, PROJECT_NAME,  RELEASE_ID, RELEASE_NAME, PLANNED_ITERATION_ID, PLANNED_ITERATION_NAME,
 ACTUAL_ITERATION_ID, ACTUAL_ITERATION_NAME, STATUS, COLLECTION_ORIGIN, COLLECTION_TYPE, COLLECTION_IMPACT, COLLECTION_TARGET,
 CREATION_DATE, URL, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, REC_DATETIME, ISSOFTDELETED) AS
 (SELECT RC.REQUIREMENT_COLLECTION_ID, RC.NAME, RC.REFERENCE_ID,RC.EXTERNAL_ID,RC.PROJECT_ID, PJ.NAME AS PROJECT_NAME,  RC.RELEASE_ID, RL.NAME AS RELEASE_NAME, RC.PLANNED_ITERATION_ID, PL.NAME AS PLANNED_ITERATION_NAME,
 RC.ACTUAL_ITERATION_ID, AC.NAME AS ACTUAL_ITERATION_NAME, RC.STATUS, RC.COLLECTION_ORIGIN, RC.COLLECTION_TYPE, RC.COLLECTION_IMPACT, RC.COLLECTION_TARGET,
 RC.CREATION_DATE, RC.URL, RC.EXTERNAL_KEY1, RC.EXTERNAL_KEY2, RC.SOURCE_ID, RC.REC_DATETIME, RC.ISSOFTDELETED
	FROM $NF_SCHEMA.REQUIREMENT_COLLECTION RC
  JOIN $NF_SCHEMA.PROJECT PJ ON PJ.PROJECT_ID=RC.PROJECT_ID
  JOIN $NF_SCHEMA.RELEASE RL ON RL.RELEASE_ID=RC.RELEASE_ID
  JOIN $NF_SCHEMA.ITERATION AC ON AC.ITERATION_ID=RC.ACTUAL_ITERATION_ID
  JOIN $NF_SCHEMA.ITERATION PL ON PL.ITERATION_ID=RC.PLANNED_ITERATION_ID);

GRANT SELECT ON $STAR_SCHEMA.VW_REQUIREMENT_COLLECTION TO REPUSER;

CREATE TABLE $NF_SCHEMA.TEST_PRIORITY (TEST_PRIORITY_ID INTEGER NOT NULL,NAME VARCHAR(255) DEFAULT 'Test Priority Name Missing' NOT NULL,REFERENCE_ID VARCHAR(50),EXTERNAL_ID VARCHAR(100),PROJECT_ID INTEGER DEFAULT -1 NOT NULL,URL VARCHAR(2048),EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,SOURCE_ID VARCHAR (36) DEFAULT '-1' NOT NULL,REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL,ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL);
CREATE INDEX $NF_SCHEMA.TSTPRIORI_IDX1 ON $NF_SCHEMA.TEST_PRIORITY (EXTERNAL_KEY1);
CREATE INDEX $NF_SCHEMA.TSTPRIORI_IDX2 ON $NF_SCHEMA.TEST_PRIORITY (EXTERNAL_KEY2);
CREATE INDEX $NF_SCHEMA.TSTPRIORI_IDX3 ON $NF_SCHEMA.TEST_PRIORITY (EXTERNAL_KEY1,SOURCE_ID);
CREATE INDEX $NF_SCHEMA.TSTPRIORI_IDX4 ON $NF_SCHEMA.TEST_PRIORITY (EXTERNAL_KEY2,SOURCE_ID);
CREATE INDEX $NF_SCHEMA.TSTPRIORI_IDX5 ON $NF_SCHEMA.TEST_PRIORITY (EXTERNAL_ID);
CREATE INDEX $NF_SCHEMA.TSTPRIORI_IDX6 ON $NF_SCHEMA.TEST_PRIORITY (ISSOFTDELETED);
ALTER TABLE $NF_SCHEMA.TEST_PRIORITY ADD CONSTRAINT TSTPRIORITY_PK PRIMARY KEY (TEST_PRIORITY_ID);
ALTER TABLE $NF_SCHEMA.TEST_PRIORITY ADD CONSTRAINT TSTPRIORITY_FK1 FOREIGN KEY (PROJECT_ID) REFERENCES $NF_SCHEMA.PROJECT (PROJECT_ID);
INSERT INTO $NF_SCHEMA.TEST_PRIORITY (TEST_PRIORITY_ID,NAME) VALUES(-1,'Info not available');

ALTER TABLE $NF_SCHEMA.TESTSUITE ADD COLUMN TEST_PRIORITY_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE $NF_SCHEMA.TESTSUITE ADD COLUMN ESTIMATE INTEGER;
ALTER TABLE $NF_SCHEMA.TESTSUITE ADD CONSTRAINT TESTSUITE_FK8 FOREIGN KEY (TEST_PRIORITY_ID) REFERENCES $NF_SCHEMA.TEST_PRIORITY (TEST_PRIORITY_ID);


ALTER TABLE $NF_SCHEMA.TESTPLAN ADD COLUMN TEST_PRIORITY_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE $NF_SCHEMA.TESTPLAN ADD COLUMN ESTIMATE INTEGER;
ALTER TABLE $NF_SCHEMA.TESTPLAN ADD CONSTRAINT TESTPLAN_FK6 FOREIGN KEY (TEST_PRIORITY_ID) REFERENCES $NF_SCHEMA.TEST_PRIORITY (TEST_PRIORITY_ID);


ALTER TABLE $NF_SCHEMA.TESTCASE ADD COLUMN TEST_PRIORITY_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE $NF_SCHEMA.TESTCASE ADD COLUMN ESTIMATE INTEGER;
ALTER TABLE $NF_SCHEMA.TESTCASE ADD COLUMN CREATION_DATE TIMESTAMP;
ALTER TABLE $NF_SCHEMA.TESTCASE ADD CONSTRAINT TESTCASE_FK7 FOREIGN KEY (TEST_PRIORITY_ID) REFERENCES $NF_SCHEMA.TEST_PRIORITY (TEST_PRIORITY_ID);


ALTER TABLE $NF_SCHEMA.EXECUTION_WORKITEM ADD COLUMN TEST_PRIORITY_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE $NF_SCHEMA.EXECUTION_WORKITEM ADD COLUMN ESTIMATE INTEGER;
ALTER TABLE $NF_SCHEMA.EXECUTION_WORKITEM ADD COLUMN TIMESPENT INTEGER;
ALTER TABLE $NF_SCHEMA.EXECUTION_WORKITEM ADD CONSTRAINT EXECWKI_FK11 FOREIGN KEY (TEST_PRIORITY_ID) REFERENCES $NF_SCHEMA.TEST_PRIORITY (TEST_PRIORITY_ID);



ALTER TABLE $NF_SCHEMA.TESTSUITELOG ADD COLUMN TOTAL_TESTCASE_COUNT INTEGER;
ALTER TABLE $NF_SCHEMA.TESTSUITELOG ADD COLUMN NOTSTARTED_TESTCASE_COUNT INTEGER;
ALTER TABLE $NF_SCHEMA.TESTSUITELOG ADD COLUMN POINTS_DEFERRED INTEGER;

ALTER TABLE $NF_SCHEMA.TESTSCRIPT ADD COLUMN CREATION_DATE TIMESTAMP;

ALTER TABLE $NF_SCHEMA.TESTSUITE_EXECUTION_RECORD ADD COLUMN TEST_PRIORITY_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE $NF_SCHEMA.TESTSUITE_EXECUTION_RECORD ADD COLUMN ESTIMATE INTEGER;
ALTER TABLE $NF_SCHEMA.TESTSUITE_EXECUTION_RECORD ADD COLUMN TIMESPENT INTEGER;
ALTER TABLE $NF_SCHEMA.TESTSUITE_EXECUTION_RECORD ADD CONSTRAINT TSEXECREC_FK9 FOREIGN KEY (TEST_PRIORITY_ID) REFERENCES $NF_SCHEMA.TEST_PRIORITY (TEST_PRIORITY_ID);


ALTER TABLE $NF_SCHEMA.TESTSUITE_ELEMENT ADD COLUMN OWNER_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE $NF_SCHEMA.TESTSUITE_ELEMENT ADD CONSTRAINT TSTSUITELE_FK5 FOREIGN KEY (OWNER_ID) REFERENCES $NF_SCHEMA.RESOURCE (RESOURCE_ID);

ALTER TABLE $NF_SCHEMA.EXECUTION_RESULT ADD COLUMN LAB_RESOURCE_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE $NF_SCHEMA.EXECUTION_RESULT ADD CONSTRAINT EXECRES_FK10 FOREIGN KEY (LAB_RESOURCE_ID)
	REFERENCES $NF_SCHEMA.LAB_RESOURCE (LAB_RESOURCE_ID);

DROP VIEW $STAR_SCHEMA.VW_TESTSUITELOG;
CREATE VIEW $STAR_SCHEMA.VW_TESTSUITELOG (BUILD_ID, TESTSUITELOG_NAME,END_DATE, EXTERNAL_ID, ITERATION_ID, ITERATION_NAME, REFERENCE_ID, START_DATE, TESTSUITELOG_ID, TESTSUITE_ID, TESTSUITE_NAME, URL, VERDICT,OWNER_ID, OWNER_NAME,TESTPLAN_ID,TESTPLAN_NAME,WEIGHT,POINTS_PASSED,POINTS_FAILED,POINTS_BLOCKED,POINTS_INCONCLUSIVE,POINTS_ATTEMPTED,POINTS_PERMFAILED,POINTS_DEFERRED,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTSUITELOG_CLASS_ID,TESTSUITELOG_CLASS_NAME,TESTSUITE_EXECRECORD_ID,TESTSUITE_EXECRECORD_NAME,REC_DATETIME,ISSOFTDELETED,
TESTSUITELOG_STATE,TESTSUITELOG_STATE_ID,TESTSUITELOG_STATE_EXTERNAL_ID,TESTSUITELG_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,TOTAL_TESTCASE_COUNT,NOTSTARTED_TESTCASE_COUNT) AS
 (SELECT S.BUILD_ID, S.NAME AS TESTSUITELOG_NAME, S.END_DATE, S.EXTERNAL_ID, S.ITERATION_ID,I.NAME AS ITERATION_NAME, S.REFERENCE_ID, S.START_DATE, S.TESTSUITELOG_ID, S.TESTSUITE_ID, T.NAME AS TESTSUITE_NAME, S.URL, S.VERDICT,S.OWNER_ID,R.FULL_NAME AS  OWNER_NAME ,S.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME,S.WEIGHT,S.POINTS_PASSED,S.POINTS_FAILED,S.POINTS_BLOCKED,S.POINTS_INCONCLUSIVE,S.POINTS_ATTEMPTED,S.POINTS_PERMFAILED,S.POINTS_DEFERRED,S.EXTERNAL_KEY1,S.EXTERNAL_KEY2,S.TESTSUITELOG_CLASS_ID,TL.NAME AS TESTSUITELOG_CLASS_NAME,S.TESTSUITE_EXECRECORD_ID,TEX.NAME AS TESTSUITE_EXECRECORD_NAME,S.REC_DATETIME,S.ISSOFTDELETED,
 TS.NAME AS TESTSUITELOG_STATE,S.TESTSUITELOG_STATE_ID,TS.EXTERNAL_ID AS TESTSUITELOG_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTSUITELG_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,S.TOTAL_TESTCASE_COUNT,S.NOTSTARTED_TESTCASE_COUNT
 FROM $NF_SCHEMA.TESTSUITELOG S
 JOIN $NF_SCHEMA.ITERATION I ON I.ITERATION_ID=S.ITERATION_ID
 JOIN $NF_SCHEMA.TESTSUITE T ON T.TESTSUITE_ID=S.TESTSUITE_ID
 JOIN $NF_SCHEMA.RESOURCE R ON R.RESOURCE_ID=S.OWNER_ID
 JOIN $NF_SCHEMA.TESTSUITELOG_CLASSIFICATION TL ON TL.TESTSUITELOG_CLASS_ID=S.TESTSUITELOG_CLASS_ID
 JOIN $NF_SCHEMA.TESTPLAN TP ON TP.TESTPLAN_ID=S.TESTPLAN_ID
 JOIN $NF_SCHEMA.TESTSUITE_EXECUTION_RECORD TEX ON TEX.TESTSUITE_EXECRECORD_ID=S.TESTSUITE_EXECRECORD_ID
 JOIN $NF_SCHEMA.TESTSUITELOG_STATE TS ON TS.TESTSUITELOG_STATE_ID=S.TESTSUITELOG_STATE_ID
JOIN $NF_SCHEMA.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID);
GRANT SELECT ON $STAR_SCHEMA.VW_TESTSUITELOG TO REPUSER;

DROP VIEW $STAR_SCHEMA.VW_TESTCASE;
CREATE VIEW $STAR_SCHEMA.VW_TESTCASE (EXTERNAL_ID,IS_BLOCKING,NAME,REFERENCE_ID,TESTCASE_ID,TESTCASE_STATE,TESTPLAN_ID,TESTPLAN_NAME,URL,OWNER_ID,OWNER_NAME,REGRESSION_TEST,WEIGHT,LAST_UPDATED,
COMPONENT_ID,COMPONENT_NAME,TESTCASE_STATE_ID,TESTCASE_STATE_EXTERNAL_ID,TESTCASE_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,EXTERNAL_KEY1,EXTERNAL_KEY2,
TESTCASE_CLASS_ID,TESTCASE_CLASS_NAME,TESTCASE_FOLDER,PROJECT_ID,PROJECT_NAME,TEST_PRIORITY_ID,TEST_PRIORITY_NAME,TEST_PRIORITY_EXTERNAL_ID,TEST_PRIORITY_REFERENCE_ID,ESTIMATE,CREATION_DATE,REC_DATETIME,ISSOFTDELETED) AS
(SELECT T.EXTERNAL_ID,T.IS_BLOCKING,T.NAME,T.REFERENCE_ID,T.TESTCASE_ID,TS.NAME AS TESTCASE_STATE,T.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME, T.URL,T.OWNER_ID,R.FULL_NAME AS OWNER_NAME,T.REGRESSION_TEST,
T.WEIGHT,T.LAST_UPDATED,T.COMPONENT_ID,C.NAME AS COMPONENT_NAME,T.TESTCASE_STATE_ID,TS.EXTERNAL_ID AS TESTCASE_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTCASE_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,
TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TESTCASE_CLASS_ID,TL.NAME AS TESTCASE_CLASS_NAME,T.TESTCASE_FOLDER,T.PROJECT_ID,P.NAME AS PROJECT_NAME,
T.TEST_PRIORITY_ID,PT.NAME AS TEST_PRIORITY_NAME,PT.EXTERNAL_ID AS TEST_PRIORITY_EXTERNAL_ID,PT.REFERENCE_ID AS TEST_PRIORITY_REFERENCE_ID,T.ESTIMATE,T.CREATION_DATE,T.REC_DATETIME,T.ISSOFTDELETED
FROM $NF_SCHEMA.TESTCASE T
JOIN $NF_SCHEMA.TESTPLAN TP ON TP.TESTPLAN_ID=T.TESTPLAN_ID
JOIN $NF_SCHEMA.RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID
JOIN $NF_SCHEMA.COMPONENT C ON C.COMPONENT_ID=T.COMPONENT_ID
JOIN $NF_SCHEMA.PROJECT P ON P.PROJECT_ID=T.PROJECT_ID
JOIN $NF_SCHEMA.TESTCASE_CLASSIFICATION TL ON TL.TESTCASE_CLASS_ID=T.TESTCASE_CLASS_ID
JOIN $NF_SCHEMA.TESTCASE_STATE TS ON TS.TESTCASE_STATE_ID=T.TESTCASE_STATE_ID
JOIN $NF_SCHEMA.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID
JOIN $NF_SCHEMA.TEST_PRIORITY PT ON PT.TEST_PRIORITY_ID=T.TEST_PRIORITY_ID);
GRANT SELECT ON $STAR_SCHEMA.VW_TESTCASE TO REPUSER;

DROP VIEW $STAR_SCHEMA.VW_TESTPLAN;
CREATE VIEW $STAR_SCHEMA.VW_TESTPLAN (EXTERNAL_ID, NAME, REFERENCE_ID, TESTPLAN_ID, TESTPLAN_STATE,PROJECT_ID,PROJECT_NAME,CREATION_DATE,OWNER_ID,OWNER_NAME,LAST_UPDATED,URL,ASSETREGISTRY_ID,ASSETREGISTRY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTPLAN_CLASS_ID,TESTPLAN_CLASS_NAME,REC_DATETIME,ISSOFTDELETED,
TESTPLAN_STATE_ID,TESTPLAN_STATE_EXTERNAL_ID,TESTPLAN_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,TEST_PRIORITY_ID,TEST_PRIORITY_NAME,TEST_PRIORITY_EXTERNAL_ID,TEST_PRIORITY_REFERENCE_ID,ESTIMATE) AS
 (SELECT T.EXTERNAL_ID, T.NAME, T.REFERENCE_ID, T.TESTPLAN_ID, TS.NAME AS TESTPLAN_STATE,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.CREATION_DATE,
T.OWNER_ID,R.FULL_NAME AS OWNER_NAME,T.LAST_UPDATED,T.URL,T.ASSETREGISTRY_ID,A.NAME AS ASSETREGISTRY_NAME,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TESTPLAN_CLASS_ID,TL.NAME AS TESTPLAN_CLASS_NAME,T.REC_DATETIME,T.ISSOFTDELETED,
T.TESTPLAN_STATE_ID,TS.EXTERNAL_ID AS TESTPLAN_STATE_EXTERNAL_ID,TS.REFERENCE_ID TESTPLAN_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,
T.TEST_PRIORITY_ID,PT.NAME AS TEST_PRIORITY_NAME,PT.EXTERNAL_ID AS TEST_PRIORITY_EXTERNAL_ID,PT.REFERENCE_ID AS TEST_PRIORITY_REFERENCE_ID,T.ESTIMATE
FROM $NF_SCHEMA.TESTPLAN T
JOIN $NF_SCHEMA.PROJECT P ON P.PROJECT_ID=T.PROJECT_ID
JOIN $NF_SCHEMA.RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID
JOIN $NF_SCHEMA.ASSETREGISTRY A ON A.ASSETREGISTRY_ID=T.ASSETREGISTRY_ID
JOIN $NF_SCHEMA.TESTPLAN_CLASSIFICATION TL ON TL.TESTPLAN_CLASS_ID=T.TESTPLAN_CLASS_ID
JOIN $NF_SCHEMA.TESTPLAN_STATE TS ON TS.TESTPLAN_STATE_ID=T.TESTPLAN_STATE_ID
JOIN $NF_SCHEMA.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID
JOIN $NF_SCHEMA.TEST_PRIORITY PT ON PT.TEST_PRIORITY_ID=T.TEST_PRIORITY_ID);
GRANT SELECT ON $STAR_SCHEMA.VW_TESTPLAN TO REPUSER;

DROP VIEW $STAR_SCHEMA.VW_TESTSUITE;
CREATE VIEW $STAR_SCHEMA.VW_TESTSUITE (EXTERNAL_ID,NAME,REFERENCE_ID,TESTSUITE_ID,TESTSUITE_STATE,URL,LAST_UPDATED,PROJECT_ID,PROJECT_NAME,CREATION_DATE,OWNER_ID,OWNER_NAME,CONFIGURATION_ID,
CONFIGURATION_NAME,ASSETREGISTRY_ID,ASSETREGISTRY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTSUITE_CLASS_ID,TESTSUITE_CLASS_NAME,TESTSUITE_STATE_ID,TESTSUITE_STATE_EXTERNAL_ID,TESTSUITE_STATE_REFERENCE_ID,
TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,REC_DATETIME,ISSOFTDELETED,DESCRIPTION,ISSEQUENTIAL,CREATOR_ID,CREATOR_NAME,WEIGHT,
TEST_PRIORITY_ID,TEST_PRIORITY_NAME,TEST_PRIORITY_EXTERNAL_ID,TEST_PRIORITY_REFERENCE_ID,ESTIMATE) AS
(SELECT T.EXTERNAL_ID,T.NAME,T.REFERENCE_ID,T.TESTSUITE_ID,TS.NAME AS TESTSUITE_STATE,T.URL,T.LAST_UPDATED,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.CREATION_DATE,T.OWNER_ID,
R.FULL_NAME AS OWNER_NAME,T.CONFIGURATION_ID,C.NAME AS CONFIGURATION_NAME,T.ASSETREGISTRY_ID,A.NAME AS ASSETREGISTRY_NAME,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TESTSUITE_CLASS_ID,
TL.NAME AS TESTSUITE_CLASS_NAME,T.TESTSUITE_STATE_ID,TS.EXTERNAL_ID AS TESTSUITE_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTSUITE_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,
T.REC_DATETIME,T.ISSOFTDELETED,T.DESCRIPTION,T.ISSEQUENTIAL,T.CREATOR_ID,CT.FULL_NAME AS CREATOR_NAME,T.WEIGHT,
T.TEST_PRIORITY_ID,PT.NAME AS TEST_PRIORITY_NAME,PT.EXTERNAL_ID AS TEST_PRIORITY_EXTERNAL_ID,PT.REFERENCE_ID AS TEST_PRIORITY_REFERENCE_ID,T.ESTIMATE
FROM $NF_SCHEMA.TESTSUITE T
JOIN $NF_SCHEMA.PROJECT P ON P.PROJECT_ID=T.PROJECT_ID
JOIN $NF_SCHEMA.RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID
JOIN $NF_SCHEMA.RESOURCE CT ON CT.RESOURCE_ID=T.CREATOR_ID
JOIN $NF_SCHEMA.CONFIGURATION C ON C.CONFIGURATION_ID =T.CONFIGURATION_ID
JOIN $NF_SCHEMA.ASSETREGISTRY A ON A.ASSETREGISTRY_ID=T.ASSETREGISTRY_ID
JOIN $NF_SCHEMA.TESTSUITE_CLASSIFICATION TL ON TL.TESTSUITE_CLASS_ID=T.TESTSUITE_CLASS_ID
JOIN $NF_SCHEMA.TESTSUITE_STATE TS ON TS.TESTSUITE_STATE_ID=T.TESTSUITE_STATE_ID
JOIN $NF_SCHEMA.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID
JOIN $NF_SCHEMA.TEST_PRIORITY PT ON PT.TEST_PRIORITY_ID=T.TEST_PRIORITY_ID);
GRANT SELECT ON $STAR_SCHEMA.VW_TESTSUITE TO REPUSER;

DROP VIEW $STAR_SCHEMA.VW_EXECUTION_WORKITEM;
CREATE VIEW $STAR_SCHEMA.VW_EXECUTION_WORKITEM (EXECWORKITEM_ID,CONFIGURATION_ID,CONFIGURATION_NAME,EXECUTION_WORKITEM_STATE,EXTERNAL_ID,NAME,OWNER_ID,OWNER_NAME,PROJECT_ID,PROJECT_NAME,REFERENCE_ID,TESTCASE_ID,TESTCASE_NAME,TESTTYPE_ID,TESTTYPE_NAME,URL,TESTPLAN_ID,TESTPLAN_NAME,FREQUENCY,REGRESSION,WEIGHT,LAST_UPDATED,CURRENT_RESULT_ID,CURRENT_RESULT_NAME,CURRENT_RESULT_VERDICT,TAGS,EXTERNAL_KEY1,EXTERNAL_KEY2,EXECWORKIT_CLASS_ID,EXECWORKIT_CLASS_NAME,CREATION_DATE,TESTSCRIPT_ID,TESTSCRIPT_NAME,
TEST_PRIORITY_ID,PRIORITY,TEST_PRIORITY_EXTERNAL_ID,TEST_PRIORITY_REFERENCE_ID,ESTIMATE,TIMESPENT,REC_DATETIME,ISSOFTDELETED) AS
(SELECT C.EXECWORKITEM_ID,C.CONFIGURATION_ID,CF.NAME AS CONFIGURATION_NAME,C.EXECUTION_WORKITEM_STATE,C.EXTERNAL_ID,C.NAME,C.OWNER_ID,R.FULL_NAME AS OWNER_NAME,C.PROJECT_ID,P.NAME AS PROJECT_NAME,C.REFERENCE_ID,C.TESTCASE_ID,T.NAME AS TESTCASE_NAME,C.TESTTYPE_ID,TT.NAME AS TESTTYPE_NAME, C.URL,C.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME,C.FREQUENCY,C.REGRESSION,C.WEIGHT,C.LAST_UPDATED,C.CURRENT_RESULT_ID,ER.NAME AS CURRENT_RESULT_NAME,ER.VERDICT AS CURRENT_RESULT_VERDICT,C.TAGS,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.EXECWORKIT_CLASS_ID,EL.NAME AS EXECWORKIT_CLASS_NAME,C.CREATION_DATE,C.TESTSCRIPT_ID,TS.NAME AS TESTSCRIPT_NAME,
C.TEST_PRIORITY_ID,PT.NAME AS PRIORITY,PT.EXTERNAL_ID AS TEST_PRIORITY_EXTERNAL_ID,PT.REFERENCE_ID AS TEST_PRIORITY_REFERENCE_ID,C.ESTIMATE,C.TIMESPENT,C.REC_DATETIME,C.ISSOFTDELETED
FROM $NF_SCHEMA.EXECUTION_WORKITEM C
JOIN $NF_SCHEMA.CONFIGURATION CF ON CF.CONFIGURATION_ID=C.CONFIGURATION_ID
JOIN $NF_SCHEMA.RESOURCE R ON R.RESOURCE_ID=C.OWNER_ID
JOIN $NF_SCHEMA.PROJECT P ON P.PROJECT_ID=C.PROJECT_ID
JOIN $NF_SCHEMA.TESTCASE T ON T.TESTCASE_ID=C.TESTCASE_ID
JOIN $NF_SCHEMA.TESTTYPE TT ON TT.TESTTYPE_ID=C.TESTTYPE_ID
JOIN $NF_SCHEMA.TESTPLAN TP ON TP.TESTPLAN_ID=C.TESTPLAN_ID
JOIN $NF_SCHEMA.TESTSCRIPT TS ON TS.TESTSCRIPT_ID=C.TESTSCRIPT_ID
JOIN $NF_SCHEMA.EXECUTION_RESULT ER ON ER.EXECUTION_RESULT_ID=C.CURRENT_RESULT_ID
JOIN $NF_SCHEMA.EXECWORKITEM_CLASSIFICATION EL ON EL.EXECWORKIT_CLASS_ID=C.EXECWORKIT_CLASS_ID
JOIN $NF_SCHEMA.TEST_PRIORITY PT ON PT.TEST_PRIORITY_ID=C.TEST_PRIORITY_ID);
GRANT SELECT ON $STAR_SCHEMA.VW_EXECUTION_WORKITEM TO REPUSER;

DROP VIEW $STAR_SCHEMA.VW_TESTSCRIPT;
CREATE VIEW $STAR_SCHEMA.VW_TESTSCRIPT (TESTSCRIPT_ID, REFERENCE_ID, EXTERNAL_ID, NAME, LAST_UPDATED, TESTSCRIPT_STATE, TYPE, OWNER_ID,OWNER_NAME, PROJECT_ID, PROJECT_NAME, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, URL, REC_DATETIME, ISSOFTDELETED,
TESTSCRIPT_STATE_ID,TESTSCRIPT_STATE_EXTERNAL_ID,TESTSCRIPT_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,CREATION_DATE) AS
 (SELECT TEST.TESTSCRIPT_ID, TEST.REFERENCE_ID, TEST.EXTERNAL_ID, TEST.NAME, TEST.LAST_UPDATED, TS.NAME AS TESTSCRIPT_STATE, TEST.TYPE, TEST.OWNER_ID, R.NAME AS OWNER_NAME, TEST.PROJECT_ID, P.NAME AS PROJECT_NAME,TEST.EXTERNAL_KEY1, TEST.EXTERNAL_KEY2, TEST.SOURCE_ID, TEST.URL, TEST.REC_DATETIME, TEST.ISSOFTDELETED,
TEST.TESTSCRIPT_STATE_ID,TS.EXTERNAL_ID AS TESTSCRIPT_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTSCRIPT_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,TEST.CREATION_DATE
FROM $NF_SCHEMA.TESTSCRIPT TEST
 JOIN $NF_SCHEMA.RESOURCE R ON R.RESOURCE_ID = TEST.OWNER_ID
 JOIN $NF_SCHEMA.PROJECT P ON P.PROJECT_ID = TEST.PROJECT_ID
 JOIN $NF_SCHEMA.TESTSCRIPT_STATE TS ON TS.TESTSCRIPT_STATE_ID=TEST.TESTSCRIPT_STATE_ID
JOIN $NF_SCHEMA.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID);
GRANT SELECT ON $STAR_SCHEMA.VW_TESTSCRIPT TO REPUSER;

DROP VIEW $STAR_SCHEMA.VW_TESTSUITE_EXECUTION_RECORD;
CREATE VIEW $STAR_SCHEMA.VW_TESTSUITE_EXECUTION_RECORD (TESTSUITE_EXECRECORD_ID,REFERENCE_ID,EXTERNAL_ID,NAME ,PROJECT_ID,PROJECT_NAME,CREATOR_ID,CREATOR_NAME,OWNER_ID,OWNER_NAME,TESTSUITE_ID,TESTSUITE_NAME,TESTPLAN_ID,TESTPLAN_NAME,ITERATION_ID,ITERATION_NAME,CONFIGURATION_ID,CONFIGURATION_NAME,CURRENT_SUITELOG_ID,CURRENT_SUITELOG_NAME,WEIGHT,CREATION_DATE,LAST_UPDATED,ISSEQUENTIAL,
TEST_PRIORITY_ID,TEST_PRIORITY_NAME,TEST_PRIORITY_EXTERNAL_ID,TEST_PRIORITY_REFERENCE_ID,ESTIMATE,TIMESPENT,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
( SELECT TSER.TESTSUITE_EXECRECORD_ID,TSER.REFERENCE_ID,TSER.EXTERNAL_ID,TSER.NAME ,TSER.PROJECT_ID,P.NAME AS PROJECT_NAME,TSER.CREATOR_ID,R1.FULL_NAME AS CREATOR_NAME,TSER.OWNER_ID,R2.FULL_NAME AS OWNER_NAME,TSER.TESTSUITE_ID,TS.NAME AS TESTSUITE_NAME,TSER.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME,TSER.ITERATION_ID,I.NAME AS ITERATION_NAME,TSER.CONFIGURATION_ID,C.NAME AS CONFIGURATION_NAME,TSER.CURRENT_SUITELOG_ID,TL.NAME AS CURRENT_SUITELOG_NAME,TSER.WEIGHT,TSER.CREATION_DATE,TSER.LAST_UPDATED,TSER.ISSEQUENTIAL,
TSER.TEST_PRIORITY_ID,PT.NAME AS TEST_PRIORITY_NAME,PT.EXTERNAL_ID AS TEST_PRIORITY_EXTERNAL_ID,PT.REFERENCE_ID AS TEST_PRIORITY_REFERENCE_ID,TSER.ESTIMATE,TSER.TIMESPENT,
TSER.EXTERNAL_KEY1,TSER.EXTERNAL_KEY2,TSER.SOURCE_ID,TSER.URL,TSER.REC_DATETIME,TSER.ISSOFTDELETED
FROM $NF_SCHEMA.TESTSUITE_EXECUTION_RECORD TSER
JOIN $NF_SCHEMA.RESOURCE R1 ON R1.RESOURCE_ID=TSER.CREATOR_ID
JOIN $NF_SCHEMA.RESOURCE R2 ON R2.RESOURCE_ID=TSER.OWNER_ID
JOIN $NF_SCHEMA.TESTSUITE TS ON TS.TESTSUITE_ID=TSER.TESTSUITE_ID
JOIN $NF_SCHEMA.TESTPLAN TP ON TP.TESTPLAN_ID=TSER.TESTPLAN_ID
JOIN $NF_SCHEMA.ITERATION I ON I.ITERATION_ID=TSER.ITERATION_ID
JOIN $NF_SCHEMA.CONFIGURATION C ON C.CONFIGURATION_ID=TSER.CONFIGURATION_ID
JOIN $NF_SCHEMA.TESTSUITELOG TL ON TL.TESTSUITELOG_ID=TSER.CURRENT_SUITELOG_ID
JOIN $NF_SCHEMA.PROJECT P ON P.PROJECT_ID=TSER.PROJECT_ID
JOIN $NF_SCHEMA.TEST_PRIORITY PT ON PT.TEST_PRIORITY_ID=TSER.TEST_PRIORITY_ID);
GRANT SELECT ON $STAR_SCHEMA.VW_TESTSUITE_EXECUTION_RECORD TO REPUSER;

DROP VIEW $STAR_SCHEMA.VW_TESTSUITE_ELEMENT;
CREATE VIEW $STAR_SCHEMA.VW_TESTSUITE_ELEMENT (TESTSUITE_ELEMENT_ID ,REFERENCE_ID,EXTERNAL_ID,NAME,TESTSUITE_ID ,TESTSUITE_NAME,TESTCASE_ID,TESTCASE_NAME,CONFIGURATION_ID,CONFIGURATION_NAME,TESTSCRIPT_ID,TESTSCRIPT_NAME,ELEMENT_INDEX,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED,OWNER_ID,OWNER_NAME) AS
(SELECT TE.TESTSUITE_ELEMENT_ID ,TE.REFERENCE_ID,TE.EXTERNAL_ID,TE.NAME,TE.TESTSUITE_ID ,TS.NAME AS TESTSUITE_NAME,TE.TESTCASE_ID,TC.NAME AS TESTCASE_NAME, TE.CONFIGURATION_ID,C.NAME AS CONFIGURATION_NAME,TE.TESTSCRIPT_ID,TR.NAME AS TESTSCRIPT_NAME,TE.ELEMENT_INDEX,TE.EXTERNAL_KEY1,TE.EXTERNAL_KEY2,TE.SOURCE_ID,TE.URL,TE.REC_DATETIME,TE.ISSOFTDELETED,
TE.OWNER_ID,R.FULL_NAME AS OWNER_NAME
FROM $NF_SCHEMA.TESTSUITE_ELEMENT TE
JOIN $NF_SCHEMA.TESTCASE TC ON TC.TESTCASE_ID=TE.TESTCASE_ID
JOIN $NF_SCHEMA.CONFIGURATION C ON C.CONFIGURATION_ID=TE.CONFIGURATION_ID
JOIN $NF_SCHEMA.TESTSUITE TS ON TS.TESTSUITE_ID=TE.TESTSUITE_ID
JOIN $NF_SCHEMA.TESTSCRIPT TR ON TR.TESTSCRIPT_ID=TE.TESTSCRIPT_ID
JOIN $NF_SCHEMA.RESOURCE R ON R.RESOURCE_ID=TE.OWNER_ID);
GRANT SELECT ON $STAR_SCHEMA.VW_TESTSUITE_ELEMENT TO REPUSER;


CREATE VIEW $STAR_SCHEMA.VW_TEST_PRIORITY (TEST_PRIORITY_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT T.TEST_PRIORITY_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED
FROM $NF_SCHEMA.TEST_PRIORITY T
JOIN $NF_SCHEMA.PROJECT P ON P.PROJECT_ID =T.PROJECT_ID);
GRANT SELECT ON $STAR_SCHEMA.VW_TEST_PRIORITY TO REPUSER;

DROP VIEW $STAR_SCHEMA.VW_EXECUTION_RESULT;
CREATE VIEW $STAR_SCHEMA.VW_EXECUTION_RESULT (EXECUTION_RESULT_ID, EXECRES_CLASS_ID, EXECRES_CLASS_NAME, NAME, REFERENCE_ID, EXTERNAL_ID, VERDICT, OWNER_ID, OWNER_NAME, BUILD_ID, BUILD_NAME, ITERATION_ID, ITERATION_NAME, TESTTYPE_ID, TESTTYPE_NAME, TESCASE_ID, TESTCASE_NAME, PROJECT_ID, PROJECT_NAME, TESTSCRIPT_ID, TESTSCRIPT_NAME, START_DATE, END_DATE, POINTS_BLOCKED, POINTS_INCONCLUSIVE, MACHINE, POINTS_ATTEMPTED, POINTS_FAILED, POINTS_PASSED, POINTS_PERMFAILED, LAST_UPDATED, CREATION_DATE, SUITE_INDEX, URL, POINTS_DEFERRED, POINTS_TOTAL, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, REC_DATETIME, ISSOFTDELETED,
EXECRESULT_STATE,EXECRESULT_STATE_ID,EXECRESULT_STATE_EXTERNAL_ID,EXECRESULT_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,LAB_RESOURCE_ID,LAB_RESOURCE_NAME) AS
(SELECT EX.EXECUTION_RESULT_ID, EX.EXECRES_CLASS_ID, EC.NAME AS EXECRES_CLASS_NAME, EX.NAME, EX.REFERENCE_ID, EX.EXTERNAL_ID, EX.VERDICT, EX.OWNER_ID, R.NAME AS OWNER_NAME, EX.BUILD_ID, B.NAME AS BUILD_NAME, EX.ITERATION_ID, I.NAME AS ITERATION_NAME, EX.TESTTYPE_ID, T.NAME AS TESTTYPE_NAME, EX.TESTCASE_ID, T1.NAME AS TESTCASE_NAME, EX.PROJECT_ID, P.NAME AS PROJECT_NAME, EX.TESTSCRIPT_ID, T2.NAME AS TESTSCRIPT_NAME, EX.START_DATE, EX.END_DATE, EX.POINTS_BLOCKED, EX.POINTS_INCONCLUSIVE, EX.MACHINE, EX.POINTS_ATTEMPTED, EX.POINTS_FAILED, EX.POINTS_PASSED, EX.POINTS_PERMFAILED, EX.LAST_UPDATED, EX.CREATION_DATE, EX.SUITE_INDEX, EX.URL,EX.POINTS_DEFERRED,EX.POINTS_TOTAL,EX.EXTERNAL_KEY1, EX.EXTERNAL_KEY2, EX.SOURCE_ID, EX.REC_DATETIME, EX.ISSOFTDELETED,
 TS.NAME AS EXECRESULT_STATE,EX.EXECRESULT_STATE_ID,TS.EXTERNAL_ID AS EXECRESULT_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS EXECRESULT_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,
EX.LAB_RESOURCE_ID,L.NAME AS LAB_RESOURCE_NAME
FROM $NF_SCHEMA.EXECUTION_RESULT EX
 JOIN $NF_SCHEMA.BUILD B ON B.BUILD_ID = EX.BUILD_ID
 JOIN $NF_SCHEMA.EXECRESULT_CLASSIFICATION EC ON EC.EXECRES_CLASS_ID = EX.EXECRES_CLASS_ID
 JOIN $NF_SCHEMA.ITERATION I ON I.ITERATION_ID = EX.ITERATION_ID
 JOIN $NF_SCHEMA.PROJECT P ON P.PROJECT_ID = EX.PROJECT_ID
 JOIN $NF_SCHEMA.RESOURCE R ON R.RESOURCE_ID = EX.OWNER_ID
 JOIN $NF_SCHEMA.TESTTYPE T ON T.TESTTYPE_ID = EX.TESTTYPE_ID
 JOIN $NF_SCHEMA.TESTCASE T1 ON T1.TESTCASE_ID = EX.TESTCASE_ID
 JOIN $NF_SCHEMA.TESTSCRIPT T2 ON T2.TESTSCRIPT_ID = EX.TESTSCRIPT_ID
 JOIN $NF_SCHEMA.EXECRESULT_STATE TS ON TS.EXECRESULT_STATE_ID=EX.EXECRESULT_STATE_ID
JOIN $NF_SCHEMA.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID
JOIN $NF_SCHEMA.LAB_RESOURCE L ON L.LAB_RESOURCE_ID=EX.LAB_RESOURCE_ID);
GRANT SELECT ON $STAR_SCHEMA.VW_EXECUTION_RESULT TO REPUSER;

UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.1' WHERE INFO_ID=6;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET CHAR_VALUE='2.0.1 RC1',INT_VALUE=7 WHERE INFO_ID=18;