DROP TRIGGER RIODS.TRG_REQITSTCD
GO
DROP TRIGGER RIODS.TRG_REQITPLND
GO
DROP VIEW RIDW.VW_PROJECT_TYPE
GO
CREATE VIEW RIDW.VW_PROJECT_TYPE (PROJECT_TYPE_ID, EXTERNAL_ID, REFERENCE_ID, NAME, PROJECT_ID, PROJECT_NAME, PROJECT_WKCFG_ID, PROJECT_WORKCONFIGURATION_NAME, RECORD_TYPE, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS (SELECT PT.PROJECT_TYPE_ID, PT.EXTERNAL_ID, PT.REFERENCE_ID, PT.NAME, PT.PROJECT_ID, P.NAME AS PROJECT_NAME, COALESCE(PWC.PROJECT_WKCFG_ID,-1) AS PROJECT_WKCFG_ID, COALESCE(PWC.NAME,'Info not available') AS PROJECT_WORKCONFIGURATION_NAME, PT.RECORD_TYPE, PT.URL,PT.EXTERNAL_KEY1,PT.EXTERNAL_KEY2,PT.REC_DATETIME,PT.ISSOFTDELETED FROM RIODS.PROJECT_TYPE PT JOIN RIODS.PROJECT P ON P.PROJECT_ID=PT.PROJECT_ID LEFT JOIN RIODS.PROJECT_WORKCONFIGURATION PWC ON P.PROJECT_ID=PWC.PROJECT_ID)
GO
GRANT SELECT ON RIDW.VW_PROJECT_TYPE TO REPUSER
GO

DROP TRIGGER RIASSET.TRG_ASSENTITLK
GO
CREATE TRIGGER TRG_ASSENTITLK ON RIASSET.ASSET_ROLE  FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RIASSET.ASSET_ROLE_ENTITLEMENT_LOOKUP  WHERE  ASSET_ROLE_ID IN (SELECT  ASSET_ROLE_ID FROM INSERTED ) END  
GO

DROP TRIGGER RIASSET.TRG_ASSETLK
GO
CREATE TRIGGER TRG_ASSETLK  ON RIASSET.ASSET  FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RIASSET.ASSET_LOOKUP  WHERE  PRED_ASSET_ID IN (SELECT ASSET_ID FROM INSERTED ) OR SUCC_ASSET_ID IN (SELECT ASSET_ID FROM INSERTED ) END  
GO

DROP TRIGGER RIASSET.TRG_ASSREQUELK
GO
CREATE TRIGGER TRG_ASSREQUELK  ON RIASSET.ASSET FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RIASSET.ASSET_REQUEST_LOOKUP  WHERE  ASSET_ID IN (SELECT  ASSET_ID FROM INSERTED ) END  
GO

DROP TRIGGER RIASSET.TRG_ASSREQUILK
GO
CREATE TRIGGER TRG_ASSREQUILK ON RIASSET.ASSET  FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RIASSET.ASSET_REQUIREMENT_LOOKUP  WHERE  ASSET_ID IN (SELECT  ASSET_ID FROM INSERTED ) END  
GO

DROP TRIGGER RIASSET.TRG_ASSRESOULK
GO
CREATE TRIGGER TRG_ASSRESOULK ON RIASSET.ASSET FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RIASSET.ASSET_RESOURCE_LOOKUP  WHERE  ASSET_ID IN (SELECT  ASSET_ID FROM INSERTED ) END  
GO

DROP TRIGGER RIASSET.TRG_ASSRLRESELK
GO
CREATE TRIGGER TRG_ASSRLRESELK ON RIASSET.ASSET_ROLE  FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RIASSET.ASSET_ROLE_RESOURCE_LOOKUP  WHERE  ASSET_ROLE_ID IN (SELECT  ASSET_ROLE_ID FROM INSERTED ) END  
GO

DROP TRIGGER RIASSET.TRG_ASSRLTEAMLK
GO
CREATE TRIGGER TRG_ASSRLTEAMLK ON RIASSET.ASSET_ROLE  FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RIASSET.ASSET_ROLE_TEAM_LOOKUP  WHERE  ASSET_ROLE_ID IN (SELECT  ASSET_ROLE_ID FROM INSERTED ) END  
GO

DROP TRIGGER RIASSET.TRG_ASSTCAT
GO
CREATE TRIGGER TRG_ASSTCAT ON RIASSET.ASSET_CATEGORY  FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN  DELETE FROM RIASSET.ASSET_CAT_HIERARCHY  WHERE  PARENT_CATEGORY_ID IN (SELECT  ASSET_CATEGORY_ID FROM INSERTED ) OR CHILD_CATEGORY_ID IN ( SELECT  ASSET_CATEGORY_ID FROM INSERTED ) END  
GO

DROP TRIGGER RIASSET.TRG_ASSTCATAST
GO
CREATE TRIGGER TRG_ASSTCATAST ON RIASSET.ASSET  FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN  DELETE FROM RIASSET.ASSET_CAT_ASSET_LOOKUP  WHERE  ASSET_ID IN (SELECT ASSET_ID FROM INSERTED ) END  
GO

DROP TRIGGER RIASSET.TRG_ASSTSTCASELK
GO
CREATE TRIGGER TRG_ASSTSTCASELK ON RIASSET.ASSET FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RIASSET.ASSET_TESTCASE_LOOKUP  WHERE  ASSET_ID IN (SELECT  ASSET_ID FROM INSERTED ) END  
GO

DROP TRIGGER RIASSET.TRG_TSTPLNLK
GO
CREATE TRIGGER TRG_TSTPLNLK ON RIASSET.ASSET  FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RIASSET.ASSET_TESTPLAN_LOOKUP  WHERE  ASSET_ID IN (SELECT  ASSET_ID FROM INSERTED ) END  
GO

DROP TRIGGER RIODS.TRG_CFGEXECWK
GO
CREATE TRIGGER TRG_CFGEXECWK ON RIODS.EXECUTION_WORKITEM  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.CONFIG_EXECUTIONWORKITM_LOOKUP  WHERE  EXECWORKITEM_ID IN  (SELECT  EXECWORKITEM_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_COMPPRO
GO
CREATE TRIGGER TRG_COMPPRO  ON RIODS.PROFILE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.PROFILE_COMPETENCY_LOOKUP  WHERE  PROFILE_ID IN  (SELECT  PROFILE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_COMPRES
GO
CREATE TRIGGER TRG_COMPRES  ON RIODS.RESOURCE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.RESOURCE_COMPETENCY_LOOKUP  WHERE  RESOURCE_ID IN  (SELECT  RESOURCE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_CONFATTRD
GO
CREATE TRIGGER TRG_CONFATTRD ON RIODS.CONFIGURATION  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.CONFIGURATION_ATTRIBUTE_LOOKUP  WHERE  CONFIGURATION_ID IN  (SELECT  CONFIGURATION_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_CONFTLGD
GO
CREATE TRIGGER TRG_CONFTLGD ON RIODS.CONFIGURATION  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.CONFIG_EXECUTIONRES_LOOKUP  WHERE  CONFIGURATION_ID IN  (SELECT  CONFIGURATION_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_ESRREQUE
GO
CREATE TRIGGER TRG_ESRREQUE  ON RIODS.EXECUTION_STEP_RESULT  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN  DELETE FROM RIODS.EXECSTEPRES_REQUEST_LOOKUP  WHERE  EXECUTION_STEP_RESULT_ID IN  (SELECT  EXECUTION_STEP_RESULT_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_EWIREQUE
GO
CREATE TRIGGER TRG_EWIREQUE  ON RIODS.EXECUTION_WORKITEM  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN  DELETE FROM RIODS.EXECWORKITEM_REQUEST_LOOKUP  WHERE  EXECWORKITEM_ID IN  (SELECT  EXECWORKITEM_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_EXECRESCATE
GO
CREATE TRIGGER TRG_EXECRESCATE ON RIODS.EXECUTION_RESULT  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.EXECRESULT_CATEGORY_LOOKUP  WHERE  EXECUTION_RESULT_ID IN  (SELECT  EXECUTION_RESULT_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_EXERESWKIT
GO
CREATE TRIGGER TRG_EXERESWKIT ON RIODS.EXECUTION_RESULT  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.EXECRES_EXECWKITEM_LOOKUP  WHERE  EXECUTION_RESULT_ID IN  (SELECT  EXECUTION_RESULT_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_EXWKIITDD
GO
CREATE TRIGGER TRG_EXWKIITDD ON RIODS.EXECUTION_WORKITEM  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.EXECWORKITEM_ITERATION_LOOKUP  WHERE  EXECWORKITEM_ID IN  (SELECT  EXECWORKITEM_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_EXWKITCATE
GO
CREATE TRIGGER TRG_EXWKITCATE ON RIODS.EXECUTION_WORKITEM  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.EXECWORKITEM_CATEGORY_LOOKUP  WHERE  EXECWORKITEM_ID IN  (SELECT  EXECWORKITEM_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_EXWKITSUD
GO
CREATE TRIGGER TRG_EXWKITSUD ON RIODS.EXECUTION_WORKITEM  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DECLARE @cls int SELECT @cls=EXECWORKIT_CLASS_ID FROM RIODS.EXECWORKITEM_CLASSIFICATION WHERE NAME ='RQM Execution Work Item' BEGIN DELETE FROM RIODS.EXECWORKITEM_TESTSUITE_LOOKUP  WHERE  EXECWORKITEM_ID IN  (SELECT  EXECWORKITEM_ID FROM INSERTED ) AND @cls NOT IN (SELECT EXECWORKIT_CLASS_ID FROM INSERTED)  END END  
GO

DROP TRIGGER RIODS.TRG_EXWKITSUD2
GO
CREATE TRIGGER TRG_EXWKITSUD2 ON RIODS.TESTSUITE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DECLARE @cls int SELECT @cls=TESTSUITE_CLASS_ID FROM RIODS.TESTSUITE_CLASSIFICATION WHERE NAME ='RQM Test Suite' BEGIN DELETE FROM RIODS.EXECWORKITEM_TESTSUITE_LOOKUP  WHERE  TESTSUITE_ID IN  (SELECT  TESTSUITE_ID FROM INSERTED ) AND @cls IN (SELECT TESTSUITE_CLASS_ID FROM INSERTED) END  END 
GO

DROP TRIGGER RIODS.TRG_FBSACTD
GO
CREATE TRIGGER TRG_FBSACTD ON RIODS.ACTIVITY  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.FILE_BASELINE_ACTIVITY_LOOKUP  WHERE  ACTIVITY_ID IN  (SELECT  ACTIVITY_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_PORTPROGPRJ
GO
CREATE TRIGGER TRG_PORTPROGPRJ ON RIODS.PORTFOLIO  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.PORTFOLIO_PROG_PROJ_LOOKUP  WHERE  PORTFOLIO_ID IN  (SELECT  PORTFOLIO_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_PRJBSLND
GO
CREATE TRIGGER TRG_PRJBSLND ON RIODS.PROJECT_BASELINE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.PROJ_BASELINE_BASELINE_LOOKUP  WHERE  BASELINE_ID IN  (SELECT  BASELINE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_PRJROLED
GO
CREATE TRIGGER TRG_PRJROLED ON RIODS.PROJECT_ROLE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.PROJECT_ROLE_MEMBER_LOOKUP  WHERE  PROJECT_ROLE_ID IN  (SELECT  PROJECT_ROLE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQACTD
GO
CREATE TRIGGER TRG_REQACTD ON RIODS.REQUEST  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUEST_ACTIVITY_LOOKUP  WHERE  REQUEST_ID IN  (SELECT  REQUEST_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQCUSTD
GO
CREATE TRIGGER TRG_REQCUSTD ON RIODS.REQUEST  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUEST_CUSTOMER_LOOKUP  WHERE  REQUEST_ID IN  (SELECT  REQUEST_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQHIER
GO
CREATE TRIGGER TRG_REQHIER ON RIODS.REQUIREMENT  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUIREMENT_HIERARCHY  WHERE  PRED_REQUIREMENT_ID IN  (SELECT  PRED_REQUIREMENT_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQICUSTD
GO
CREATE TRIGGER TRG_REQICUSTD ON RIODS.REQUIREMENT  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUIREMENT_CUSTOMER_LOOKUP  WHERE  REQUIREMENT_ID IN  (SELECT  REQUIREMENT_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQIREQUID
GO
CREATE TRIGGER TRG_REQIREQUID ON RIODS.REQUIREMENT  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUIREMENT_REQUIREMENT_LOOKUP  WHERE  REQUIREMENT_ID IN  (SELECT  REQUIREMENT_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQITPLND2
GO
CREATE TRIGGER TRG_REQITPLND2 ON RIODS.TESTPLAN  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DECLARE @cls int SELECT @cls=TESTPLAN_CLASS_ID FROM RIODS.TESTPLAN_CLASSIFICATION WHERE NAME='RQM Test Plan' BEGIN DELETE FROM RIODS.REQUIREMENT_TESTPLAN_LOOKUP  WHERE  TESTPLAN_ID IN  (SELECT  TESTPLAN_ID FROM INSERTED ) AND @cls IN (SELECT TESTPLAN_CLASS_ID FROM INSERTED)  END END  
GO

DROP TRIGGER RIODS.TRG_REQITSTCD2
GO
CREATE TRIGGER TRG_REQITSTCD2 ON RIODS.TESTCASE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DECLARE @cls int SELECT @cls=TESTCASE_CLASS_ID FROM RIODS.TESTCASE_CLASSIFICATION WHERE NAME='RQM Test Case' BEGIN DELETE FROM RIODS.REQUIREMENT_TESTCASE_LOOKUP  WHERE  TESTCASE_ID IN  (SELECT  TESTCASE_ID FROM INSERTED ) AND @cls IN (SELECT TESTCASE_CLASS_ID FROM INSERTED)  END END
GO

DROP TRIGGER RIODS.TRG_REQITSUTD
GO
CREATE TRIGGER TRG_REQITSUTD ON RIODS.REQUIREMENT  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUIREMENT_TESTSUITE_LOOKUP  WHERE  REQUIREMENT_ID IN  (SELECT  REQUIREMENT_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQLOG2
GO
CREATE TRIGGER TRG_REQLOG2 ON RIODS.EXECUTION_RESULT  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DECLARE @cls int SELECT @cls=EXECRES_CLASS_ID FROM RIODS.EXECRESULT_CLASSIFICATION WHERE NAME ='RQM Execution Result' BEGIN  DELETE FROM RIODS.EXECRES_REQUEST_LOOKUP  WHERE  EXECUTION_RESULT_ID IN (SELECT  EXECUTION_RESULT_ID FROM INSERTED )  AND @cls IN (SELECT EXECRES_CLASS_ID FROM INSERTED)  END END  
GO

DROP TRIGGER RIODS.TRG_REQREQ
GO
CREATE TRIGGER TRG_REQREQ ON RIODS.REQUEST  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUEST_HIERARCHY  WHERE  PARENT_REQUEST_ID IN  (SELECT  PARENT_REQUEST_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQREQUI
GO
CREATE TRIGGER TRG_REQREQUI ON RIODS.REQUEST  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUIREMENT_REQUEST_LOOKUP  WHERE  REQUEST_ID IN  (SELECT  REQUEST_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQTASK
GO
CREATE TRIGGER TRG_REQTASK ON RIODS.REQUEST  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TASK_REQUEST_LOOKUP  WHERE  REQUEST_ID IN  (SELECT  REQUEST_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQTP
GO
CREATE TRIGGER TRG_REQTP ON RIODS.TESTPLAN  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUEST_TESTPLAN_LOOKUP  WHERE  TESTPLAN_ID IN  (SELECT  TESTPLAN_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQTSC
GO
CREATE TRIGGER TRG_REQTSC ON RIODS.TESTSCRIPT  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUEST_TESTSCRIPT_LOOKUP  WHERE  TESTSCRIPT_ID IN  (SELECT  TESTSCRIPT_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQTSU
GO
CREATE TRIGGER TRG_REQTSU ON RIODS.TESTSUITE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUEST_TESTSUITE_LOOKUP  WHERE  TESTSUITE_ID IN  (SELECT  TESTSUITE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQUICOL
GO
CREATE TRIGGER TRG_REQUICOL ON RIODS.REQUIREMENT_COLLECTION  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUICOL_REQUIREMENT_LOOKUP  WHERE  REQUIREMENT_COLLECTION_ID IN  (SELECT  REQUIREMENT_COLLECTION_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQUICOLTP
GO
CREATE TRIGGER TRG_REQUICOLTP ON RIODS.REQUIREMENT_COLLECTION  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUICOL_TESTPLAN_LOOKUP  WHERE  REQUIREMENT_COLLECTION_ID IN  (SELECT  REQUIREMENT_COLLECTION_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQUITSCRPT
GO
CREATE TRIGGER TRG_REQUITSCRPT  ON RIODS.TESTSCRIPT  FOR UPDATE  AS SET NOCOUNT ON IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RIODS.REQUIREMENT_TESTSCRIPT_LOOKUP  WHERE  TESTSCRIPT_ID IN (SELECT  TESTSCRIPT_ID FROM INSERTED ) END  
GO

DROP TRIGGER RIODS.TRG_REQUITSTCD
GO
CREATE TRIGGER TRG_REQUITSTCD ON RIODS.REQUIREMENT  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUIREMENT_EXECWRKITEM_LOOKUP  WHERE  REQUIREMENT_ID IN  (SELECT  REQUIREMENT_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_REQUTCASE
GO
CREATE TRIGGER TRG_REQUTCASE ON RIODS.TESTCASE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.REQUEST_TESTCASE_LOOKUP  WHERE  TESTCASE_ID IN  (SELECT  TESTCASE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_RSKREQUST
GO
CREATE TRIGGER TRG_RSKREQUST ON RIODS.RISK  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.RISK_REQUEST_LOOKUP  WHERE  RISK_ID IN  (SELECT  RISK_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_SKILLPRO
GO
CREATE TRIGGER TRG_SKILLPRO  ON RIODS.PROFILE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.PROFILE_SKILL_LOOKUP  WHERE  PROFILE_ID IN  (SELECT  PROFILE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_SKILLRES
GO
CREATE TRIGGER TRG_SKILLRES  ON RIODS.RESOURCE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.RESOURCE_SKILL_LOOKUP  WHERE  RESOURCE_ID IN  (SELECT  RESOURCE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TCASECAT
GO
CREATE TRIGGER TRG_TCASECAT ON RIODS.TESTCASE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TESTCASE_CATEGORY_LOOKUP  WHERE  TESTCASE_ID IN  (SELECT  TESTCASE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TESTSUITELOG
GO
CREATE TRIGGER TRG_TESTSUITELOG ON RIODS.TESTSUITELOG  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TESTSUITELOG_CATEGORY_LOOKUP  WHERE  TESTSUITELOG_ID IN  (SELECT  TESTSUITELOG_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TPLNCAT
GO
CREATE TRIGGER TRG_TPLNCAT ON RIODS.TESTPLAN  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TESTPLAN_CATEGORY_LOOKUP  WHERE  TESTPLAN_ID IN  (SELECT  TESTPLAN_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TPLNITERD
GO
CREATE TRIGGER TRG_TPLNITERD ON RIODS.TESTPLAN  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TESTPLAN_ITERATION_LOOKUP  WHERE  TESTPLAN_ID IN  (SELECT  TESTPLAN_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TPLNTCS
GO
CREATE TRIGGER TRG_TPLNTCS ON RIODS.TESTPLAN  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TESTPLAN_TESTCASE_LOOKUP  WHERE  TESTPLAN_ID IN  (SELECT  TESTPLAN_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TSCATLK
GO
CREATE TRIGGER TRG_TSCATLK  ON RIODS.TESTSUITE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN  DELETE FROM RIODS.TESTSUITE_CATEGORY_LOOKUP  WHERE  TESTSUITE_ID IN  (SELECT  TESTSUITE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TSCITERD
GO
CREATE TRIGGER TRG_TSCITERD ON RIODS.TESTCASE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TESTCASE_ITERATION_LOOKUP  WHERE  TESTCASE_ID IN  (SELECT  TESTCASE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TSCRTCATE
GO
CREATE TRIGGER TRG_TSCRTCATE ON RIODS.TESTSCRIPT  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TESTSCRIPT_CATEGORY_LOOKUP  WHERE  TESTSCRIPT_ID IN  (SELECT  TESTSCRIPT_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TSCSCRIPT
GO
CREATE TRIGGER TRG_TSCSCRIPT ON RIODS.TESTCASE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TESTCASE_TESTSCRIPT_LOOKUP  WHERE  TESTCASE_ID IN  (SELECT  TESTCASE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TSKREQID
GO
CREATE TRIGGER TRG_TSKREQID ON RIODS.REQUIREMENT  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TASK_REQUIREMENT_LOOKUP  WHERE  REQUIREMENT_ID IN  (SELECT  REQUIREMENT_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TSLOG
GO
CREATE TRIGGER TRG_TSLOG ON RIODS.TESTSUITELOG  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TESTSUITELOG_EXECRESULT_LOOKUP  WHERE  TESTSUITELOG_ID IN  (SELECT  TESTSUITELOG_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TSTC
GO
CREATE TRIGGER TRG_TSTC ON RIODS.TIMESHEET  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TIMESHEET_TIMECODE_LOOKUP  WHERE  TIMESHEET_ID IN  (SELECT  TIMESHEET_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TSTPLTLK
GO
CREATE TRIGGER TRG_TSTPLTLK  ON RIODS.TESTPLAN  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN  DELETE FROM RIODS.TESTSUITE_TESTPLAN_LOOKUP  WHERE  TESTPLAN_ID IN  (SELECT  TESTPLAN_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TSTSEXECRECCATE
GO
CREATE TRIGGER TRG_TSTSEXECRECCATE ON RIODS.TESTSUITE_EXECUTION_RECORD  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TSTSUITEXECREC_CATEGORY_LOOKUP  WHERE  TESTSUITE_EXECRECORD_ID IN  (SELECT  TESTSUITE_EXECRECORD_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TSUTCASE
GO
CREATE TRIGGER TRG_TSUTCASE ON RIODS.TESTSUITE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TESTSUITE_TESTCASE_LOOKUP  WHERE  TESTSUITE_ID IN  (SELECT  TESTSUITE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RIODS.TRG_TSUTITERD
GO
CREATE TRIGGER TRG_TSUTITERD ON RIODS.TESTSUITE  FOR UPDATE AS SET NOCOUNT ON IF UPDATE(REC_DATETIME) BEGIN DELETE FROM RIODS.TESTSUITE_ITERATION_LOOKUP  WHERE  TESTSUITE_ID IN  (SELECT  TESTSUITE_ID FROM INSERTED )  END 
GO

DROP TRIGGER RISCHK.TRG_BALDEFBALTAB
GO
CREATE TRIGGER TRG_BALDEFBALTAB  ON RISCHK.BALLOT_DEFINITION  FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RISCHK.BALLOTDEF_BALLOT_TAB_LOOKUP  WHERE  BALLOT_DEFINITION_ID IN (SELECT  BALLOT_DEFINITION_ID FROM INSERTED ) END  
GO

DROP TRIGGER RISCHK.TRG_BALTABQUES
GO
CREATE TRIGGER TRG_BALTABQUES  ON RISCHK.QUESTION  FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RISCHK.BALLOT_TAB_QUESTION_LOOKUP  WHERE  QUESTION_ID IN (SELECT  QUESTION_ID FROM INSERTED ) END  
GO

DROP TRIGGER RISCHK.TRG_SESCOFACILI
GO
CREATE TRIGGER TRG_SESCOFACILI  ON RISCHK.SC_SESSION  FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RISCHK.SCSESSION_COFACILIT_LOOKUP  WHERE  SESSION_ID IN (SELECT  SESSION_ID FROM INSERTED ) END  
GO

DROP TRIGGER RISCHK.TRG_SESPARTICI
GO
CREATE TRIGGER TRG_SESPARTICI  ON RISCHK.SC_SESSION  FOR UPDATE  AS  SET NOCOUNT ON  IF UPDATE(REC_DATETIME)  BEGIN DELETE FROM RISCHK.SCSESSION_PARTICIPANT_LOOKUP  WHERE  SESSION_ID IN (SELECT  SESSION_ID FROM INSERTED ) END  
GO

UPDATE CONFIG.SYSCONFIG_INFO SET INT_VALUE=4, CHAR_VALUE='2.0 RC2' WHERE INFO_ID=18
GO