IF NOT EXISTS (SELECT INFO_ID FROM CONFIG.SYSCONFIG_INFO WHERE INFO_ID=18) INSERT INTO CONFIG.SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,2 AS INT_VALUE,'2.0' AS CHAR_VALUE
GO

CREATE TABLE RIODS.TEST_STATUS (		TEST_STATUS_ID INT  NOT NULL,		NAME NVARCHAR(255) DEFAULT 'Test Status Name Missing' NOT NULL,		REFERENCE_ID NVARCHAR(50),		EXTERNAL_ID NVARCHAR(100),		PROJECT_ID INT  DEFAULT -1 NOT NULL,		URL NVARCHAR(2048),		EXTERNAL_KEY1 INT  DEFAULT -1 NOT NULL,		EXTERNAL_KEY2 NCHAR(40) DEFAULT '-1' NOT NULL,		SOURCE_ID NVARCHAR (36) DEFAULT '-1' NOT NULL,		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL,		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL) ON VNF_32K 
GO
ALTER TABLE RIODS.TEST_STATUS ADD CONSTRAINT TSTSTATUS_PK PRIMARY KEY (TEST_STATUS_ID) ON VNF_IDX
GO
INSERT INTO RIODS.TEST_STATUS (TEST_STATUS_ID,NAME) VALUES(-1,'Info not available')
GO
CREATE INDEX TSTSTATUS_IDX1 ON RIODS.TEST_STATUS (EXTERNAL_KEY2) ON VNF_IDX
GO             
CREATE INDEX TSTSTATUS_IDX2 ON RIODS.TEST_STATUS (EXTERNAL_KEY1) ON VNF_IDX
GO            
CREATE INDEX TSTSTATUS_IDX3 ON RIODS.TEST_STATUS (EXTERNAL_KEY2,SOURCE_ID) ON VNF_IDX
GO            
CREATE INDEX TSTSTATUS_IDX4 ON RIODS.TEST_STATUS (EXTERNAL_KEY1,SOURCE_ID) ON VNF_IDX
GO           
CREATE INDEX TSTSTATUS_IDX5 ON RIODS.TEST_STATUS (EXTERNAL_ID) ON VNF_IDX
GO           
CREATE INDEX TSTSTATUS_IDX6 ON RIODS.TEST_STATUS (ISSOFTDELETED) ON VNF_IDX
GO           
CREATE TABLE RIODS.TESTSUITE_STATE (		TESTSUITE_STATE_ID INT  NOT NULL,		NAME NVARCHAR(255) DEFAULT 'Test Suite State Name Missing' NOT NULL,		REFERENCE_ID NVARCHAR(50),		EXTERNAL_ID NVARCHAR(100),		PROJECT_ID INT  DEFAULT -1 NOT NULL,		TEST_STATUS_ID INT  DEFAULT -1 NOT NULL,		URL NVARCHAR(2048),		EXTERNAL_KEY1 INT  DEFAULT -1 NOT NULL,		EXTERNAL_KEY2 NCHAR(40) DEFAULT '-1' NOT NULL,		SOURCE_ID NVARCHAR (36) DEFAULT '-1' NOT NULL,		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL,		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL) ON VNF_32K 
GO
ALTER TABLE RIODS.TESTSUITE_STATE ADD CONSTRAINT TSTSUITESTATE_PK PRIMARY KEY (TESTSUITE_STATE_ID) ON VNF_IDX
GO
ALTER TABLE RIODS.TESTSUITE_STATE ADD CONSTRAINT TSTSUITESTATE_FK1 FOREIGN KEY (TEST_STATUS_ID)	REFERENCES RIODS.TEST_STATUS (TEST_STATUS_ID)
GO
INSERT INTO RIODS.TESTSUITE_STATE (TESTSUITE_STATE_ID,NAME) VALUES(-1,'Info not available')
GO
CREATE INDEX TSTSUITESTATE_IDX1 ON RIODS.TESTSUITE_STATE (EXTERNAL_KEY2)ON VNF_IDX
GO                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
CREATE INDEX TSTSUITESTATE_IDX2 ON RIODS.TESTSUITE_STATE (EXTERNAL_KEY1)ON VNF_IDX
GO                                                                                                                                                                                                                                                                                                                                                                                                 
CREATE INDEX TSTSUITESTATE_IDX3 ON RIODS.TESTSUITE_STATE (EXTERNAL_KEY2,SOURCE_ID)ON VNF_IDX
GO                                                                                                                                                                                                                                                                                          
CREATE INDEX TSTSUITESTATE_IDX4 ON RIODS.TESTSUITE_STATE (EXTERNAL_KEY1,SOURCE_ID)ON VNF_IDX
GO                                                                                                                                                                                     
CREATE INDEX TSTSUITESTATE_IDX5 ON RIODS.TESTSUITE_STATE (EXTERNAL_ID)ON VNF_IDX
GO                                                                                             
CREATE INDEX TSTSUITESTATE_IDX6 ON RIODS.TESTSUITE_STATE (ISSOFTDELETED)ON VNF_IDX
GO   
CREATE TABLE RIODS.TESTSUITELOG_STATE (		TESTSUITELOG_STATE_ID INT  NOT NULL,		NAME NVARCHAR(255) DEFAULT 'Test Suite Log State Name Missing' NOT NULL,		REFERENCE_ID NVARCHAR(50),		EXTERNAL_ID NVARCHAR(100),		PROJECT_ID INT  DEFAULT -1 NOT NULL,		TEST_STATUS_ID INT  DEFAULT -1 NOT NULL,		URL NVARCHAR(2048),		EXTERNAL_KEY1 INT  DEFAULT -1 NOT NULL,		EXTERNAL_KEY2 NCHAR(40) DEFAULT '-1' NOT NULL,		SOURCE_ID NVARCHAR (36) DEFAULT '-1' NOT NULL,		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL,		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL) ON VNF_32K 
GO
ALTER TABLE RIODS.TESTSUITELOG_STATE ADD CONSTRAINT TSTSULOGSTATE_PK PRIMARY KEY (TESTSUITELOG_STATE_ID) ON VNF_IDX
GO
ALTER TABLE RIODS.TESTSUITELOG_STATE ADD CONSTRAINT TSTSULOGSTATE_FK1 FOREIGN KEY (TEST_STATUS_ID)	REFERENCES RIODS.TEST_STATUS (TEST_STATUS_ID)
GO
INSERT INTO RIODS.TESTSUITELOG_STATE (TESTSUITELOG_STATE_ID,NAME) VALUES(-1,'Info not available')
GO
CREATE INDEX TSTSULOGSTATE_IDX1 ON RIODS.TESTSUITELOG_STATE (EXTERNAL_KEY2)ON VNF_IDX
GO                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
CREATE INDEX TSTSULOGSTATE_IDX2 ON RIODS.TESTSUITELOG_STATE (EXTERNAL_KEY1)ON VNF_IDX
GO                                                                                                                                                                                                                                                                                                                                                                                              
CREATE INDEX TSTSULOGSTATE_IDX3 ON RIODS.TESTSUITELOG_STATE (EXTERNAL_KEY2,SOURCE_ID)ON VNF_IDX
GO                                                                                                                                                                                                                                                                                       
CREATE INDEX TSTSULOGSTATE_IDX4 ON RIODS.TESTSUITELOG_STATE (EXTERNAL_KEY1,SOURCE_ID)ON VNF_IDX
GO                                                                                                                                                                                  
CREATE INDEX TSTSULOGSTATE_IDX5 ON RIODS.TESTSUITELOG_STATE (EXTERNAL_ID)ON VNF_IDX
GO                                                                                          
CREATE INDEX TSTSULOGSTATE_IDX6 ON RIODS.TESTSUITELOG_STATE (ISSOFTDELETED)ON VNF_IDX
GO                                                                                          
CREATE TABLE RIODS.EXECRESULT_STATE (		EXECRESULT_STATE_ID INT  NOT NULL,		NAME NVARCHAR(255) DEFAULT 'Execution Result State Name Missing' NOT NULL,		REFERENCE_ID NVARCHAR(50),		EXTERNAL_ID NVARCHAR(100),		PROJECT_ID INT  DEFAULT -1 NOT NULL,		TEST_STATUS_ID INT  DEFAULT -1 NOT NULL,		URL NVARCHAR(2048),		EXTERNAL_KEY1 INT  DEFAULT -1 NOT NULL,		EXTERNAL_KEY2 NCHAR(40) DEFAULT '-1' NOT NULL,		SOURCE_ID NVARCHAR (36) DEFAULT '-1' NOT NULL,		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL,		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL) ON VNF_32K 
GO
ALTER TABLE RIODS.EXECRESULT_STATE ADD CONSTRAINT EXECRESSTATE_PK PRIMARY KEY (EXECRESULT_STATE_ID) ON VNF_IDX
GO
ALTER TABLE RIODS.EXECRESULT_STATE ADD CONSTRAINT EXECRESSTATE_FK1 FOREIGN KEY (TEST_STATUS_ID) REFERENCES RIODS.TEST_STATUS (TEST_STATUS_ID)
GO
INSERT INTO RIODS.EXECRESULT_STATE (EXECRESULT_STATE_ID,NAME) VALUES(-1,'Info not available')
GO
CREATE INDEX EXECRESSTATE_IDX1 ON RIODS.EXECRESULT_STATE (EXTERNAL_KEY2)ON VNF_IDX
GO               
CREATE INDEX EXECRESSTATE_IDX2 ON RIODS.EXECRESULT_STATE (EXTERNAL_KEY1)ON VNF_IDX
GO                                                                                                                                                                                                                                                                                                                                                                                                 
CREATE INDEX EXECRESSTATE_IDX3 ON RIODS.EXECRESULT_STATE (EXTERNAL_KEY2,SOURCE_ID)ON VNF_IDX
GO                                                                                                                                                                                                                                                                                          
CREATE INDEX EXECRESSTATE_IDX4 ON RIODS.EXECRESULT_STATE (EXTERNAL_KEY1,SOURCE_ID)ON VNF_IDX
GO                                                                                                                                                                                     
CREATE INDEX EXECRESSTATE_IDX5 ON RIODS.EXECRESULT_STATE (EXTERNAL_ID)ON VNF_IDX
GO                                                                                             
CREATE INDEX EXECRESSTATE_IDX6 ON RIODS.EXECRESULT_STATE (ISSOFTDELETED)ON VNF_IDX
GO       
CREATE TABLE RIODS.TESTCASE_STATE (		TESTCASE_STATE_ID INT  NOT NULL,		NAME NVARCHAR(255) DEFAULT 'Test Case State Name Missing' NOT NULL,		REFERENCE_ID NVARCHAR(50),		EXTERNAL_ID NVARCHAR(100),		PROJECT_ID INT  DEFAULT -1 NOT NULL,		TEST_STATUS_ID INT  DEFAULT -1 NOT NULL,		URL NVARCHAR(2048),		EXTERNAL_KEY1 INT  DEFAULT -1 NOT NULL,		EXTERNAL_KEY2 NCHAR(40) DEFAULT '-1' NOT NULL,		SOURCE_ID NVARCHAR (36) DEFAULT '-1' NOT NULL,		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL,		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL) ON VNF_32K 
GO
ALTER TABLE RIODS.TESTCASE_STATE ADD CONSTRAINT TSTCASESTATE_PK PRIMARY KEY (TESTCASE_STATE_ID) ON VNF_IDX
GO
ALTER TABLE RIODS.TESTCASE_STATE ADD CONSTRAINT TSTCASESTATE_FK1 FOREIGN KEY (TEST_STATUS_ID) REFERENCES RIODS.TEST_STATUS (TEST_STATUS_ID)
GO
INSERT INTO RIODS.TESTCASE_STATE(TESTCASE_STATE_ID,NAME) VALUES(-1,'Info not available')
GO
CREATE INDEX TSTCASESTATE_IDX1 ON RIODS.TESTCASE_STATE  (EXTERNAL_KEY2)ON VNF_IDX
GO     	 	                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
CREATE INDEX TSTCASESTATE_IDX2 ON RIODS.TESTCASE_STATE  (EXTERNAL_KEY1)ON VNF_IDX
GO       	         
CREATE INDEX TSTCASESTATE_IDX3 ON RIODS.TESTCASE_STATE  (EXTERNAL_KEY2,SOURCE_ID)ON VNF_IDX
GO	                                                                                               	                                                                                                                                                                                           
CREATE INDEX TSTCASESTATE_IDX4 ON RIODS.TESTCASE_STATE  (EXTERNAL_KEY1,SOURCE_ID)ON VNF_IDX
GO	                                                                                                	                                                                                                                                                                              
CREATE INDEX TSTCASESTATE_IDX5 ON RIODS.TESTCASE_STATE  (EXTERNAL_ID)ON VNF_IDX
GO	                                                                                                                                                                                      
CREATE INDEX TSTCASESTATE_IDX6 ON RIODS.TESTCASE_STATE  (ISSOFTDELETED)ON VNF_IDX
GO	   
CREATE TABLE RIODS.TESTPLAN_STATE (		TESTPLAN_STATE_ID INT  NOT NULL,		NAME NVARCHAR(255) DEFAULT 'Test Plan State Name Missing' NOT NULL,		REFERENCE_ID NVARCHAR(50),		EXTERNAL_ID NVARCHAR(100),		PROJECT_ID INT  DEFAULT -1 NOT NULL,		TEST_STATUS_ID INT  DEFAULT -1 NOT NULL,		URL NVARCHAR(2048),		EXTERNAL_KEY1 INT  DEFAULT -1 NOT NULL,		EXTERNAL_KEY2 NCHAR(40) DEFAULT '-1' NOT NULL,		SOURCE_ID NVARCHAR (36) DEFAULT '-1' NOT NULL,		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL,		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL) ON VNF_32K 
GO
ALTER TABLE RIODS.TESTPLAN_STATE ADD CONSTRAINT TSTPLANSTATE_PK PRIMARY KEY (TESTPLAN_STATE_ID) ON VNF_IDX
GO
ALTER TABLE RIODS.TESTPLAN_STATE ADD CONSTRAINT TSTPLANSTATE_FK1 FOREIGN KEY (TEST_STATUS_ID) REFERENCES RIODS.TEST_STATUS (TEST_STATUS_ID)
GO
INSERT INTO RIODS.TESTPLAN_STATE(TESTPLAN_STATE_ID,NAME) VALUES(-1,'Info not available')
GO
CREATE INDEX TSTPLANSTATE_IDX1 ON RIODS.TESTPLAN_STATE  (EXTERNAL_KEY2)ON VNF_IDX
GO
CREATE INDEX TSTPLANSTATE_IDX2 ON RIODS.TESTPLAN_STATE  (EXTERNAL_KEY1)ON VNF_IDX
GO
CREATE INDEX TSTPLANSTATE_IDX3 ON RIODS.TESTPLAN_STATE  (EXTERNAL_KEY2,SOURCE_ID)ON VNF_IDX
GO
CREATE INDEX TSTPLANSTATE_IDX4 ON RIODS.TESTPLAN_STATE  (EXTERNAL_KEY1,SOURCE_ID)ON VNF_IDX
GO
CREATE INDEX TSTPLANSTATE_IDX5 ON RIODS.TESTPLAN_STATE  (EXTERNAL_ID)ON VNF_IDX
GO
CREATE INDEX TSTPLANSTATE_IDX6 ON RIODS.TESTPLAN_STATE  (ISSOFTDELETED)ON VNF_IDX
GO
CREATE TABLE RIODS.TESTSCRIPT_STATE (		TESTSCRIPT_STATE_ID INT  NOT NULL,		NAME NVARCHAR(255) DEFAULT 'Test Script State Name Missing' NOT NULL,		REFERENCE_ID NVARCHAR(50),		EXTERNAL_ID NVARCHAR(100),		PROJECT_ID INT  DEFAULT -1 NOT NULL,		TEST_STATUS_ID INT  DEFAULT -1 NOT NULL,		URL NVARCHAR(2048),		EXTERNAL_KEY1 INT  DEFAULT -1 NOT NULL,		EXTERNAL_KEY2 NCHAR(40) DEFAULT '-1' NOT NULL,		SOURCE_ID NVARCHAR (36) DEFAULT '-1' NOT NULL,		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL,		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL) ON VNF_32K 
GO
ALTER TABLE RIODS.TESTSCRIPT_STATE ADD CONSTRAINT TSTSCRPTSTATE_PK PRIMARY KEY (TESTSCRIPT_STATE_ID) ON VNF_IDX
GO
ALTER TABLE RIODS.TESTSCRIPT_STATE ADD CONSTRAINT TSTSCRPTSTATE_FK1 FOREIGN KEY (TEST_STATUS_ID) REFERENCES RIODS.TEST_STATUS (TEST_STATUS_ID)
GO
INSERT INTO RIODS.TESTSCRIPT_STATE(TESTSCRIPT_STATE_ID,NAME) VALUES(-1,'Info not available')
GO
CREATE INDEX TSTSCRPTSTATE_IDX1 ON RIODS.TESTSCRIPT_STATE  (EXTERNAL_KEY2)ON VNF_IDX
GO
CREATE INDEX TSTSCRPTSTATE_IDX2 ON RIODS.TESTSCRIPT_STATE  (EXTERNAL_KEY1)ON VNF_IDX
GO
CREATE INDEX TSTSCRPTSTATE_IDX3 ON RIODS.TESTSCRIPT_STATE  (EXTERNAL_KEY2,SOURCE_ID)ON VNF_IDX
GO
CREATE INDEX TSTSCRPTSTATE_IDX4 ON RIODS.TESTSCRIPT_STATE  (EXTERNAL_KEY1,SOURCE_ID)ON VNF_IDX
GO
CREATE INDEX TSTSCRPTSTATE_IDX5 ON RIODS.TESTSCRIPT_STATE  (EXTERNAL_ID)ON VNF_IDX
GO
CREATE INDEX TSTPSCRPTSTATE_IDX6 ON RIODS.TESTSCRIPT_STATE  (ISSOFTDELETED)ON VNF_IDX
GO
ALTER TABLE RIODS.TESTSUITE ADD TESTSUITE_STATE_ID INT DEFAULT -1 NOT NULL
GO
ALTER TABLE RIODS.TESTSUITE ADD CONSTRAINT TESTSUITE_FK7 FOREIGN KEY (TESTSUITE_STATE_ID) REFERENCES RIODS.TESTSUITE_STATE (TESTSUITE_STATE_ID)
GO
ALTER TABLE RIODS.TESTSUITELOG ADD TESTSUITELOG_STATE_ID INT DEFAULT -1 NOT NULL
GO
ALTER TABLE RIODS.TESTSUITELOG ADD CONSTRAINT TESTSUITELOG_FK8 FOREIGN KEY (TESTSUITELOG_STATE_ID) REFERENCES RIODS.TESTSUITELOG_STATE (TESTSUITELOG_STATE_ID)
GO
ALTER TABLE RIODS.EXECUTION_RESULT ADD EXECRESULT_STATE_ID INT DEFAULT -1 NOT NULL
GO
ALTER TABLE RIODS.EXECUTION_RESULT ADD CONSTRAINT EXECRES_FK9 FOREIGN KEY (EXECRESULT_STATE_ID) REFERENCES RIODS.EXECRESULT_STATE (EXECRESULT_STATE_ID)
GO
ALTER TABLE RIODS.TESTCASE ADD TESTCASE_STATE_ID INT DEFAULT-1 NOT NULL
GO
ALTER TABLE RIODS.TESTCASE ADD CONSTRAINT TESTCASE_FK6 FOREIGN KEY (TESTCASE_STATE_ID) REFERENCES RIODS.TESTCASE_STATE (TESTCASE_STATE_ID)
GO
ALTER TABLE RIODS.TESTPLAN  ADD TESTPLAN_STATE_ID INT DEFAULT-1 NOT NULL
GO
ALTER TABLE RIODS.TESTPLAN ADD CONSTRAINT TESTPLAN_FK5 FOREIGN KEY (TESTPLAN_STATE_ID) REFERENCES RIODS.TESTPLAN_STATE (TESTPLAN_STATE_ID)
GO	                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
ALTER TABLE RIODS.TESTSCRIPT  ADD TESTSCRIPT_STATE_ID INT DEFAULT-1 NOT NULL
GO
ALTER TABLE RIODS.TESTSCRIPT ADD CONSTRAINT TESTSCRIPT_FK3 FOREIGN KEY (TESTSCRIPT_STATE_ID) REFERENCES RIODS.TESTSCRIPT_STATE (TESTSCRIPT_STATE_ID)
GO
CREATE TABLE RIODS.TIMELINE (  		TIMELINE_ID INT  NOT NULL,  		NAME NVARCHAR(255) DEFAULT 'Project Timeline Name Missing' NOT NULL,  		REFERENCE_ID NVARCHAR(50), 	 	EXTERNAL_ID NVARCHAR(100),  		PROJECT_ID INT  DEFAULT -1 NOT NULL,  		STATUS NVARCHAR(255),  		START_DATE DATETIME,  		END_DATE DATETIME,  		URL NVARCHAR(2048),  		EXTERNAL_KEY1 INT  DEFAULT -1 NOT NULL,  		EXTERNAL_KEY2 NCHAR(40) DEFAULT '-1' NOT NULL,  		SOURCE_ID NVARCHAR (36) DEFAULT '-1' NOT NULL,  		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL,  		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL ) ON VNF_32K 
GO
ALTER TABLE RIODS.TIMELINE ADD CONSTRAINT TIMELINE_PK PRIMARY KEY (TIMELINE_ID) ON VNF_IDX
GO
INSERT INTO RIODS.TIMELINE (TIMELINE_ID,NAME) VALUES(-1,'Info not available')
GO
CREATE INDEX TIMELINE_IDX1 ON RIODS.TIMELINE (EXTERNAL_KEY2) ON VNF_IDX
GO             
CREATE INDEX TIMELINE_IDX2 ON RIODS.TIMELINE (EXTERNAL_KEY1) ON VNF_IDX
GO            
CREATE INDEX TIMELINE_IDX3 ON RIODS.TIMELINE (EXTERNAL_KEY2,SOURCE_ID) ON VNF_IDX
GO            
CREATE INDEX TIMELINE_IDX4 ON RIODS.TIMELINE (EXTERNAL_KEY1,SOURCE_ID) ON VNF_IDX
GO           
CREATE INDEX TIMELINE_IDX5 ON RIODS.TIMELINE (EXTERNAL_ID) ON VNF_IDX
GO           
CREATE INDEX TIMELINE_IDX6 ON RIODS.TIMELINE (ISSOFTDELETED) ON VNF_IDX
GO           
ALTER TABLE RIODS.ITERATION ADD PARENT_ITERATION_ID INT DEFAULT-1 NOT NULL
GO
ALTER TABLE RIODS.ITERATION ADD TIMELINE_ID INT DEFAULT-1 NOT NULL
GO
ALTER TABLE RIODS.ITERATION ADD CONSTRAINT ITERATION_FK5 FOREIGN KEY (PARENT_ITERATION_ID)	REFERENCES RIODS.ITERATION (ITERATION_ID)
GO	
ALTER TABLE RIODS.ITERATION ADD CONSTRAINT ITERATION_FK6 FOREIGN KEY (TIMELINE_ID)	REFERENCES RIODS.TIMELINE (TIMELINE_ID)
GO	
CREATE TABLE RIODS.REQUIREMENT_TESTSCRIPT_LOOKUP(		REQUIREMENT_ID INT  NOT NULL,		TESTSCRIPT_ID INT  NOT NULL,		LINK_TYPE_NAME NVARCHAR(255) NOT NULL) ON VNF_32K 
GO
ALTER TABLE RIODS.REQUIREMENT_TESTSCRIPT_LOOKUP ADD CONSTRAINT REQTSTSRPT_PK PRIMARY KEY (REQUIREMENT_ID,TESTSCRIPT_ID,LINK_TYPE_NAME) ON VNF_IDX
GO
ALTER TABLE RIODS.REQUIREMENT_TESTSCRIPT_LOOKUP ADD CONSTRAINT REQTSTSRPT_FK1 FOREIGN KEY (REQUIREMENT_ID)	REFERENCES RIODS.REQUIREMENT (REQUIREMENT_ID)
GO
ALTER TABLE RIODS.REQUIREMENT_TESTSCRIPT_LOOKUP ADD CONSTRAINT REQTSTSRPT_FK2 FOREIGN KEY (TESTSCRIPT_ID)	REFERENCES RIODS.TESTSCRIPT (TESTSCRIPT_ID)
GO
ALTER TABLE RIODS.TESTSCRIPT ADD PROJECT_ID INT DEFAULT -1 NOT NULL
GO
ALTER TABLE RIODS.TESTSCRIPT ADD CONSTRAINT TESTSCRIPT_FK2 FOREIGN KEY (PROJECT_ID) REFERENCES RIODS.PROJECT (PROJECT_ID)
GO
CREATE TRIGGER RIODS.TRG_REQUITSCRPT ON RIODS.TESTSCRIPT FOR UPDATE AS BEGIN DELETE FROM RIODS.REQUIREMENT_TESTSCRIPT_LOOKUP  WHERE  TESTSCRIPT_ID IN  (SELECT  TESTSCRIPT_ID FROM INSERTED ) END
GO
CREATE VIEW RIDW.VW_REQUIREMT_TESTSCRIPT_LOOKUP(REQUIREMENT_ID,REQUIREMENT_NAME,TESTSCRIPT_ID,TESTSCRIPT_NAME,LINK_TYPE_NAME) AS(SELECT RT.REQUIREMENT_ID,R.NAME AS REQUIREMENT_NAME,RT.TESTSCRIPT_ID,T.NAME AS TESTSCRIPT_NAME,RT.LINK_TYPE_NAME FROM RIODS.REQUIREMENT_TESTSCRIPT_LOOKUP RT JOIN RIODS.REQUIREMENT R ON R.REQUIREMENT_ID=RT.REQUIREMENT_ID JOIN RIODS.TESTSCRIPT T ON T.TESTSCRIPT_ID=RT.TESTSCRIPT_ID)
GO
GRANT SELECT ON RIDW.VW_REQUIREMT_TESTSCRIPT_LOOKUP TO REPUSER
GO
DROP VIEW RIDW.VW_ITERATION
GO
CREATE VIEW RIDW.VW_ITERATION (ITERATION_ID, NAME, REFERENCE_ID, EXTERNAL_ID, ASSETREGISTRY_ID,ASSETREGISTRY_NAME,PROJECT_ID, PROJECT_NAME,PHASE_ID, PHASE_NAME,OWNER_ID,OWNER_NAME,PARENT_ITERATION_ID,PARENT_ITERATION_NAME,TIMELINE_ID,TIMELINE_NAME,STATUS, DESCRIPTION, START_DATE, END_DATE, EXPECTED_START_DATE, EXPECTED_END_DATE,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,EXPECTED_TOTAL_POINTS,EXPECTED_DEFECTS,EXPECTED_VALIDITY_RATE,REC_DATETIME,ISSOFTDELETED) AS (SELECT I.ITERATION_ID, I.NAME, I.REFERENCE_ID, I.EXTERNAL_ID, I.ASSETREGISTRY_ID,A.NAME,I.PROJECT_ID, P.NAME AS PROJECT_NAME,I.PHASE_ID,PH.NAME,I.OWNER_ID,R.FULL_NAME AS OWNER_NAME,I.PARENT_ITERATION_ID,PI.NAME AS PARENT_ITERATION_NAME,I.TIMELINE_ID,T.NAME AS TIMELINE_NAME,I.STATUS,I.DESCRIPTION,I.START_DATE, I.END_DATE , I.EXPECTED_START_DATE, I.EXPECTED_END_DATE,I.URL,I.EXTERNAL_KEY1,I.EXTERNAL_KEY2,I.EXPECTED_TOTAL_POINTS,I.EXPECTED_DEFECTS,I.EXPECTED_VALIDITY_RATE,I.REC_DATETIME,I.ISSOFTDELETED  FROM RIODS.ITERATION I  JOIN RIODS.PROJECT P ON P.PROJECT_ID=I.PROJECT_ID JOIN RIODS.PHASE PH ON PH.PHASE_ID=I.PHASE_ID  JOIN RIODS.RESOURCE R ON R.RESOURCE_ID=I.OWNER_ID JOIN RIODS.ASSETREGISTRY A ON A.ASSETREGISTRY_ID=I.ASSETREGISTRY_ID JOIN RIODS.ITERATION PI ON PI.ITERATION_ID=I.PARENT_ITERATION_ID JOIN RIODS.TIMELINE T ON T.TIMELINE_ID=I.TIMELINE_ID)
GO
GRANT SELECT ON RIDW.VW_ITERATION TO REPUSER
GO 
CREATE VIEW RIDW.VW_TEST_STATUS (TEST_STATUS_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS(SELECT T.TEST_STATUS_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED FROM RIODS.TEST_STATUS T JOIN RIODS.PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO
GRANT SELECT ON RIDW.VW_TEST_STATUS TO REPUSER
GO 
CREATE VIEW RIDW.VW_TESTSUITE_STATE (TESTSUITE_STATE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,TEST_STATUS_ID,TEST_STATUS_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS(SELECT T.TESTSUITE_STATE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.TEST_STATUS_ID,TS.NAME AS TEST_STATUS_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED FROM RIODS.TESTSUITE_STATE T JOIN RIODS.TEST_STATUS TS ON TS.TEST_STATUS_ID=T.TEST_STATUS_ID JOIN RIODS.PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO
GRANT SELECT ON RIDW.VW_TESTSUITE_STATE TO REPUSER
GO 
CREATE VIEW RIDW.VW_TESTSUITELOG_STATE (TESTSUITELOG_STATE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,TEST_STATUS_ID,TEST_STATUS_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS(SELECT T.TESTSUITELOG_STATE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.TEST_STATUS_ID,TS.NAME AS TEST_STATUS_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED FROM RIODS.TESTSUITELOG_STATE T JOIN RIODS.TEST_STATUS TS ON TS.TEST_STATUS_ID=T.TEST_STATUS_ID JOIN RIODS.PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO
GRANT SELECT ON RIDW.VW_TESTSUITELOG_STATE TO REPUSER
GO 
CREATE VIEW RIDW.VW_EXECRESULT_STATE (EXECRESULT_STATE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,TEST_STATUS_ID,TEST_STATUS_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS(SELECT T.EXECRESULT_STATE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.TEST_STATUS_ID,TS.NAME AS TEST_STATUS_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED FROM RIODS.EXECRESULT_STATE T JOIN RIODS.TEST_STATUS TS ON TS.TEST_STATUS_ID=T.TEST_STATUS_ID JOIN RIODS.PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO
GRANT SELECT ON RIDW.VW_EXECRESULT_STATE TO REPUSER
GO 
CREATE VIEW RIDW.VW_TESTCASE_STATE (TESTCASE_STATE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,TEST_STATUS_ID,TEST_STATUS_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS(SELECT T.TESTCASE_STATE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.TEST_STATUS_ID,TS.NAME AS TEST_STATUS_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED FROM RIODS.TESTCASE_STATE T JOIN RIODS.TEST_STATUS TS ON TS.TEST_STATUS_ID=T.TEST_STATUS_ID JOIN RIODS.PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO
GRANT SELECT ON RIDW.VW_TESTCASE_STATE TO REPUSER
GO 
CREATE VIEW RIDW.VW_TESTPLAN_STATE (TESTPLAN_STATE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,TEST_STATUS_ID,TEST_STATUS_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS (SELECT T.TESTPLAN_STATE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.TEST_STATUS_ID,TS.NAME AS TEST_STATUS_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED FROM RIODS.TESTPLAN_STATE T JOIN RIODS.TEST_STATUS TS ON TS.TEST_STATUS_ID=T.TEST_STATUS_ID JOIN RIODS.PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO
GRANT SELECT ON RIDW.VW_TESTPLAN_STATE TO REPUSER
GO
CREATE VIEW RIDW.VW_TESTSCRIPT_STATE (TESTSCRIPT_STATE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,TEST_STATUS_ID,TEST_STATUS_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT T.TESTSCRIPT_STATE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.TEST_STATUS_ID,TS.NAME AS TEST_STATUS_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED FROM RIODS.TESTSCRIPT_STATE T JOIN RIODS.TEST_STATUS TS ON TS.TEST_STATUS_ID=T.TEST_STATUS_ID JOIN RIODS.PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO
GRANT SELECT ON RIDW.VW_TESTSCRIPT_STATE TO REPUSER
GO
CREATE VIEW RIDW.VW_TIMELINE (TIMELINE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,STATUS,START_DATE,END_DATE,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED )AS	(SELECT T.TIMELINE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.STATUS,T.START_DATE,T.END_DATE,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED  FROM RIODS.TIMELINE T JOIN RIODS.PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO
GRANT SELECT ON RIDW.VW_TIMELINE TO REPUSER
GO 
DROP VIEW RIDW.VW_TESTCASE
GO
CREATE VIEW RIDW.VW_TESTCASE (EXTERNAL_ID,IS_BLOCKING,NAME,REFERENCE_ID,TESTCASE_ID,TESTCASE_STATE,TESTPLAN_ID,TESTPLAN_NAME,URL,OWNER_ID,OWNER_NAME,REGRESSION_TEST,WEIGHT,LAST_UPDATED,COMPONENT_ID,COMPONENT_NAME,TESTCASE_STATE_ID,TESTCASE_STATE_EXTERNAL_ID,TESTCASE_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTCASE_CLASS_ID,TESTCASE_CLASS_NAME,TESTCASE_FOLDER,PROJECT_ID,PROJECT_NAME,REC_DATETIME,ISSOFTDELETED) AS (SELECT T.EXTERNAL_ID,T.IS_BLOCKING,T.NAME,T.REFERENCE_ID,T.TESTCASE_ID,TS.NAME AS TESTCASE_STATE,T.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME, T.URL,T.OWNER_ID,R.FULL_NAME AS OWNER_NAME,T.REGRESSION_TEST,T.WEIGHT,T.LAST_UPDATED,T.COMPONENT_ID,C.NAME AS COMPONENT_NAME,T.TESTCASE_STATE_ID,TS.EXTERNAL_ID AS TESTCASE_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTCASE_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TESTCASE_CLASS_ID,TL.NAME AS TESTCASE_CLASS_NAME,T.TESTCASE_FOLDER,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.REC_DATETIME,T.ISSOFTDELETED FROM RIODS.TESTCASE T JOIN RIODS.TESTPLAN TP ON TP.TESTPLAN_ID=T.TESTPLAN_ID JOIN RIODS.RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID JOIN RIODS.COMPONENT C ON C.COMPONENT_ID=T.COMPONENT_ID JOIN RIODS.PROJECT P ON P.PROJECT_ID=T.PROJECT_ID JOIN RIODS.TESTCASE_CLASSIFICATION TL ON TL.TESTCASE_CLASS_ID=T.TESTCASE_CLASS_ID JOIN RIODS.TESTCASE_STATE TS ON TS.TESTCASE_STATE_ID=T.TESTCASE_STATE_ID JOIN RIODS.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID)
GO
GRANT SELECT ON RIDW.VW_TESTCASE TO REPUSER
GO
DROP VIEW RIDW.VW_TESTSUITE
GO
CREATE VIEW RIDW.VW_TESTSUITE (EXTERNAL_ID,NAME,REFERENCE_ID,TESTSUITE_ID,TESTSUITE_STATE,URL,LAST_UPDATED,PROJECT_ID,PROJECT_NAME,CREATION_DATE,OWNER_ID,OWNER_NAME,CONFIGURATION_ID,CONFIGURATION_NAME,ASSETREGISTRY_ID,ASSETREGISTRY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTSUITE_CLASS_ID,TESTSUITE_CLASS_NAME,TESTSUITE_STATE_ID,TESTSUITE_STATE_EXTERNAL_ID,TESTSUITE_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,REC_DATETIME,ISSOFTDELETED,DESCRIPTION,ISSEQUENTIAL,CREATOR_ID,CREATOR_NAME,WEIGHT) AS (SELECT T.EXTERNAL_ID,T.NAME,T.REFERENCE_ID,T.TESTSUITE_ID,TS.NAME AS TESTSUITE_STATE,T.URL,T.LAST_UPDATED,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.CREATION_DATE,T.OWNER_ID,R.FULL_NAME AS OWNER_NAME,T.CONFIGURATION_ID,C.NAME AS CONFIGURATION_NAME,T.ASSETREGISTRY_ID,A.NAME AS ASSETREGISTRY_NAME,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TESTSUITE_CLASS_ID,TL.NAME AS TESTSUITE_CLASS_NAME,T.TESTSUITE_STATE_ID,TS.EXTERNAL_ID AS TESTSUITE_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTSUITE_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,T.REC_DATETIME,T.ISSOFTDELETED,T.DESCRIPTION,T.ISSEQUENTIAL,T.CREATOR_ID,CT.FULL_NAME AS CREATOR_NAME,T.WEIGHT FROM RIODS.TESTSUITE T JOIN RIODS.PROJECT P ON P.PROJECT_ID=T.PROJECT_ID JOIN RIODS.RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID JOIN RIODS.RESOURCE CT ON CT.RESOURCE_ID=T.CREATOR_ID JOIN RIODS.CONFIGURATION C ON C.CONFIGURATION_ID =T.CONFIGURATION_ID JOIN RIODS.ASSETREGISTRY A ON A.ASSETREGISTRY_ID=T.ASSETREGISTRY_ID JOIN RIODS.TESTSUITE_CLASSIFICATION TL ON TL.TESTSUITE_CLASS_ID=T.TESTSUITE_CLASS_ID JOIN RIODS.TESTSUITE_STATE TS ON TS.TESTSUITE_STATE_ID=T.TESTSUITE_STATE_ID JOIN RIODS.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID)
GO
GRANT SELECT ON RIDW.VW_TESTSUITE TO REPUSER
GO
DROP VIEW RIDW.VW_TESTSUITELOG
GO
CREATE VIEW RIDW.VW_TESTSUITELOG (BUILD_ID, TESTSUITELOG_NAME,END_DATE, EXTERNAL_ID, ITERATION_ID, ITERATION_NAME, REFERENCE_ID, START_DATE, TESTSUITELOG_ID, TESTSUITE_ID, TESTSUITE_NAME, URL, VERDICT,OWNER_ID, OWNER_NAME,TESTPLAN_ID,TESTPLAN_NAME,WEIGHT,POINTS_PASSED,POINTS_FAILED,POINTS_BLOCKED,POINTS_INCONCLUSIVE,POINTS_ATTEMPTED,POINTS_PERMFAILED,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTSUITELOG_CLASS_ID,TESTSUITELOG_CLASS_NAME,TESTSUITE_EXECRECORD_ID,TESTSUITE_EXECRECORD_NAME,REC_DATETIME,ISSOFTDELETED,
TESTSUITELOG_STATE,TESTSUITELOG_STATE_ID,TESTSUITELOG_STATE_EXTERNAL_ID,TESTSUITELG_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID) AS (SELECT S.BUILD_ID, S.NAME AS TESTSUITELOG_NAME, S.END_DATE, S.EXTERNAL_ID, S.ITERATION_ID,I.NAME AS ITERATION_NAME, S.REFERENCE_ID, S.START_DATE, S.TESTSUITELOG_ID, S.TESTSUITE_ID, T.NAME AS TESTSUITE_NAME, S.URL, S.VERDICT,S.OWNER_ID,R.FULL_NAME AS  OWNER_NAME ,S.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME,S.WEIGHT,S.POINTS_PASSED,S.POINTS_FAILED,S.POINTS_BLOCKED,S.POINTS_INCONCLUSIVE,S.POINTS_ATTEMPTED,S.POINTS_PERMFAILED,S.EXTERNAL_KEY1,S.EXTERNAL_KEY2,S.TESTSUITELOG_CLASS_ID,TL.NAME AS TESTSUITELOG_CLASS_NAME,S.TESTSUITE_EXECRECORD_ID,TEX.NAME AS TESTSUITE_EXECRECORD_NAME,S.REC_DATETIME,S.ISSOFTDELETED, TS.NAME AS TESTSUITELOG_STATE,S.TESTSUITELOG_STATE_ID,TS.EXTERNAL_ID AS TESTSUITELOG_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTSUITELG_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID   FROM RIODS.TESTSUITELOG S  JOIN RIODS.ITERATION I ON I.ITERATION_ID=S.ITERATION_ID  JOIN RIODS.TESTSUITE T ON T.TESTSUITE_ID=S.TESTSUITE_ID JOIN RIODS.RESOURCE R ON R.RESOURCE_ID=S.OWNER_ID JOIN RIODS.TESTSUITELOG_CLASSIFICATION TL ON TL.TESTSUITELOG_CLASS_ID=S.TESTSUITELOG_CLASS_ID JOIN RIODS.TESTPLAN TP ON TP.TESTPLAN_ID=S.TESTPLAN_ID JOIN RIODS.TESTSUITE_EXECUTION_RECORD TEX ON TEX.TESTSUITE_EXECRECORD_ID=S.TESTSUITE_EXECRECORD_ID JOIN RIODS.TESTSUITELOG_STATE TS ON TS.TESTSUITELOG_STATE_ID=S.TESTSUITELOG_STATE_ID JOIN RIODS.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID)
GO
GRANT SELECT ON RIDW.VW_TESTSUITELOG TO REPUSER
GO
DROP VIEW RIDW.VW_EXECUTION_RESULT
GO
CREATE VIEW RIDW.VW_EXECUTION_RESULT (EXECUTION_RESULT_ID, EXECRES_CLASS_ID, EXECRES_CLASS_NAME, NAME, REFERENCE_ID, EXTERNAL_ID, VERDICT, OWNER_ID, OWNER_NAME, BUILD_ID, BUILD_NAME, ITERATION_ID, ITERATION_NAME, TESTTYPE_ID, TESTTYPE_NAME, TESCASE_ID, TESTCASE_NAME, PROJECT_ID, PROJECT_NAME, TESTSCRIPT_ID, TESTSCRIPT_NAME, START_DATE, END_DATE, POINTS_BLOCKED, POINTS_INCONCLUSIVE, MACHINE, POINTS_ATTEMPTED, POINTS_FAILED, POINTS_PASSED, POINTS_PERMFAILED, LAST_UPDATED, CREATION_DATE, SUITE_INDEX, URL, POINTS_DEFERRED, POINTS_TOTAL, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, REC_DATETIME, ISSOFTDELETED,EXECRESULT_STATE,EXECRESULT_STATE_ID,EXECRESULT_STATE_EXTERNAL_ID,EXECRESULT_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID) AS (SELECT EX.EXECUTION_RESULT_ID, EX.EXECRES_CLASS_ID, EC.NAME AS EXECRES_CLASS_NAME, EX.NAME, EX.REFERENCE_ID, EX.EXTERNAL_ID, EX.VERDICT, EX.OWNER_ID, R.NAME AS OWNER_NAME, EX.BUILD_ID, B.NAME AS BUILD_NAME, EX.ITERATION_ID, I.NAME AS ITERATION_NAME, EX.TESTTYPE_ID, T.NAME AS TESTTYPE_NAME, EX.TESTCASE_ID, T1.NAME AS TESTCASE_NAME, EX.PROJECT_ID, P.NAME AS PROJECT_NAME, EX.TESTSCRIPT_ID, T2.NAME AS TESTSCRIPT_NAME, EX.START_DATE, EX.END_DATE, EX.POINTS_BLOCKED, EX.POINTS_INCONCLUSIVE, EX.MACHINE, EX.POINTS_ATTEMPTED, EX.POINTS_FAILED, EX.POINTS_PASSED, EX.POINTS_PERMFAILED, EX.LAST_UPDATED, EX.CREATION_DATE, EX.SUITE_INDEX, EX.URL,EX.POINTS_DEFERRED,EX.POINTS_TOTAL,EX.EXTERNAL_KEY1, EX.EXTERNAL_KEY2, EX.SOURCE_ID, EX.REC_DATETIME, EX.ISSOFTDELETED, TS.NAME AS EXECRESULT_STATE,EX.EXECRESULT_STATE_ID,TS.EXTERNAL_ID AS EXECRESULT_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS EXECRESULT_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID FROM RIODS.EXECUTION_RESULT EX JOIN RIODS.BUILD B ON B.BUILD_ID = EX.BUILD_ID JOIN RIODS.EXECRESULT_CLASSIFICATION EC ON EC.EXECRES_CLASS_ID = EX.EXECRES_CLASS_ID JOIN RIODS.ITERATION I ON I.ITERATION_ID = EX.ITERATION_ID JOIN RIODS.PROJECT P ON P.PROJECT_ID = EX.PROJECT_ID JOIN RIODS.RESOURCE R ON R.RESOURCE_ID = EX.OWNER_ID JOIN RIODS.TESTTYPE T ON T.TESTTYPE_ID = EX.TESTTYPE_ID JOIN RIODS.TESTCASE T1 ON T1.TESTCASE_ID = EX.TESTCASE_ID JOIN RIODS.TESTSCRIPT T2 ON T2.TESTSCRIPT_ID = EX.TESTSCRIPT_ID JOIN RIODS.EXECRESULT_STATE TS ON TS.EXECRESULT_STATE_ID=EX.EXECRESULT_STATE_ID JOIN RIODS.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID)
GO
GRANT SELECT ON RIDW.VW_EXECUTION_RESULT TO REPUSER
GO
DROP VIEW RIDW.VW_TESTPLAN
GO
CREATE VIEW RIDW.VW_TESTPLAN (EXTERNAL_ID, NAME, REFERENCE_ID, TESTPLAN_ID, TESTPLAN_STATE,PROJECT_ID,PROJECT_NAME,CREATION_DATE,OWNER_ID,OWNER_NAME,LAST_UPDATED,URL,ASSETREGISTRY_ID,ASSETREGISTRY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTPLAN_CLASS_ID,TESTPLAN_CLASS_NAME,REC_DATETIME,ISSOFTDELETED,TESTPLAN_STATE_ID,TESTPLAN_STATE_EXTERNAL_ID,TESTPLAN_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID) AS (SELECT T.EXTERNAL_ID, T.NAME, T.REFERENCE_ID, T.TESTPLAN_ID, TS.NAME AS TESTPLAN_STATE,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.CREATION_DATE, T.OWNER_ID,R.FULL_NAME AS OWNER_NAME,T.LAST_UPDATED,T.URL,T.ASSETREGISTRY_ID,A.NAME AS ASSETREGISTRY_NAME,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TESTPLAN_CLASS_ID,TL.NAME AS TESTPLAN_CLASS_NAME,T.REC_DATETIME,T.ISSOFTDELETED,T.TESTPLAN_STATE_ID,TS.EXTERNAL_ID AS TESTPLAN_STATE_EXTERNAL_ID,TS.REFERENCE_ID TESTPLAN_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID FROM RIODS.TESTPLAN T JOIN RIODS.PROJECT P ON P.PROJECT_ID=T.PROJECT_ID JOIN RIODS.RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID JOIN RIODS.ASSETREGISTRY A ON A.ASSETREGISTRY_ID=T.ASSETREGISTRY_ID JOIN RIODS.TESTPLAN_CLASSIFICATION TL ON TL.TESTPLAN_CLASS_ID=T.TESTPLAN_CLASS_ID JOIN RIODS.TESTPLAN_STATE TS ON TS.TESTPLAN_STATE_ID=T.TESTPLAN_STATE_ID JOIN RIODS.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID)
GO
GRANT SELECT ON RIDW.VW_TESTPLAN TO REPUSER
GO
DROP VIEW RIDW.VW_TESTSCRIPT
GO
CREATE VIEW RIDW.VW_TESTSCRIPT (TESTSCRIPT_ID, REFERENCE_ID, EXTERNAL_ID, NAME, LAST_UPDATED, TESTSCRIPT_STATE, TYPE, OWNER_ID,OWNER_NAME, PROJECT_ID, PROJECT_NAME, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, URL, REC_DATETIME, ISSOFTDELETED,TESTSCRIPT_STATE_ID,TESTSCRIPT_STATE_EXTERNAL_ID,TESTSCRIPT_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID) AS (SELECT TEST.TESTSCRIPT_ID, TEST.REFERENCE_ID, TEST.EXTERNAL_ID, TEST.NAME, TEST.LAST_UPDATED, TS.NAME AS TESTSCRIPT_STATE, TEST.TYPE, TEST.OWNER_ID, R.NAME AS OWNER_NAME, TEST.PROJECT_ID, P.NAME AS PROJECT_NAME,TEST.EXTERNAL_KEY1, TEST.EXTERNAL_KEY2, TEST.SOURCE_ID, TEST.URL, TEST.REC_DATETIME, TEST.ISSOFTDELETED,TEST.TESTSCRIPT_STATE_ID,TS.EXTERNAL_ID AS TESTSCRIPT_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTSCRIPT_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID FROM RIODS.TESTSCRIPT TEST JOIN RIODS.RESOURCE R ON R.RESOURCE_ID = TEST.OWNER_ID JOIN RIODS.PROJECT P ON P.PROJECT_ID = TEST.PROJECT_ID JOIN RIODS.TESTSCRIPT_STATE TS ON TS.TESTSCRIPT_STATE_ID=TEST.TESTSCRIPT_STATE_ID JOIN RIODS.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID)
GO
GRANT SELECT ON RIDW.VW_TESTSCRIPT TO REPUSER
GO
DROP TRIGGER RIODS.TRG_TSTPLTLK
GO
CREATE TRIGGER RIODS.TRG_TSTPLTLK ON RIODS.TESTPLAN FOR UPDATE AS BEGIN DELETE FROM RIODS.TESTSUITE_TESTPLAN_LOOKUP  WHERE  TESTPLAN_ID IN (SELECT  TESTPLAN_ID FROM INSERTED ) END
GO
DROP TRIGGER RIODS.TRG_REQLOG
GO
INSERT INTO RIODS.TESTSUITE_STATE (TESTSUITE_STATE_ID,NAME) SELECT STATE_ID, NAME FROM RIDW.D_TESTSUITE_STATE WHERE STATE_ID <>-1
GO
INSERT INTO RIODS.TESTCASE_STATE (TESTCASE_STATE_ID,NAME) SELECT STATE_ID, NAME FROM RIDW.D_TESTCASE_STATE WHERE STATE_ID <>-1
GO 
INSERT INTO RIODS.TESTPLAN_STATE (TESTPLAN_STATE_ID,NAME) SELECT STATE_ID, NAME FROM RIDW.D_TESTPLAN_STATE WHERE STATE_ID <>-1
GO 
UPDATE RIODS.TESTSUITE SET TESTSUITE_STATE_ID=COALESCE((SELECT S.TESTSUITE_STATE_ID FROM RIODS.TESTSUITE_STATE S WHERE S.NAME =TESTSUITE_STATE),-1)
GO
UPDATE RIODS.TESTPLAN SET TESTPLAN_STATE_ID=COALESCE((SELECT S.TESTPLAN_STATE_ID FROM RIODS.TESTPLAN_STATE S WHERE S.NAME =TESTPLAN_STATE),-1)
GO
UPDATE RIODS.TESTCASE SET TESTCASE_STATE_ID=COALESCE((SELECT S.TESTCASE_STATE_ID FROM RIODS.TESTCASE_STATE S WHERE S.NAME =TESTCASE_STATE),-1)
GO
SET IDENTITY_INSERT RIDW.D_DATE OFF
GO

UPDATE CONFIG.SYSCONFIG_INFO SET INT_VALUE=3, CHAR_VALUE='2.0 RC1' WHERE INFO_ID=18
GO