/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2008, 2011,
 * 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("jazz.util.theming");

dojo.require("jazz.util.internal.theming");
dojo.require("net.jazz.ajax.hasLocalRepository");
dojo.require("jazz.app.theming.currentTheme");

/*
 * PROVISIONAL: This API is considered provisional and may be changed or removed
 * in the future with minimal or no warning.
 * 
 * @since 0.7
 */

(function() {
	jazz.util.theming = {
		initialize : function() {
			jazz.util.theming.jsDfd = new dojo.Deferred();
			// if ( !jazz.util.theming.isThemingLocal()) return;
			if ( jazz.util.theming.hasCSS() ) {
				jazz.util.internal.theming._loadThemingCSS();
			}
			if ( jazz.util.theming.hasJS() ) {
				var dfd = jazz.util.internal.theming._loadThemingJS();
				dfd.addCallback(function() {
					jazz.util.theming.jsDfd.callback();
				});
				dfd.addErrback(function() {
					jazz.util.theming.jsDfd.errback();
				});
			} else {
				jazz.util.theming.jsDfd.callback();
			}
			dojo.registerModulePath("jazz.theme",
					jazz.util.internal.theming._getThemingUrl()
							+ "/resource");
		},
		
		hasCSS : function() {
			return jazz.app.theming.currentTheme().themeCss || jazz.util.theming.getPreviewTheme() != null ;
		},
		
		hasJS : function() {
			return jazz.app.theming.currentTheme().themeJs || jazz.util.theming.getPreviewTheme() != null;
		},

		themeFileUrl : function(path) {
			var result = this.getPreviewUrl(dojo.moduleUrl("jazz.theme", path).toString());
			return new dojo._Url(result);
		},
		
		getPreviewTheme : function() {
			if (window.location.search) {
				var queryObject = dojo.queryToObject(window.location.search
						.substring(1));
				if (queryObject.previewTheme) {
					return queryObject.previewTheme;
				}
			}
			return null;
		},
		getPreviewUrl : function(url) {
			var themeName = jazz.util.theming.getPreviewTheme();
			if (themeName) {
				return url + "?theme=" + encodeURIComponent(themeName);
			}
			return url;
		},
		isThemingLocal : function(url) {
			return net.jazz.ajax.hasLocalRepository();
		}
	};
})();
