/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.dashboard.web.ui.TeamDashboard");

dojo.require("com.ibm.team.dashboard.web.ui.DashboardConstants");
dojo.require("com.ibm.team.dashboard.web.ui.ProcessAreaDashboard");

var DashboardConstants = com.ibm.team.dashboard.web.ui.DashboardConstants;
var ProcessAreaDashboard = com.ibm.team.dashboard.web.ui.ProcessAreaDashboard;

/**
 * A team dashboard. Provides API and behavior specific to team dashboards, including
 * toolbar actions, auto-save behavior, and team details.
 * 
 * @since 4.0.1
 */
dojo.declare("com.ibm.team.dashboard.web.ui.TeamDashboard", [ProcessAreaDashboard], {
	
	/**
	 * (Required)
	 * The name of the project containing the team whose to show. The project is assumed to
	 * reside on the current server hosting the Web UI.
	 * 
	 * @type string
	 */
	projectName: null,
	
	/**
	 * (Required)
	 * A slash-separated path string containing the team hierarchy from a top-level team in a project
	 * to the target team whose dashboard to show. Each path segment is a team name (unencoded). The
	 * teams must reside in the project identified by the <code>projectName</code> parameter.
	 * 
	 * e.g. "Root Team/Child Team"
	 * 
	 * @type string
	 */
	team: null,
	
	// internal
	iconUrl: dojo.moduleUrl("com.ibm.team.dashboard.web", "graphics/Dashboard/icons/team-dash_obj.gif").toString(),
	scope: DashboardConstants.SCOPE_TEAM_AREA,
	
	constructor: function(args) {
		this.projectArea = args.projectName;
		this.scopeItem = args.team.split("/");
	}
});

})();
