/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.ProjectAreaListPage"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dojo.cookie"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("jazz.ui.ResourceLink");//$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("jazz.ui.Toolbar"); //$NON-NLS-1$	
	dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.contextRoot");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.client.init.InitializationData"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper");//$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var InitializationData = com.ibm.team.repository.web.client.init.InitializationData;
	var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var ResourceLink = jazz.ui.ResourceLink;
	var UIHelper = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;
	
	var MANAGE_PROJECT_AREAS_ACTION_URI = "#action=jazz.viewPage&id=com.ibm.team.process.ProjectAreaManagement"; //$NON-NLS-1$
	dojo.declare("com.ibm.team.process.web.ui.internal.ProjectAreaListPage", //$NON-NLS-1$
 [dijit._Widget, dijit._Templated], {
	
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/templates/ProjectAreaListPage.html"), //$NON-NLS-1$ //$NON-NLS-2$
		
		widgetsInTemplate: true,
		
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this._manageHref = net.jazz.ajax.contextRoot() + "/admin" + MANAGE_PROJECT_AREAS_ACTION_URI; //$NON-NLS-1$
			this._adminIconSrc = "com.ibm.team.process.web/ui/internal/images/manage-proj_co.gif"; //$NON-NLS-1$
			this._dashboardIconSrc = "com.ibm.team.process.web/ui/internal/images/explore-proj_co.gif"; //$NON-NLS-1$
			this._twistOpenIconSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/twistie-open.gif").toString(); //$NON-NLS-1$ //$NON-NLS-2$
			this._twistClosedIconSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/twistie-closed.gif").toString(); //$NON-NLS-1$ //$NON-NLS-2$
			this._resourceLinks = [];
			this._toolbars = [];
		},
		
		postCreate: function(){
			var ActionRegistry = net.jazz.ajax.ui.PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction("com.ibm.team.process.web._listProjects", this, "_runDefaultAction"); //$NON-NLS-1$ //$NON-NLS-2$
			var link = document.createElement("a"); //$NON-NLS-1$
			link.href = this._manageHref;
			link.appendChild(document.createTextNode(this.messages.ProjectAreaListPage_2));
			
			this.manageLink.appendChild(document.createTextNode(this.messages.ProjectAreaListPage_1));
			this.manageLink.appendChild(link);
			this.manageLink.appendChild(document.createTextNode(this.messages.ProjectAreaListPage_3));
			
			this.serverUrl.appendChild(document.createTextNode(dojo.string.substitute(this.messages.ProjectAreaListPage_9, [window.location.hostname])));
			
			this._messageBox = new jazz.ui.MessageBox();
			this._messageBoxDiv.appendChild(this._messageBox.domNode);
		},
		
		_runDefaultAction: function(){
			dojo.addClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
			dojox.xml.parser.removeChildren(this.myProjects);
			dojox.xml.parser.removeChildren(this.otherProjects);
			dojox.xml.parser.removeChildren(this.archivedProjects);
			
			var authContrib = getAuthenticatedContributor();
			var authContribId;
			if (authContrib) {
				authContribId = authContrib.userId;
			}
			var srh = new ServiceResponseHandler(this, "populateProjectAreas", "handleError"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.getAllProjectAreas(srh, {
				userId: authContribId
			});
		},
		
		showNoProjectAreasMessage: function(showMessage){
			if (showMessage) {
				dojo.removeClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
				dojo.addClass(this.contentArea, "hidden"); //$NON-NLS-1$
				var permissionInitializer = InitializationData.get("com.ibm.team.repository.service.canGrantPermissionInitializer"); //$NON-NLS-1$
				if (permissionInitializer && permissionInitializer.canGrantPermission) {
					dojo.removeClass(this.adminLinkArea, "hidden"); //$NON-NLS-1$
					dojo.removeClass(this.manageLink, "hidden"); //$NON-NLS-1$
					dojo.addClass(this.adminContact, "hidden"); //$NON-NLS-1$
				} else {
					dojo.addClass(this.adminLinkArea, "hidden"); //$NON-NLS-1$
					dojo.addClass(this.manageLink, "hidden"); //$NON-NLS-1$
					dojo.removeClass(this.adminContact, "hidden"); //$NON-NLS-1$
				}
			} else {
				dojo.addClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
				dojo.removeClass(this.adminLinkArea, "hidden"); //$NON-NLS-1$
				dojo.removeClass(this.contentArea, "hidden"); //$NON-NLS-1$
			}
		},
		
		populateProjectAreas: function(projectAreas){
			if (projectAreas) {
				projectAreas = projectAreas.sort(function(a, b){
					return a.name > b.name ? 1 : a.name < b.name ? -1 : 0;
				});
				var myProjects = [];
				var archivedProjects = [];
				for (var i = 0; i < projectAreas.length; i++) {
					if (projectAreas[i].archived) {
						archivedProjects.push(projectAreas[i]);
						projectAreas.splice(i, 1);
						i--;
					} else if (projectAreas[i].myProjectArea) {
						myProjects.push(projectAreas[i]);
						projectAreas.splice(i, 1);
						i--;
					}
				}
			}
			
			var showNoProjectsMessage = true;
			if (projectAreas && (projectAreas.length !== 0 || archivedProjects.length !== 0 || myProjects.length !== 0)) {
				if (myProjects.length > 0) {
					dojo.addClass(this.emptyMyProjectsMessage, "hidden");//$NON-NLS-1$
					this.populateArea(this.myProjects, myProjects);
					showNoProjectsMessage = false;
				} else {
					dojo.removeClass(this.emptyMyProjectsMessage, "hidden"); //$NON-NLS-1$
				}
				
				if (projectAreas && projectAreas.length > 0) {
					dojo.addClass(this.emptyOtherProjectsMessage, "hidden");//$NON-NLS-1$
					this.populateArea(this.otherProjects, projectAreas);
					showNoProjectsMessage = false;
				} else {
					dojo.removeClass(this.emptyOtherProjectsMessage, "hidden");//$NON-NLS-1$
				}
				
				if (archivedProjects.length > 0) {
					dojo.addClass(this.emptyArchivedProjectsMessage, "hidden");//$NON-NLS-1$
					this.populateArea(this.archivedProjects, archivedProjects, true);
					showNoProjectsMessage = false;
				} else {
					dojo.removeClass(this.emptyArchivedProjectsMessage, "hidden");//$NON-NLS-1$
				}
			}
			this.showNoProjectAreasMessage(showNoProjectsMessage);
		},
		
		_onMyProjectsTabTabClick: function(event) {
			dojo.stopEvent(event);
			
			//toggle tabSection
			if (dojo.hasClass(this.myProjectsTabSection, "selected")) { //$NON-NLS-1$
				// click on current selected tab
				return;
			}
			dojo.addClass(this.myProjectsTabSection, "selected"); //$NON-NLS-1$
			dojo.removeClass(this.otherProjectsTabSection, "selected"); //$NON-NLS-1$
			dojo.removeClass(this.archivedProjectsTabSection, "selected"); //$NON-NLS-1$
			
			// toggle projectsSection
			dojo.removeClass(this.myProjectsSection, "hidden"); //$NON-NLS-1$
			dojo.addClass(this.projectsSection, "hidden"); //$NON-NLS-1$
			dojo.addClass(this.archivedProjectsSection, "hidden"); //$NON-NLS-1$
		},
		
		_onOtherProjectsTabTabClick: function(event) {
			dojo.stopEvent(event);
			
			//toggle tabSection
			if (dojo.hasClass(this.otherProjectsTabSection, "selected")) { //$NON-NLS-1$
				// click on current selected tab
				return;
			}
			dojo.addClass(this.otherProjectsTabSection, "selected"); //$NON-NLS-1$
			dojo.removeClass(this.myProjectsTabSection, "selected"); //$NON-NLS-1$
			dojo.removeClass(this.archivedProjectsTabSection, "selected"); //$NON-NLS-1$
			
			// toggle projectsSection
			dojo.removeClass(this.projectsSection, "hidden"); //$NON-NLS-1$
			dojo.addClass(this.myProjectsSection, "hidden"); //$NON-NLS-1$
			dojo.addClass(this.archivedProjectsSection, "hidden"); //$NON-NLS-1$
		},

		_onArchivedProjectsTabTabClick: function(event) {
			dojo.stopEvent(event);
			
			//toggle tabSection
			if (dojo.hasClass(this.archivedProjectsTabSection, "selected")) { //$NON-NLS-1$
				// click on current selected tab
				return;
			}
			dojo.addClass(this.archivedProjectsTabSection, "selected"); //$NON-NLS-1$
			dojo.removeClass(this.otherProjectsTabSection, "selected"); //$NON-NLS-1$
			dojo.removeClass(this.myProjectsTabSection, "selected"); //$NON-NLS-1$
			
			// toggle projectsSection
			dojo.removeClass(this.archivedProjectsSection, "hidden"); //$NON-NLS-1$
			dojo.addClass(this.projectsSection, "hidden"); //$NON-NLS-1$
			dojo.addClass(this.myProjectsSection, "hidden"); //$NON-NLS-1$
		},

		populateArea: function(area, data, isArchived){
			var curUrl = new dojo._Url(location.href);
			
			if (curUrl.query) { //check for debug mode
				var urlSuffix = "?" + curUrl.query; //$NON-NLS-1$
			} else {
				urlSuffix = ""; //$NON-NLS-1$
			}
			
			for (var i = 0; i < data.length; i++) {
				var initCheckedName = data[i].name;
				if (!data[i].initialized) {
					initCheckedName = dojo.string.substitute(this.messages.ProjectAreaListPage_ProjectUninitialized, [data[i].name]);//$NON-NLS-1$
				}
				area.appendChild(this.createProjectAreaRow(initCheckedName, data[i].summary, data[i].description, data[i].webUrl, data[i].itemId, data[i].projectLinks, urlSuffix, isArchived));
			}
		},
		handleError: function(err){
			this._displayMessage(this.messages.ProjectAreaListPage_4, err);
		},
		
		_displayMessage: function(summary, errorObject){
            var messageBoxArgs = {
				type: jazz.ui.MessageBox.STATUS_TYPES.ERROR,
            	summary: summary,
            	errorObject: errorObject
            }; 			
			this._messageBox.showMessage(messageBoxArgs);
		},
		
		createProjectAreaRow: function(projectAreaName, projectAreaSummary, projectAreaDetails, dashboardUrl, projectAreaId, projectLinks, urlSuffix, isArchived){
			var row = document.createElement("div"); //$NON-NLS-1$
			row.className = "project"; //$NON-NLS-1$
			
			// create project area link
			var linkArea = document.createElement("h3"); //$NON-NLS-1$
			var link = document.createElement("a"); //$NON-NLS-1$
			if (isArchived) {
				dojo.addClass(link, "archived-project-name"); //$NON-NLS-1$
			}
			link.appendChild(document.createTextNode(projectAreaName));
			linkArea.appendChild(link);
			
			
			link.href = this.getProjectAreaUrl(projectAreaId);
			
			var rl = new ResourceLink({
				'presentationUri': dashboardUrl,//$NON-NLS-1$
				'lazyFetch': true //$NON-NLS-1$
			}, link);
			
			this._resourceLinks.push(rl);
			
			row.appendChild(linkArea);
			
			if ((projectAreaSummary && projectAreaSummary !== "") || (projectAreaDetails && projectAreaDetails !== "")) { //$NON-NLS-1$ //$NON-NLS-2$
				var projectDescriptionNode = document.createElement("div"); //$NON-NLS-1$
				projectDescriptionNode.className = "projectDescription"; //$NON-NLS-1$
				if (projectAreaSummary && projectAreaSummary !== "") { //$NON-NLS-1$
					projectDescriptionNode.appendChild(document.createTextNode(projectAreaSummary));
				}
				if (projectAreaDetails && projectAreaDetails !== "") { //$NON-NLS-1$
					if ((projectAreaSummary && projectAreaSummary !== "")) { //$NON-NLS-1$
						projectDescriptionNode.appendChild(document.createElement("br")); //$NON-NLS-1$
						projectDescriptionNode.appendChild(document.createElement("br")); //$NON-NLS-1$
					}
					var lines = projectAreaDetails.split(/\n/);
					for (var i = 0; i < lines.length; i++) {
						if (i > 0) {
							projectDescriptionNode.appendChild(document.createElement("br")); //$NON-NLS-1$
						}
						projectDescriptionNode.appendChild(document.createTextNode(lines[i]));
					}
				}
				row.appendChild(projectDescriptionNode);
			}
			
			var projectContentAreaNode = document.createElement("div"); //$NON-NLS-1$
			projectContentAreaNode.className = "projectContentArea"; //$NON-NLS-1$
			row.appendChild(projectContentAreaNode);

			var actionDiv = document.createElement("div");//$NON-NLS-1$
			dojo.addClass(actionDiv, "projectActionArea");//$NON-NLS-1$
			var toolbar = new jazz.ui.Toolbar();
			this._toolbars.push(toolbar);
			var button = new jazz.ui.toolbar.Button({
				href : dashboardUrl,
				imgSrc :  this._dashboardIconSrc,
				label : this.messages.ProjectAreaListPage_12				
			});
			toolbar.addChild(button);

			button = new jazz.ui.toolbar.Button({
				href :  this.getProjectAreaUrl(projectAreaId),
				imgSrc :  this._adminIconSrc,
				label : this.messages.ProjectAreaListPage_13
			});
			toolbar.addChild(button);
			actionDiv.appendChild(toolbar.domNode);									
			projectContentAreaNode.appendChild(actionDiv);

			if (projectLinks && projectLinks.length > 0) {
				var node = document.createElement("div"); //$NON-NLS-1$
				dojo.addClass(node, "linkSectionHead"); //$NON-NLS-1$
				var label = document.createTextNode(this.messages.ProjectAreaListPage_11);
				node.appendChild(label);
				projectContentAreaNode.appendChild(node);
				
				var usesLinks = [];
				var prividesLinks = [];
				for (i = 0; i < projectLinks.length; i++) {
					var projectLink = projectLinks[i];
					if (UIHelper.isUsesLinkType(projectLink.linkType)) {
						usesLinks.push(projectLink);
					} else {
						prividesLinks.push(projectLink);
					}
				}
				
				if (usesLinks.length > 0) {
					this._createLinksSection(projectContentAreaNode, usesLinks, this.messages.ProjectAreaListPage_14, this.messages.ProjectAreaListPage_15, this.messages.ProjectAreaListPage_16);
				}
				
				if (prividesLinks.length > 0) {
					this._createLinksSection(projectContentAreaNode, prividesLinks, this.messages.ProjectAreaListPage_17, this.messages.ProjectAreaListPage_18, this.messages.ProjectAreaListPage_19);
				}
			}
			
			return row;
		},
		
		_createLinksSection: function(row, projectLinks, titleTextFormat, contentTextFormat, actionTitle) {
			// create collapse action button area
			var actionArea = document.createElement("div"); //$NON-NLS-1$
			var collapseButton = document.createElement("div"); //$NON-NLS-1$
			dojo.addClass(collapseButton, "collapseLinkSectionButton"); //$NON-NLS-1$
			var collapseButtonImg = document.createElement("img"); //$NON-NLS-1$
			collapseButtonImg.src = this._twistClosedIconSrc;
			dojo.addClass(collapseButtonImg, "linkSectionCollapseImage"); //$NON-NLS-1$
			collapseButton.appendChild(collapseButtonImg);
			var textNode = document.createElement("span"); //$NON-NLS-1$; 
			dojo.addClass(textNode, "buttonText"); //$NON-NLS-1$; 
			var countHTML = "<span class=\"linksCounts\">" + dojo.string.substitute(this.messages.ProjectAreaListPage_9, [projectLinks.length]) + "</span>"; //$NON-NLS-1$;  //$NON-NLS-2$; 
			textNode.innerHTML = dojo.string.substitute(titleTextFormat, [countHTML]);
			collapseButton.appendChild(textNode);
			collapseButton.title = actionTitle;
			this.connect(collapseButton, "onclick", "_onLinksSectionCollapseButtonClick");//$NON-NLS-1$  //$NON-NLS-2$ 
			actionArea.appendChild(collapseButton);
			row.appendChild(actionArea);
			
			// create content area
			var linksContentAreaDivNode = document.createElement("div"); //$NON-NLS-1$
			// hidden by default
			dojo.addClass(linksContentAreaDivNode, "hidden"); //$NON-NLS-1$
			for (var i = 0; i < projectLinks.length; i++) {
				var projectLink = projectLinks[i];
				var linkRowDivNode = document.createElement("div"); //$NON-NLS-1$
				dojo.addClass(linkRowDivNode, "linkRow"); //$NON-NLS-1$
				linkRowDivNode.appendChild(UIHelper.getProjectLinkImage(projectLink.linkType, "projectLinkImage")); //$NON-NLS-1$
				var linkTypeLabel = UIHelper.getLinkTypeLabel(projectLink.linkType, this.messages);
				var link = "<a href=\"" + projectLink.targetURL + "\">" + projectLink.label + "</a>"; //$NON-NLS-1$  //$NON-NLS-2$  //$NON-NLS-3$
				var linkNode = document.createElement("SPAN"); //$NON-NLS-1$
				dojo.addClass(linkNode, "linkText"); //$NON-NLS-1$
				linkNode.innerHTML = dojo.string.substitute(contentTextFormat, [linkTypeLabel, link]);
				for (var j = 0; j < linkNode.childNodes.length; j++) {
					if (linkNode.childNodes[j].tagName === "A") { //$NON-NLS-1$
						var rl = new ResourceLink({
							'uri': projectLink.targetURL, //$NON-NLS-1$
							'lazyFetch': true //$NON-NLS-1$
						}, linkNode.childNodes[j]);
						this._resourceLinks.push(rl);
						break;
					}
				}
				linkRowDivNode.appendChild(linkNode);
				linksContentAreaDivNode.appendChild(linkRowDivNode);
			}
			row.appendChild(linksContentAreaDivNode);
		},
		
		_onLinksSectionCollapseButtonClick: function(event) {
			dojo.stopEvent(event);
			var collapseButton = event.currentTarget;
			var collapseImgNode = collapseButton.firstChild;
			var linksContentNode = collapseButton.parentNode.nextSibling;
			if (dojo.hasClass(linksContentNode, "hidden")) { //$NON-NLS-1$
				collapseImgNode.src = this._twistOpenIconSrc;
			} else {
				collapseImgNode.src = this._twistClosedIconSrc;
			}
			dojo.toggleClass(linksContentNode, "hidden"); //$NON-NLS-1$
		},
		
		getProjectAreaUrl: function(projectAreaItemId){
			var location = document.location.href;
			var path = location.split("/");//$NON-NLS-1$
			var serverAddress;
			if (path.length > 0) {
				serverAddress = path.shift() + "//";//$NON-NLS-1$
				path.shift(); //empty from the double //
				serverAddress = serverAddress + path.shift();
			}
			return serverAddress + net.jazz.ajax.contextRoot() + "/process/project-areas/" + projectAreaItemId; //$NON-NLS-1$ 
		},
		
		_destroyResourceLinks: function(){
			for (var i = 0; i < this._resourceLinks.length; i++) {
				this._resourceLinks[i].destroyRecursive();
			}
			this._resourceLinks = [];
		},

		_destroyToolbars: function(){
			for (var i = 0; i < this._toolbars.length; i++) {
				this._toolbars[i].destroyRecursive();
			}
			this._toolbars = [];
		},

		uninitialize: function(){
			this._destroyResourceLinks();
			this._destroyToolbars();
			this.inherited(arguments);
		}
		
	});
})();
