/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.SaveAsDialog");

dojo.require("dojo.i18n");
dojo.require("dojo.date.locale");

dojo.require("jazz.ui.Dialog");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() {
    dojo.declare("com.ibm.team.reports.web.ui.internal.SaveAsDialog", [dijit._Widget, dijit._Templated], {
       templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/SaveAsDialog.html"),
		
		widgetsInTemplate: true,
		
		constructor: function(props) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
		},
		
		postCreate: function() {
			this._dialog = new jazz.ui.Dialog({
				contentNode: this._dialog,
				primaryTitle: this.messages.saveAs,
				width: "250px",
				isClosable: true
			});
			this.connect(this._onSubmit, "onclick", this._onSubmit);
			this.connect(this._onClose, "onclick", this._onClose);
		},
		
		_onSubmit: function() {
			if (this.onSubmit && this.textField.value.length > 0) {
				this.onSubmit(this.textField.value);
			}
			this._onClose();
		},
		
		_onClose: function() {
			this._dialog.close();
		},
		
		open: function() {
			this._dialog.show();
			this.textField.focus();
		}
		
	});
	
})();
