/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.TRToolbar"); //$NON-NLS-1$
dojo.require("jazz.ui.SimpleToolbar"); //$NON-NLS-1$
(function(){

	dojo.declare("com.ibm.team.process.web.ui.internal.TRToolbar", jazz.ui.SimpleToolbar, { //$NON-NLS-1$
		addButton: function(context, callback, args){
			var button = this.inherited(arguments);
			button.domNode.callbackData = args.callbackData;
			
			this.selectRowOnFocus(button.domNode);
			
			return button;
		},
		
		/**
		 * Disables all buttons on the toolbar by adding the class "toolbar-disabled" to the
		 * toolbar.
		 * 
		 * @param {boolean} disabled - true if the toolbar should be disabled
		 */
		disableToolbar: function(disabled) {
			if (disabled === true) {
				dojo.toggleClass(this.domNode, "toolbar-disabled", true); //$NON-NLS-1$
			} else {
				dojo.toggleClass(this.domNode, "toolbar-disabled", false); //$NON-NLS-1$
			}
		},
		
		/**
		 * A helper to make this toolbar's row 'selected' -- with an orange
		 * background and visible toolbar buttons -- when child widgets are
		 * given focus. This is essential for keyboard navigation using the Tab
		 * key. Buttons added to this toolbar via addButton() will have this
		 * behavior automatically. This function is available for widgets
		 * that are added via other API, or for elements in the row that are
		 * outside of the toolbar, but should put the row in the selected
		 * state when they are focused.
		 * 
		 * @param {DOM node} domNode - A DOM element
		 */
		selectRowOnFocus: function(domNode) {
			this.connect(domNode, "onfocus", function(e){ //$NON-NLS-1$
				var row = e.target;
				while (row && row.tagName.toLowerCase() !== "tr") { //$NON-NLS-1$
					row = row.parentNode;
				}
				if (row) {
					dojo.toggleClass(row, "selected", true); //$NON-NLS-1$
				}
			});
			this.connect(domNode, "onblur", function(e){ //$NON-NLS-1$
				var row = e.target;
				while (row && row.tagName.toLowerCase() !== "tr") { //$NON-NLS-1$
					row = row.parentNode;
				}
				if (row) {
					dojo.toggleClass(row, "selected", false); //$NON-NLS-1$
				}
			});
		}
	});
})();
