/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_templates.AbstractButtonActionHandler"); //$NON-NLS-1$
(function(){

	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_templates.AbstractButtonActionHandler", null, { //$NON-NLS-1$
		/*
		 * The process template item UUID
		 */
		itemId: "", //$NON-NLS-1$
	
		/*
		 * Called by the process template list page action handler is created
		 * is clicked.
		 *
		 * @param String The process template item UUID 
		 *
		 * @return void
		 */
		setItemId: function(itemId){
			this.itemId = itemId;
		},
		
		/**
		 * Called when the customized action button in process template list page is created.
		 * 
		 * @param String The process template name
		 */
		setItemName: function(itemName) {
			this.itemName = itemName;			
		},		
		
		/*
		 * Called by the process template list page when the contributed action button 
		 * is clicked. 
		 *
		 * @param void
		 *
		 * @return void
		 */
		doAction: function(){
		},
		
		uninitialize: function(){
			this.inherited(arguments);
		}
	});
	
})();
