/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.AbstractProcessAreaEditor"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dojo.cookie"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("dojox.collections.Dictionary"); //$NON-NLS-1$
	dojo.require("dojox.string.BidiComplex"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.contextRoot");//$NON-NLS-1$
	dojo.require("jazz.ui.Breadcrumbs"); //$NON-NLS-1$
	dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
	dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProcessMessageBox"); //$NON-NLS-1$
	dojo.require("jazz.ui.StyledTable"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.SelectableStyledTable"); //$NON-NLS-1$
	dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
	dojo.require("jazz.ui.underlay"); //$NON-NLS-1$
	dojo.require("jazz.ui.Menu"); //$NON-NLS-1$
	dojo.require("jazz.ui.MenuPopup"); //$NON-NLS-1$
	dojo.require("jazz.core.RegistryFactory"); //$NON-NLS-1$
	dojo.require("jazz.app.ua.PageHoverHelp"); //$NON-NLS-1$		
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.client.session.Session"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.PermissionsScopeEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.RolesEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ErrorTab"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TeamHierarchyElementToolbar"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ConfigurationDataEditorContainer"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProcessAreaEditorPageHeaderSection"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.OperationBehaviorEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.AddMembersWizard"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProcessBulkEditRolesDialog"); //$NON-NLS-1$
	dojo.require("jazz.client.xhr"); //$NON-NLS-1$
	dojo.require("jazz.util.html"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.TRToolbar"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.TRLink"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.client.init.InitializationData"); //$NON-NLS-1$	
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.OsgiBasedConfigurationDataModel"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.RolesStore"); //$NON-NLS-1$
	
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	
	var AbstractProcessAreaEditor = com.ibm.team.process.web.ui.internal.admin.projects.AbstractProcessAreaEditor;
	AbstractProcessAreaEditor.PROJECT_AREA_EDITOR = "com.ibm.team.process.editProjectArea"; //$NON-NLS-1$
	AbstractProcessAreaEditor.TEAM_AREA_EDITOR = "com.ibm.team.process.editTeamArea"; //$NON-NLS-1$
	AbstractProcessAreaEditor.MSG_COOKIE_NAME = "com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaEditor#saveMsg"; //$NON-NLS-1$
	AbstractProcessAreaEditor.NEW_MEMBERS_COOKIE_NAME = "com.ibm.team.process.web.ui.internal.admin.projects.ProcessAreaEditor#newMembers"; //$NON-NLS-1$
	AbstractProcessAreaEditor.SHOW_ARCHIVED_COOKIE_NAME = "com.ibm.team.process.web.ui.internal.admin.projects.ProcessAreaEditor#showArchived"; //$NON-NLS-1$
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var ConfigurationDataEditorContainer = com.ibm.team.process.web.ui.internal.admin.projects.ConfigurationDataEditorContainer;
	var ResourceLink = jazz.ui.ResourceLink;
	var UIHelper = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;
	var USER_EDITOR = "com.ibm.team.repository.viewUserProfile"; //$NON-NLS-1$
	var KEY_RETURN = 13;
	var KEY_ENTER = 14;
	var MANAGE_ARCHIVED_LINK = "#action=com.ibm.team.process.manageArchivedProjectAreas"; //$NON-NLS-1$
	var MANAGE_ACTIVE_LINK = "#action=com.ibm.team.process.manageProjectAreas"; //$NON-NLS-1$
	var DEFAULT_DISPLAY_MAX = 5;
	var FETCH_MAX_MEMBERS = 20;
	var SHOW_TEXT_LENGTH = 1024;
	var HIERARCHY_TAB_SPACING = 1.5;
	var ON_CLICK = "onclick"; //$NON-NLS-1$
	var RegistryFactory = jazz.core.RegistryFactory;
	var ProcessAreaEditorPageHeaderSection = com.ibm.team.process.web.ui.internal.admin.projects.ProcessAreaEditorPageHeaderSection;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.AbstractProcessAreaEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		// for project/team area editor to access
		fetchMaxMembers: FETCH_MAX_MEMBERS,
		
		/**
    	 * Counts the number of new members added to a project
    	 * 
    	 * @private
    	 * @type Positive_Integers
    	 * @default 0
    	 */ 
		_countNewMembers : 0,
		
		/**
    	 * Counts the number of new administrators added to a project
    	 * 
    	 * @private
    	 * @type Positive_Integers
    	 * @default 0
    	 */ 
		_countNewAdmins : 0,
		
		widgetsInTemplate: true,
		
		constructor: function(args){
			this._owningApplicationKey = args.owningApplicationKey;
			this._isEmbedded = args.isEmbedded;
			this._appContextRoot = args.appContextRoot;
			this._appName = args.appName;
			this._hideTeams = args.hideTeams;
			this._widgetCache = {};
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this._expandedIconSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/grey-twistie-open.png").toString(); //$NON-NLS-1$ //$NON-NLS-2$
			this._collapsedIconSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/grey-twistie-closed.png").toString(); //$NON-NLS-1$ //$NON-NLS-2$
			this.isNew = args.itemId === ProcessConstants.EditorMode.NEW;
			this.initTabId = args.tabId;
			this.processAuthoringPracticeUrl = args.practiceUrl;
			this.processAuthoringPracticeElementUrl = args.practiceElementUrl;
			this._resourceLinks = [];
			this._memberTRLinks = [];
			this._adminTRLinks = [];
			this.configurationDataModel = new com.ibm.team.process.web.ui.internal.admin.projects.OsgiBasedConfigurationDataModel();
			this.initialize(args);
		},
		
		postCreate: function(){
			this._messageBox = new com.ibm.team.process.web.ui.internal.admin.projects.ProcessMessageBox();
			this._messageBoxDiv.appendChild(this._messageBox.domNode);
			
			if (this.isNew) {
				this.tabSection.style.display = ProcessConstants.NONE;	
				this._sideNavigationControl.style.display = ProcessConstants.NONE;
			}
			
			if (!this.isNew) {
				if (this.itemId !== undefined && this.itemId !== this.projectAreaItemId) {
					this.isTeamArea = true;
				} else {
					this.isTeamArea = false;
				}
				
				this.connect(this._sideNavigationControl, "onmouseover", function(e) { //$NON-NLS-1$
					this._highlightSideNavigationControl(e);
				});
				
				this.connect(this._sideNavigationControl, "onmouseout", function(e) { //$NON-NLS-1$
					this._unHighlightSideNavigationControl(e);
				});
				
				this.connect(this._sideNavigationControl, "onclick", function(e) { //$NON-NLS-1$
					this._sideNavigationTabSection(e);
				});
				
				this.connect(this._sideNavigationButton, "onmouseover", function(e) { //$NON-NLS-1$
					this._highlightSideNavigationButton(e);
				});
				
				this.connect(this._sideNavigationButton, "onmouseout", function(e) { //$NON-NLS-1$
					this._unHighlightSideNavigationButton(e);
				});
				
				this.connect(this._sideNavigationButton, "onclick", function(e) { //$NON-NLS-1$
					dojo.stopEvent(e);
					this._sideNavigationTabSection(e);
				});
				
				this.connect(window, "onscroll",  function(e) { //$NON-NLS-1$
					dojo.stopEvent(e);
					this._calculateSideNavigationArrowPos(e);
				});
				
				this.connect(window, "onresize", function(e) { //$NON-NLS-1$
					dojo.stopEvent(e);
					this._calculateSideNavigationArrowPos(e);
				});
				
				this._createTabs();
			}
			
			this.showingAllMembers = this.isNew;
			this.showingAllAdmins = this.isNew;
			this.connectHandles = [];
			this._actionToolbars = [];
			this._memberActionToolbars = [];
			this._adminActionToolbars = [];
			this._hierarchyToolbars = [];
			this.inputFields = [this.name, this.summary, this.description];
			this.connect(this.name, "onkeypress", function(e){ //$NON-NLS-1$
				if (e.keyCode === KEY_RETURN || e.keyCode === KEY_ENTER) {
					dojo.stopEvent(e);
					this.togglePrimaryField(ProcessConstants.EditorMode.PREVIEW);
				}
			});
			this.summary.viewElement = this.summaryView;
			this.summary.viewAllElement = this.summaryViewAll;
			this.summary.showAllLink = this.showAllSummaryLink;
			this.summary.showLessLink = this.showLessSummaryLink;
			this.summary.showingAll = false;
			this.description.viewElement = this.descriptionView;
			this.description.viewAllElement = this.descriptionViewAll;
			this.description.showAllLink = this.showAllDescriptionLink;
			this.description.showLessLink = this.showLessDescriptionLink;
			this.description.showingAll = false;
			this.editViewFields = [this.summary, this.description];
			this.connect(this.editViewTable, ON_CLICK, function(){
				this.toggleViewEditMode(ProcessConstants.EditorMode.EDIT);
			});
			
			this.showBreadcrumbs();
			
			for (var i = 0; i < this.inputFields.length; i++) {
				this.connect(this.inputFields[i], "onkeyup", "handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
				this.connect(this.inputFields[i], "onchange", "handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
			}
			
			this.customConnect();
			
			this.connect(this.name, "onkeyup", function(){ //$NON-NLS-1$
				if (this.hierarchyNameDisplay) {
					if (this.name.value == ProcessConstants.EMPTY && this.context == ProcessConstants.EditorContext.TEAM) {
						if(this.isNew) {
							this.hierarchyNameDisplay.firstChild._nameElement.innerHTML = this.messages.TeamAreaEditor_23;
						} else {
							this.hierarchyNameDisplay.firstChild._nameElement.innerHTML = this.messages.TeamAreaEditor_8;
						}
					} else if (this.name.value == ProcessConstants.EMPTY && this.context == ProcessConstants.EditorContext.PROJECT) {
						this.hierarchyNameDisplay.firstChild._nameElement.innerHTML = this.messages.ProjectAreaEditor_7;
					} else {
						this.hierarchyNameDisplay.firstChild._nameElement.innerHTML = jazz.util.html.escape(this.name.value);
					}
				}
			});
			
			this.connect(this.memberAddButton, ON_CLICK, function(e){
				e.preventDefault();
				if (!this.allMembers) {
					this.allMembers = [];
					this.allMemberIds = [];
				}
				this.addUserWizard(this.allMemberIds); //$NON-NLS-1$
			});
			this.connect(this.adminAddButton, ON_CLICK, function(e){
				e.preventDefault();
				if (!this.allAdmins) {
					this.allAdmins = [];
				}
				this.addAdminDialog(this.allAdmins); //$NON-NLS-1$
			});
			
			this.connect(this.saveButton, ON_CLICK, "handleSave"); //$NON-NLS-1$
			this.connect(this.toggleDescLink, ON_CLICK, function(e){
				e.preventDefault();
				this.toggleDescLinkIsClicked = true;
				if (e.target.mode === ProcessConstants.EditorMode.PREVIEW) {
					this.toggleViewEditMode(ProcessConstants.EditorMode.EDIT);
				} else {
					this.toggleViewEditMode(ProcessConstants.EditorMode.PREVIEW);
					
				}
			});
			
			this.connect(this.previewName, "onmouseover", function(e){ //$NON-NLS-1$
				e.target.style.backgroundColor = "#FFFFCC"; //$NON-NLS-1$
			});
			this.connect(this.previewName, "onmouseout", function(e){ //$NON-NLS-1$
				e.target.style.backgroundColor = ProcessConstants.EMPTY;
			});
			this.connect(this.previewName, ON_CLICK, function(e){
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
			});
			this.connect(this.previewName, "onfocus", function(e){  //$NON-NLS-1$
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
			});
			this.connect(this.name, "onblur", function(e){ //$NON-NLS-1$
				this.togglePrimaryField(ProcessConstants.EditorMode.PREVIEW);
			});
			this.connect(this.showAllSummaryLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.summary.showingAll = true;
				this.summary.viewAllElement.style.display = ProcessConstants.INLINE;
				this.summary.showAllLink.style.display = ProcessConstants.NONE;
				this.summary.showLessLink.style.display = ProcessConstants.BLOCK;
			});
			this.connect(this.showLessSummaryLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.summary.showingAll = false;
				this.summary.viewAllElement.style.display = ProcessConstants.NONE;
				this.summary.showAllLink.style.display = ProcessConstants.BLOCK;
				this.summary.showLessLink.style.display = ProcessConstants.NONE;
			});
			this.connect(this.showAllDescriptionLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.description.showingAll = true;
				this.description.viewAllElement.style.display = ProcessConstants.INLINE;
				this.description.showAllLink.style.display = ProcessConstants.NONE;
				this.description.showLessLink.style.display = ProcessConstants.BLOCK;
			});
			this.connect(this.showLessDescriptionLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.description.showingAll = false;
				this.description.viewAllElement.style.display = ProcessConstants.NONE;
				this.description.showAllLink.style.display = ProcessConstants.BLOCK;
				this.description.showLessLink.style.display = ProcessConstants.NONE;
			});
			
			this.connect(this.showAllMembersLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.showingAllMembers = true;
				if(this.isNew){
					this.populateMembers(this.allMembers);
				} else {
					this.membersDiv.styledTable.changeTablePosition(0, -1);
					this._updateShowAllFewerMembersLinkDisplay(this.allMembers);
				}
			});
			this.connect(this.showFewerMembersLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.showingAllMembers = false;
				if(this.isNew){
					this.populateMembers(this.allMembers);
				} else {
					this.membersDiv.styledTable.changeTablePosition(0, this.isNew ? DEFAULT_DISPLAY_MAX : DEFAULT_DISPLAY_MAX + this._countNewMembers);
					this._updateShowAllFewerMembersLinkDisplay(this.allMembers);
				}
			});
			
			this.connect(this.showAllAdminsLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.showingAllAdmins = true;
				this.populateAdmins(this.allAdmins);
			});
			this.connect(this.showFewerAdminsLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.showingAllAdmins = false;
				this.populateAdmins(this.allAdmins);
			});
			
			this._teamHierarchyToolbar = new jazz.ui.SimpleToolbar();
			var filterAction = {};
			filterAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/teamarea_archived_obj.gif"); //$NON-NLS-1$  //$NON-NLS-2$
			filterAction.label = this.messages.AbstractProcessAreaEditor_ShowArchived;
			filterAction.buttonType = jazz.ui.SimpleToolbar.ButtonTypes.TWO_STATE;
			this._showArchivedButton = this._teamHierarchyToolbar.addButton(this, this._updateHierarchyRoot, filterAction);
			this.checkForShowArchived();
			var createTeamAction = {};
			createTeamAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/create_ta_co.gif"); //$NON-NLS-1$  //$NON-NLS-2$
			createTeamAction.label = this.messages.ProjectAreaEditorHTML_3;
			this._createChildButton = this._teamHierarchyToolbar.addButton(this, this._createTeamArea, createTeamAction);
			this._teamHierarchyToolbar.disableButton(this._createChildButton);
			this.teamAreaHierarchyToolbarDiv.appendChild(this._teamHierarchyToolbar.domNode);
			this.refresh(false);
		},
		
		customConnect: function(){
			// Derived can override and add custom connects here
		
		},
		
		// Switch to the tab specified in the args used to create this
		// editor. Derived should call this only after having fetched
		// all of their data
		navigateToInitTab : function() {
			//switch tab if tabId is setting
			if (this.initTabId) {
				this._switchTab(this.initTabId);
				this.initTabId = null;
			}
		},		
		
		_createTabs: function(){
			this._saveParticipants = new dojox.collections.Dictionary();
			this._tabs = [];
			this.createTab(this.messages.ProjectAreaEditor_OverviewTabLabel, ProcessConstants.TabEnum.OVERVIEW, function(tabLink){
				//Create the OverView tab page header				
				var args = {};
				args.pageTitle = this.messages.ProjectAreaEditor_OverviewTabLabel;
				args.tabLink = tabLink;
				var headerSection = new ProcessAreaEditorPageHeaderSection(args);
				this.overViewHeaderSection.appendChild(headerSection.domNode);
			}, undefined, undefined, this.getTabUAKey(ProcessConstants.TabEnum.OVERVIEW));
			dojo.removeClass(this._tabs[ProcessConstants.TabEnum.OVERVIEW].helpWidget.domNode, "helpHidden"); //$NON-NLS-1$
			this.createTab(this.messages.ProjectAreaEditor_RolesTabLabel, ProcessConstants.TabEnum.ROLES, this._createRoles, undefined, undefined, this.getTabUAKey(ProcessConstants.TabEnum.ROLES));
			this.createTab(this.messages.ProjectAreaEditor_PermissionTabLabel, ProcessConstants.TabEnum.PERMISSIONS, this._createPermissions, undefined, undefined, this.getTabUAKey(ProcessConstants.TabEnum.PERMISSIONS));
			
			var operationBehaviorProperty = com.ibm.team.repository.web.client.init.InitializationData.get("com.ibm.team.process.service.hideOperationBehaviorTab"); //$NON-NLS-1$
			if (operationBehaviorProperty && operationBehaviorProperty.value === false) {
				this.createTab(this.messages.AbstractProcessAreaEditor_12, ProcessConstants.TabEnum.OPERATION_BEHAVIOR, this._createOperationBehaviorEditor, undefined, undefined, this.getTabUAKey(ProcessConstants.TabEnum.OPERATION_BEHAVIOR));
			}
			
			this.createCustomTabs();
			
			dojo.toggleClass(this.tabSection.childNodes[0], "selected", true); //$NON-NLS-1$
			this.selectedTab = ProcessConstants.TabEnum.OVERVIEW;
			this.overViewHeaderSection.style.display = "block"; //$NON-NLS-1$
		},
		
		createCustomTabs: function(){
			// Derived can override and add custom widgets here
			// using the createTab() function
		
		},
		
		createTab: function(text, tabId, createCallBack, idOfTabToInsertBefore, extensionPointWidget, uaKey, tabType, parentTabTitle, description){
			if (!this._tabs[tabId]) {
				var link = document.createElement("a"); //$NON-NLS-1$
				
				if (tabType === "configurationDataCategoryTab") { //$NON-NLS-1$
					link.className = "tab expanded configurationDataCategory"; //$NON-NLS-1$
				} else if (tabType === "configurationDataTab") { //$NON-NLS-1$
					link.className = "tab configurationData"; //$NON-NLS-1$
				} else {
					link.className = "tab"; //$NON-NLS-1$
				}
				
				link.href = "#"; //$NON-NLS-1$
				link.tabId = tabId;
				link.createTab = createCallBack;
				link.extensionPointWidget = extensionPointWidget;
				link.tabTitle = text;
				link.parentTabTitle = parentTabTitle;
				link.title = text;
				link.description = description;
				dijit.setWaiRole(link, "tab"); //$NON-NLS-1$
				var title = document.createElement("div"); //$NON-NLS-1$
				title.className = "title"; //$NON-NLS-1$
				
				if (tabType === "configurationDataCategoryTab") { //$NON-NLS-1$
					var img = document.createElement("img"); //$NON-NLS-1$
					img.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/grey-twistie-open.png"); //$NON-NLS-1$ //$NON-NLS-2$;
					title.className = "title"; //$NON-NLS-1$
					title.appendChild(img);
				}
				
				title.appendChild(document.createTextNode(text));
				title.tabId = tabId;
				title.title = text;
				dijit.setWaiRole(title, "tab"); //$NON-NLS-1$
				link.appendChild(title);
				if (uaKey) {
					var helpHooks = document.createElement("div"); //$NON-NLS-1$
					var helpWidget = new jazz.app.ua.PageHoverHelp({
						uaKey: uaKey
					});
					helpWidget.domNode.tabId = tabId;
					helpHooks.appendChild(helpWidget.domNode);
					dojo.addClass(helpHooks, "helpInline"); //$NON-NLS-1$
					link.helpWidget = helpWidget;
					link.helpHooks = helpHooks;
				}

				if (idOfTabToInsertBefore) {
					this.tabSection.insertBefore(link, this._tabs[idOfTabToInsertBefore]);
				} else {
					this.tabSection.appendChild(link);
				}
				
				//Call Overview tab callback method here,
				//since there is no chance to invoke the Overview tab callback method in other places
				if (tabId === ProcessConstants.TabEnum.OVERVIEW) {
					link.createTab.call(this, link);
				}
				
				this.connect(link, ON_CLICK, "_onTabClick"); //$NON-NLS-1$
				this.connect(link, "onmousedown", "_onTabMousedown"); //$NON-NLS-1$ //$NON-NLS-2$
				this._tabs[tabId] = link;
			} else {
				// Tab with a duplicate ID is found...don't create it
				console.error(dojo.string.substitute(this.messages.AbstractProcessAreaEditor_ErrorDuplicateTabId, [tabId]));
			}
		},
		
		_highlightSideNavigationControl: function (e) {
			dojo.toggleClass(this._sideNavigationControl, "sideNavigationControlHover", true); //$NON-NLS-1$
			this._highlightSideNavigationButton(e);
		},
		
		_unHighlightSideNavigationControl: function (e) {
			dojo.toggleClass(this._sideNavigationControl, "sideNavigationControlHover", false); //$NON-NLS-1$
			this._unHighlightSideNavigationButton(e);
		},
		
		_highlightSideNavigationButton: function(e) {
			dojo.toggleClass(this._sideNavigationButton, "sideNavigationButton", false); //$NON-NLS-1$
			dojo.toggleClass(this._sideNavigationButton, "sideNavigationButtonHover", true); //$NON-NLS-1$
			if (this.tabSection.style.display === ProcessConstants.BLOCK) {
				dojo.toggleClass(this._sideNavigationButton, "sideNavigationButtonExpanded",true); //$NON-NLS-1$
				dojo.toggleClass(this._sideNavigationButton, "sideNavigationButtonCollapsed",false); //$NON-NLS-1$
			} else {
				dojo.toggleClass(this._sideNavigationButton, "sideNavigationButtonCollapsed", true); //$NON-NLS-1$
				dojo.toggleClass(this._sideNavigationButton, "sideNavigationButtonExpanded",false); //$NON-NLS-1$
			}
			
		},
		
		_unHighlightSideNavigationButton: function(e) {
			dojo.toggleClass(this._sideNavigationButton, "sideNavigationButtonHover", false); //$NON-NLS-1$
			dojo.toggleClass(this._sideNavigationButton, "sideNavigationButton", true); //$NON-NLS-1$
		},
		
		_sideNavigationTabSection: function(e) {
			if (this.tabSection.style.display === ProcessConstants.BLOCK) {
				this.tabSection.style.display = ProcessConstants.NONE;
				dojo.toggleClass(this._sideNavigationControl, "sideNavigationControlCollapsed", true); //$NON-NLS-1$
				dojo.toggleClass(this._sideNavigationControl, "sideNavigationControlExpanded", false); //$NON-NLS-1$
			} else {
				this.tabSection.style.display = ProcessConstants.BLOCK;
				dojo.toggleClass(this._sideNavigationControl, "sideNavigationControlCollapsed", false); //$NON-NLS-1$
				dojo.toggleClass(this._sideNavigationControl, "sideNavigationControlExpanded", true); //$NON-NLS-1$
			}
		},
		
		_calculateSideNavigationArrowPos: function(e) {
			var height = document.body.clientHeight;
			var offset = dojo.coords(this.domNode);
			this._sideNavigationButton.style.top = (height / 2 - offset.y - 100) + "px"; //$NON-NLS-1$
		},
		
		_createPermissions: function(tabLink) {
		
			var editor = new com.ibm.team.process.web.ui.internal.admin.projects.PermissionsScopeEditor({
				editor: this,
				owningApplicationKey: this._owningApplicationKey
			});
			this.permissionEditor = editor;
			var args = {};
			args.pageTitle = this.messages.ProjectAreaEditor_PermissionTabLabel;
			args.tabLink = tabLink;
			var headerSection = new ProcessAreaEditorPageHeaderSection(args);
			this.twoColumnMainColumn.appendChild(headerSection.domNode);
			this.twoColumnMainColumn.appendChild(editor.domNode);
			return editor;
		},
		
		_createOperationBehaviorEditor: function(tabLink) {
			this.operationBehaviorEditor = new com.ibm.team.process.web.ui.internal.admin.projects.OperationBehaviorEditor({
				editor: this,
				owningApplicationKey: this._owningApplicationKey,
				configurationDataModel: this.configurationDataModel,
				rolesStore: this.getRolesStore(),
				contextStore: this._getProcessAreaStore()
			});
			var args = {};
			args.pageTitle = this.messages.AbstractProcessAreaEditor_12;
			args.tabLink = tabLink;
			var headerSection = new ProcessAreaEditorPageHeaderSection(args);
			headerSection.addHeaderAction(this.operationBehaviorEditor.getHeaderActionArea());
			this.twoColumnMainColumn.appendChild(headerSection.domNode);
			this.twoColumnMainColumn.appendChild(this.operationBehaviorEditor.domNode);
			this.operationBehaviorEditor.startup();
			return this.operationBehaviorEditor;
		},
		
		_getProcessAreaStore: function(){
			// Must be overridden by the project and team are editors
			// To supply the correct type of store for permisions/timelines
		},
		
		_handleCreateStoreError: function(error, permissionsScopeContext){
			switch (permissionsScopeContext) {
				case ProcessConstants.PermissionsScopeContext.DEV_LINES:
					this.handleServerResponseError(error, this.messages.AbstractProcessAreaEditor_ErrorFetchingDevelopmentLines);
					break;
				case ProcessConstants.PermissionsScopeContext.ITERATION_TYPES:
					this.handleServerResponseError(error, this.messages.AbstractProcessAreaEditor_ErrorFetchingIterationTypes);
					break;
				case ProcessConstants.PermissionsScopeContext.ITERATIONS:
					this.handleServerResponseError(error, this.messages.AbstractProcessAreaEditor_ErrorFetchingIterations);
					break;
			}
			
		},
		
		_createRoles: function(tabLink) {
		
			var editor = new com.ibm.team.process.web.ui.internal.admin.projects.RolesEditor({
				editor: this,
				rolesStore:this.getRolesStore()
			});
			this.rolesEditor = editor;
			
			var args = {};
			args.pageTitle = this.messages.ProjectAreaEditor_RolesTabLabel;
			args.pageDescription = this.messages.ProjectAreaEditor_RolesDescription;
			args.tabLink = tabLink;
			var headerSection = new ProcessAreaEditorPageHeaderSection(args);
			this.twoColumnMainColumn.appendChild(headerSection.domNode);
			
			this.twoColumnMainColumn.appendChild(editor.domNode);
			return editor;
		},
		
		_switchTab: function(targetTabId){
			if (this.selectedTab !== targetTabId) {
				var oldTab = this._tabs[this.selectedTab].mainPage;
				if (oldTab && dojo.isFunction(oldTab.deactivateTab)) {
					if (!oldTab.deactivateTab.call(oldTab)) {
						return;
					}
				}
			}
			
			var selectedTab;
			var selectedTabNode;
			for (var i = 0; i < this.tabSection.childNodes.length; i++) {
				var tabId = this.tabSection.childNodes[i].tabId;
				var helpWidget = this._tabs[tabId].helpWidget;
				if (tabId == targetTabId) {
					dojo.toggleClass(this.tabSection.childNodes[i], "selected", true); //$NON-NLS-1$
					selectedTab = tabId;
					selectedTabNode = this.tabSection.childNodes[i];
				} else {
					dojo.toggleClass(this.tabSection.childNodes[i], "selected", false); //$NON-NLS-1$
					if (helpWidget) {
						dojo.toggleClass(helpWidget.domNode, "helpHidden", true); //$NON-NLS-1$
					}
				}
			}
			
			//If clicking on the configuration data category tab
			//Show/Hide its children configuration data tabs
			if(dojo.hasClass(selectedTabNode, "configurationDataCategory")) { //$NON-NLS-1$
				
				if(dojo.hasClass(selectedTabNode, "expanded")) { //$NON-NLS-1$
					dojo.removeClass(selectedTabNode, "expanded"); //$NON-NLS-1$
					dojo.addClass(selectedTabNode, "collaped"); //$NON-NLS-1$
					selectedTabNode.firstChild.firstChild.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/grey-twistie-closed.png").toString(); //$NON-NLS-1$ //$NON-NLS-2$ 
				} else {
					dojo.removeClass(selectedTabNode, "collaped"); //$NON-NLS-1$
					dojo.addClass(selectedTabNode, "expanded");  //$NON-NLS-1$
					selectedTabNode.firstChild.firstChild.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/grey-twistie-open.png").toString(); //$NON-NLS-1$ //$NON-NLS-2$;
				}
				
				var tabId = selectedTabNode.tabId;
				var children = [];
				var next = selectedTabNode.nextSibling;
				while(next && dojo.hasClass(next, "configurationData")) { //$NON-NLS-1$
					children.push(next);
					next = next.nextSibling;
				}
				
				for(var i = 0; i < children.length; i++) {
					dojo.toggleClass(children[i], "hiddenConfigurationData"); //$NON-NLS-1$
				}									
				return;
			}

			if (this.selectedTab === selectedTab) {
				return; //tab already selected
			}

			// cache the current tab
			if (!this._widgetCache[this.selectedTab]) {
				this._cacheCurrentChildren(this.selectedTab);
			}
			dojox.xml.parser.removeChildren(this.twoColumnMainColumn);
			this.selectedTab = selectedTab;
			
			
			if (this.selectedTab === ProcessConstants.TabEnum.OVERVIEW) {
				this.overViewHeaderSection.style.display = "block"; //$NON-NLS-1$
			} else {
				this.overViewHeaderSection.style.display = "none"; //$NON-NLS-1$
			}
 			
			// Only show the team area hierarchy on the overview tab
			if (this.selectedTab === ProcessConstants.TabEnum.OVERVIEW && !this._hideTeams) {
				this.teamAreaHierarchy.style.display = "block"; //$NON-NLS-1$
			} else {
				this.teamAreaHierarchy.style.display = "none"; //$NON-NLS-1$
			}
			
			if (!this._widgetCache[selectedTab]) {
				var tabLink = this._tabs[selectedTab];
				//first time going to the tab so invoke it's creation
				if (tabLink.extensionPointWidget) {
					try {
						// If tab loaded from registry...load and create the widget
						tabLink.mainPage = this._createExtensionTab(tabLink);
					} catch (error) {
						// Create an error tab
						var tabContainer = this._createTabContainer();
						tabLink.mainPage = new com.ibm.team.process.web.ui.internal.admin.projects.ErrorTab({
							itemUUID: this.projectAreaItemId,
							tabContainer: tabContainer,
							tabID: tabLink.tabId,
							tabTitle: tabLink.tabTitle,
							tabWidget: tabLink.extensionPointWidget,
							tabError: error.message
						});
						
						this.twoColumnMainColumn.appendChild(tabLink.mainPage.domNode);
						
					}
				} else if (dojo.hasClass(tabLink, "configurationData")) { //$NON-NLS-1$
					var args = {};
					args.projectAreaEditor = this;
					args.editorId = tabLink.tabId; 
					tabLink.mainPage = this._createConfigurationDataContainer(tabLink);
				} else {
					// Invoke the call back creation method 
					if(tabLink.createTab) {
						tabLink.mainPage = tabLink.createTab.call(this, tabLink);
					} 
				}
			} else {
				var theTab = this._tabs[selectedTab].mainPage;
				if (theTab && dojo.isFunction(theTab.activateTab)) {
					theTab.activateTab.call(theTab);
				}
				
			}
			
			//replaceChild
			if (this._widgetCache[selectedTab]) {
				this._switchCachedTab(selectedTab);
			}
		},
		
		isTheActiveTab : function(theTab) {
			return this.selectedTab === theTab;
		},
		
		_onTabClick: function(event){
			dojo.stopEvent(event);
			
			//TODO:
			//If the clicked tab is the category tab, don't switchTab
			//
			this._switchTab(event.currentTarget.tabId);
		},
		
		//clear the text decoration when mouse is down
		_onTabMousedown: function(event) {
			dojo.stopEvent(event);
			event.currentTarget.style.textDecoration = "none"; //$NON-NLS-1$
		},
		
		_createExtensionTab: function(tabLink){
			// Load widget JS, HTML & CSS		
			jazz.core.loader.load_sync(tabLink.extensionPointWidget);
			// Instantiate widget
			var widgetConstructor = eval(tabLink.extensionPointWidget);
			var tabContainer = this._createTabContainer();
			var subNode = document.createElement(ProcessConstants.DIV);
			
			var args = {};
			args.tabLink = tabLink;
			var headerSection = new ProcessAreaEditorPageHeaderSection(args);
			this.twoColumnMainColumn.appendChild(headerSection.domNode);
			this.twoColumnMainColumn.appendChild(subNode);
			var tabContentWidget = new widgetConstructor({
				itemUUID: this.projectAreaItemId,
				owningApplicationKey: this._owningApplicationKey,
				editor: this,
				tabContainer: tabContainer,
				tabID: tabLink.tabId,
				tabTitle: tabLink.tabTitle
			}, subNode);
			return tabContentWidget;
		},
		
		_createConfigurationDataContainer: function(tabLink){
			var args = {};
			args.processAreaEditor = this;
			args.projectAreaItemId = this.projectAreaItemId;
			args.configurationEditorId = tabLink.tabId;
			args.configurationDataEditorMgr = this.configurationDataManager;
			var container = new ConfigurationDataEditorContainer(args);
			this.configurationDataManager.addConfigDataContainer(args.configurationEditorId, container);
			var args = {};
			args.pageTitle = tabLink.parentTabTitle + " - " + tabLink.tabTitle; //$NON-NLS-1$
			if (tabLink.description) {
				args.pageDescription = tabLink.description;
			}
			args.tabLink = tabLink;
			var headerSection = new ProcessAreaEditorPageHeaderSection(args);
			this.twoColumnMainColumn.appendChild(headerSection.domNode);
			this.twoColumnMainColumn.appendChild(container.domNode);
			return container;
		},
		
		getSelectedTabId: function() {
			return this.selectedTab;
		},
		
		_createTabContainer: function(){
			return {
				setDirty: dojo.hitch(this, this.setDirty),
				changesPending: dojo.hitch(this, this.changesPending),
				displaySuccessMessage: dojo.hitch(this, this._displayLongSuccessMessage),
				displayErrorMessage: dojo.hitch(this, this._displayLongErrorMessage),
				displayWarningMessage: dojo.hitch(this, this._displayLongWarningMessage),
				displayPendingMessage: dojo.hitch(this, this._displayPendingMessage),
				clearMessage: dojo.hitch(this, this._clearMessage)
			};
		},
		
		_switchCachedTab: function(selectedTab){
			dojo.forEach(this._widgetCache[selectedTab], function(child){
				this.twoColumnMainColumn.appendChild(child);
			}, this);
		},
		
		_cacheCurrentChildren: function(selectedTab){
			var children = [];
			for (var i = 0; i < this.twoColumnMainColumn.childNodes.length; i++) {
				children[i] = this.twoColumnMainColumn.childNodes[i];
			}
			this._widgetCache[selectedTab] = children;
		},
		
		_filterUserItemIds: function (filterUsers){
			var userFilter = [];
			for (var i = 0; i < filterUsers.length; i++) {
				if (!filterUsers[i].itemId) {
					userFilter.push({
						'itemId': filterUsers[i] //$NON-NLS-1$
					});
				} else {
					userFilter.push({
						'itemId': filterUsers[i].itemId //$NON-NLS-1$
					});
				}
			}
			return userFilter;
		},
		addAdminDialog: function(filterUsers){
			var userPicker = new com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog({
				destroyContents: true,
				disableUsers: this._filterUserItemIds(filterUsers) 
			});
			
			this.connect(userPicker, "onAdd", this.addNewAdmins); //$NON-NLS-1$
		},
		
		addUserWizard : function(filterUsers) {

			if (this.isNew) {
				// For new (unsaved) editors, we do not have a
				// list of roles available,
				// so we bing up the 'old' dialog which only
				// offers user selection and
				// assignes the default role.
				var userPicker = new com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog({
					destroyContents : true,
					'disableUsers' : this._filterUserItemIds(filterUsers) //$NON-NLS-1$
				});
				this.connect(userPicker, "onAdd", dojo.hitch(this, function(newMembers) { //$NON-NLS-1$
					// No way to choose roles for the new case so
					// pass the default role as the
					// chosen roles
					var defaultRole = this.getDefaultRole();
					this._addNewMembersWithRoles(newMembers, [{
						id : ProcessConstants.DEFAULT_ROLE_ID,
						label : defaultRole.label,
						description : defaultRole.description
					}]);
				}));

			} else {
				var userPicker = new com.ibm.team.process.web.ui.internal.admin.projects.AddMembersWizard({
					disableUsers : this._filterUserItemIds(filterUsers),
					allRoles : this.getAllProcessRoles(),
					defaultRole : this.getDefaultRole()
				});
				this.connect(userPicker, "onFinish", this._addNewMembersWithRoles); //$NON-NLS-1$
			}
		},
		
		refresh: function(refreshClicked){
			if (!this.navigateAwayHandle) {
				this.navigateAwayHandle = PlatformUI.getWorkbench().registerBodyClickHandler(dojo.hitch(this, this._handleNavigate), /*priority*/ 10000);
				this.onBeforeUnloadHandle = PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(dojo.hitch(this, this.navigateAwayEvent), /*priority*/ 10000);
			}
			
			this.clearState(refreshClicked);
			this.deferredSaveCount = 0;
			if (this.isNew) {
				this.toggleViewEditMode(ProcessConstants.EditorMode.EDIT);
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
				this.populateMembers([]);
				this.populateAdmins([]);
				setTimeout(dojo.hitch(this.name, function(){
					try {
						this.select();
					} catch (error) {
						// If the text can't be selected...ignore the error
					}
				}), 250);
			} else {
				this._destroyStyledTable(this.membersDiv);
				this._destroyStyledTable(this.adminsDiv);
			}
			
			this.customRefresh(refreshClicked);
			this.checkForSuccessMsg();
		},
		
		_handleNavigate: function(urlObj){
			if (urlObj && urlObj.fragment === "") { //$NON-NLS-1$		
				return false;
			}	
			try {
				if (this.changesPending()) {
					if (!confirm(this.messages.ProjectAreaEditor_2)) {
						return true; //veto the navigate
					}
				}
			} catch (error) {
				// Work around for workitem 56269 as documented 
				// in workitem 161749.  Need to let the handlers 
				// get unregistered in the event of an exception
				// or they stick around forever preventing other
				// handlers from getting called.
			}
			//move away from the editor
			this._unregisterHandlers();
			return false;
		},
		
		navigateAwayEvent: function(){
			return this.changesPending() ? this.messages.ProjectAreaEditor_3 : false;
		},
		
		_unregisterHandlers: function(){
			PlatformUI.getWorkbench().unregisterBodyClickHandler(this.navigateAwayHandle);
			this.navigateAwayHandle = null;
			PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandle);
			this.onBeforeUnloadHandle = null;
		},
		
		checkForSuccessMsg: function(){
			var msgCookie = dojo.cookie(AbstractProcessAreaEditor.MSG_COOKIE_NAME);
			if (msgCookie) {
				this._displayLongSuccessMessage(msgCookie);
				var now = new Date();
				now.setTime(now.getTime() - 1);
				dojo.cookie(AbstractProcessAreaEditor.MSG_COOKIE_NAME, ProcessConstants.EMPTY, {
					expires: now
				});
			}
		},
		
		checkForTeamInvitation: function(){
			var inviteCookie = dojo.cookie(AbstractProcessAreaEditor.NEW_MEMBERS_COOKIE_NAME);
			if (inviteCookie) {
				var newMemberArray = this._getNewMembers(dojo.fromJson(inviteCookie), false);
				if (newMemberArray.length > 0 && !this._isEmbedded) {//cookie and more than yourself & not an embedded editor
					this.chooseTeamInvitees(newMemberArray);
				}
				var now = new Date();
				now.setTime(now.getTime() - 1);
				dojo.cookie(AbstractProcessAreaEditor.NEW_MEMBERS_COOKIE_NAME, ProcessConstants.EMPTY, {
					expires: now
				});
			}
		},
		
		checkForNewMembersWithoutRoles: function(){
			var newMemberCookie = dojo.cookie(AbstractProcessAreaEditor.NEW_MEMBERS_COOKIE_NAME);
			if (!newMemberCookie) {
				return;
			}
			var newMemberArray = this._getNewMembers(dojo.fromJson(newMemberCookie), true);
			var trace = ""; //$NON-NLS-1$
			dojo.forEach(newMemberArray, function(member){
				if (member.processRoles.length == 1) { //only the default role
					trace += "\n\t" + member.name; //$NON-NLS-1$
				}
			});
			
			if (trace.length > 0) {
				var error = {};
				error.errorData = {};
				error.errorData.identifier = "com.ibm.team.process.newMembersWithoutRole"; //$NON-NLS-1$
				error.errorData.internalReportInfos = [];
				error.errorData.internalReportInfos[0] = {};
				error.errorData.internalReportInfos[0].identifier = "com.ibm.team.process.internal.newMembersWithoutRoles"; //$NON-NLS-1$
				error.errorData.internalReportInfos[0].data = this.messages.AbstractProcessAreaEditor_NewMembersWithoutRoles + trace;
				var errorHeader = this.messages.AbstractProcessAreaEditor_NewMembersWithoutRolesWarningHeader;
				this._handleWarning(error, ProcessConstants.ERROR_PRIORITY_WARNING_LOW, errorHeader);
			}
		},
		
		checkForShowArchived: function(){
			var showArchived = dojo.cookie(AbstractProcessAreaEditor.SHOW_ARCHIVED_COOKIE_NAME);
			if (showArchived === "true") { //$NON-NLS-1$
				this._teamHierarchyToolbar.setPressed(this._showArchivedButton, true);
				var now = new Date();
				now.setTime(now.getTime() - 1);
				dojo.cookie(AbstractProcessAreaEditor.SHOW_ARCHIVED_COOKIE_NAME, ProcessConstants.EMPTY, {
					expires: now
				});
			}
		},
		
		clearState: function(refreshClicked){
			delete this.errObj;
			this.setDirty(false);
			this.pendingMemberChanges = {};
			this.pendingAdminChanges = {};
			this.cancelPreviousMembersRequest();
			this.allMembers = [];
			this.allMemberIds = [];
			delete this.loadingAllMembers;
			this.allAdmins = [];
			this._clearMessage();
			this.name.value = ProcessConstants.EMPTY;
			this.summary.value = ProcessConstants.EMPTY;
			this.description.value = ProcessConstants.EMPTY;
			this._destroyStyledTable(this.membersDiv);
			this._destroyStyledTable(this.adminsDiv);
			for (var i = 0; i < this.inputFields.length; i++) {
				this.inputFields[i].changePending = false;
			}
			
			this.clearEnterpriseProcessState();
			
			if (refreshClicked) {
				this._destroySaveParticipants();
				this._saveParticipants = new dojox.collections.Dictionary();
			}
			if (this.sharedStore) {
				delete this.sharedStore;
			}
			this._destroyActionToolbars();
			this._destroyHierarchyToolbars();
			this._destroyResourceLinks();
			
			this._countNewMembers = 0;
			this._countNewAdmins = 0;			
		},
		

		/**
		 * Clears any state affected by process sharing.
		 * This will be called when the editor is
		 * refreshed.
		 * 
		 * This function is currently overriden and
		 * called from the ProjectAreaEditor.
		 */
		clearEnterpriseProcessState : function() {
		},
		
		_clearMessage: function(){
			PlatformUI.getWorkbench().hideMessageArea();
			this._messageBox.hideMessage();
		},
		
		handleFetchError: function(error){
			this.stopLoading();
			error.priority = ProcessConstants.ERROR_PRIORITY_HIGH;
			if (error.status == ProcessConstants.SC_FORBIDDEN) {
				// Hide everything in the editor
				this.primaryFieldContainer.style.display = ProcessConstants.NONE;
				this.tabSection.style.display = ProcessConstants.NONE;
				this.contentWrapper.style.display = ProcessConstants.NONE;
				// Eliminate the stock message from core.
				error.message = ""; //$NON-NLS-1$ 
			}
			var message = this.getFetchErrorMessage(error);
			this.handleServerResponseError(error, message, [ProcessConstants.PERMISSION_DENIED_EXCEPTION, ProcessConstants.LICENSE_NOT_GRANTED_EXCEPTION]);
		},
		
		handleServerResponseSuccess: function(response){
			this.deferredSaveCount--;
			if (this.deferredSaveCount <= 0) {
				if (!this.errObj) { //no more outstanding saves and not already showing an error
					this.refresh(false);
					this._displayLongSuccessMessage(this.getServerResponseSuccessMessage());
				} else { //all the deferred saves are complete. Report the previously hit error
					if (this.errObj.priority > ProcessConstants.ERROR_PRIORITY_WARNING) {
						this._displayLongErrorMessage(this.errObj);
					} else {
						var errorObject = this.errObj;
						if (this.isNeedRefreshWithWarning()) {
							this.refresh(false);
						}
						this._displayLongWarningMessage(errorObject);
					}
					
				}
			}
			return response;
		},
		
		getServerResponseSuccessMessage: function(){
			if (this.isTeamArea) {
				return this.messages.TeamAreaEditor_30;
			} else {
				return this.messages.ProjectAreaEditor_30;
			}
		},
		
		handleServerResponseError: function(error, optionalHeaderMessage, optionalExceptionClassesToIgnore){
			this.deferredSaveCount--;
			
			// If the error doesn't have a priority...give it a really low one. 
			if (!error.priority) {
				error.priority = ProcessConstants.ERROR_PRIORITY_LOW;
			}
			
			if (!this.errObj || error.priority > this.errObj.priority) {
				this.errObj = dojo.mixin({}, error);
				if (optionalHeaderMessage) {
					this.errObj.headerMessage = optionalHeaderMessage;
				}
				if (optionalExceptionClassesToIgnore) {
					this.errObj.exceptionClassesToIgnore = optionalExceptionClassesToIgnore;
				}
			}
			
			if (this.deferredSaveCount <= 0) { //no more outstanding saves and not already showing an error
				this._displayLongErrorMessage(this.errObj);
			}
		},
		
		handleServerResponseWarning: function(error, optionalHeaderMessage){
			this.deferredSaveCount--;
			this._handleWarning(error, ProcessConstants.ERROR_PRIORITY_WARNING, optionalHeaderMessage);
		},
		
		_handleWarning: function(error, priority, optionalHeaderMessage){
			if (this.errObj && this.errObj.priority >= priority) {
				return;
			}
			
			this.errObj = dojo.mixin({}, error);
			this.errObj.priority = priority;
			this.errObj.headerMessage = optionalHeaderMessage;
			var errorObject = this.errObj;
			if (this.deferredSaveCount <= 0) { //no more outstanding saves and not already showing an error
				if (this.isNeedRefreshWithWarning()) {
					this.refresh(false);
				}
				this._displayLongWarningMessage(errorObject);
			}
		},
		
		togglePrimaryField: function(mode){
			if (mode === ProcessConstants.EditorMode.PREVIEW) {
				this.name.style.display = ProcessConstants.NONE;
				dojox.xml.parser.removeChildren(this.previewName);
				this.previewName.appendChild(document.createTextNode(this.name.value || this.getPrimaryFieldLabel()));
				this.previewName.style.display = ProcessConstants.EMPTY;
			} else if (mode === ProcessConstants.EditorMode.EDIT) {
				this.previewName.style.display = ProcessConstants.NONE;
				this.name.style.display = ProcessConstants.EMPTY;
				this.name.focus();
				this.name.select();
			}
		},
		
		toggleViewEditMode: function(mode){
			this.toggleDescLink.mode = mode;
			if (mode === ProcessConstants.EditorMode.PREVIEW) {
				dojo.forEach(this.editViewFields, function(field){
					field.style.display = ProcessConstants.NONE;
					dojox.xml.parser.removeChildren(field.viewElement);
					var previewString = field.value.substring(0, SHOW_TEXT_LENGTH);
					var hiddenString = field.value.substring(SHOW_TEXT_LENGTH);
					if (field.value.length > SHOW_TEXT_LENGTH) {
						var spaceIndex = hiddenString.indexOf(" "); //$NON-NLS-1$
						var newlineIndex = hiddenString.indexOf("\n"); //$NON-NLS-1$
						// if there is no good point to break the string in hiddenString, just show the whole thing
						if (spaceIndex === -1 && newlineIndex === -1) {
							previewString += hiddenString;
							hiddenString = ProcessConstants.EMPTY;
						} else if (newlineIndex === -1 || (spaceIndex !== -1 && spaceIndex < newlineIndex)) {
							previewString += hiddenString.substring(0, spaceIndex);
							hiddenString = hiddenString.substring(spaceIndex);
						} else if (spaceIndex === -1 || (newlineIndex !== -1 && newlineIndex < spaceIndex)) {
							previewString += hiddenString.substring(0, newlineIndex);
							hiddenString = hiddenString.substring(newlineIndex);
						}
					}
					var strings = previewString.split(/\n/);
					for (var i = 0; i < strings.length; i++) {
						if (i > 0) {
							field.viewElement.appendChild(document.createElement(ProcessConstants.BR));
						}
						if (strings[i].length > 0) {
							field.viewElement.appendChild(document.createTextNode(strings[i]));
						}
					}
					field.viewElement.style.display = ProcessConstants.EMPTY;
					dojox.xml.parser.removeChildren(field.viewAllElement);
					if (hiddenString) { //a non empty string
						strings = hiddenString.split(/\n/);
						for (i = 0; i < strings.length; i++) {
							if (i > 0) {
								field.viewAllElement.appendChild(document.createElement(ProcessConstants.BR));
							}
							if (strings[i].length > 0) {
								field.viewAllElement.appendChild(document.createTextNode(strings[i]));
							}
						}
						if (field.showingAll) {
							field.viewAllElement.style.display = ProcessConstants.INLINE;
							field.showLessLink.style.display = ProcessConstants.BLOCK;
							field.showAllLink.style.display = ProcessConstants.NONE;
						} else {
							field.viewAllElement.style.display = ProcessConstants.NONE;
							field.showLessLink.style.display = ProcessConstants.NONE;
							field.showAllLink.style.display = ProcessConstants.BLOCK;
						}
					}
				});
				dojox.xml.parser.removeChildren(this.toggleDescLink);
				this.toggleDescLink.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_8));
			} else if (mode === ProcessConstants.EditorMode.EDIT) {
				dojox.xml.parser.removeChildren(this.toggleDescLink);
				this.toggleDescLink.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_9));
				dojo.forEach(this.editViewFields, function(field){
					field.viewElement.style.display = ProcessConstants.NONE;
					field.viewAllElement.style.display = ProcessConstants.NONE;
					field.style.display = ProcessConstants.EMPTY;
					field.showAllLink.style.display = ProcessConstants.NONE;
					field.showLessLink.style.display = ProcessConstants.NONE;
				});
			}
		},
		
		populateProcessAreaData: function(data){
			this.stateId = data.stateId;
			this._isArchived = data.archived;
			this._setProcessAreaIcon(data.archived, data.initialized);
			this.name.value = data.name;
			this.name.savedValue = data.name;
			this.togglePrimaryField(ProcessConstants.EditorMode.PREVIEW);
			this.summary.value = data.summary;
			this.summary.savedValue = data.summary;
			this.description.value = data.description;
			this.description.savedValue = data.description;
			if (!this.toggleDescLinkIsClicked) {
				if (data.description) {
					this.toggleViewEditMode(ProcessConstants.EditorMode.PREVIEW);
				} else {
					this.toggleViewEditMode(ProcessConstants.EditorMode.EDIT);
				}
			}
			this.processAuthoringlicenseInfo = data.licenseInformation;
			
			this.populateEnterpriseProcessData(data);
			
			if (this.rolesEditor) {
				this.rolesEditor.refresh();
			}
			
			this.allMembers = data.members;
			this.allAdmins = data.admins;
			this.allMemberIds = data.memberIds;
			this.populateMembers(this.allMembers);
			this.populateAdmins(this.allAdmins);
			if (data.memberIds && data.memberIds.length > FETCH_MAX_MEMBERS) {
				this.fetchAllMembers(data);
			} else {
				this.checkForNewMembersWithoutRoles();
				this.checkForTeamInvitation();
			}
		},
		
		/**
		 * Fills in fields and data affected by process sharing.
		 * 
		 * @param {ProcessAreaDTO} data
		 */
		populateEnterpriseProcessData: function(data) {
			var allProcessRoles= [];
			if (data.processProviderDTO) {
				allProcessRoles = data.processProviderDTO.roles;
			} else if (data.processDTO) {
				allProcessRoles = data.processDTO.roles;
			} 

			this._rolesStore = new com.ibm.team.process.web.ui.internal.admin.projects.RolesStore({
				roles : allProcessRoles
			});
		},
		
		/**
		 * public: Returns the current RolesStore.
		 * @returns {com.ibm.team.process.web.ui.internal.admin.projects.RolesStore}
		 */
		getRolesStore: function(){
			return this._rolesStore;
		},
		
		_setProcessAreaIcon: function(isArchived, isInitialized){
			// Derived must override to set the icon, based on archived and initialized status
		},
		
		fetchAllMembers: function(data) {
			// kick off the call to get all members
			this.indicateLoadingMembers();
			var srh = new ServiceResponseHandler(this, "handleGetAllMembers", "handleGetAllMembersError"); //$NON-NLS-1$ //$NON-NLS-2$
			this.previousMembersRequest = ProcessClient.getMembersPaged({
				processAreaItemId: this.isTeamArea ? this.itemId : this.projectAreaItemId,
				requestToken: data.resultToken
			}, srh);	
		},
		
		indicateLoadingMembers: function(){
			this.loadingAllMembers = true;
			this.showAllMembersLink.style.display = ProcessConstants.NONE;
			this.loadingMembersDiv.style.display = ProcessConstants.BLOCK;
		},
		
		indicateDoneLoadingMembers: function(){
			delete this.loadingAllMembers;
			this.showAllMembersLink.style.display = ProcessConstants.BLOCK;
			this.loadingMembersDiv.style.display = ProcessConstants.NONE;
		},
		
		cancelPreviousMembersRequest: function(){
			if (this.previousMembersRequest) {
				// set failOk so that cancelled error does not show up in
				// browser console (aborted GET will still show up)
				this.previousMembersRequest._deferred.ioArgs.args.failOk = true;
				this.previousMembersRequest.abort();
				delete this.previousMembersRequest;
			}
		},

		showBreadcrumbs: function(project){
			if (this._breadCrumbsWidget) {
				this._breadCrumbsWidget.destroyRecursive();
				delete this._breadCrumbsWidget;
			}
			dojox.xml.parser.removeChildren(this.breadcrumbs);
			
			var breadcrumbSegments = [];
			var projectManagementSegment = {};
			
			if (this.isNew || project) {
				var isProjectAreaArchived = !this.isNew && project.archived;
				projectManagementSegment.href = isProjectAreaArchived ? MANAGE_ARCHIVED_LINK : MANAGE_ACTIVE_LINK;
				projectManagementSegment.label = isProjectAreaArchived ? this.messages.ProjectAreaEditor_10 : this.messages.ProjectAreaEditor_11;
				breadcrumbSegments.push(projectManagementSegment);
				if (project) {
					this.customAddBreadcrumbSegments(breadcrumbSegments, project);
				}
			} else {
				// placeholder to reduce page flicker
				projectManagementSegment.href = ""; //$NON-NLS-1$
				projectManagementSegment.label = "..."; //$NON-NLS-1$
				breadcrumbSegments.push(projectManagementSegment);
			}
			
			this._breadCrumbsWidget = new jazz.ui.Breadcrumbs({
				segments: breadcrumbSegments
			});
			this.breadcrumbs.appendChild(this._breadCrumbsWidget.domNode);
		},
		
		getAllProcessRoles: function(){
			var allRoles =this._rolesStore.getAllProcessRoles();
			
			return allRoles;
		},
		
		customAddBreadcrumbSegments: function(breadcrumbSegments, data){
			// Derived can override and add custom bread crumb segments
		},
		
		_teamArchiveHandler: function(event) {
			dojo.stopEvent(event);
			if (confirm(dojo.string.substitute(this.messages.AbstractProcessAreaEditor_ConfirmArchiveTeam, [event.currentTarget.callbackData.name]))) {
				this._disableToolbars(true);
				this._displayPendingMessage(this.messages.AbstractProcessAreaEditor_ArchiveTeamAreaInProgress);
				var srh = new ServiceResponseHandler(this, "_teamArchiveSuccessCallback", "_teamArchiveErrorCallback"); //$NON-NLS-1$ //$NON-NLS-2$
				ProcessClient.postArchiveProcessItem({
					uuid: event.currentTarget.callbackData.itemId,
					itemType: ProcessConstants.ITEM_TYPE.TEAM_AREA
				}, srh);
			}
			
		},
		
		_teamArchiveSuccessCallback: function(){
			UIHelper.runSafe(dojo.hitch(this, function(){
				this._refreshProcessAreaHierarchy();
				this._disableToolbars(false);
				this._displayLongSuccessMessage(this.messages.AbstractProcessAreaEditor_ArchiveTeamAreaSuccess);
			}));
		},
		
		_teamArchiveErrorCallback: function(err){
			this._disableToolbars(false);
			var summary = dojo.string.substitute(this.messages.AbstractProcessAreaEditor_ArchiveTeamAreaError, [err.message]);
			this._displayLongErrorMessage(summary);
		},
		
		_teamUnarchiveHandler: function(event) {
			dojo.stopEvent(event);
			if (confirm(dojo.string.substitute(this.messages.AbstractProcessAreaEditor_6, [event.currentTarget.callbackData.name]))) {
				this._disableToolbars(true);
				this._displayPendingMessage(this.messages.AbstractProcessAreaEditor_3);
				var srh = new ServiceResponseHandler(this, "_teamUnarchiveSuccessCallback", "_teamUnarchiveErrorCallback"); //$NON-NLS-1$ //$NON-NLS-2$
				ProcessClient.postUnarchiveProcessArea({
					uuid: event.currentTarget.callbackData.itemId,
					itemType: ProcessConstants.ITEM_TYPE.TEAM_AREA
				}, srh);
			}
		},

		_teamUnarchiveSuccessCallback: function() {
			UIHelper.runSafe(dojo.hitch(this, function(){
				this._refreshProcessAreaHierarchy();
				this._disableToolbars(false);
				this._displayLongSuccessMessage(this.messages.AbstractProcessAreaEditor_4);
			}));
		},

		_teamUnarchiveErrorCallback: function(err) {
			this._disableToolbars(false);
			var summary = dojo.string.substitute(this.messages.AbstractProcessAreaEditor_5, [err.message]);
			this._displayLongErrorMessage(summary);
		},
		
		_updateHierarchyRoot: function() {
			var rootElement = this.teamAreaHierarchyContent.firstChild;
			this._updateHierarchyView(rootElement);
		},
		
		_updateHierarchyView: function(element) {
			dojo.forEach(element.childAreas, function(child){
				this._updateHierarchyView(child);
			},this);
			this._updateHierarchyElementDisplayState(element, false);
		},
		
		_updateHierarchyElementDisplayState: function(element,toggleExpansionState) {
			var showArchived = this._teamHierarchyToolbar.isPressed(this._showArchivedButton);
			var twistieIcon = dojo.query(".treeIconImg",element)[0]; //$NON-NLS-1$
			if (element.archived === undefined) {
				element.archived = false;
			}
			if (element.archived) {
				if (!showArchived) {
					dojo.addClass(element, "hidden"); //$NON-NLS-1$
				} else {
					if (element.parentNode.isExpanded) {
						dojo.removeClass(element,"hidden"); //$NON-NLS-1$
					}
				}
			}
			if (toggleExpansionState) {
				if (element.isExpanded) { //Then collapse
					dojo.forEach(element.childAreas, function(child){
						dojo.addClass(child, "hidden"); //$NON-NLS-1$
					});
					element.isExpanded = false;
					twistieIcon.src = this._collapsedIconSrc;
					this._toggleHierarchyIconVisibility(twistieIcon, true);
				} else { //Expand this node
					dojo.forEach(element.childAreas, function(child){
						if (child.archived === false || showArchived) {
							dojo.removeClass(child, "hidden"); //$NON-NLS-1$
						}
					});
					element.isExpanded = true;
					twistieIcon.src = this._expandedIconSrc;
					this._toggleHierarchyIconVisibility(twistieIcon, true);
				}
			}
			// If all the element's children are hidden, remove the twistie icon
			if(!showArchived && !element.archived) {
				if (dojo.every(element.childAreas, function(child){
					return child.archived;})) {
					this._toggleHierarchyIconVisibility(twistieIcon, false);
				}
			} else {
				if (element.childAreas.length > 0) {
					this._toggleHierarchyIconVisibility(twistieIcon, true);
				}
			}
		},
		
		
		// Toggles a hierarchy icon element between visible & anchored or not
		// Pass the icon in
		_toggleHierarchyIconVisibility: function(element,enableIcon){
			var twistieAnchor = element.parentNode;
			if (enableIcon) {
				dojo.removeClass(element, "hideIcon"); //$NON-NLS-1$
				dojo.attr(twistieAnchor, "href", "#"); //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				dojo.addClass(element, "hideIcon"); //$NON-NLS-1$
				dojo.removeAttr(twistieAnchor, "href"); //$NON-NLS-1$
			}
		},
		
		populateTeamAreaHierarchy: function(data){
			this.updateProcessHierarchyButtons(data.archived);
			var showArchived = this._teamHierarchyToolbar.isPressed(this._showArchivedButton);
			dojox.xml.parser.removeChildren(this.teamAreaHierarchyContent);
                var processAreaData = {
					processAreaName: data.name,
					processAreaItemId: this.projectAreaItemId,
					archived: data.archived,
					initialized: data.initialized,
					isProjectArea: true
				};
			var div = this._createTeamHierarchyElement(processAreaData, false, false);
			var twistieIcon = dojo.query(".treeIconImg",div)[0]; //$NON-NLS-1$
			this.hierarchyNameDisplay = div;
			div.archived = data.archived;
			div.isRoot = true;
			this.teamAreaHierarchyContent.appendChild(div);
			// Turns node into a tree branch
			if (data.children) {
				div.isExpanded = true;
				twistieIcon.src = this._expandedIconSrc;
				this._toggleHierarchyIconVisibility(twistieIcon, true);
				
				this.displayProcessChildren(data.children, HIERARCHY_TAB_SPACING, div);
				//Manually collapses everything but first-level nodes
				dojo.forEach(div.childAreas, function(child){
					if (child.childAreas.length > 0) {
						var parentIcon = dojo.query(".treeIconImg",child)[0]; //$NON-NLS-1$
						// On visible nodes, if all children are archived and showArchived isn't on, remove the twistie
						if (!child.archived) {
							if (!showArchived && dojo.every(child.childAreas, function(item) {
								return item.archived;})) {
								this._toggleHierarchyIconVisibility(parentIcon, false);
							} else {
								child.isExpanded = false;
								parentIcon.src = this._collapsedIconSrc;
								this._toggleHierarchyIconVisibility(parentIcon, true);
							}
						} else {
							child.isExpanded = false;
							parentIcon.src = this._collapsedIconSrc;
							this._toggleHierarchyIconVisibility(parentIcon, true);
						}
					}
					dojo.forEach(child.childAreas,function(subChild){
						dojo.addClass(subChild, "hidden"); //$NON-NLS-1$
					},this);
				},this);
			} else {
				this._toggleHierarchyIconVisibility(twistieIcon, false);
			}
		},
		
		updateProcessHierarchyButtons: function(archived) {
			if (!archived) {
				this._teamHierarchyToolbar.enableButton(this._createChildButton);
			} else {
				this._teamHierarchyToolbar.setPressed(this._showArchivedButton, true);
			}
		},
		
		displayProcessChildren: function(children, indent, parentProcessArea){
			children = children.sort(function(a, b){
				return ProcessClient.stringCompare(a.name, b.name);
			});
			dojo.forEach(children, function(child){
                var processAreaData = {
					processAreaName: child.name,
					processAreaItemId: child.itemId,
					parentProcessArea: parentProcessArea,
					archived: child.archived,
					isProjectArea: false
				};
				var div = this._createTeamHierarchyElement(processAreaData, !parentProcessArea.archived, true);
				var twistieIcon = dojo.query(".treeIconImg",div)[0]; //$NON-NLS-1$
				div.archived = child.archived;
				parentProcessArea.appendChild(div);
				parentProcessArea.childAreas.push(div);
	            div.firstChild.style.paddingLeft = indent + "em"; //$NON-NLS-1$ //Indentation for sub-hierarchy
				if (child.children) {
					this.displayProcessChildren(child.children, indent + HIERARCHY_TAB_SPACING, div);
					div.isExpanded = true;
					twistieIcon.src = this._expandedIconSrc;
					this._toggleHierarchyIconVisibility(twistieIcon, true);
				} else {
					this._toggleHierarchyIconVisibility(twistieIcon, false);
				}
			},this);
			this._updateHierarchyRoot();
		},
		
		_createTeamHierarchyElement: function(processAreaData, canToggleArchive, canLink) {
			var container = dojo.create("div", { //$NON-NLS-1$
				className:"hierarchyContainer" //$NON-NLS-1$
			});
			container.childAreas = [];
			container._parentProcessArea = processAreaData.parentProcessArea;
			var element = dojo.create("div", { //$NON-NLS-1$
				className:"hierarchyElement" //$NON-NLS-1$
			},container);
			
            var iconAnchor = dojo.create("a", { //$NON-NLS-1$
            	href:"#", //$NON-NLS-1$
            	role:"button", //$NON-NLS-1$
        		className:"treeIconAnchor" //$NON-NLS-1$
        	},element);
            dojo.create("img", { //$NON-NLS-1$
        		className:"treeIconImg", //$NON-NLS-1$
        		src:this._expandedIconSrc //As a placeholder/default
        	},iconAnchor);
            
		    dojo.connect(iconAnchor, "onclick", this, function(evt){ //$NON-NLS-1$
		        evt.preventDefault();
		        var hasChildren = container.childAreas.length > 0;
		        this._updateHierarchyElementDisplayState(container, hasChildren);
		    });
            
            img = dojo.create("img", { //$NON-NLS-1$
        		className:"hierarchyElementIcon" //$NON-NLS-1$
        	});
			if (processAreaData.isProjectArea === true) {
				if (processAreaData.archived === true) {
					img.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/projectarea_archived_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					img.alt = this.messages.AbstractProcessAreaEditor_9;
				} else {
					if (!processAreaData.initialized) {
						img.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/uninitialized_pa_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
						img.alt = this.messages.AbstractProcessAreaEditor_14;
					} else {
						img.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/projectarea_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
						img.alt = this.messages.AbstractProcessAreaEditor_8;
					}
				}
			} else {
				if (processAreaData.archived === true) {
					img.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/teamarea_archived_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					img.alt = this.messages.AbstractProcessAreaEditor_11;
				} else {
					img.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/teamarea_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					img.alt = this.messages.AbstractProcessAreaEditor_10;
				}
			}
			element.appendChild(img);
						
			var toolbar = new com.ibm.team.process.web.ui.internal.admin.projects.TeamHierarchyElementToolbar();
			
			this.connectHandles.push(dojo.connect(element, "onmouseover", element, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				element._onHighlight(true);
			}));
			this.connectHandles.push(dojo.connect(element, "onmouseout", element, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				element._onHighlight(false);
			}));
			
			element.appendChild(toolbar.domNode);
			this._hierarchyToolbars.push(toolbar);
			
			var archiveAction = {};
			archiveAction.callbackData = {
				itemId: processAreaData.processAreaItemId,
				name: processAreaData.processAreaName
			};
			if (!processAreaData.archived) {
				archiveAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/archive_hov.gif"); //$NON-NLS-1$  //$NON-NLS-2$
				if (processAreaData.isProjectArea === true) {
					archiveAction.label = this.messages.AbstractProcessAreaEditor_ArchiveProjectArea;
				} else {
					archiveAction.label = this.messages.AbstractProcessAreaEditor_ArchiveTeamArea;
				}
				var archiveButton = toolbar.addButton(this, this._teamArchiveHandler, archiveAction);
			} else {
				archiveAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/unarchive_hov.gif"); //$NON-NLS-1$  //$NON-NLS-2$
				if (processAreaData.isProjectArea === true) {
					archiveAction.label = this.messages.AbstractProcessAreaEditor_1;
				} else {
					archiveAction.label = this.messages.AbstractProcessAreaEditor_2;
				}
				var archiveButton = toolbar.addButton(this, this._teamUnarchiveHandler, archiveAction);
			}
			element._toolbar = toolbar;
			element._archiveAction = archiveButton;
			
			this.connectHandles.push(dojo.connect(element._archiveAction.domNode, "onfocus", element, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				element._onHighlight(true);
			}));
			this.connectHandles.push(dojo.connect(element._archiveAction.domNode, "onblur", element, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				element._onHighlight(false);
			}));
			
			if (!canToggleArchive) {
				element._toolbar.disableButton(element._archiveAction);
			}
			
			element._onHighlight = function(value){
				dojo.toggleClass(this, "selected", value); //$NON-NLS-1$
				dojo.forEach(this.childAreas,function(subchild){
					this._displayChildrenArchiveButton(subchild,value);
				},this);
			};
			
			element._displayChildrenArchiveButton = function(element,value){
				dojo.toggleClass(element._archiveAction.domNode,"hidden", value);  //$NON-NLS-1$
				dojo.forEach(element.childAreas,function(child){
					element._displayChildrenArchiveButton(child,value);
				},this);
			};
			
			if (canLink) {
				var link = document.createElement("a"); //$NON-NLS-1$
				var openEditorUri = "#action="; //$NON-NLS-1$
				if (processAreaData.processAreaItemId === this.projectAreaItemId) {
					link.href = this._getServerUrl() + net.jazz.ajax.contextRoot() + "/process/project-areas/" + this.projectAreaItemId;//$NON-NLS-1$
					openEditorUri += AbstractProcessAreaEditor.PROJECT_AREA_EDITOR + "&itemId=" +this.projectAreaItemId; //$NON-NLS-1$
				} else {
					link.href = this._getServerUrl() + net.jazz.ajax.contextRoot() + "/process/project-areas/" + this.projectAreaItemId + "/team-areas/" + processAreaData.processAreaItemId; //$NON-NLS-1$ //$NON-NLS-2$
					openEditorUri += AbstractProcessAreaEditor.TEAM_AREA_EDITOR + "&itemId=" + processAreaData.processAreaItemId + "&projectAreaItemId=" + this.projectAreaItemId; //$NON-NLS-1$ //$NON-NLS-2$
				}  
				link.appendChild(document.createTextNode(processAreaData.processAreaName));
				var rl = new ResourceLink({
					'presentationUri': openEditorUri,//$NON-NLS-1$
					'lazyFetch': true //$NON-NLS-1$
				}, link);
				this._resourceLinks.push(rl);
				
				this.connectHandles.push(dojo.connect(link, "onfocus", element, function(e){ //$NON-NLS-1$
					dojo.stopEvent(e);
					element._onHighlight(true);
				}));
				this.connectHandles.push(dojo.connect(link, "onblur", element, function(e){ //$NON-NLS-1$
					dojo.stopEvent(e);
					element._onHighlight(false);
				}));
				
				this.connectHandles.push(dojo.connect(link, "onclick", this, function(e){ //$NON-NLS-1$
					dojo.cookie(AbstractProcessAreaEditor.SHOW_ARCHIVED_COOKIE_NAME, this._teamHierarchyToolbar.isPressed(this._showArchivedButton));
				}));
				dojo.addClass(rl.domNode, "processAreaLink");  //$NON-NLS-1$
				element.appendChild(rl.domNode);
				element._nameElement = link;
			} else {
				var span = dojo.create("span", { }, element); //$NON-NLS-1$
				dojo.addClass(span, "j-label"); //$NON-NLS-1$
				dojo.addClass(span, "processAreaLink"); //$NON-NLS-1$
				span.appendChild(document.createTextNode(processAreaData.processAreaName));
				element._nameElement = span;
			}
			
			return container;			
		},
		
		handleTeamAreaHierarchyFetchError: function(error){
			this.handleServerResponseError(error, this.messages.ProjectAreaEditor_12);
		},
				
		handleGetAllMembers: function(data){
			UIHelper.runSafe(dojo.hitch(this, function(){
				delete this.previousMembersRequest;
				var fetchedMembers = data && data.members.count > 0 ? data.members.elements : [];
				this._mergeInFetchedMembers(fetchedMembers);
				this.indicateDoneLoadingMembers();
				this.populateMembers(this.allMembers);
				this.checkForNewMembersWithoutRoles();
				this.checkForTeamInvitation();
			}));
		},
		
		_mergeInFetchedMembers: function(fetchedMembers){
			// splice off added members (to keep them at the end of the list)
			for (var i = this.allMembers.length-1; i >= 0; i--) {
				var added = this.pendingMemberChanges.add && dojo.some(this.pendingMemberChanges.add, function(itemId) {
					return this.allMembers[i].itemId === itemId;
				}, this);
				if (!added) {
					break;
				}
			}
			var addedMembers = this.allMembers.splice(i+1, this.allMembers.length-1-i);
			
			// filter removed and already fetched members from incoming list
			fetchedMembers = dojo.filter(fetchedMembers, function(member) {
            	var removed = this.pendingMemberChanges.remove && dojo.some(this.pendingMemberChanges.remove, function(itemId) {
					return member.itemId === itemId;
				}, this);
            	var alreadyFetched = dojo.some(this.allMembers, function(other){
            		return member.itemId === other.itemId;
            	}, this);
            	return !removed && !alreadyFetched;
        	}, this);
        	
        	// add newly fetched members
        	this.allMembers = this.allMembers.concat(fetchedMembers);
        	
        	// add added members back in
        	this.allMembers = this.allMembers.concat(addedMembers);
		},
		
		handleGetAllMembersError: function(error){
			delete this.previousMembersRequest;
			this.handleServerResponseError(error, dojo.string.substitute(this.messages.AbstractProcessAreaEditor_7, [this.name.value]));
		},
		
		/**
    	 * Populates the members table with the users inputed 
    	 * 
    	 * @param {Object[]} members An array of the members to be added
    	 */
		populateMembers: function(members){
			this._destroyMemberTRLinks();
			this._destroyMemberActionToolbars();
			var membersToDisplay = !this.showingAllMembers ? (this.isNew ? DEFAULT_DISPLAY_MAX : DEFAULT_DISPLAY_MAX + this._countNewMembers) : members.length;
			if (this._isEmbedded) {
				this.populateUsers(members, this.membersDiv, !this.isNew, this._countNewMembers, membersToDisplay, this._memberTRLinks, this._memberActionToolbars, "memberRemoveHandler", "processRoleHandler"); //$NON-NLS-1$ //$NON-NLS-2$ 
			} else {
				this.populateUsers(members, this.membersDiv, !this.isNew, this._countNewMembers, membersToDisplay, this._memberTRLinks, this._memberActionToolbars, "memberRemoveHandler", "processRoleHandler", "teamInviteHandler"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			}
			this._updateShowAllFewerMembersLinkDisplay(members);
		},
		
		_updateShowAllFewerMembersLinkDisplay: function(members) {
			if (!this.loadingAllMembers && members && members.length > (this.isNew ? DEFAULT_DISPLAY_MAX : DEFAULT_DISPLAY_MAX + this._countNewMembers)) {
				if (this.showingAllMembers) {
					this.showFewerMembersLink.style.display = ProcessConstants.BLOCK;
					this.showAllMembersLink.style.display = ProcessConstants.NONE;
				} else {
					this.showFewerMembersLink.style.display = ProcessConstants.NONE;
					this.showAllMembersLink.style.display = ProcessConstants.BLOCK;
				}
			} else {
				this.showFewerMembersLink.style.display = ProcessConstants.NONE;
				this.showAllMembersLink.style.display = ProcessConstants.NONE;
			}
		},
		
		/**
    	 * Populates the administrator table with the users inputed 
    	 * 
    	 * @param {Object[]} admins An array of the administrators to be added
    	 */
		populateAdmins: function(admins){
			this._destroyAdminTRLinks();
			this._destroyAdminActionToolbars();
			var adminsToDisplay = !this.showingAllAdmins ? (this.isNew ? DEFAULT_DISPLAY_MAX : DEFAULT_DISPLAY_MAX + this._countNewAdmins) : admins.length;
			this.populateUsers(admins, this.adminsDiv, false, this._countNewAdmins, adminsToDisplay, this._adminTRLinks, this._adminActionToolbars, "adminRemoveHandler"); //$NON-NLS-1$
			if (admins && admins.length > (this.isNew ? DEFAULT_DISPLAY_MAX : DEFAULT_DISPLAY_MAX + this._countNewAdmins)) {
				if (this.showingAllAdmins) {
					this.showFewerAdminsLink.style.display = ProcessConstants.BLOCK;
					this.showAllAdminsLink.style.display = ProcessConstants.NONE;
				} else {
					this.showFewerAdminsLink.style.display = ProcessConstants.NONE;
					this.showAllAdminsLink.style.display = ProcessConstants.BLOCK;
				}
			} else {
				this.showFewerAdminsLink.style.display = ProcessConstants.NONE;
				this.showAllAdminsLink.style.display = ProcessConstants.NONE;
			}
		},
		
		/**
    	 * This function determines if only one member is current selected
    	 * 
    	 * @private
    	 * @param {Object} row A row's callback data
    	 * @returns {Boolean} True if only one member is selected, false otherwise
    	 */ 
		_handleEnableMenuItemForSingleItems: function(row){
			return this.membersDiv.styledTable.getSelectedCount() === 1;
		},
		
		/**
    	 * This function determines if only many members are currently selected
    	 * 
    	 * @private
    	 * @param {Object} row A row's callback data
    	 * @returns {Boolean} True if only many member are selected and is a valid selection, false otherwise
    	 */ 
		_handleEnableMenuForManyItems: function(row){
			return this.membersDiv.styledTable.isRowSelected(row.userObj.itemId) && this.membersDiv.styledTable.getSelectedCount() > 1;
		},
		
		 /**
    	 * This function determines if Bulk Remove Process Roles should be enabled based on the current users
    	 * 
    	 * @private
    	 * @param {Object} row A row's callback data
    	 * @returns {Boolean} True if Bulk Remove Process Role is Enabled, false otherwise
    	 */ 
		_handleEnableMenuItemForBulkRemoveMenuItem: function(row){
			//check if menu should be enabled
			if(!this._handleEnableMenuItemForSingleItems(row) && !this._handleEnableMenuForManyItems(row)){
				return false;
			}
			
			//check if the bulk remove dialog would be populated
			var members = this.membersDiv.styledTable.getAllSelectedRows();
			
			//Get an object which tells us if the process role exists on the current member
			for(var i = 0; i < members.length; i++){
				if(members[i].userObj.processRoles.length > 1){
					return true;
				}
			}
			
			return false;
		},
		
		/**
    	 * This function determines what text to display for Bulk Add Process Roles
    	 * 
    	 * @private
    	 * @param {Object} row A row's callback data
    	 * @returns {String} The string to be displayed for the item
    	 */ 
		_handleEnableMenuTextForBulkAddMenuItem: function(row){
			//check if menu should be enabled
			if(!this._handleEnableMenuItemForSingleItems(row) && !this._handleEnableMenuForManyItems(row)){
				return dojo.string.substitute(this.messages.ProjectAreaEditor_BulkAddRoles, [this.membersDiv.styledTable.getSelectedCount() - 1]);
			}
			
			return dojo.string.substitute(this.messages.ProjectAreaEditor_BulkAddRoles, [this.membersDiv.styledTable.getSelectedCount()]);
		},
		
		/**
    	 * This function determines what text to display for Bulk Remove Process Roles
    	 * 
    	 * @private
    	 * @param {Object} row A row's callback data
    	 * @returns {String} The string to be displayed for the item
    	 */ 
		_handleEnableMenuTextForBulkRemoveMenuItem: function(row){
			//check if menu should be enabled
			if(!this._handleEnableMenuItemForSingleItems(row) && !this._handleEnableMenuForManyItems(row)){
				return dojo.string.substitute(this.messages.ProjectAreaEditor_BulkRemoveRoles, [this.membersDiv.styledTable.getSelectedCount() - 1]);
			}
			
			return dojo.string.substitute(this.messages.ProjectAreaEditor_BulkRemoveRoles, [this.membersDiv.styledTable.getSelectedCount()]);
		},
		
		/**
    	 * This function determines what text to display for Remove Members
    	 * 
    	 * @private
    	 * @param {Object} row A row's callback data
    	 * @returns {String} The string to be displayed for the item
    	 */ 
		_handleEnableMenuTextForMemberRemoveMenuItem: function(row){
			//get the appropiate count
			var count = this.membersDiv.styledTable.getSelectedCount();
			if(!this._handleEnableMenuItemForSingleItems(row) && !this._handleEnableMenuForManyItems(row)){
				count--;
			}
			
			if(count < 2){
				return this.messages.ProjectAreaEditor_RemoveMembers;
			}
			
			return dojo.string.substitute(this.messages.ProjectAreaEditor_RemoveMembersWithCount, [count]);
		},
		
		/**
    	 * Populates the table inputed with the users inputed 
    	 * 
    	 * @private
    	 * @param {Object[]} users An array of the users to be inputted
    	 * @param {Object} tableDiv The table to be populated
    	 * @param {Boolean} isNotNew Determines if the table is not in a new project
    	 * @param {Integer} newCount The number of rows which are new in the table
    	 * @param {Integer} displayCount The number of rows which are to be displayed in the new table
    	 * @param {Object[]} TRLinks An array containing all the Link elements which are to be destroyed when the page is destroyed 
    	 * @param {Object[]} actionToolbars An array containing all the toolbars which are to be destroyed when the page is destroyed 
    	 * @param {Function} removeHandlerThe remove function to used for each row
    	 * @param {Function} processRoleHandler The Edit Roles function to be used for each row
    	 * @param {Function} teamInviteHandler The Team Invite function to be used for each row
    	 */ 
		populateUsers: function(users, tableDiv, isNotNew, newCount, displayCount, TRLinks, actionToolbars, removeHandler, processRoleHandler, teamInviteHandler){
					
			this._destroyStyledTable(tableDiv);
			
			var columns = [];
			//Name column
			columns.push({
				label: this.messages.ProjectAreaEditor_18,
				className: "memberName", //$NON-NLS-1$
				sortable: false
			});
			//Process Roles column or E-mail column
			if (isNotNew) {
				columns.push({
					label: this.messages.ProjectAreaEditor_19,
					className: "memberRoles", //$NON-NLS-1$
					sortable: false
				});
			} else {
				columns.push({
					label: this.messages.ProjectAreaEditor_20,
					className: "memberMail", //$NON-NLS-1$
					sortable: false
				});
			}

			if (isNotNew){
				//Add popup menu button
				var button = {
					imgSrc: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/action-menu_co.gif"), //$NON-NLS-1$  //$NON-NLS-2$
					label: this.messages.ProjectAreaEditor_MembersDropDownButtonLabel
				};

				//Add popup menu
				var menu = [];
				
				menu.push({
					label: this.messages.ProjectAreaEditor_21,
					title: this.messages.ProjectAreaEditor_21,
					iconClass: 'ProcessRolesIcon', //$NON-NLS-1$
					onClick: dojo.hitch(this, this.processRoleHandler),
					isEnabled: dojo.hitch(this, this._handleEnableMenuItemForSingleItems)
				});
				
				menu.push({
					label: dojo.hitch(this, this._handleEnableMenuTextForBulkAddMenuItem),
					title: dojo.hitch(this, this._handleEnableMenuTextForBulkAddMenuItem),
					iconClass: 'BulkAddRolesIcon', //$NON-NLS-1$
					onClick: dojo.hitch(this, this.processBulkAddRoles),
					isEnabled: dojo.hitch(this, function(row) {return this._handleEnableMenuItemForSingleItems(row) || this._handleEnableMenuForManyItems(row);})
				});
				
				menu.push({
					label: dojo.hitch(this, this._handleEnableMenuTextForBulkRemoveMenuItem),
					title: dojo.hitch(this, this._handleEnableMenuTextForBulkRemoveMenuItem),
					iconClass: 'BulkRemoveRolesIcon', //$NON-NLS-1$
					onClick: dojo.hitch(this, this.processBulkRemoveRoles),
					isEnabled: dojo.hitch(this, this._handleEnableMenuItemForBulkRemoveMenuItem)
				});
				
				menu.push({
					isDivider: true
				});
				
				if(teamInviteHandler){
					menu.push({
						label: this.messages.ProjectAreaEditor_40,
						title: this.messages.ProjectAreaEditor_40,
						iconClass: 'TeamInviteIcon', //$NON-NLS-1$
						onClick: dojo.hitch(this, this.teamInviteHandler),
						isEnabled: dojo.hitch(this, this._handleEnableMenuItemForSingleItems)
					});
				}
				
				menu.push({
					label: dojo.hitch(this, this._handleEnableMenuTextForMemberRemoveMenuItem),
					title: dojo.hitch(this, this._handleEnableMenuTextForMemberRemoveMenuItem),
					iconClass: 'RemoveMemberIcon', //$NON-NLS-1$
					onClick: dojo.hitch(this, this.memberRemoveHandler),
					isEnabled: dojo.hitch(this, function(row) {return this._handleEnableMenuItemForSingleItems(row) || this._handleEnableMenuForManyItems(row);})
				});
				
				//create the table
				tableDiv.styledTable = new com.ibm.team.process.web.ui.internal.SelectableStyledTable({
					length: displayCount,
					menu: menu,
					button: button,
					columns: columns,
					showHover: true
				});
				
				tableDiv.styledTable.suspendTableUpdate(true);
				tableDiv.styledTable.clear();
			}else{
				//End actions column
				columns.push({
					label: this.messages.AbstractProcessAreaEditor_UserTableActionsHeader,
					// Work around for 127064	
					className: ProcessConstants.CSSClass.ACTION_COLUMN + " action-column-3-actions", //$NON-NLS-1$
					sortable: false
				});
				
				tableDiv.styledTable = new jazz.ui.StyledTable({
					columns: columns,
					showHover: true
				});
			}
			tableDiv.appendChild(tableDiv.styledTable.domNode);
			if (users && users.length > 0) {
				var usersToShow = (!isNotNew && displayCount < users.length) ? displayCount : users.length;
				for (var i = 0; i < usersToShow; i++) {
					this._createMemberRow(users[i], isNotNew, i < newCount, TRLinks, actionToolbars, removeHandler, processRoleHandler, teamInviteHandler, tableDiv);					
				}
			}
			
			if (isNotNew){
				tableDiv.styledTable.suspendTableUpdate(false);
			}
		},
			
		_createMemberRow: function(user, isNotNew, rowIsNew, TRLinks, actionToolbars, removeHandler, processRoleHandler, teamInviteHandler, tableDiv) {
			var columnsData = [];
			var callbackData = {};
			callbackData.userObj = user;

			var column = document.createElement("div"); //$NON-NLS-1$
			column.className = "memberName"; //$NON-NLS-1$
			var presentationUri = "#action=" + USER_EDITOR + "&itemId=" + user.itemId; //$NON-NLS-1$ //$NON-NLS-2$
			var encodedUserId = encodeURIComponent(user.userId);
			var link = new com.ibm.team.process.web.ui.internal.TRLink({
				href: this._getServerUrl() + net.jazz.ajax.contextRoot() + "/users/" + encodedUserId, //$NON-NLS-1$
				linkItem: user.name,
				resourceLink: {
					'presentationUri': presentationUri, //$NON-NLS-1$
					'lazyFetch': true //$NON-NLS-1$
				}
			});

			TRLinks.push(link);
			column.appendChild(link.domNode);
			
			columnsData.push(column);
			if (isNotNew) {
				column = document.createElement("div"); //$NON-NLS-1$
				column.className = "memberRoles"; //$NON-NLS-1$
				var roleStr = ProcessConstants.EMPTY;
				if (user.processRoles) {
					user.savedProcessRoles = user.processRoles;
					var roleIds = [];
					for (var j = 0; j < user.processRoles.length; j++) {
						// hide the default role from the display
						if (user.processRoles[j].id != "default") { //$NON-NLS-1$
							roleIds.push(user.processRoles[j].label);
						}
					}
					roleStr = roleIds.join(", "); //$NON-NLS-1$
				}
				if (dojo.isIE && roleStr === ProcessConstants.EMPTY) {
					roleStr = " "; //$NON-NLS-1$
				}
				column.appendChild(document.createTextNode(roleStr));
				callbackData.roleDisplay = column;
			} else {
				column = document.createElement("div"); //$NON-NLS-1$
				column.className = "memberMail"; //$NON-NLS-1$
				if (user.emailAddress) {
					link = document.createElement("a"); //$NON-NLS-1$
					//Do not format the email address code, just the display String
					var emailAddress = dojox.string.BidiComplex.createDisplayString(user.emailAddress, "EMAIL"); //$NON-NLS-1$
					
					var link = new com.ibm.team.process.web.ui.internal.TRLink({
						href: "mailto:" + user.emailAddress, //$NON-NLS-1$
						linkItem: emailAddress
					});
					
					TRLinks.push(link);
					column.appendChild(link.domNode);
				} else if (dojo.isIE) {
					column.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
				}
				callbackData.mailDisplay = column;
			}
			columnsData.push(column);
			
			if(!isNotNew){
				column = document.createElement("div"); //$NON-NLS-1$
				var trToolbar = new com.ibm.team.process.web.ui.internal.TRToolbar();
				column.appendChild(trToolbar.domNode);
				actionToolbars.push(trToolbar);
				this.addRemoveIcon(trToolbar, removeHandler);
				columnsData.push(column);
				
				var tr = document.createElement("tr"); //$NON-NLS-1$
				tr.userObj = callbackData.userObj;
				tr.roleDisplay = callbackData.roleDisplay;
				tr.mailDisplay = callbackData.mailDisplay;
				
				var i;
				for(i = 0; i < columnsData.length; i++){
					var td = document.createElement("td"); //$NON-NLS-1$
					td.appendChild(columnsData[i]);
					tr.appendChild(td);
				}
				
				if(rowIsNew){
					dojo.addClass(tr, "new-row"); //$NON-NLS-1$
				}
				
				tableDiv.styledTable.tbody.appendChild(tr);
			}
			else{
				//create the row
				if(rowIsNew){
					tableDiv.styledTable.insertRowAtEnd({ id: user.itemId, className: "new-row", callbackData: callbackData, columnsData: columnsData }); //$NON-NLS-1$
				} else {
					tableDiv.styledTable.insertRowAtEnd({ id: user.itemId, callbackData: callbackData, columnsData: columnsData }); //$NON-NLS-1$
				}	
			}
		},
		
		addRemoveIcon: function(trToolbar, removeHandler){
			var removeAction = {};
			removeAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/remove.gif"); //$NON-NLS-1$  //$NON-NLS-2$
			removeAction.label = this.messages.ProjectAreaEditor_22;
			trToolbar.addButton(this, removeHandler, removeAction);
		},
		
		/**
		 * This function is responible for removing a member from this.allMembers and this.allMemberIds, and adds a member to this.pendingMemberChanges
		 * 
		 * @private
		 * @param {String} memberId ID of member to be removed
		 */
		_removeMemberFromMembersList: function(memberId){
			this.pendingMemberChanges.remove.push(memberId);
			for (var j = 0; j < this.allMembers.length; j++) {
				if (memberId === this.allMembers[j].itemId) {
					this.allMembers.splice(j, 1);
					break;
				}
			}
			for (var j = 0; j < this.allMemberIds.length; j++) {
				if (memberId === this.allMemberIds[j]) {
					this.allMemberIds.splice(j, 1);
					break;
				}
			}
			if (this.pendingMemberChanges.add) {
				for (j = 0; j < this.pendingMemberChanges.add.length; j++) {
					if (this.pendingMemberChanges.add[j] == memberId) {
						this.pendingMemberChanges.add.splice(j, 1);
						this.pendingMemberChanges.remove.pop();
						break;
					}
				}
			}
			this.setDirty(this.changesPending());
		},
		
		/**
		 * This function handles when the remove button is pressed on the this.membersDiv.styledTable
		 * 
		 * @private
		 * @param {Event} e The event object being fired
		 */
		memberRemoveHandler: function(e){
			dojo.stopEvent(e);
			if (!this.pendingMemberChanges.remove) {
				this.pendingMemberChanges.remove = [];
			}
			var rowNode = e.target;
			while (rowNode.tagName !== "TR") { //$NON-NLS-1$
				rowNode = rowNode.parentNode;
			}
			var selectedUser;
			if(rowNode.userObj !== undefined){
				selectedUser = rowNode.userObj;
				if (dojo.hasClass(rowNode, "new-row")) { //$NON-NLS-1$
					this._countNewMembers--;
				}
				
				this._removeMemberFromMembersList(selectedUser.itemId);
				dojo.destroy(rowNode);
				
				//See if there's another user in the "Show All" section we can display
				if (this.isNew && !this.showingAllMembers && this.allMembers.length >= DEFAULT_DISPLAY_MAX) {
					this._createMemberRow(this.allMembers[DEFAULT_DISPLAY_MAX-1], !this.isNew, this._memberTRLinks, this._memberActionToolbars, "memberRemoveHandler", "processRoleHandler", "teamInviteHandler", this.membersDiv); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				}
			} else {
				rowNode = this.membersDiv.styledTable.getAllSelectedRows();
				this.membersDiv.styledTable.suspendTableUpdate(true);
				for(var i = 0; i < rowNode.length; i++){
					selectedUser = rowNode[i].userObj;
					if(this.membersDiv.styledTable.hasClass(selectedUser.itemId, "new-row")) { //$NON-NLS-1$
						this._countNewMembers--;
					}
					
					this._removeMemberFromMembersList(selectedUser.itemId);
					this.membersDiv.styledTable.remove(selectedUser.itemId);
				}
				this.membersDiv.styledTable.suspendTableUpdate(false);
			}
	
			this._updateShowAllFewerMembersLinkDisplay(this.allMembers);
		},
		
		_handleBulkAddRoles: function(selectedRoles){
			//do for each selected member
			var selectedMembers = this.membersDiv.styledTable.getAllSelectedRows();
			for(var property = 0; property < selectedMembers.length; property++){
				if(selectedMembers[property] != null){
					var selectedRow = selectedMembers[property];
					//Find the new roles for the current user
					var rolesToAdd = [];
					for(var i = 0; i < selectedRoles.length; i++){
						var j = 0;
						for(; j < selectedRow.userObj.processRoles.length; j++){
							if(selectedRoles[i].id == selectedRow.userObj.processRoles[j].id){
								break;
							}
						}
						if(j == selectedRow.userObj.processRoles.length){
							rolesToAdd.push(selectedRoles[i]);
						}
					}

					//If the current row has been changed
					if(rolesToAdd.length > 0){
						//Create an updated role string
						var roleString = ""; //$NON-NLS-1$
						var newRoles = [];
						var defaultRole = null;
						for(var i = 0; i < selectedRow.userObj.processRoles.length; i++){
							if(selectedRow.userObj.processRoles[i].id != "default") { //$NON-NLS-1$
								newRoles.push(selectedRow.userObj.processRoles[i]);
								roleString += selectedRow.userObj.processRoles[i].label.length < 1 ? selectedRow.userObj.processRoles[i].id : selectedRow.userObj.processRoles[i].label + ", "; //$NON-NLS-1$
							} else {
								defaultRole = selectedRow.userObj.processRoles[i];
							}
						}
						for(var i = 0; i < rolesToAdd.length; i++){
							newRoles.push(rolesToAdd[i]);
							roleString += rolesToAdd[i].label.length < 1 ? rolesToAdd[i].id : rolesToAdd[i].label + ", "; //$NON-NLS-1$
						}
						newRoles.push(defaultRole);
						if(roleString.length > 1){
							roleString = roleString.substring(0, roleString.length - 2);
						}
						
						//Add the text to the Process Roles column
						dojox.xml.parser.removeChildren(selectedRow.roleDisplay);
						selectedRow.roleDisplay.appendChild(document.createTextNode(roleString));
						selectedRow.userObj.processRoles = newRoles;
						
						//check if there are changes from the saved state
						var roleChanged = false;
						if (newRoles.length == selectedRow.userObj.savedProcessRoles.length) {
							for (var j = 0; j < newRoles.length; j++) {
								if (newRoles[j].id != selectedRow.userObj.savedProcessRoles[j].id) {
									roleChanged = true;
									break;
								}
							}
						} else {
							roleChanged = true;
						}								
						
						//Append new information on change
						if(roleChanged){
							var roleArray = [];
							for (var j = 0; j < selectedRow.userObj.processRoles.length; j++) {
								roleArray.push(selectedRow.userObj.processRoles[j].id);
							}
							if (!this.pendingMemberChanges.roles) {
								this.pendingMemberChanges.roles = {};
							}
							this.pendingMemberChanges.roles[selectedRow.userObj.itemId] = roleArray;
						} else {
							//Discard change set if same as saved state
							if (this.pendingMemberChanges.roles) {
								delete this.pendingMemberChanges.roles[selectedRow.userObj.itemId];
								var roleChanges = false;
								for (role in this.pendingMemberChanges.roles) {
									roleChanges = true;
									break;
								}
								if (!roleChanges) {
									delete this.pendingMemberChanges.roles;
								}
							}
						}
					}
				}
			}
			
			//Check if changes were made
			if (this.changesPending()) {
				this.setDirty(true);
			} else {
				this.setDirty(false);
			}
		},
		
		processBulkAddRoles: function(e){
			dojo.stopEvent(e);

			var processBulkAddRoleDialog = new com.ibm.team.process.web.ui.internal.admin.projects.ProcessBulkEditRolesDialog({
				isRemove: false,
				allRoles: this.getAllProcessRoles(),
				membersCount: this.membersDiv.styledTable.getSelectedCount()
			});
			
			processBulkAddRoleDialog.startup();
			
			processBulkAddRoleDialog.onFinish = dojo.hitch(this, function(selectedRoles){
				this._handleBulkAddRoles(selectedRoles);
				processBulkAddRoleDialog.close();
			});
		},
		
		_handleBulkRemoveRoles: function(selectedRoles){
			//do for each selected member
			var selectedMembers = this.membersDiv.styledTable.getAllSelectedRows();
			for(var property = 0; property < selectedMembers.length; property++){
				if(selectedMembers[property] != null){
					var selectedRow = selectedMembers[property];
					//Find the removed roles for the current user
					var rolesChange = false;
					for(var i = 0; i < selectedRoles.length; i++){
						var j = 0;
						for(; j < selectedRow.userObj.processRoles.length; j++){
							if(selectedRoles[i].id == selectedRow.userObj.processRoles[j].id){
								rolesChange = true;
								break;
							}
						}
						if(rolesChange){
							break;
						}
					}

					//If the current row has been changed
					if(rolesChange){
						//Create an updated role string
						var roleString = ""; //$NON-NLS-1$
						var newRoles = [];
						var defaultRole = null;
						for(var i = 0; i < selectedRow.userObj.processRoles.length; i++){
							if(selectedRow.userObj.processRoles[i].id != "default") { //$NON-NLS-1$
								var j = 0;
								for(; j < selectedRoles.length; j++){
									if(selectedRow.userObj.processRoles[i].id == selectedRoles[j].id){
										break;
									}
								}
								if(j == selectedRoles.length){
									newRoles.push(selectedRow.userObj.processRoles[i]);
									roleString += selectedRow.userObj.processRoles[i].label.length < 1 ? selectedRow.userObj.processRoles[i].id : selectedRow.userObj.processRoles[i].label+ ", "; //$NON-NLS-1$
								}
							} else {
								defaultRole = selectedRow.userObj.processRoles[i];
							}
						}
						newRoles.push(defaultRole);						
						if(roleString.length > 1){
							roleString = roleString.substring(0, roleString.length - 2);
						}
						
						//Add the text to the Process Roles column
						dojox.xml.parser.removeChildren(selectedRow.roleDisplay);
						selectedRow.roleDisplay.appendChild(document.createTextNode(roleString));
						selectedRow.userObj.processRoles = newRoles;
						
						//check if there are changes from the saved state
						var roleChanged = false;
						if (newRoles.length == selectedRow.userObj.savedProcessRoles.length) {
							for (var j = 0; j < newRoles.length; j++) {
								if (newRoles[j].id != selectedRow.userObj.savedProcessRoles[j].id) {
									roleChanged = true;
									break;
								}
							}
						} else {
							roleChanged = true;
						}								
						
						//Append new information on change
						if(roleChanged){
							var roleArray = [];
							for (var j = 0; j < selectedRow.userObj.processRoles.length; j++) {
								roleArray.push(selectedRow.userObj.processRoles[j].id);
							}
							if (!this.pendingMemberChanges.roles) {
								this.pendingMemberChanges.roles = {};
							}
							this.pendingMemberChanges.roles[selectedRow.userObj.itemId] = roleArray;
						} else {
							//Discard change set if same as saved state
							if (this.pendingMemberChanges.roles) {
								delete this.pendingMemberChanges.roles[selectedRow.userObj.itemId];
								var roleChanges = false;
								for (role in this.pendingMemberChanges.roles) {
									roleChanges = true;
									break;
								}
								if (!roleChanges) {
									delete this.pendingMemberChanges.roles;
								}
							}
						}
					}
				}
			}
			
			//Check if changes were made
			if (this.changesPending()) {
				this.setDirty(true);
			} else {
				this.setDirty(false);
			}
		},
		
		processBulkRemoveRoles: function(e){
			dojo.stopEvent(e);
			
			var members = this.membersDiv.styledTable.getAllSelectedRows();
			var allRoles = this.getAllProcessRoles();
			var allRolesbyID = {};
			
			//Get an object which tells us if the process role exists on the current member
			for(var i = 0; i < members.length; i++){
				for(var j = 0; j < members[i].userObj.processRoles.length; j++){
					allRolesbyID[members[i].userObj.processRoles[j].id] = members[i].userObj.processRoles[j];
				}
			}
			
			//Now remove the roles from allRoles which are not included in the members
			for(var i = 0; i < allRoles.length; i++){
				if(allRolesbyID[allRoles[i].id] == null){
					allRoles.splice(i, 1);
					i--;
				} else {
					delete allRolesbyID[allRoles[i].id];
				}
			}
			
			//Now add remaining roles (needed if a role belongs to a member, but not to the project)
			for (var property in allRolesbyID) {
				allRoles.push(allRolesbyID[property]);
            }
			
			//Start up the dialog with the given information
			var processBulkRemoveRoleDialog = new com.ibm.team.process.web.ui.internal.admin.projects.ProcessBulkEditRolesDialog({
				isRemove: true,
				allRoles: allRoles,
				membersCount: this.membersDiv.styledTable.getSelectedCount()
			});
			
			processBulkRemoveRoleDialog.startup();
			
			processBulkRemoveRoleDialog.onFinish = dojo.hitch(this, function(selectedRoles){
				this._handleBulkRemoveRoles(selectedRoles);
				processBulkRemoveRoleDialog.close();
			});
		},
		
		processRoleHandler: function(e){
			dojo.stopEvent(e);
			var rowNode = this.membersDiv.styledTable.getAllSelectedRows().pop();

			var selectedUser = rowNode.userObj;
			this.processRoleRow = rowNode;
			
			var roleObj = {};
			roleObj.allRoles = this.getAllProcessRoles();
			roleObj.member = selectedUser;
			var processRoleDialog = new com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog(roleObj);
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: this.messages.ProjectAreaEditor_23,
				contentNode: processRoleDialog.domNode,
				width: "52em", //$NON-NLS-1$
				destroyContents: true,
				execute: function(selectedRoles){
					var roleIds = [];
					for (var i = 0; i < selectedRoles.length; i++) {
						// hide the default role from the display
						if (selectedRoles[i].id != "default") { //$NON-NLS-1$
							roleIds.push(selectedRoles[i].label);
						}
					}
					var roleString = roleIds.join(", "); //$NON-NLS-1$
					var selectedRow = this.targetObj.processRoleRow;
					dojox.xml.parser.removeChildren(selectedRow.roleDisplay);
					selectedRow.roleDisplay.appendChild(document.createTextNode(roleString));
					selectedRow.userObj.processRoles = selectedRoles;
					var roleChanged = false;
					if (selectedRoles.length == selectedRow.userObj.savedProcessRoles.length) {
						for (var j = 0; j < selectedRoles.length; j++) {
							if (selectedRoles[j].id != selectedRow.userObj.savedProcessRoles[j].id) {
								roleChanged = true;
								break;
							}
						}
					} else {
						roleChanged = true;
					}
					if (roleChanged) {
						var roleArray = [];
						for (var j = 0; j < selectedRow.userObj.processRoles.length; j++) {
							roleArray.push(selectedRow.userObj.processRoles[j].id);
						}
						if (!this.targetObj.pendingMemberChanges.roles) {
							this.targetObj.pendingMemberChanges.roles = {};
						}
						this.targetObj.pendingMemberChanges.roles[selectedRow.userObj.itemId] = roleArray;
					} else {
						if (this.targetObj.pendingMemberChanges.roles) {
							delete this.targetObj.pendingMemberChanges.roles[selectedRow.userObj.itemId];
							var roleChanges = false;
							for (role in this.targetObj.pendingMemberChanges.roles) {
								roleChanges = true;
								break;
							}
							if (!roleChanges) {
								delete this.targetObj.pendingMemberChanges.roles;
							}
						}
					}
					if (this.targetObj.changesPending()) {
						this.targetObj.setDirty(true);
					} else {
						this.targetObj.setDirty(false);
					}
				}
			});
			
			processRoleDialog.startup();
			dialogWidget.targetObj = this;
			dialogWidget.processRoleDialogObj = processRoleDialog;
			this.connectHandles.push(dojo.connect(processRoleDialog.cancelButton, ON_CLICK, dialogWidget, function(e){
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(processRoleDialog.finishButton, ON_CLICK, dialogWidget, function(e){
				this.execute(this.processRoleDialogObj.getChosenRoles());
				this.close();
			}));
		},
		
		teamInviteHandler: function(e){
			dojo.stopEvent(e);
			
			var rowNode = this.membersDiv.styledTable.getAllSelectedRows().pop();
			
			this.customizeAndSendTeamInvitation([rowNode.userObj.itemId], rowNode.userObj, false);
		},
		
		createInvitationPropertiesString: function(user, repoLink){
			return dojo.string.substitute("teamRepository=${0}\nuserId=${1}\nuserName=${2}\nprojectAreaName=${3}", [repoLink, user.userId, user.name, this.name.value]); //$NON-NLS-1$
		},
		
		getInvitationLink: function(host){
			return dojo.string.substitute("${0}/web/projects/${1}", [host, this.name.value]); //$NON-NLS-1$
		},
		
		handleLoadInvitationExtensionResponse: function(response){
			response = dojo.fromJson(response);
			var host = document.location.protocol + "//" + document.location.host + net.jazz.ajax.contextRoot(); //$NON-NLS-1$
			var link = this.getInvitationLink(host);
			link = encodeURI(link);
			var invitees = this.cachedInvitees;
			var singleUser = this.cachedSingleUser;
			var emailObj = {};
			emailObj.subject = response.emailSubject;
			emailObj.message = response.emailBody;
			if (response.invalidEmailSubject || response.invalidEmailBody) {
				emailObj.invalidEmailSubjectOrBody = true;
			}
			if (invitees.length == 1) {
				emailObj.description = dojo.string.substitute(this.messages.ProjectAreaEditor_36, [singleUser.name]);
				emailObj.singleUserObj = singleUser;
				emailObj.properties = this.createInvitationPropertiesString(singleUser, host);
			} else {
				emailObj.description = this.messages.ProjectAreaEditor_37;
			}
			emailObj.copySelf = response.copySelf;
			emailObj.includeEclipseConnection = response.includeEclipseConnection;
			
			var invitationDialog = new com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog(emailObj);
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: this.messages.ProjectAreaEditor_51,
				contentNode: invitationDialog.domNode,
				width: dojo.isIE ? "48em" : "46em", //$NON-NLS-1$ //$NON-NLS-2$
				destroyContents: true,
				execute: function(dialogObj){
					var params = {
						subject: dialogObj.getEmailSubject(),
						message: dialogObj.getEmailBody(),
						cc: dialogObj.getCopySelf() ? getAuthenticatedContributor().emailAddress : ProcessConstants.EMPTY
					};
					
					params.jsonInvitees = dojo.toJson(invitees);
					this.targetObj.customTeamInvitationParams(params);
					var srh = new ServiceResponseHandler(this.targetObj, "handleInvitationResponse", "handleInvitationError"); //$NON-NLS-1$ //$NON-NLS-2$
					if (invitees.length == 1) {
						this.targetObj.messageToDisplay = this.targetObj.messages.ProjectAreaEditor_44;
					} else {
						this.targetObj.messageToDisplay = this.targetObj.messages.ProjectAreaEditor_43;
					}
					ProcessClient.generateTeamInvitations(params, srh);
					this.targetObj._displayPendingMessage(this.targetObj.messages.ProjectAreaEditor_41);
				}
			});
			dialogWidget.targetObj = this;
			dialogWidget.invitationDialogObj = invitationDialog;
			invitationDialog.startup();
			invitationDialog.emailSubject.focus();
			this.connectHandles.push(dojo.connect(invitationDialog.cancelButton, ON_CLICK, dialogWidget, function(e){
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(invitationDialog.finishButton, ON_CLICK, dialogWidget, function(e){
				this.execute(this.invitationDialogObj);
				this.close();
			}));
			invitationDialog.disableEmailCustomization(invitationDialog.checkingMailerServiceStatusNode);
			this.invitationDialog = invitationDialog;
			var srh = new ServiceResponseHandler(this, "_handleGetMailerServiceStatusSuccess", "_handleGetMailerServiceStatusFailure"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.getMailerServiceStatus(srh);
		},
		
		_handleGetMailerServiceStatusSuccess: function(response) {
			response = dojo.fromJson(response);
			if(response.statusCode === 0) {
				this.invitationDialog.enableEmailCustomization();
			} else {
				this.invitationDialog.disableEmailCustomization(this.invitationDialog.mailerServiceDisabledNode);
			}
		},
		
		_handleGetMailerServiceStatusFailure: function(error) {
			this.invitationDialog.disableEmailCustomization(this.invitationDialog.mailerServiceDisabledNode);
		},
		
		handleLoadInvitationExtensionError: function(error){
			this.handleServerResponseError(error, this.messages.ProjectAreaEditor_52, [ProcessConstants.TEAM_OPERATION_CANCELED_EXCEPTION]);
		},
		
		customizeAndSendTeamInvitation: function(invitees, singleUser){
			this.cachedInvitees = invitees;
			this.cachedSingleUser = singleUser;
			var srh = new ServiceResponseHandler(this, "handleLoadInvitationExtensionResponse", "handleLoadInvitationExtensionError"); //$NON-NLS-1$ //$NON-NLS-2$
			var parms = {};
			var repositoryUrl = document.location.protocol + "//" + document.location.host + net.jazz.ajax.contextRoot(); //$NON-NLS-1$
			parms.repositoryUrl = repositoryUrl;
			if (this.isTeamArea) {
				parms.processAreaId = this.itemId;
			} else {
				parms.processAreaId = this.projectAreaItemId;
			}
			parms.invitees = this.cachedInvitees;
			ProcessClient.generateTeamInvitation(parms, srh);
		},
		
		customTeamInvitationParams: function(params){
			params.projectAreaUuid = this.projectAreaItemId;
		},
		
		_getNewMembers: function(newMemberIds, includeCurrentUser){
			if (!includeCurrentUser) {
				var currentUser = getAuthenticatedContributor();
			}
			
			var newMemberArray = [];
			dojo.forEach(newMemberIds, function(itemId){
				dojo.forEach(this.allMembers, function(member){
					if (member.itemId === itemId && (includeCurrentUser || (member.itemId !== currentUser.itemId))) {
						newMemberArray.push(member);
					}
				});
			}, this);
			return newMemberArray;
		},
		
		chooseTeamInvitees: function(newMemberArray){
			var mixinObj = {};
			mixinObj.newMembers = newMemberArray;
			
			var self = this;
			var teamInvitationDialog = new com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog(mixinObj);
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: this.messages.ProjectAreaEditor_42,
				contentNode: teamInvitationDialog.domNode,
				width: dojo.isIE ? "38em" : "36em", //$NON-NLS-1$ //$NON-NLS-2$
				destroyContents: true,
				execute: function(){
					var invitees = this.teamInvitationDialogObj.getChosenMembers();
					if (invitees.length > 0) {
						self.customizeAndSendTeamInvitation(invitees, this.teamInvitationDialogObj.singleUser, true);
					}
				}
			});
			dialogWidget.targetObj = this;
			dialogWidget.teamInvitationDialogObj = teamInvitationDialog;
			teamInvitationDialog.startup();
			teamInvitationDialog.okButton.focus();
			this.connectHandles.push(dojo.connect(teamInvitationDialog.cancelButton, ON_CLICK, dialogWidget, function(e){
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(teamInvitationDialog.okButton, ON_CLICK, dialogWidget, function(e){
				this.execute();
				this.close();
			}));
		},
		
		handleInvitationResponse: function(response){
			this._displayLongSuccessMessage(this.messageToDisplay);
		},
		
		handleInvitationError: function(error){
			this.handleServerResponseError(error, this.messages.ProjectAreaEditor_45, [ProcessConstants.TEAM_OPERATION_CANCELED_EXCEPTION, ProcessConstants.MAIL_SERVICE_NOT_CONFIGURED_EXCEPTION]);
		},
		
		adminRemoveHandler: function(e){
			dojo.stopEvent(e);
			if (!this.pendingAdminChanges.remove) {
				this.pendingAdminChanges.remove = [];
			}
			var rowNode = e.target;
			while (rowNode.tagName !== "TR") { //$NON-NLS-1$
				rowNode = rowNode.parentNode;
			}
			var selectedUser = rowNode.userObj;
			var itemId = selectedUser.itemId;
			
			if (dojo.hasClass(rowNode, "new-row")) { //$NON-NLS-1$
				this._countNewAdmins--;
			}
			
			this.pendingAdminChanges.remove.push(itemId);
			for (var j = 0; j < this.allAdmins.length; j++) {
				if (itemId === this.allAdmins[j].itemId) {
					this.allAdmins.splice(j, 1);
					break;
				}
			}
			if (this.pendingAdminChanges.add) {
				for (j = 0; j < this.pendingAdminChanges.add.length; j++) {
					if (this.pendingAdminChanges.add[j] == itemId) {
						this.pendingAdminChanges.add.splice(j, 1);
						this.pendingAdminChanges.remove.pop();
						break;
					}
				}
			}
			
			this.setDirty(this.changesPending());
			this.populateAdmins(this.allAdmins);
		},
		

		/**
		 * Adds a new member to the Members Section table
		 * 
		 * @param {Object[]} newMembers A lsit of members to be added
		 * @param {Object[]} chosenRoles The roles for the new members
		 */
		_addNewMembersWithRoles : function(newMembers, chosenRoles) {
			if (newMembers) {
				if (newMembers.length > 0) {
					if (!this.pendingMemberChanges.add) {
						this.pendingMemberChanges.add = [];
					};
						
					var roleIdArray = [];
					for ( var k = 0; k <chosenRoles.length; k++) {
						roleIdArray.push(chosenRoles[k].id);
					}
	
				
					var defaultRole = this.getDefaultRole();
					for (var i = newMembers.length - 1; i >= 0; i--) {
						var member = newMembers[i];
						member.processRoles= chosenRoles;
						member.savedProcessRoles = [{
							id: ProcessConstants.DEFAULT_ROLE_ID,
							label: defaultRole.label,
							description: defaultRole.description
						}];
						
						this._countNewMembers++;
						this.allMembers.unshift(member);
						this.allMemberIds.unshift(member.itemId);
						this.pendingMemberChanges.add.push(member.itemId);
						if (this.pendingMemberChanges.remove) {
							for (var j = 0; j < this.pendingMemberChanges.remove.length; j++) {
								if (this.pendingMemberChanges.remove[j] == member.itemId) {
									this.pendingMemberChanges.remove.splice(j, 1);
									this.pendingMemberChanges.add.pop();
									break;
								}
							}
						}
						// There will always be at least one role (the default role).
						// If there are more (then the default one) role selected,
						// add the role ids array to the this.pendingMemberChanges.roles for
						// the member, so that this information can be saved.
						if (chosenRoles.length > 1) {
							if (!this.pendingMemberChanges.roles) {
								this.pendingMemberChanges.roles = {};
							}
							this.pendingMemberChanges.roles[member.itemId] = roleIdArray;
						}
					}
				}
			}
			this.setDirty(this.changesPending());
			this.populateMembers(this.allMembers);
		},
		

		getDefaultRole : function() {
			if (this._rolesStore) {
				return this._rolesStore.getDefaultRole();
			}
			
			//The this._rolesStore would be undefined for example, if
			// 1. You create a new project area. (DO NOT SAVE)
			// 2. Try to add members.
			// For this use case we construct and return the defaultRole object below.
			var defaultRole = {};
			defaultRole[ProcessConstants.ProcessRoleDTO.ID] = ProcessConstants.DEFAULT_ROLE_ID;
			defaultRole[ProcessConstants.ProcessRoleDTO.LABEL] = ProcessConstants.DEFAULT_ROLE_ID;
			defaultRole[ProcessConstants.ProcessRoleDTO.CARDINALITY] = ProcessConstants.RoleCardinality.MANY;
			defaultRole[ProcessConstants.ProcessRoleDTO.DESCRIPTION] = ProcessConstants.EMPTY;
			return defaultRole;
		},
		
		/**
		 * Adds new administrators to the administrator section table
		 * 
		 * @param {Object[]} newAdmins A list of administrators to be added
		 */
		addNewAdmins: function(newAdmins){
			if (newAdmins) {
				if (newAdmins.length > 0) {
					this.setDirty(true);
					if (!this.pendingAdminChanges.add) {
						this.pendingAdminChanges.add = [];
					}
				}
				var defaultRole = this.getDefaultRole();
				for (var i = newAdmins.length - 1; i >= 0; i--) {
					var admin = newAdmins[i];
					admin.itemId = admin.itemId;
					admin.processRoles = [{
						id: ProcessConstants.DEFAULT_ROLE_ID,
						label: defaultRole.label,
						description: defaultRole.description
					}];
					admin.savedProcessRoles = [{
						id: ProcessConstants.DEFAULT_ROLE_ID,
						label: defaultRole.label,
						description: defaultRole.description
					}];
					
					this._countNewAdmins++;
					this.allAdmins.unshift(admin);
					this.pendingAdminChanges.add.push(admin.itemId);
					if (this.pendingAdminChanges.remove) {
						for (var j = 0; j < this.pendingAdminChanges.remove.length; j++) {
							if (this.pendingAdminChanges.remove[j] == admin.itemId) {
								this.pendingAdminChanges.remove.splice(j, 1);
								this.pendingAdminChanges.add.pop();
								break;
							}
						}
					}
				}
			}
			this.setDirty(this.changesPending());
			this.populateAdmins(this.allAdmins);
		},
		
		handleChange: function(e){
			this.handleCustomChange(e);
			
			if (e.target.value != e.target.savedValue) {
				e.target.changePending = true;
				this.setDirty(true);
			} else {
				e.target.changePending = false;
				if (!this.changesPending()) {
					this.setDirty(false);
				}
			}
		},
		
		setDirty: function(isDirty){
			this.enableSaveButton(isDirty);
			if (isDirty || this.isNew) {
				this.modifiedFlag.style.display = ProcessConstants.INLINE;
				if (this._canSave()) {
					this._messageBox.hideMessage();
				}
			} else {
				this.modifiedFlag.style.display = ProcessConstants.NONE;
			}
		},
		
		enableSaveButton: function(isDirty){
			if (isDirty && this.name.value && (!this.isNew || this.processSelector.selectedIndex > -1) && this._canSave()) {
				this.saveButton.disabled = false;
			} else {
				this.saveButton.disabled = true;
			}
			
		},
		
		_canSave: function(){
			// Check if the tabs loaded by extension point have any
			// changes pending
			if (this._tabs) {
				for (tabId in this._tabs) {
					var tab = this._tabs[tabId];
					if (this.isActivatedExtensionTab(tab) && !tab.mainPage.canSave()) {
						return false;
					}
				}
			}
			
			// TODO need generic ability to call on each tab
			if (this.rolesEditor) {
				if (!this.rolesEditor.canSave()) {
					return false;
				}
			}
			if (this.operationBehaviorEditor) {
				if (!this.operationBehaviorEditor.canSave()) {
					return false;
				}
			}
			
			if (!this.customCanSave()) {
				return false;
			}
			return true;
		},
		
		customCanSave: function(){
			// Derived can override to check custom fields here
			return true;
		},
		
		isActivatedExtensionTab: function(tab){
			return tab.extensionPointWidget && tab.mainPage;
		},
		
		changesPending: function(){
			if (this._processAreaChangesPending()) {
				return true;
			}
			
			// Check if the tabs loaded by extension point have any
			// changes pending
			if (this._tabs) {
				for (tabId in this._tabs) {
					var tab = this._tabs[tabId];
					if (this.isActivatedExtensionTab(tab) && tab.mainPage.changesPending()) {
						return true;
					}
				}
			}
			return false;
		},
		
		_processAreaChangesPending: function() {
			for (var i = 0; i < this.inputFields.length; i++) {
				if (this.inputFields[i].changePending) {
					return true;
				}
			}

			if (this.pendingMemberChanges.add && this.pendingMemberChanges.add.length > 0 || this.pendingMemberChanges.remove && this.pendingMemberChanges.remove.length > 0) {
				return true;
			}
			
			if (this.pendingMemberChanges.roles) {
				return true;
			}
			
			if (this.pendingAdminChanges.add && this.pendingAdminChanges.add.length > 0 || this.pendingAdminChanges.remove && this.pendingAdminChanges.remove.length > 0) {
				return true;
			}
			
			if (!this.isNew && this._saveParticipants) {
				var iter = this._saveParticipants.getIterator();
				while (!iter.atEnd()) {
					if (iter.get().value.changesPending()) {
						return true;
					}
				}
			}
			
			if (this.customChangesPending()) {
				return true;
			}
			
			return false;
			
		},
		
		customChangesPending: function(){
			// Derived can override and add custom changes pending here
		},
		
		handleSave: function(e){
		
			if (e) {
				dojo.stopEvent(e);
			}
			this.deferredSaveCount = this.getDeferredSaveCount();
			delete this.errObj;
			this.saveButton.disabled = true;
			
			var saveObj = null;
			try {
				saveObj = this.configureSaveObject();
			} catch (error) {
				//Intercept errors that originated in custom widgets,
				//(eg. configuration data or operation behavior editors)
				//These would likely be programming errors; we will display a
				//message with the text of the exception and prohibit saving
				//when these errors are thrown
				if (error.customWidgetId) {
					this.setDirty(true);
					this._displayLongErrorMessage({
						headerMessage: dojo.string.substitute(this.messages.AbstractProcessAreaEditor_15, [error.customWidgetId]),
						exception: error.toString()
					});
					return;
				}
				throw error;
			}
			
			var msg = this.validateRequired(saveObj);
			if (msg) { //nonempty message
				this._displayLongErrorMessage(msg);
			} else if (this._processAreaChangesPending()) {
				var srh = new ServiceResponseHandler(this, "handleSaveResponse", "handleSaveError"); //$NON-NLS-1$ //$NON-NLS-2$
				this.doSave(saveObj, srh);
			} else {
				this.deferredSaveCount--; // We won't be saving the process area
				this._displayPendingMessage(this.messages.ProjectAreaEditor_25);
				
				this._saveExtensionTabs();
			}
		},
		
		doSave: function(saveObj, serviceResponseHandler){
			ProcessClient.postProjectArea(saveObj, serviceResponseHandler);
			if (this.isNew) {
				this._displayPendingMessage(this.messages.ProjectAreaEditor_24);
			} else {
				this._displayPendingMessage(this.messages.ProjectAreaEditor_25);
			}
		},
		
		configureSaveObject: function(){
			var saveObj = {
				itemId: this.projectAreaItemId
			};
			if (!this.isNew) {
				saveObj.stateId = this.stateId;
			}
			saveObj.owningApplicationKey = this._owningApplicationKey;
			for (var i = 0; i < this.inputFields.length; i++) {
				if (this.inputFields[i].changePending) {
					saveObj[this.inputFields[i].name] = dojo.string.trim(this.inputFields[i].value);
				}
			}
			saveObj.jsonMembers = dojo.toJson(this.pendingMemberChanges);
			saveObj.jsonAdmins = dojo.toJson(this.pendingAdminChanges);
			if (this.isNew) {
				if (this.processSelector) {
					saveObj.processUuid = this.processSelector.value;
					saveObj.processLocale = this.processSelector.options[this.processSelector.selectedIndex].locale;
				}
			}
			if (saveObj.processLocale === null || saveObj.processLocale === undefined) {
				saveObj.processLocale = this.processLocale ? this.processLocale : ProcessConstants.EMPTY;
			}
						
			this.generateChangeParameters(saveObj);
			this.generateRoleChanges(saveObj);
			this.customSave(saveObj);
			return saveObj;
		},
		
		customSave: function(saveObj){
			// Derived can override and add custom save here
		},
		
		customValidateRequired: function(saveObj){
			// Derived can override and add custom validation here
		},
		
		generateRoleChanges : function(saveObj) {
			if ((this._rolesStore && this._rolesStore.isDirty()) || (this.rolesEditor && this.rolesEditor.changesPending())) {
				var jsonRoles = {
					definedRoles : this._rolesStore.getAllDefinedRoles()
				};
				saveObj.jsonRoles = dojo.toJson(jsonRoles);
			}
		},
		
		validateRequired: function(saveData){
			if (saveData.name == ProcessConstants.EMPTY || (this.isNew && !saveData.name)) {
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
				return this.messages.ProjectAreaEditor_26;
			}
			
			if (saveData.name && saveData.name.indexOf('/') >= 0) { //$NON-NLS-1$
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
				if (this.isTeamArea) {
					return this.messages.TeamAreaEditor_35;
				} else {
					return this.messages.ProjectAreaEditor_55;
				}
			}
			
			if (this.isNew && !saveData.processUuid && !saveData.internalProcessProviderUUID) {
				if (this.processList.options.length === 0) {
					return this.messages.ProjectAreaEditor_27;
				} else {
					this.processList.focus();
					return this.messages.ProjectAreaEditor_28;
				}
			}
			
			// TODO need generic mechanism that is called on each tab
			if (this.rolesEditor) {
				var msg = this.rolesEditor.validateRequired();
				if (msg) {
					return msg;
				}
			}
			return this.customValidateRequired(saveData);
		},
		
		generateChangeParameters: function(saveObj){
			if (!this.isNew) {
				var iter = this._saveParticipants.getIterator();
				while (!iter.atEnd()) {
					iter.get().value.aboutToBeSaved(saveObj);
				}
			}
		},
		
		addSaveParticipant: function(participant, participantId){
			if (!this._saveParticipants.contains(participantId)) {
				this._saveParticipants.add(participantId, participant);
				return true;
			}
			var message = dojo.string.substitute(this.messages.AbstractProjectAreaEditor_DuplicateSaveParticipant, [participantId]);
			this._displayLongErrorMessage(message);
			throw new Error(message);
		},
		
		removeSaveParticipant: function(participantId){
			if (this._saveParticipants.contains(participantId)) {
				this._saveParticipants.remove(participantId);
				return true;
			}
			return false;
		},
		
		handleSaveResponse: function(response){			
			this._saveExtensionTabs();
			
			if (this.pendingMemberChanges.add && this.pendingMemberChanges.add.length > 0) {
				dojo.cookie(AbstractProcessAreaEditor.NEW_MEMBERS_COOKIE_NAME, dojo.toJson(this.pendingMemberChanges.add));
			}
			
			if (this.isNew && response) {
				dojo.publish(ProcessConstants.ProjectSelectorContext.ADD, [this.name.value]);
				dojo.cookie(AbstractProcessAreaEditor.MSG_COOKIE_NAME, this.messages.ProjectAreaEditor_29);
				this._unregisterHandlers();
				document.location.href = "#action=" + AbstractProcessAreaEditor.PROJECT_AREA_EDITOR + "&itemId=" + response; //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				if (this.name.changePending && !this._isArchived) {
					dojo.publish(ProcessConstants.ProjectSelectorContext.DELETE, [this.name.savedValue]);
					dojo.publish(ProcessConstants.ProjectSelectorContext.ADD, [this.name.value]);
				}
				this.handleServerResponseSuccess(response);
				var iter = this._saveParticipants.getIterator();
				while (!iter.atEnd()) {
					iter.get().value.saved(response);
				}
			}
		},
		
		handleSaveError: function(error){
			this.saveButton.disabled = false;
			this.deferredSaveCount = 0; // Save of process area did not complete successfully so there will be no deferred saves
			this.handleServerResponseError(error, this.getSaveErrorMessage(), [ProcessConstants.PROCESS_DATA_VALIDATION_EXCEPTION, ProcessConstants.STALE_DATA_EXCEPTION, ProcessConstants.PERMISSION_DENIED_EXCEPTION, ProcessConstants.TEAM_OPERATION_CANCELED_EXCEPTION, ProcessConstants.LICENSE_NOT_GRANTED_EXCEPTION]);
		},
		
		getSaveErrorMessage: function(err){
			return this.messages.ProjectAreaEditor_31;
		},
		
		onRefresh: function(e){
			dojo.stopEvent(e);
			if (this.changesPending() && !confirm(this.messages.ProjectAreaEditor_32)) {
				return;
			}
			this.refresh(true);
		},
		
		startLoading: function(msg) {
			// Need to trap the focus because disabling
			// the controls can cause some of them to lose
			// focus once re-enabled when loading is done on IE
			if (dojo.isIE && !this._lastFocus) {
				this._lastFocus = dijit.getFocus();
			}
			this._displayPendingMessage(msg);
			jazz.ui.underlay.show({
				appendTo: this.domNode,
				zIndex: 999,
				animate: false,
				stopEvents: true 
			});
		},
		
		stopLoading: function() {
			PlatformUI.getWorkbench().hideMessageArea();
			jazz.ui.underlay.hide();
			if (dojo.isIE && this._lastFocus) {
				dijit.focus(this._lastFocus);
				this._lastFocus = undefined;
			}
		},
		
		_displayPendingMessage: function(msg){
			var messageBoxArgs = {
				type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
				summary: msg
			};
			PlatformUI.getWorkbench().showMessage(msg);
		},
		
		_displayLongSuccessMessage: function(msg){
			var messageBoxArgs = {
				type: jazz.ui.MessageBox.STATUS_TYPES.OK,
				summary: msg,
				closable: true
			};
			this._displayLongMessage(messageBoxArgs);
		},
		
		_displayLongInfoMessage: function(msg){
			var messageBoxArgs = {
				type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
				summary: msg,
				closable: true
			};
			this._displayLongMessage(messageBoxArgs);
		},
		
		_displayLongWarningMessage: function(msg){
			var messageBoxArgs = this._convertMsgToMsgBoxArgs(msg);
			messageBoxArgs.type = jazz.ui.MessageBox.STATUS_TYPES.WARNING;
			this._displayLongMessage(messageBoxArgs);
		},
		
		_displayLongErrorMessage: function(msg){
			var messageBoxArgs = this._convertMsgToMsgBoxArgs(msg);
			messageBoxArgs.type = jazz.ui.MessageBox.STATUS_TYPES.ERROR;
			this._displayLongMessage(messageBoxArgs);
		},
		
		_displayLongMessage: function(messageBoxArgs){
			PlatformUI.getWorkbench().hideMessageArea();
			this._messageBox.showMessage(messageBoxArgs);
		},
		
		_convertMsgToMsgBoxArgs: function(msg){
			var messageBoxArgs = {};
			if (dojo.isString(msg)) {
				messageBoxArgs.summary = msg;
			} else {
				messageBoxArgs.summary = msg.headerMessage;
				messageBoxArgs.errorObject = msg;
				
				if (msg.errorClass === "com.ibm.team.process.common.advice.TeamOperationCanceledException") { //$NON-NLS-1$
					var  messageHasReportInfos = msg.errorData && msg.errorData.internalReportInfos && msg.errorData.internalReportInfos.length > 0;
					var message = ""; //$NON-NLS-1$
					if (messageHasReportInfos) {
						var data = msg.errorData.internalReportInfos[0].data;
						var operations = [];
						try {
							var doc = UIHelper.parseXmlTextToDOMDocument(data);
							var nodes = doc.documentElement.childNodes;
							var children = UIHelper.getNodes(nodes, "action", null); //$NON-NLS-1$
							dojo.forEach(children, function(item) {
								var description = UIHelper.getAttributeNodeValue(item, "description", ""); //$NON-NLS-1$ //$NON-NLS-2$
								if (description) {
									operations.push(description);
								}
							});
							for(var i = 0; i < operations.length; i++) {
								if (i === 0) {
									message += "<b>"+ this.messages.AbstractProcessAreaEditor_OperationFailProblem + "</b><br>" + messageBoxArgs.errorObject.message; //$NON-NLS-1$ //$NON-NLS-2$
									message += "<br><br><b>" + this.messages.AbstractProcessAreaEditor_OperationFailReason + "</b><br>" + this.messages.AbstractProcessAreaEditor_OperationFailTip; //$NON-NLS-1$ //$NON-NLS-2$
									message += "<br>" + operations[i]; //$NON-NLS-1$
								} else {
									message += "<br>" + operations[i]; //$NON-NLS-1$
								}
							}		
						} catch (err) {
							message = ""; //$NON-NLS-1$
						} 
						
						if (message) {
							messageBoxArgs.errorObject.message = ""; //$NON-NLS-1$
							if (!messageBoxArgs.details) {
								messageBoxArgs.details = [];
							}
							messageBoxArgs.details.push({"message" : message}); //$NON-NLS-1$
						}
					}
				} 
				
				if(this._isErrorDataOfInterest(msg.errorData)) {
					msg.exception = msg.errorData.internalReportInfos[0].data.split("\n"); //$NON-NLS-1$
				} else if (this._shouldIgnoreException(msg)) {
					delete msg.errorClass;
					delete msg.exception;
				}
				this.processErrorData(msg.errorData, messageBoxArgs);
			}
			return messageBoxArgs;
		},
		
		_shouldIgnoreException: function(errObj){
			if (errObj.exceptionClassesToIgnore) {
				for (var i = 0; i < errObj.exceptionClassesToIgnore.length; i++) {
					if (errObj.exceptionClassesToIgnore[i] === errObj.errorClass) {
						return true;
					}
				}
			}
			return false;
		},
		
		_isErrorDataOfInterest: function(errorData){
			return errorData !== undefined &&
			(errorData.identifier === "com.ibm.team.process.server.initializeProjectArea" || errorData.identifier === "com.ibm.team.process.projectLinks" || errorData.identifier === "com.ibm.team.process.newMembersWithoutRole") && //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			errorData.internalReportInfos !== undefined &&
			errorData.internalReportInfos.length > 0 &&
			(errorData.internalReportInfos[0].identifier === "com.ibm.team.process.internal.operationException" || errorData.internalReportInfos[0].identifier === "com.ibm.team.process.internal.linksException" || errorData.internalReportInfos[0].identifier === "com.ibm.team.process.internal.newMembersWithoutRoles") && //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			errorData.internalReportInfos[0].data !== undefined;
		},
		
		processErrorData: function(errorData, messageBoxArgs){
			// sub-classes can override to alter the message box args based
			// on error data from the exception about to be shown
		},
		
		_destroyResourceLinks: function(){
			for (var i = 0; i < this._resourceLinks.length; i++) {
				this._resourceLinks[i].destroyRecursive();
			}
			this._resourceLinks = [];
			this._destroyMemberTRLinks();
			this._destroyAdminTRLinks();
		},
		
		_disableToolbars: function(disabled){
			for (var i = 0; i < this._actionToolbars.length; i++) {
				this._actionToolbars[i].disableToolbar(disabled);
			}
			for (var i = 0; i < this._hierarchyToolbars.length; i++) {
				this._hierarchyToolbars[i].disableToolbar(disabled);
			}
			for (var i = 0; i < this._memberActionToolbars.length; i++) {
				this._memberActionToolbars[i].disableToolbar(disabled);
			}
			for (var i = 0; i < this._adminActionToolbars.length; i++) {
				this._adminActionToolbars[i].disableToolbar(disabled);
			}
		},
		
		_destroyActionToolbars: function(){
			for (var i = 0; i < this._actionToolbars.length; i++) {
				this._actionToolbars[i].destroyRecursive();
			}
			this._actionToolbars = [];
			this._destroyMemberActionToolbars();
			this._destroyAdminActionToolbars();
		},
		
		_destroyHierarchyToolbars: function(){
			for (var i = 0; i < this._hierarchyToolbars.length; i++) {
				this._hierarchyToolbars[i].destroyRecursive();
			}
			this._hierarchyToolbars = [];
		},

		_destroySaveParticipants: function(){
			if (this._saveParticipants) {
				var keys = this._saveParticipants.getKeyList();
				for (var i = 0; i < keys.length; i++) {
					this._saveParticipants.remove(keys[i]);
				}
				delete this._saveParticipants;
			}
			
		},
		
		_destroyStyledTable: function(tableDiv){
			if (tableDiv.styledTable) {
				if(tableDiv.styledTable instanceof com.ibm.team.process.web.ui.internal.SelectableStyledTable){
					tableDiv.styledTable.clear();
				}
				tableDiv.styledTable.destroyRecursive();
				// IE 7 doesn't like delete here for some reason so just undefine it
				tableDiv.styledTable = undefined;
			}
			dojox.xml.parser.removeChildren(tableDiv);
		},
		
		_destroyMemberTRLinks: function(){
			for (var i = 0; i < this._memberTRLinks.length; i++) {
				this._memberTRLinks[i].destroyRecursive();
			}
			this._memberTRLinks = [];
		},
		
		_destroyAdminTRLinks: function(){
			for (var i = 0; i < this._adminTRLinks.length; i++) {
				this._adminTRLinks[i].destroyRecursive();
			}
			this._adminTRLinks = [];
		},
		
		_destroyMemberActionToolbars: function(){
			for (var i = 0; i < this._memberActionToolbars.length; i++) {
				this._memberActionToolbars[i].destroyRecursive();
			}
			this._memberActionToolbars = [];
		},
		
		_destroyAdminActionToolbars: function(){
			for (var i = 0; i < this._adminActionToolbars.length; i++) {
				this._adminActionToolbars[i].destroyRecursive();
			}
			this._adminActionToolbars = [];
		},
		
		_getServerUrl: function(){
			var location = document.location.href;
			var separator = "/"; //$NON-NLS-1$
			var path = location.split(separator);
			var serverAddress;
			if (path.length > 0) {
				serverAddress = path.shift() + separator + separator;
				path.shift(); //empty from the double //
				serverAddress = serverAddress + path.shift();
			}
			return serverAddress;
		},
		
		uninitialize: function(){
			this._destroyActionToolbars();
			this._destroyHierarchyToolbars();
			dojo.forEach(this.connectHandles, function(handle){
				dojo.disconnect(handle);
			});
			
			if (this.rolesEditor) {
				this.rolesEditor.destroyRecursive();
				delete this.rolesEditor;
				
			}
			
			if (this.permissionEditor) {
				this.permissionEditor.destroyRecursive();
				delete this.permissionEditor;
			}
			
			if (this.operationBehaviorEditor) {
				this.operationBehaviorEditor.destroyRecursive();
				delete this.operationBehaviorEditor;
			}
			
			this._destroySaveParticipants();
			
			if (this._widgetCache) {
				for (var tabId in this._widgetCache) {
					this._widgetCache[tabId] = null;
				}
				delete this._widgetCache;
			}
			
			if (this._tabs) {
				for (tabId in this._tabs) {
					var tab = this._tabs[tabId];
					if (this.isActivatedExtensionTab(tab)) {
						tab.mainPage.destroyRecursive();
					}
					if (tab.helpWidget) {
						tab.helpWidget.destroyRecursive();
					}
					this._tabs[tabId] = null;
				}
				delete this._tabs;
			}
			
			if (this._breadCrumbsWidget) {
				this._breadCrumbsWidget.destroyRecursive();
			}
			
			this._destroyStyledTable(this.membersDiv);
			this._destroyStyledTable(this.adminsDiv);
			this._destroyResourceLinks();
			
			this._messageBox.destroyRecursive();
			
			this.cancelPreviousMembersRequest();
			this.inherited(arguments);
		},
		
		handleCustomChange: function(e){
			// Derived can override and add custom event handling here
		},
		
		_loadRegistryTabs: function(){
			// Get extension registry
			var registry = RegistryFactory.getRegistry();
			if (!registry) {
				return;
			}
			// Get extension points
			var extensionsPoints = registry.getExtensionPoint(ProcessConstants.ProjectAreaExtensionPage.EXTENSION_POINT_PROFILE_PAGES);
			if (!extensionsPoints) {
				return;
			}
			// Get extensions
			var extensions = extensionsPoints.getExtensions();
			if ((extensions instanceof Array === false) ||
			(extensions.length === 0)) {
				return;
			}
			// Get elements
			var allElements = [];
			for ( var index = 0; index < extensions.length; index++) {
				var elements = extensions[index].getConfigurationElements();
				if (elements instanceof Array) {
					for ( var i = 0; i < elements.length; i++) {
						var element = elements[i];
						if (element.getName() !== ProcessConstants.ProjectAreaExtensionPage.ELEMENT_PAGE) {
							continue;
						}
						// Get id
						var id = element.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_ID);
						if (!id) {
							continue;
						}
						// Get title
						var title = element.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_TITLE);
						if (!title) {
							continue;
						}
						// Get widget
						var widget = element.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_WIDGET);
						if (!widget) {
							continue;
						}

						// Get widget
						var createForTeamAreaEditor = element.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_TEAM_AREA_EDITOR);
						if (!this._createForCurrentEditor(createForTeamAreaEditor)) {
							continue;
						}
						allElements.push(element);
					}
				}
			}
			this._processTabElements(allElements);
		},
		

		/**
		 * @param Array elements
		 * 
		 * @return void
		 */
		_processTabElements : function(elements) {
			// SORT ALL ELEMENTS BY NAME
			elements.sort(function(e1, e2) {
				return ProcessClient.stringCompare(e1.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_TITLE), e2
						.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_TITLE));
			});

			for ( var index = 0; index < elements.length; index++) {
				var element = elements[index];
				// Get ua key
				var uaKey = this.getRegistryTabUAKey(element);

				var description = ""; //$NON-NLS-1$
				var children = element.getChildren();
				if (children != null && children.length > 0) {
					for ( var i = 0; i < children.length; i++) {
						if (children[i].getName() === "description") { //$NON-NLS-1$
							description = children[i].getValue();
							break;
						}
					}
				}

				this.createTab(element.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_TITLE), element
						.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_ID), undefined, undefined, element
						.getAttribute(ProcessConstants.ProjectAreaExtensionPage.ATTRIBUTE_WIDGET), uaKey, undefined, undefined, description);
			}
		},

		_createForCurrentEditor: function(createForTeamAreaEditor){
			return true;
		},
		
		_saveExtensionTabs: function(){
			if (!this.isNew && this._tabs) {
				for (tabId in this._tabs) {
					var tab = this._tabs[tabId];
					if (this.isActivatedExtensionTab(tab)) {
						if (tab.mainPage.changesPending()) {
							tab.mainPage.doSave(dojo.hitch(this, this._saveExtensionPageCallback));
						}
					}
				}
			}
		},
		
		/*
		 * @param Error errorObject
		 *
		 * @return void
		 */
		_saveExtensionPageCallback: function(errorObject){
		
			if (!this.domNode) {
				// Edge case
				// Notification too late, the editor has already been destroyed
				return;
			}
			
			if (errorObject) {
				// Save operation failed for the tab
				this.handleServerResponseError(errorObject);
				this.saveButton.disabled = false;
			} else {
				// Save operation passed for the tab
				this.handleServerResponseSuccess();
			}
		},
		
		getTabUAKey: function(tabKey) {
			return undefined;
		},
		
		getRegistryTabUAKey: function(extensionElement) {
			return undefined;
		},
		
		isNeedRefreshWithWarning: function() {
			return false;
		}
		
	});
	
})();
