/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.IterationTypeModel"); //$NON-NLS-1$
	dojo.require("dijit.Tree"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TimelineModel"); //$NON-NLS-1$
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.IterationTypeModel", com.ibm.team.process.web.ui.internal.admin.projects.TimelineModel, { //$NON-NLS-1$		
		/*
		 * Constructs the Iteration Type model
		 * @param {Object} args The args are expected to contain the following:
		 *  {
		 *    store: the store the model should use for it's data
		 *  }
		 */
		constructor: function(args){
            this.query = {
            	enabledContext: ProcessConstants.PermissionContext.ITERATION_TYPE,
            	archived: false
            };
			this._parentNodeId = ProcessConstants.PermissionsScopeContext.ITERATION_TYPES;
			this._sortOptions = [{
					attribute: "name" //$NON-NLS-1$
				}, {
					attribute: "contextId" //$NON-NLS-1$
				}];
		}
						
	});
	
})();
