/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.IterationTypeTree"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.PermissionsScopeTree"); //$NON-NLS-1$
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.IterationTypeTree", [com.ibm.team.process.web.ui.internal.admin.projects.PermissionsScopeTree], { //$NON-NLS-1$
		
		postCreate: function(){
			this.inherited(arguments);
			dojo.addClass(this.domNode, "com-ibm-team-process-web-ui-internal-IterationTypeTree"); //$NON-NLS-1$
		},
		
		getLabelClass: function(item, opened){
			var store = this.model.store;
			if (store.isItem(item) && !store.getValue(item, "root")) { //$NON-NLS-1$
				if (store.isIterationType(item)) {
					if (this.isItemInErrorState(item)) {
						return 'errorProcessItem'; //$NON-NLS-1$
					} else if (this.isNewItem(item)) {
						return 'newProcessItem'; //$NON-NLS-1$
					}
				}
				
				return this.inherited(arguments);
				
			}
		},
		
		isItemInErrorState: function(item){
			return this.model.store.getValue(item, 'errorState'); //$NON-NLS-1$
		},
				
		updateSelectedIterationType: function(iterationTypeData){
			var selectedIterationType = this.getFocusedItem();
			if (selectedIterationType !== null) {
				this.model.store.updateIterationType(selectedIterationType, iterationTypeData);
			}
		},
		
		addNewIterationType: function(iterationType){
			var newIterationType = this.model.store.addNewIterationType(iterationType);
			this.focusItem(newIterationType);
			return newIterationType;
		},
		
		uninitialize: function(){
			// Place holder for now
			this.inherited(arguments);
		}
		
	});
})();
