/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.OperationBehaviorEditRoleDialog"); //$NON-NLS-1$
	
	dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
	dojo.require("jazz.util.html"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.OperationBehaviorEditDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.OperationBehaviorSelectRoleWidget"); //$NON-NLS-1$
	
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	
	/**
	 * A simple dialog allowing the user to change the role for an existing
	 * operation behavior configuration.
	 * 
	 * See the constructor of OperationBehaviorEditRoleDialog for the required
	 * arguments to the constructor of this widget. In addition, the following
	 * field in argument 'model' is required:
	 * 
	 * - rolesStore	 A dojo.data.ItemFileReadStore with roles available to
	 * 				select from, with fields id, name, and description
	 */
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.OperationBehaviorEditRoleDialog", //$NON-NLS-1$
		[com.ibm.team.process.web.ui.internal.admin.projects.OperationBehaviorEditDialog], {
		
		createCustomContents: function() {
			this._operationBehaviorSelectRoleWidget = new com.ibm.team.process.web.ui.internal.admin.projects.OperationBehaviorSelectRoleWidget({
				model: this.model,
				behaviorConfigurationItem: this.behaviorConfigurationItem,
				selectionChangedCallback: dojo.hitch(this, this._selectionChanged)
			});
			this.widgetContainer.appendChild(this._operationBehaviorSelectRoleWidget.domNode);
			this._operationBehaviorSelectRoleWidget.resizeRolesList();
		},
		
		getSummaryTextString: function() {
			return this._operationBehaviorSelectRoleWidget.getSummaryTextString();
		},
		
		hideSummaryTextNode: function() {
			this._operationBehaviorSelectRoleWidget.hideSummaryTextNode();
		},
		
		getResultObject: function() {
			var obj = {};
			obj[ProcessConstants.BehaviorConfigurationDTO.ROLE_ID] = this._selectedRoleId;
			return obj;
		},
		
		canFinish: function() {
			return this.model.configurationStore.getValue(this.behaviorConfigurationItem, ProcessConstants.BehaviorConfigurationDTO.ROLE_ID) !== this._selectedRoleId;
		},
		
		_selectionChanged: function(selectedValues, doubleClicked) {
			this._selectedRoleId = selectedValues.roleId;
			this.notifySelectionChanged(doubleClicked);
		},
		
		uninitialize: function() {
			this._operationBehaviorSelectRoleWidget.destroyRecursive();
			this.inherited(arguments);
		}
	});
})();
