/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaManagementMenu"); //$NON-NLS-1$
	dojo.require("jazz.app._ComponentMenu"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("jazz.util.html"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaRecentlyViewed"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("jazz.app.viewHistory"); //$NON-NLS-1$
	dojo.require("jazz.ui.internal.MenuItemGroup"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var _ComponentMenu = jazz.app._ComponentMenu;
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ProjectAreaRecentlyViewed = com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaRecentlyViewed;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var PROJECTAREAS_TYPE = "com.ibm.team.process.projectareas"; //$NON-NLS-1$
	var JTS_APP = jazz.app.internal.applicationAbout.findAboutUriFromContext(net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL);
	var viewHistory = jazz.app.viewHistory;
	var MenuItemGroup = jazz.ui.internal.MenuItemGroup;
	var WrapHints = jazz.ui.MegaMenu.WrapHints; 
	var MAX_RECENT_VIEW = 5;
	 
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaManagementMenu", _ComponentMenu, { //$NON-NLS-1$
		
		constructor: function() {
			this._insertIndex = 0;
		},
		
		postCreate: function() {
			dojo.addClass(this.domNode, "com-ibm-team-projectareas-menu"); //$NON-NLS-1$
			this.refresh();
		},
		
		refresh: function() {
			this._insertIndex = 0;
			this.clear();
			this._addBrowseSection();
			this._addCreationSection();
		},
		
		/**
		 * Get the current selected menu item
		 */
		getSelected: function() {
	    	var currentHref = window.location.href;
			var items = this.getItems();
			for (var i in items) {
			    if (currentHref.indexOf(items[i].href) > -1) {
				    return items[i];
				}
			}
			return null;
		},
		
		/**
		 * Add Active Project Area and Archived Project Area menu items under the the 'Browse' category 
		 */
		_addBrowseSection: function() {
			
			this.addTitle(this._escape(messages.ProjectAreaManagementMenu_Browse), this._insertIndex++);
			
			var menuItem = {};
			menuItem.icon = String(dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/projectarea_obj.gif")); //$NON-NLS-1$ //$NON-NLS-2$
			menuItem.label = this._escape(messages.ProjectAreaManagementMenu_ActiveProjectAreas);
			menuItem.href = "#action=com.ibm.team.process.manageProjectAreas"; //$NON-NLS-1$
			menuItem.insertIndex = this._insertIndex++;
			this.addItemByArgs(menuItem);
			
			menuItem = {};
			menuItem.icon = String(dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/projectAreaIcon_archived.png")); //$NON-NLS-1$ //$NON-NLS-2$
			menuItem.label = this._escape(messages.ProjectAreaManagementMenu_ArchivedProjectAreas);
			menuItem.href = "#action=com.ibm.team.process.manageArchivedProjectAreas"; //$NON-NLS-1$
			menuItem.insertIndex = this._insertIndex++;
			this.addItemByArgs(menuItem);
		},
		
		/**
		 * Add Create Project Area and Create Life-cycle Project menu items under the the 'Create' category 
		 */
		_addCreationSection: function() {
			
			this.addTitle(this._escape(messages.ProjectAreaManagementMenu_Create), this._insertIndex++);
			
			var menuItem = {};
			menuItem.icon = String(dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/new-project_co.gif")); //$NON-NLS-1$ //$NON-NLS-2$;
			menuItem.label = this._escape(messages.ProjectAreaManagementMenu_CreateNewProjectArea);
			menuItem.href = "#action=com.ibm.team.process.editProjectArea&itemId=new";  //$NON-NLS-1$
			menuItem.insertIndex = this._insertIndex++;
			this.addItemByArgs(menuItem);
			
			this.addLoading(this._insertIndex);
			
			var srh = new ServiceResponseHandler(this, "_handleLpaResponse", "_nullErrorHandler"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.getLPACreateProjectAreaUrl(srh);
		},

		/**
		 * Successful response to GET the LPA url
		 * @param {String} lpaUrl
		 */
		_handleLpaResponse: function(lpaUrl) {
			this.remove(this._insertIndex);
			if (!lpaUrl) {
				this._addRecentViewedSection();
				return; 
			}
			var menuItem = {};
			menuItem.icon = String(dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/create-lpa_obj.png")); //$NON-NLS-1$ //$NON-NLS-2$;
			menuItem.label = this._escape(messages.ProjectAreaManagementMenu_CreateNewLifecycleProject) + "<img class = 'trailingImage' src='" + dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/launch_obj.gif").toString() + "'>"; //$NON-NLS-1$ //$NON-NLS-2$; //$NON-NLS-3$ //$NON-NLS-4$;
			menuItem.href = lpaUrl;
			menuItem.insertIndex = this._insertIndex++;
			this.addItemByArgs(menuItem);
			
			this._addRecentViewedSection();
		},
		
		/**
		 * Error GET the LPA url, don't add the menu item
		 */
		_nullErrorHandler:function() {
			this.remove(this._insertIndex);
			this._addRecentViewedSection();
		},
		
		_addRecentViewedSection: function() {
			this._initRecent();
			dojo.subscribe(ProcessConstants.PROJECT_AREA_RECENTLY_VIEWED, this, "_addRecent"); //$NON-NLS-1$
		},
		
		//Init the recently viewed section
		//Construct the recently viewed section if there are recently viewed project areas
		_initRecent: function(){
            var items = [];
            var query = {
                application: JTS_APP,
                type: PROJECTAREAS_TYPE
            };
            var def = viewHistory.get(query);
            var menuDef = new dojo.Deferred();
            this._createDeferredRecentSection(menuDef);
            def.addCallback(dojo.hitch(this, function(result){
                var history = result.items;
				if(history.length === 0 && this._recentProjectAreas) {
					this._recentProjectAreas.remove();
	                this._recentProjectAreas.destroy();
	                delete this._recentProjectAreas;
					return;
				}
                outer: for (var i = 0; i < history.length; i++) {
                    var entry = history[i];
                    var item = {
                        label: entry.label,
                        icon: entry.iconUri,
                        href: entry.data ? entry.data : entry.url,
                        uri: entry.uri
                    };
                    for (var j = 0; j < items.length; j++) {
                        if (items[j].href == item.href) 
                            continue outer;
                    }
                    items.push(item);
                }
                menuDef.callback(items);
                this._recentProjectAreas.set("groupTitle", "<b>" + messages.ProjectAreaManagementMenu_RecentProjectAreas + "</b> (" + (items ? items.length : 0) + ")"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
                if (items.length > 0) {
                    this.updateSelected();
                }
            }));
        },
        
		//Create the recently viewed section
        _createRecentSection: function(items){
            if (!this._recentProjectAreas) 
                this._recentProjectAreas = new MenuItemGroup({
                    menu: this,
                    wrapHint: WrapHints.FORCE_WRAP,
                    groupTitle: "<b>" + messages.ProjectAreaManagementMenu_RecentProjectAreas + "</b> (" + (items ? items.length : 0) + ")", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
                    items: items || []
                });
        },
		
        _createDeferredRecentSection: function(def){
            if (!this._recentProjectAreas) 
                this._recentProjectAreas = new MenuItemGroup({
                    menu: this,
                    wrapHint: WrapHints.FORCE_WRAP,
                    groupTitle: "<b>" + messages.ProjectAreaManagementMenu_RecentProjectAreas + "</b>", //$NON-NLS-1$ //$NON-NLS-2$
                    itemProvider: function(){
                        return def
                    }
                });
        },
        
		//callback method when there is project area is viewed
        _addRecent: function(recentProjectArea){
            var item = this._createMenuItem(recentProjectArea);
            return this._addRecentItem(item);
        },
        
		//Add the recently viewed project area into the recently viewed section
        _addRecentItem: function(item){
            if (!this._recentProjectAreas) {
                this._createRecentSection();
            }
            var items = this._recentProjectAreas.get("items"); //$NON-NLS-1$
			if(items && items.length > 0) {
				for (var i = 0; i < items.length; i++) {
	                if (items[i].href === item.href) {
	                    this._recentProjectAreas.remove(items[i]).destroy();
	                    break;
	                }
	            }
				while (items.length >= MAX_RECENT_VIEW) {
	                this._recentProjectAreas.remove(items[0]).destroy();
	            }
			}
            this._recentProjectAreas.addItemByArgs(item, 0);
            this._updateRecentCount();
            this.updateSelected();
            return true;
        },
        
		//Return the parameters that needs to create a menu item
        _createMenuItem: function(recentProjectArea){
            var label = this._escape(recentProjectArea.projectAreaName);
			var icon = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/projectarea_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			if (!recentProjectArea.isInitialized) {
				icon = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/uninitialized_pa_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			}
			if (recentProjectArea.isArchived) {
				icon = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/projectAreaIcon_archived.png"); //$NON-NLS-1$ //$NON-NLS-2$
			}
            return {
                label: label,
                icon: icon,
                href: recentProjectArea.href
            };
        },
        
		//Update the recent count of the recent viewed section
        _updateRecentCount: function(){
            if (!this._recentProjectAreas) {
				return 0;
			}
            var items = this._recentProjectAreas.get("items"); //$NON-NLS-1$
            var length = (items && items.length > 0) ? items.length : 0;
            this._recentProjectAreas.set("groupTitle", "<b>" + messages.ProjectAreaManagementMenu_RecentProjectAreas + "</b> (" + length + ")"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
            return length;
		},
		
		/**
		 * Escape the special html characters in the text
		 * @param {String} text
		 */
		_escape: function(text) {
			return jazz.util.html.escape(text);
		}
	});
	
})();
