/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2012. All
 * Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.SelectRolesWizardStep"); //$NON-NLS-1$

	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("jazz.ui.wizard.WizardStep"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog"); //$NON-NLS-1$

	/**
	 * Provides a jazz.ui.wizard.WizardStep for the
	 * com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog.
	 * 
	 * 
	 * @constructor new
	 *              com.ibm.team.process.web.ui.internal.admin.projects.SelectRolesWizardStep({arguments});
	 * @arguments: allRoles : [] : Array of role objects.
	 *             <p>
	 *             defaultRole:The default role object.
	 * @since 4.0.1
	 */
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.SelectRolesWizardStep", //$NON-NLS-1$
	[jazz.ui.wizard.WizardStep, dijit._Widget, dijit._Templated], {

		templatePath : dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/templates/SelectRolesWizardStep.html"), //$NON-NLS-1$ //$NON-NLS-2$

		constructor : function(args) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.stepTitle = this.messages.SelectRolesWizardStep_Title;
		},

		postCreate : function() {
			var rolePickerArgs = {
				allRoles : this.allRoles,
				member : {
					// The name will be used to construct the header:
					// "Assign the
					// process roles for the selected users."
					name : this.messages.SelectRolesWizardStep_TitleEnding,
					processRoles : [this.defaultRole]
				}
			};

			this._rolePicker = new com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog(rolePickerArgs);
			this._roleSelector.appendChild(this._rolePicker.domNode);
		},

		getChosenRoles : function() {
			return this._rolePicker.getChosenRoles();
		},

		canFinish : function() {
			return true;
		},

		uninitialize : function() {
			this._rolePicker.destroyRecursive();
			delete this._rolePicker;

			this.inherited(arguments);
		}
	});
})();
