/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.JazzTokenProviderConfigStep");
dojo.require("com.ibm.team.repository.web.ui.wizard.WizardConfigurationStep");
dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "ConfigurePageMessages");
var WizardConfigurationStep = com.ibm.team.repository.web.ui.wizard.WizardConfigurationStep;
(function(){
    dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.JazzTokenProviderConfigStep", WizardConfigurationStep, {
		constructor: function(){
			this.configMessages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "ConfigurePageMessages");
		},
		
        _initializePropertiesAfterLoaded: function(){
            this.STATUS.NO_URI = {
                test: false,
                revert: true,
                next: true,
                edit: true,
                code: "NONE",
                message: 'loading'
            };
            this.uriProperty = this._config.getServerPropertyElement("jazzTokenProvider.tokenServerURI");
            this.connect(this._config, "_markChanged", "setStateForEmptyURI");
            this.connect(this._config, "_checkUnchanged",  function(){
                if (this._config._changed) {
                    this.setStateForEmptyURI();
                }
                else {
                    this._setState(this._initialLoadedState);
                }
            });
            this.connect(this._config, "_markInvalid", "_handleInvalidInput");
            this.setStateForEmptyURI();
            this._initialLoadedState = this.hasURI() ? this.STATUS.PENDING_OK : this.STATUS.NO_URI;
        },
        
        setStateForEmptyURI: function(){
            if (this.hasURI()) {
                this._setState(this.STATUS.PENDING_OK);
            }
            else {
                this._setState(this.STATUS.NO_URI);
            }
        },
        
        hasURI: function(){
            return this.uriProperty.hasOverride();
        },
        
        cancelRequested: function(){
            var verifyCancel = this._config._changed ? confirm(this.configMessages.dirtyCancelWarn) : true;
            if (verifyCancel) {
                this.parentPointer.close();
            }
        }
        
        
        
    });
})()
