/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.JazzTokenProviderConfigWizard");
dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.PropertiesWizard");
dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.JazzTokenProviderConfigStep");
dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "JazzTokenProviderConfigWizardMessages");
var TokenProviderConfigStep = com.ibm.team.repository.web.ui.internal.admin.server.JazzTokenProviderConfigStep;
var PropertiesWizard = com.ibm.team.repository.web.ui.internal.admin.server.PropertiesWizard;
(function(){
	
    dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.JazzTokenProviderConfigWizard", null , {
		configSaveCallback : null,		
        constructor: function(args){
        	this.messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "JazzTokenProviderConfigWizardMessages");
			this.configSaveCallback = args.configSaveCallback;
			this.showWizard();			
        },
        		
        showWizard: function(){
            var uriConfigArgs = {
                stepTitle: this.messages.configStepTitle,
                parentPointer: this,
                description: this.messages.configStepDesc,
                implementationClassName: "com.ibm.team.repository.service.internal.license.token.JazzLicenseTokenProviderService",
				
                extraServiceConfigArgs: {
                    forceSimple: true
                },
                
                innerArgs: {
                    headingLabel: this.messages.configStepInnerUriTitle,
                    heading: ""
                },
                canFinish: function(){
                    return this.enableNext === true;
                }
            }
            this.uriConfigStep = new TokenProviderConfigStep(uriConfigArgs);            
			var args = { 
				propConfigStep: this.uriConfigStep,
				configSaveCallback: this.configSaveCallback
			}
			this.propWizard = new PropertiesWizard(args); 						
        },
		
		close : function(){
			this.propWizard.close();
		}
		
    })
})()
