/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.LicenseTokenView");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.xml.parser");
dojo.require("jazz.ui.MessageBox");
dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.LicenseTokenUsageView");
dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.LicenseTokenEditor");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "LicenseTokenViewMessages");
var messages;

var MessageBox = jazz.ui.MessageBox;
var LicenseTokenUsageView = com.ibm.team.repository.web.ui.internal.admin.server.LicenseTokenUsageView;
var LicenseTokenEditor = com.ibm.team.repository.web.ui.internal.admin.server.LicenseTokenEditor;

dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.LicenseTokenView", [dijit._Widget, dijit._Templated], {
	templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/admin/server/templates/LicenseTokenView.html"),
    constructor: function(){      
        this.messages = messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "LicenseTokenViewMessages");
    },
    
    postCreate: function(){
		this.header = new MessageBox();
		this.headerArea.appendChild(this.header.domNode);	
        var args = {parentHeader : this.header};	
		this.editor = new LicenseTokenEditor(args);
		this.editorArea.appendChild(this.editor.domNode);        
		
		this.connect(this._showUsage, "onclick", function(e) {
			this._toggleUsage(e.target.checked);
		});
    },
	
	_toggleUsage : function(show){
		if (show) {
		  this.usage = new LicenseTokenUsageView();
		  this.usageArea.appendChild(this.usage.domNode); 
		} else {
		  dojox.xml.parser.removeChildren(this.usageArea);		  
		}
	},
	
	_refresh : function(){
		this.header.hideMessage();
		if (this.usage)
			this.usage._refresh();
		if (this.editor)
			this.editor._refresh();
	}
    
});
