/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.TokenLicenseUploadWizard");
dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.TokenLicenseFileUploadStep");

var UploadStep = com.ibm.team.repository.web.ui.internal.admin.server.TokenLicenseFileUploadStep;

(function(){
    dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.TokenLicenseUploadWizard", null, {
            
        constructor: function(){
            this.messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "LicenseTokenViewMessages");
            this.launchWizard();                                    
        },
 
        launchWizard: function(){                                    
            var self = this;
            
            this.uploadStep = new UploadStep({
                parentPointer: self                
            });                        
            this.steps = [this.uploadStep];            
            var wizardArgs = {
                steps: this.steps,
                width: "870px",
                primaryTitle: this.messages.tokenWizardTitle,
                showStepSummary: false,
                processFinish: function(){
					self.uploadStep.performFinish();					
                },
                processCancel: function(){
                    self.wizard.close();
                }                
            };
            
            this.wizard = new jazz.ui.Wizard(wizardArgs);
			this.connect(this.uploadStep, "finished", function(){
				this.wizard.close();
			});
        }

    });
})();
