/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	'welcome': "Welcome to the Jazz Team Server Administration Home",
	'subTitle': "As a ${0} user, you can get started with the following tasks:",
	
	'subTitle_admin': "As a <strong>Jazz Administrator</strong>, you have access to the following tasks:",
	'subTitle_projectAdmin': "As a <strong>Jazz Project Administrator</strong>, you have access to the following tasks:",
	'subTitle_user': "As a <strong>Jazz User</strong>, you have access to the following tasks:",
	'subTitle_guest': "As a <strong>Jazz Guest</strong>, you have access to the following tasks:",
	
	'applicationAdministration': "Application Administration",
	'serverAdministration': "Jazz Team Server Administration",
	'loading': "Loading...",
	'goToSetup': "Go to Setup",
	
	//manage profile section
	'manageProfile': "Explore My Dashboards and User Profile",
	'manageProfileDescription': "Use the following links below to access your User Profile and work with Personal Dashboards.",
	'personalDashboards': "Manage Personal Dashboard",
	'editProfile': "Edit User Profile",
	
	//manage server section
	'manageServer': "Manage Server",
	'manageServerDescription': "Configure the Jazz Team Server settings, manage license keys, and check server status information.",
	'aboutAdministeringTheJTS': "About administering the Jazz Team Server",
	'noSetupDetected': "Before you begin using the Jazz Team Server Administration Web UI, you must run the Setup Wizard to configure the server. This will allow you to register applications and Lifecycle Project Administration so that you can create and manage projects and their membership.",
	'setupJustCompleted': "Congratulations on successfully completing the Jazz Team Server & Application Setup. You are now ready to setup users and projects. For the recommended next steps, see the Task Guide on the right side within the page below.",
	'connected': "Connected",
	'unavailable': "Unavailable",
	'databaseStatus': "Database Status",
	'diagnosticStatus': "Diagnostics",
	'publicURI': "Public URI",
	'serverStatus': "Server Status",
	'notSet': "Not set",
	'unknown': "Unknown",
	'tryAgain': "Try Again",
	
	//manage users section
	'manageUsers': "Manage Users",
	'manageUsersDescImport': "Why Import Users to the Jazz Team Server? When using an external user registry, the users exist in the registry but not in the Jazz Team Server repository. Importing users is required in order for these users to be able to use the Jazz Team Server and its associated applications. To simplify your setup and administration, we recommend you import users to the Jazz Team Server before doing any Application Administration.",
	'manageUsersDescCreate': "The Jazz Team Server provides a single synchronized user database that is shared by the server and all registered applications. You can create and manage user accounts and user license assignments directly in the centralized Jazz Team Server administration or the applications registered with the server.",
	'syncJts': "Synchronize Jazz Team Server Users With External User Registry",
	'syncStarted': "(Starting synchronization...)",
	'syncRunning': "(Running: ${0}% complete)", //${0} is an integer (0-100) representing a %
	'syncFinished': "The external user registry synchronization is complete. All users have been imported into the Jazz Team Server.",
	'importUsersAction': "Import Users",
	'createUsersAction': "Create Users",
	'assignCALS': "Assign Client Access Licenses",
	'aboutCreatingUsers': "About creating users",
	'aboutManagingUsers': "About managing users",
	'aboutImportingUsers': "About importing users from an external registry service",
	'noUsersImported': "No users have been imported",
	'noUsersCreated': "No users have been created",
	
	//manage lifecycle projects
	'manageLPA': "Manage Lifecycle Projects",
	'manageLPADescription': "Why Create and Manage Lifecycle Projects? Using Lifecycle Projects allows you to easily establish and manage associations between projects in the software development lifecycle. Whether you plan to make associations when you first create a project or later, starting with a Lifecycle Project gives you more flexibility to easily make these associations than if you were to create a single standalone Project Area within an application.",
	'noProjectsYet': "No projects have been created",
	'createProject': "Create Lifecycle Project",
	'manageProjects': "Manage Lifecycle Projects",
	'aboutProjects': "About creating and managing lifecycle projects",
	'trySample': "Try out the Money That Matters sample",
	'trySampleInLPA': "Try out the Money That Matters sample in Lifecycle Projects",
	
	//task guide
	'taskGuide': "Task Guide",
	'taskGuideDesc': "The Task Guide is your quick reference for recommended next steps and related tasks. For more information on each task, see the content sections within this page.",
	'setupServer': "Setup Server",
	'createLPA': "Create Lifecycle Projects",

	//task guide - learn more
	'learnMore': "Explore Related Topics",
	'aboutAddingMembers': "About adding members to projects",
	'aboutAddingUsers': "About adding and modifying users as members of project areas",
	
	//manage application section
	'viewApplications' : "View Applications",
	'manageApplications' : "Manage Application Artifacts",
	'createProjectArea': "Create Project Area",
	'viewAllProjects': "All Projects",
	'manageAllProjects': "Manage All Project Areas",
	'aboutCreatingProject': "About creating a project area",
	'linksToAppPages': "Links to application administration pages:",
	
	//success and error messages
	'dbErrorOccurred': "A database error has occurred. Visit the ${0}Status Summary${1} page for detailed information about this error.",
	'syncRequestFailed': "The request to synchronize users with this Jazz Team Server failed."

})