/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.schema.AdminHome");

(function() {

var NAMESPACES = {
	dc: "http://purl.org/dc/terms/",
	jd:	"http://jazz.net/xmlns/prod/jazz/discovery/1.0/",
	jfs: "http://jazz.net/xmlns/foundation/1.0/",
	oslc: "http://open-services.net/ns/core#",
	rdf: "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
	ju: "http://jazz.net/ns/ui#"
};

var AdminHome = {
	namespaces: NAMESPACES,
	service: ["string", "jd:service/@rdf:resource", "1"],
	contextRoot: ["string", "jd:contextRoot", "1"],
	publisher: ["string", "dc:publisher", "1"],
	applicationAbout: ["string", "oslc:publisher/@rdf:resource", "1"]
};

var permission = {
	namespaces: NAMESPACES,
	roles: ["string", "jfs:permission", "*"]
};

var entry = {
	namespaces: NAMESPACES,
	title: ["string", "dc:title", "1"],
	description: ["string", "dc:description", "1"],
	href: ["string", "jfs:href/@rdf:resource", "1"],
	icon: ["string", "ju:icon/@rdf:resource", "1"],
	usage: ["string", "ju:usage/@rdf:resource", "1"],
	promoted: ["string", "ju:promoted", "1"],
	visibility: [permission, "ju:visibility", "1"]
};

com.ibm.team.repository.web.ui.internal.admin.server.schema.AdminHome = {
	
	discovery: {
		namespaces: NAMESPACES,
		AdminHome: [AdminHome, "jfs:AdminHome", "*"]
	},
	
	adminHomeService: {
		namespaces: NAMESPACES,
		entries: [entry, "jfs:AdminHomeEntries/jfs:entry", "*"]
	}
}

})();
