/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	'repoPermissions': "Repository Permissions",
	'loading': "Loading...",
	'details': "Details",
	'userIdCS': "User ID (case sensitive):",
	'emailAddr': "E-mail Address:",
	'changePassword': "Change Password...",
	'clientAccessLicenses': "Client Access Licenses",
	'noCALMessage': "While a license is not required to administer a Jazz Team Server, a user without a license may have limited access to other capabilities within the product. The server does not limit the number of users without a license and these users will not be counted as part of the server limit.",
	'serverLicenseLimitMessage': "CRJAZ1531W Warning: The server has reached the maximum user limit.  You will not be able to increase the number of users that are assigned a Client Access License type that is counted in the server user limit.",
	'readOnlyName': "The name is a read-only attribute",
	'readOnlyUserID': "The user ID is a read-only attribute",
	'readOnlyEmailAddress': "The email address is a read-only attribute",
	'userRegistryNotWritable': "Because this server is connected to an external user registry, some user details including User ID, E-Mail Address, and Repository Permissions are read-only. To modify these read-only details, you must make the changes in the external user registry.",
	'photo': "Photo",
	'revert': "Revert",
	'remove': "Remove",
	'browseButton': "Browse...",
	'scaled': "Will be scaled to 100 x 100 pixels",
	'userName': "User Name",
	'navigateAway': "Are you sure you want to navigate away from this page?",
	'unsavedChanges': "You have unsaved changes in the user editor.  If you continue, you will lose your changes.",
	'okOrCancel': "Press OK to continue, or Cancel to stay on the current page.",
	'userRegistryError': "CRJAZ1533E Necessary information about the user registry could not be loaded. For more information, view the error details and check the server log file.",
	'userRegistryError.explanation': "An error occurred while fetching configuration details for the user registry.",
	'userRegistryError.useraction': "View the details that are included with the error message, and check the server log file.",
	// Last UA revision: 09/18/2012
	
	'newDefaultPassword': "New users will be created with a default password equal to their User ID in your directory service.",
	'licensesAvailable': "(${0} available)",
	'simpleLicensesAvailable': "${0} available",
	'noCALsFound': "No client access licenses were found.",
	'licenseInfoError': "CRJAZ1525E Error fetching license information from the repository.",
	'groupInfoError': "CRJAZ1523E Error fetching group information from the user registry.  Please check your registry configuration.",
	'dsNotWritable': "Notice: You are using a directory service that is not writable.  User roles cannot be modified.",
	'errorFetchingUserData': "CRJAZ1520E Error fetching user data.  Please check your registry configuration.",
	'userNotFound': "CRJAZ1532I This user was not found in the directory service. This user will not be able to login unless they have an account in the directory service.",
	'problemFetchingRoles': "CRJAZ1527E Problem fetching user roles: ${0}",
	'errorFetchingAssignedLicenses': "CRJAZ1519E Error fetching assigned licenses from the repository.",
	'passwordNoMatch': "The passwords you typed do not match",
	'passwordChangeSuccess': "Password changed successfully.",
	'passwordChangeError': "CRJAZ1526E The password could not be changed because of the following issue: '${0}'. For more details, open the help system and search for CRJAZ1526E.",
	'passwordChangeError.explanation': "A problem occurred while trying to change the password. Additional information about the cause of the problem is provided with the message.",
	'passwordChangeError.useraction': "For more information about how to fix the problem, see the information provided with the message. For additional help, see the help topic 'Changing your password'.",
	// Last UA revision: 02/10/2012
	
	'incorrectPassword': "Incorrect password",
	'passwordUnknownError': "Unknown Error",
	'resetPassword': "Reset Password...",
	'resetPasswordPending': "Sending an e-mail with the new password...",
	'resetPasswordConfirm': "Reset the password for ${0}? An e-mail will be sent to the user with a new password.", // ${0} is a userId
	'resetPasswordSuccess': "The password was reset. An e-mail containing the new password was sent to ${0}.", // ${0} is a userId
	'resetPasswordFailed': "Unable to reset the password for ${0}.", // ${0} is a userId
	'invalidFileName': "CRJAZ1524E An error occured during file upload.\nThis will happen when an invalid fully qualified file name is provided.",
	'errorUploadingFile': "CRJAZ1522E Error uploading file: ${0}",
	'noPhotoOnFile': "No photo on file",
	'photoToBeRemoved': "Photo to be removed on Save",
	'revokeAdminUserWarning': "CRJAZ1528W Warning: You are about to revoke JazzAdmin and JazzUser priviliges from your account.  If you continue, your account will be completely locked out of the repository.  Are you sure you would like to continue?",
	'revokeAdminWarning': "CRJAZ1529W Warning: You are about to revoke JazzAdmin privileges from your account.  If you continue, your account will be locked out of the admin application.  Are you sure you would like to continue?",
	'revokeUserWarning': "CRJAZ1530W Warning: You are about to revoke JazzUser privileges from your account.  If you continue, your account will be completely locked out of the repository.  Are you sure you would like to continue?",
	'saveInProgress': "Save in progress...",
	'userMustHaveName': "The user must have a name",
	'userMustHaveID': "The user must have a User ID",
	'userMustHaveEmail': "The user must have an e-mail address",
	'userCreatedSuccessfully': "User created successfully.",
	'successWithWarning': "The user was created successfully, but no licenses were assigned. Certain capabilities will not be available until you assign a license. Consider selecting one of the licenses below.",
	'successWithMultipleLicensingMessages': "The user was saved successfully, but the server returned one or more messages regarding the license assignments. Click \"Show details\" to view the message(s).",
	'userSavedSuccessfully': "User saved successfully.",
	'userSaveFailed': "CRJAZ2419E Saving user failed.",
	'refreshWarning': "Refreshing will discard any changes you have made.  Would you like to continue?",
	'errorTimeout': "CRJAZ1521E Save operation timed-out for editor page: ${0}",
	'overviewTabName': "Overview",
	'refresh': "Refresh", 
	'save': "Save",
	'newUnsavedUser': "[New User]",
	'invalidEmail': "Invalid e-mail address. Please correct the e-mail address below.",
	'licenseHelpMessage': "Learn more about licenses >",
	'licenseAssignedError': "CRJAZ1846E An error occurred while trying to assign the Client Access License keys to the user. Click \"show details\" to view the details of the license assignment error. Follow the instructions to fix the problem, and click \"Save\" to try again."
})	
