/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.catalog.DashboardCatalog");

dojo.require("jazz.core.loader");
dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardCatalogMessages");

(function() {

dojo.declare("com.ibm.team.dashboard.web.ui.internal.catalog.DashboardCatalog", [dijit._Widget, dijit._Templated], {
	
	compatibilityMode: false, // if true, requests backward-compatible URLs
	onAddWidget: null,
	
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "ui/internal/templates/DashboardCatalog.html"),
	
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardCatalogMessages");
	},
	
	// this gets called automatically by _Widget if onAddWidget is passed into the constructor
	_setOnAddWidgetAttr: function(onAddWidget) {
		if (this._addWidgetHelper) {
			// everything has already been loaded and initialized - update to the new onAddWidget callback
			this._addWidgetHelper.onAddWidget = onAddWidget;
		} else { 
			// load the code and instantiate the catalog
			jazz.core.loader.batch_load_async([
				"jazz.ensemble.internal.catalog.WidgetCatalog",
				"com.ibm.team.dashboard.web.ui.internal.catalog.CatalogServicesProvider",
				"com.ibm.team.dashboard.web.ui.internal.catalog.AddWidgetHelper"
			], dojo.hitch(this, function() {
				this._serviceProvider = new com.ibm.team.dashboard.web.ui.internal.catalog.CatalogServicesProvider({
					compatibilityMode: this.compatibilityMode
				});
				this._catalog = new jazz.ensemble.internal.catalog.WidgetCatalog({
					provider: this._serviceProvider,
					onAddWidget: dojo.hitch(this,this._addWidget)
				}).placeAt(this.domNode, "only");
				this._addWidgetHelper = new com.ibm.team.dashboard.web.ui.internal.catalog.AddWidgetHelper({
					onAddWidget: onAddWidget
				});
			}));
		}
		this.onAddWidget = onAddWidget;
	},
	_addWidget: function(data, rootServices, local) {
		return this._addWidgetHelper.addWidget(data, rootServices, local);  // returns a deferred
	},
	destroy: function() {
		this._catalog&&this._catalog.destroy();
		this._serviceProvider&&this._serviceProvider.destroy();
		if (this._addWidgetHelper) {
			this._addWidgetHelper.destroy();
			delete this._addWidgetHelper;
		}
		this.inherited(arguments);
	}
});
})();