/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.CollapsibleSection"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.CollapsibleSection", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/CollapsibleSection.html"), //$NON-NLS-1$ //$NON-NLS-2$
		isExpand: true,
		title: "", //$NON-NLS-1$
		constructor: function(args) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			this.inherited(arguments);
			this.setTitle(this.title);
			this.toggleSection(this.isExpand);
		},
		
		setTitle: function(title) {
			dojo.empty(this._sectionTitleBar);
			this._sectionTitleBar.appendChild(document.createTextNode(title));
		},
		
		_onClick: function(evt) {
			this.isExpand = !this.isExpand;
			this.toggleSection(this.isExpand);
		},
		
		toggleSection: function(isExpand) {
			dojo.toggleClass(this._contentNode, "hide", !isExpand); //$NON-NLS-1$
			dojo.attr(this.sectionTitleBar, "expanded", "" + this.isExpand); //$NON-NLS-1$  //$NON-NLS-2$
		},
		
		setContent: function(widget) {
			if (this.content) {
				dojo.empty(this._contentNode);
				this.content.destroyRecursive();
			}
			this.content = widget;
			this._contentNode.appendChild(widget.domNode);
		},
		
		uninitialize: function() {
			if (this.content) {
				this.content.destroyRecursive();
			}
			this.inherited(arguments);
		}
	});
	
})();
