/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.ContentEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.Section"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("jazz.ui.SimpleToolbar"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.InlineEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeElementLanguageDialog"); //$NON-NLS-1$
	dojo.require("dijit.form.SimpleTextarea"); //$NON-NLS-1$
	dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionDetailEditor"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var Section = com.ibm.team.process.authoring.web.common.ui.internal.editors.Section;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var InlineEditor = com.ibm.team.process.authoring.web.common.ui.internal.editors.InlineEditor;
	var ProcessDescriptionDetailEditor = com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionDetailEditor;
	var PracticeElementLanguageDialog = com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeElementLanguageDialog;
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.ContentEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/ContentEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
		sections: null,
		practiceResource: null,
		practiceElementData: null,
		practiceTitle: "", //$NON-NLS-1$
		practiceElementDescription: ProcessAuthoringConstants.EMPTY,
		practiceElementLanguage: "en", //$NON-NLS-1$
		item: null,
		isNewNode: false,
		practiceElementURL: null,
		workingCopy: null,
		editToolBar: null,
		initializedCallback: null,
		editPractice: false,
		controller: null,
		subscriptionHandles: null,
		isSharedElement: false,
		messageBox: null,
		attachmentSections: null,
		
		constructor: function(args) {
			this.sections = [];
			this.attachmentSections = [];
			if (!args) {
				return;
			}
			
			this._navigateIconSrc = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/navigate-button.gif"); //$NON-NLS-1$ //$NON-NLS-2$						
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.initializedCallback = new dojo.Deferred();
            this.isSharedElement = args.item.root ? args.item.isSharedElement : args.item._S.getValue(args.item, "isSharedElement"); //$NON-NLS-1$
		},
		
		postCreate: function() {
			this.inherited(arguments);
			this.titleArea = new InlineEditor({
				disabled: this.editPractice,
				onChange: dojo.hitch(this, this._titleOnChange),
				onBlur: dojo.hitch(this, this._titleOnBlur),
				title: this.messages.ContentEditor_6
			}, this.titleArea);
			
			this.practiceElementURL = this.item.resource + ""; //$NON-NLS-1$
			//prepare detail data
			if (this.practiceElementData) {
				if (!this.editPractice) {
					this.titleArea.set('disabled', this.isViewMode()); //$NON-NLS-1$
				} 
				this.practiceElementDescription = UIHelper.getPracticeElementDescription(this.practiceElementData);
				this.practiceElementLanguage = this.workingCopy.currentLanguage;
				var languages = UIHelper.getLanguages(this.practiceElementData);
				if (languages) {
					languages = languages.split(','); //$NON-NLS-1$
					this.workingCopy.updateLanguagesById(this.item.id, languages);
				}
				this.initializeSections();
			} else {
				this.practiceElementDescription = ProcessAuthoringConstants.EMPTY;
			}
			
			//create detail section
			this.descriptionArea = new ProcessDescriptionDetailEditor({
				descriptionContent: this.practiceElementDescription, //$NON-NLS-1$
				viewOnly: this.viewOnly,
				viewMode: this.isViewMode(),
				container: this,
				containerType: ProcessAuthoringConstants.DETAILEDITOR_CONTAINER_PRACTICECONTENT,
				hideLanguage: true
			}, this.descriptionArea);
			this.descriptionArea.setLanguage(this.getFullLanguage(this.practiceElementLanguage));
			this.connect(this.descriptionArea.description, "onkeyup", "_descriptionOnChange"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.descriptionArea.description, "onchange", "_descriptionOnChange"); //$NON-NLS-1$ //$NON-NLS-2$

			if (this.item) {
				this.practiceTitle = '' + this.item.label; //$NON-NLS-1$
				// record the initial practice title after the page was loaded. 
				this.initialPracticeTitle = '' + this.item.label; //$NON-NLS-1$
				this.titleArea.set("value", this.practiceTitle); //$NON-NLS-1$  
			}
			this.setupWarning();			
			setTimeout(dojo.hitch(this, function() {
				this.initializedCallback.callback();
                
                if (this.isNewNode) {
					this.viewOnly = false;
                	this.titleArea.edit();
                }
			}), 100);
			
			if (!this.viewOnly) { //this is for the content of practice in non-shared pane 
				this.initialToolbar();
			}
			//subscribe edit mode event for viewOnly content. This is to display message
            // subscribe mode event
            this.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_VIEWMODE, function() {
              	this.toggleEditViewMode(true);
            });
            this.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_EDITMODE, function() {
               	this.toggleEditViewMode(false);
            });
			
			this.toggleEditViewMode(this.isViewMode());			
		},

		isViewOnly: function() {
			return this.viewOnly;
		},
				
		isViewMode: function() {
			return this.controller.viewMode;
		},
		
		getFullLanguage: function(lang) {
			var langDesc = null;
			if (this.workingCopy.languageList != undefined) {
				dojo.some(this.workingCopy.languageList, function(language) {
					if (language.langCode === lang) {
						langDesc = language.label;
						return true;
					}
					return false;
				}, this);
			}
			if (langDesc == null) {
				langDesc = lang;
			}
			return langDesc;
		},
		
		addInitializedCallback: function(callback) {
			this.initializedCallback.addCallback(callback);
		},
		
		initializeSections: function() {
			dojo.forEach(UIHelper.getSections(this.practiceElementData), function(sectionNode) {
				var section = new Section({
					controller: this,
					sectionData: sectionNode
				});
				this.contentSection.appendChild(section.domNode);
				this.sections.push(section);
			}, this);
		},
		
		_onAddButtonClick: function(evt) {
			dojo.stopEvent(evt);
			var section = new Section({
				controller: this,
				newCreated: true
			});
			this.contentSection.appendChild(section.domNode);
			this.sections.push(section);
			this._setChange();
			this.resizeEditor();
		},
		
		resizeEditor: function() {
			this.controller.resizeEditor(this);
		},
		
		toggleEditViewMode: function(toViewMode) {
			//shared element in PLM should display message in edit mode
			//process description editor is viewOnly only when it's associated to a project area
            if (this.isViewOnly() && this.isSharedElement && !this.controller.viewOnly) {
            	dojo.toggleClass(this.longMessageBox, ProcessAuthoringConstants.CSS_HIDE, toViewMode);
            }
			var view = toViewMode || this.isViewOnly();
            dojo.toggleClass(this.editBar, "hide", view); //$NON-NLS-1$
            this.titleArea.set("disabled", view || this.editPractice); //$NON-NLS-1$
		},
		
		initialToolbar: function() {
			this.editToolBar = new jazz.ui.SimpleToolbar({});
			this.editBar.appendChild(this.editToolBar.domNode);
			
			this.editToolBar.addButton(this, dojo.hitch(this, this._onAddButtonClick), {
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/add-section_co.gif"), //$NON-NLS-1$  //$NON-NLS-2$
				label: this.messages.ContentEditor_0
			});
		},
		
		removeSection: function(section) {
			this.sections.splice(dojo.indexOf(this.sections, section), 1);
			section.destroyRecursive();
			this._setChange();
			this.resizeEditor();
		},
		
		moveUpSection: function(section) {
			var index = dojo.indexOf(this.sections, section);
			if (index !== 0) {
				var prev = section.domNode.previousSibling;
				if (prev) {
					dojo.place(section.domNode, prev, "before"); //$NON-NLS-1$
					var otherSection = this.sections[index - 1];
					this.sections[index] = otherSection;
					this.sections[index - 1] = section;
					this._setChange();
				}
			}
		},
		
		moveDownSection: function(section) {
			var index = dojo.indexOf(this.sections, section);
			if (index !== (this.sections.length - 1)) {
				var next = section.domNode.nextSibling;
				if (next) {
					dojo.place(section.domNode, next, "after"); //$NON-NLS-1$
					var otherSection = this.sections[index + 1];
					this.sections[index] = otherSection;
					this.sections[index + 1] = section;
					this._setChange();
				}
			}
		},
		
		_titleOnChange: function(value) {
			if (this.practiceTitle != value) {   //$NON-NLS-1$
				this.practiceTitle = value;
				if (this.item.root) {//practice
					this.item.label = value;
					this.item.store.onChange(this.item);
				} else { //practice element
					this.item._S.setValue(this.item, "label", value); //$NON-NLS-1$
				}
				this._setChange();
			}
		},
		
		_titleOnBlur: function(value) {
			if (value === '') { //$NON-NLS-1$
				if (this.item.root) { //practice
					this.practiceTitle = this.initialPracticeTitle ? this.initialPracticeTitle : this.messages.AbstractPracticesEditor_2;
					this.item.label = this.practiceTitle;
					this.item.store.onChange(this.item);
				 	this.titleArea.set("value", this.practiceTitle); //$NON-NLS-1$
				} else {   //practice element
					this.practiceTitle = this.initialPracticeTitle ? this.initialPracticeTitle : this.messages.AbstractPracticesEditor_3;
					this.item._S.setValue(this.item, "label", this.practiceTitle); //$NON-NLS-1$
					this.titleArea.set("value", this.practiceTitle); //$NON-NLS-1$
				}
				this._setChange();
			}
		},
		
		_descriptionOnChange: function(e) {
			var value = this.descriptionArea.getDescription();
			if (!value) {
				value = ""; //$NON-NLS-1$
			}
			if (this.practiceElementDescription !== value) {
				this.practiceElementDescription = value;
				this._setChange();
			}
		},
		
		_setChange: function() {
			var data = this.getXML();
			if (this.item.root ) { //for practice,pass resource url 
				this.onChange(this.practiceResource, data);
			} else {
				this.onChange(this.item, data);
			}
		},
		
		onChange: function(item, data) {
		
		},
		
		getXML: function() {
			//in practice editor, the title and description are retrieved from PracticeEditor.
			var params = {};
			if (this.controller && this.editPractice) {
				params.title = this.controller.practiceName;
				params.description = this.controller.practiceDescription;
			} else {
				params.title = this.practiceTitle;
				params.description = this.practiceElementDescription;
			}
			
			var elementName = this.item.root ? "Practice" : "PracticeElement"; //$NON-NLS-1$ //$NON-NLS-2$
			var data = "<${0} xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/terms/\" xml:lang=\"" + this.practiceElementLanguage + "\"><presentation-type>description</presentation-type><dc:title>"; //$NON-NLS-1$ //$NON-NLS-2$
			data += UIHelper.escapeXML(params.title);
			data += "</dc:title><dc:description>"; //$NON-NLS-1$
			data += UIHelper.escapeXML(params.description);
			data += "</dc:description>"; //$NON-NLS-1$
			data += "<presentation rdf:parseType=\"Literal\">"; //$NON-NLS-1$
			if (this.sections.length > 0) {
				dojo.forEach(this.sections, function(section) {
					data += section.getXML();
				});
			}
			data += "</presentation>"; //$NON-NLS-1$
			data += "</${0}>"; //$NON-NLS-1$
			return dojo.string.substitute(data, [elementName]);
		},
		
		getCurrentLanguage: function() {
			return this.practiceElementLanguage;
		},
		
		getEditing: function() {
			var isEditing = false;
			dojo.some(this.sections, function(section) {
				if (section.getEditing()) {
					isEditing = true;
					return true;
				}
				return false;
			});
			return isEditing;
		},
		
		doCommit: function() {
			dojo.forEach(this.sections, function(section) {
				section.doCommit();
			});
		},
		
		resize: function() {
		},
		
		reload: function(data, ETag) {
			this.clean();
			this.ETag = ETag;
			this.practiceElementData = data;
			this.titleArea.set("value", UIHelper.getPracticeElementTitle(this.practiceElementData)); //$NON-NLS-1$
			this.practiceElementDescription = UIHelper.getPracticeElementDescription(this.practiceElementData);
			this.practiceElementLanguage = UIHelper.getLanguage(this.practiceElementData);
			this.descriptionArea.setDescription(this.practiceElementDescription);
			this.descriptionArea.setLanguage(this.getFullLanguage(this.practiceElementLanguage));
			this.workingCopy.setCurrentLanguage(this.item.id, this.practiceElementLanguage);
			this.initializeSections();
		},
		
		clean: function() {
			dojo.forEach(this.sections, function(section) {
				section.destroyRecursive();
			}, this);
			this.sections = [];
		},
		
		setupWarning: function(){
			//setup warning message
			this.messageBox = new jazz.ui.MessageBox();
			UIHelper.setReadOnlyWarning(this);
			this.longMessageBox.appendChild(this.messageBox.domNode);
		},

		onNavigateSharedPractice: function(e){
			dojo.stopEvent(e);
			this.controller.onNavigateSharedPractice(this.practiceResource);
		},
		
		addAttachmentSection: function(attachmentSection) {
			this.attachmentSections.push(attachmentSection);
		},	
		
		uninitialize: function() {
			dojo.forEach(this.sections, function(section) {
				section.destroyRecursive();
			}, this);
			
            dojo.forEach(this.attachmentSections, function(section) {
            	section.destroyRecursive();
            }, this);
			
			if (this.editToolBar) {
				this.editToolBar.destroyRecursive();
			}
			if (this.titleArea) {
				this.titleArea.destroyRecursive();
			}
			
			if (this.descriptionArea) {
				this.descriptionArea.destroyRecursive();
			}
            
            if (this.messageBox) {
            	this.messageBox.destroyRecursive();
            }
			
			this.inherited(arguments);
		}
	});
	
})();
