/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.MoveDialog"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dijit.form.ComboBox"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dojo.io.iframe"); //$NON-NLS-1$
	dojo.require("dojox.uuid"); //$NON-NLS-1$
	dojo.require("dojox.uuid.generateTimeBasedUuid"); //$NON-NLS-1$
	dojo.require("jazz.ui.Dialog");//$NON-NLS-1$
	dojo.require("dijit.form.CheckBox"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeTreePane"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeTree"); //$NON-NLS-1$	
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var PracticeTreePane = com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeTreePane;
	var PracticeTree = com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeTree;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.MoveDialog", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/MoveDialog.html"),//$NON-NLS-1$ //$NON-NLS-2$ 
		widgetsInTemplate: true,
		controller: null,  //AbstractPracticeEditor
		sourceTree: null,  //PracticeTree
		sourceItem: null,
		oldParentItem: null,
		title: null,
		workingCopy: null,
		
		constructor: function(args) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			var titleMsg = null;
			var headerMessage = null;
			if (this.sourceItem.root === true) {
				titleMsg = this.messages.MoveDialog_11;
				headerMessage = dojo.string.substitute(this.messages.MoveDialog_0_1, [this.messages.MoveDialog_8, this.sourceItem.label])
			} else if (this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY) {
				titleMsg = this.messages.MoveDialog_12;
				headerMessage = dojo.string.substitute(this.messages.MoveDialog_0_2, [this.messages.MoveDialog_9, this.sourceItem.label])
			} else if (this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT) {
				titleMsg = this.messages.MoveDialog_13;
				headerMessage = dojo.string.substitute(this.messages.MoveDialog_0_3, [this.messages.MoveDialog_10, this.sourceItem.label])
			}
			this.topMessage.appendChild(document.createTextNode(headerMessage));
			
			this.dialog = new jazz.ui.Dialog({
				contentNode: this.contentNode,
				primaryTitle: titleMsg,
				destroyContents: true
			});
			
			this.targetMessage.appendChild(document.createTextNode(dojo.string.substitute(this.messages.MoveDialog_1, [this.sourceItem.label])));
			
			var maxWidth = 0;
			if (this.sourceItem.root !== true) {
				this.parent = new dijit.form.RadioButton({
					checked: true,
					value: "parent", //$NON-NLS-1$
					name: "location", //$NON-NLS-1$
					onClick: dojo.hitch(this, function() {
						this.checkButtonEnabled();
					})
				}, ""); //$NON-NLS-1$
				var radioSpan = this.createRadioSpan();
				radioSpan.appendChild(this.parent.domNode);
				radioSpan.appendChild(document.createTextNode(this.messages.MoveDialog_7));
				this.targetLocation.appendChild(radioSpan);
				var spanWidth = dojo.style(radioSpan, "width");  //$NON-NLS-1$
				spanWidth += dojo.style(radioSpan, "paddingRight"); //$NON-NLS-1$
				if(spanWidth && spanWidth > maxWidth){
					maxWidth = spanWidth;
				}
			}
			this.before = new dijit.form.RadioButton({
				checked: this.parent ? false : true,
				value: "before", //$NON-NLS-1$
				name: "location", //$NON-NLS-1$
				onClick: dojo.hitch(this, function() {
					this.checkButtonEnabled();
				})
			}, "");     //$NON-NLS-1$
			var radioSpan = this.createRadioSpan();
			radioSpan.appendChild(this.before.domNode);
			radioSpan.appendChild(document.createTextNode(this.messages.MoveDialog_2));
            this.targetLocation.appendChild(radioSpan);
            var spanWidth = dojo.style(radioSpan, "width"); //$NON-NLS-1$
            spanWidth += dojo.style(radioSpan, "paddingRight"); //$NON-NLS-1$
            if (spanWidth && spanWidth > maxWidth) {
            	maxWidth = spanWidth;
            }

			this.after = new dijit.form.RadioButton({
				checked: false,
				value: "after", //$NON-NLS-1$
				name: "location", //$NON-NLS-1$
				onClick: dojo.hitch(this, function() {
					this.checkButtonEnabled();
				})
			}, "");     //$NON-NLS-1$
			var radioSpan = this.createRadioSpan();
			radioSpan.appendChild(this.after.domNode);
			radioSpan.appendChild(document.createTextNode(this.messages.MoveDialog_3));
			this.targetLocation.appendChild(radioSpan);
			var spanWidth = dojo.style(radioSpan, "width"); //$NON-NLS-1$
			spanWidth += dojo.style(radioSpan, "paddingRight"); //$NON-NLS-1$
            if (spanWidth && spanWidth > maxWidth) {
            	maxWidth = spanWidth;
            }
			var targetLocationWidth = dojo.style(this.targetLocation, "width"); //$NON-NLS-1$
			var otherBorderAndPaddingWidth = this.dialog.domNode.clientWidth - targetLocationWidth;
		    this.dialog.domNode.style.minWidth = maxWidth + otherBorderAndPaddingWidth + "px";   //$NON-NLS-1$
			
			//load practice tree
			this.treeContainer = new PracticeTreePane({
				isPlainTree: true,
                rootOnly: this.sourceItem.root === true ? true : false,
				controller: this
			});
			
			dojo.removeClass(this.treeContainer.treeSection, "content"); //$NON-NLS-1$
			dojo.addClass(this.treeContainer.treeSection, "treeSection"); //$NON-NLS-1$
			
			if (this.sourceTree.editPractice) {
				var practice = this.workingCopy.getNodeById(this.sourceTree.practiceResource).practice;
				this.workingCopy.getTreeJsonArray(practice, dojo.hitch(this, function(treeData) {
					//remove source item in tree data
					var sourceId = null;
					if (this.sourceItem.id instanceof Array) {
						sourceId = this.sourceItem.id[0];
					} else {
						sourceId = this.sourceItem.id;
					}
					for (var i = 0; i < treeData.items.length; i++) {
						var item = treeData.items[i];
						if (sourceId == item.id) {
							treeData.items.splice(i, 1);
							break;
						} else if (item.type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY) {
							if (this.removeSourceItemInTreeData(this.sourceItem, item)) {
								break;
							}
						}
					}
                    var tree = this._createPracticeTree(treeData, this.treeContainer, true);
					this.treeContainer.addPracticeTree(tree);
				}), false);
			} else {
				if (this.sourceItem.root === true) {
					dojo.forEach(this.workingCopy.processDescription.model.practiceList, function(practice, idx) {
						var practiceNode = this.workingCopy.getNodeById(practice.url).practice;
						if (practiceNode.resource != this.sourceTree.practiceResource) {
							this.workingCopy.getTreeJsonArray(practiceNode, dojo.hitch(this, function(treeData) {
								treeData.items = [];
                                var tree = this._createPracticeTree(treeData, this.treeContainer, practice.shared === "true"); //$NON-NLS-1$
								tree.indexInParent = idx;
								this.treeContainer.addPracticeTree(tree);
							}), false);
						}
					}, this);
				} else {
					dojo.forEach(this.workingCopy.processDescription.model.practiceList, function(practice) {
						if (this.sourceTree.practiceResource == practice.url) {
							var practiceNode = this.workingCopy.getNodeById(practice.url).practice;
							this.workingCopy.getTreeJsonArray(practiceNode, dojo.hitch(this, function(treeData) {
								//remove source item in tree data
								var sourceId = null;
								if (this.sourceItem.id instanceof Array) {
									sourceId = this.sourceItem.id[0];
								} else {
									sourceId = this.sourceItem.id;
								}
								for (var i = 0; i < treeData.items.length; i++) {
									var item = treeData.items[i];
									if (sourceId == item.id) {
										treeData.items.splice(i, 1);
										break;
									} else if (item.type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY) {
										if (this.removeSourceItemInTreeData(this.sourceItem, item)) {
											break;
										}
									}
								}
                                var tree = this._createPracticeTree(treeData, this.treeContainer, practice.shared === "true"); //$NON-NLS-1$
								this.treeContainer.addPracticeTree(tree);
							}), false);
						}
					}, this);
				}
			}
			
			this.targetTree.appendChild(this.treeContainer.domNode);
			
			this.connect(this.cancelButton, "onclick", function(e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				if (window.stop) {
					window.stop();
				}
				this.dialog.close();
			});
			
			this.connect(this.okButton, "onclick", "_onOk"); //$NON-NLS-1$ //$NON-NLS-2$ 
		},
	     
		createRadioSpan: function() {
			var radioSpan = document.createElement("span"); //$NON-NLS-1$
			radioSpan.style.whiteSpace = "nowrap" ;  //$NON-NLS-1$
			radioSpan.style.display = "inline-block";  //$NON-NLS-1$
			radioSpan.style.paddingRight = "1em";  //$NON-NLS-1$
			return radioSpan;
		},
			
		checkButtonEnabled: function() {
			if (this.treeContainer && this.treeContainer.selectedNode) {
				var item = this.treeContainer.selectedNode.item;
				if (item.type == ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT) {
					if ((!this.parent.checked) && (this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT || this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY)) {
						this.okButton.disabled = false;
					} else {
						this.okButton.disabled = true;
					}
				} else if (item.type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY) {
					if (this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY || this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT) {
						this.okButton.disabled = false;
					} else {
						this.okButton.disabled = true;
					}
				} else if (item.root === true) {
					if (this.sourceItem.root === true || this.sourceItem.root !== true && this.parent.checked) {
						this.okButton.disabled = false;
					} else {
						this.okButton.disabled = true;
					}
				}
			}
		},
		
	    removeSourceItemInTreeData: function(sourceItem, sourceNode) {
			for (var k = 0; k < sourceNode.children.length; k++) {
				var sourceId = null;
				if (sourceItem.id instanceof Array) {
					sourceId = sourceItem.id[0];
				} else {
					sourceId = sourceItem.id;
				}
				var targetId = null;
				if (sourceNode.children[k].id instanceof Array) {
					targetId = sourceNode.children[k].id[0];
				} else {
					targetId = sourceNode.children[k].id;
				}
				if (sourceId == targetId) {
					sourceNode.children.splice(k, 1);
					return true;
				} else if (sourceNode.children[k].type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY) {
					var value = this.removeSourceItemInTreeData(sourceItem, sourceNode.children[k]);
					if (value) {
						return value;
					}
				}
			}
			return false;
		},
		
		_onOk: function(e) {
			if (e) {
				dojo.stopEvent(e);
			}
			this.onOk();
		},
		
		onOk: function() {
			var selectedTargetNode = this.treeContainer.selectedNode;
			var selectedTargetItem = selectedTargetNode.item;
			var newParentItem = null;
			var selectedTargetIndex = -1;
			var targetResource = null;
			var sourceResource = null;
			if (this.parent && this.parent.checked) {
				//position = "over"; //$NON-NLS-1$ 
				//change the structure of the tree node
				selectedTargetIndex = selectedTargetItem.children.length;
				
				// get new parent item in source tree
				if (selectedTargetItem.root === true) {
					this.sourceTree.treeContainer.getItem(this.sourceTree.practiceResource, null, dojo.hitch(this, function(item, tree) {
						newParentItem = item;
					}));
				} else {
					this.sourceTree.treeContainer.getItem(this.sourceTree.practiceResource, selectedTargetItem, dojo.hitch(this, function(item, tree) {
						newParentItem = item;
					}));
				}
				
				if (this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT && selectedTargetItem.type != ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT) {
					this.controller.onMoveNode(this.sourceItem, this.oldParentItem, newParentItem, selectedTargetIndex, this.sourceTree);
				} else if (this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY && selectedTargetItem.type != ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT) {
					if (this.sourceItem.id != selectedTargetItem.id) {
						this.okButton.disabled = false;
					}
					this.controller.onMoveNode(this.sourceItem, this.oldParentItem, newParentItem, selectedTargetIndex, this.sourceTree);
				}
			} else {
				//reorder
				selectedTargetIndex = this.treeContainer.selectedNodeItemIndex;
				if (this.before.checked) {
					//position = "before"; //$NON-NLS-1$ 
				} else {
					//position = "after"; //$NON-NLS-1$ 
					selectedTargetIndex = selectedTargetIndex + 1;
				}
				
				// get new parent item in source tree
				if (selectedTargetItem.root !== true) {
					if (selectedTargetNode.getParent().item.root === true) {
						this.sourceTree.treeContainer.getItem(this.sourceTree.practiceResource, null, dojo.hitch(this, function(item, tree) {
							newParentItem = item;
						}));
					} else {
						this.sourceTree.treeContainer.getItem(this.sourceTree.practiceResource, selectedTargetNode.getParent().item, dojo.hitch(this, function(item, tree) {
							newParentItem = item;
						}));
					}
				}
				
				if (this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT && selectedTargetItem.root !== true) {
					this.controller.onMoveNode(this.sourceItem, this.oldParentItem, newParentItem, selectedTargetIndex, this.sourceTree);
				} else if (this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY && selectedTargetItem.root !== true) {
					this.controller.onMoveNode(this.sourceItem, this.oldParentItem, newParentItem, selectedTargetIndex, this.sourceTree);
				} else if (this.sourceItem.root === true && selectedTargetItem.root === true) { //practices reorder
					sourceResource = this.sourceItem.id;
					this.controller.onReorderPractice(this.sourceTree.treeContainer, sourceResource, selectedTargetIndex);
				} else {
				//TODO show error message
				}
			}
			this.dialog.close();
		},
		
		/**
		 * Creates a new practice tree for this MoveDialog.
		 * 
		 * @param {Object} practiceJsonData
		 * @param {Object} treeContainer
		 * @param {Object} isShared
		 * @return a new practice tree
		 */
		_createPracticeTree: function(practiceJsonData, treeContainer, isShared) {
			var dataStore = new dojo.data.ItemFileWriteStore({
				data: practiceJsonData
			});
			var model = new dijit.tree.ForestStoreModel({
				rootLabel: practiceJsonData.title,
				store: dataStore,
				childrenAttr: ["children"] //$NON-NLS-1$
			});
			var practiceTree = new PracticeTree({
				viewOnly: true,
				rootOnly: this.sourceItem.root,
				treeContainer: treeContainer,
				isSharedTree: isShared, //shared practice tree pane is view only
				model: model,
				isNew: practiceJsonData.isNew,
				practiceResource: practiceJsonData.resource,
				onSelectNode: dojo.hitch(this, this._onSelectNode),
			}, document.createElement("div")); //$NON-NLS-1$
			return practiceTree;
		},
		
		/**
		 * @see PracticeTree.onSelectNode
		 */
		_onSelectNode: function(/* dojo.data */item, /*TreeNode*/ node, practiceTree) {
			if (item.type == ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT) {
				if ((!this.parent.checked) && (this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT || this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY)) {
					this.okButton.disabled = false;
				} else {
					this.okButton.disabled = true;
				}
				this.treeContainer.selectedNode = node;
				this.treeContainer.selectedNodeItemIndex = node.getIndexInParent();
			} else if (item.type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY) {
				if (this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY || this.sourceItem.type == ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT) {
					this.okButton.disabled = false;
				} else {
					this.okButton.disabled = true;
				}
				this.treeContainer.selectedNode = node;
				this.treeContainer.selectedNodeItemIndex = node.getIndexInParent();
			} else if (item.root === true) {
				if (this.sourceItem.root === true || this.sourceItem.root !== true && this.parent.checked) {
					this.okButton.disabled = false;
				} else {
					this.okButton.disabled = true;
				}
				this.treeContainer.selectedNode = node;
				this.treeContainer.selectedNodeItemIndex = dojo.indexOf(this.treeContainer.trees, practiceTree);
			}
		},
			
		uninitialize: function() {
			this.inherited(arguments);
		}
	});
})();
