/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.PlainTextField"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.InlineEditor"); //$NON-NLS-1$
	dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$
	dojo.require("dojo.string"); //$NON-NLS-1$
	dojo.require("dojo.html"); //$NON-NLS-1$
	dojo.require("jazz.util.html"); //$NON-NLS-1$
	dojo.require("jazz.ui.SimpleToolbar"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var InlineEditor = com.ibm.team.process.authoring.web.common.ui.internal.editors.InlineEditor;
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.PlainTextField", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/PlainTextField.html"), //$NON-NLS-1$ //$NON-NLS-2$
		isEditing: false,
		controller: null,
		fieldData: null,
		name: null,
		fieldValue : null,
		editToolBar: null,
		subscriptionHandles: null,
		newCreated: false,
		richTextCopy: null, //this value stores the original value when switching from richtext field
		
		constructor: function(args) {
			if (!args) {
				return;
			}
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			this.inherited(arguments);
			
			this.titleArea = new InlineEditor({
				noValueIndicator: this.messages.RichTextField_4,
				onChange: dojo.hitch(this, this._titleOnChange)
			}, this.titleArea);
			
			if (this.fieldData) {
				this.newCreated = UIHelper.isNewCreated(this.fieldData);
				this.name = UIHelper.getFieldName(this.fieldData);
				this.fieldID = UIHelper.getNodeId(this.fieldData);
				this.titleArea.set("value", UIHelper.getFieldLabel(this.fieldData)); //$NON-NLS-1$
				this.titleArea.set('disabled', this.isViewMode() || this.isViewOnly()); //$NON-NLS-1$
				this.setFieldValue(UIHelper.getFieldText(this.fieldData));
			} else {
				this.setFieldValue(ProcessAuthoringConstants.EMPTY);
			}

			if (!this.isViewOnly()) {
				this.initialToolbar();
                this.connect(this.switchField, ProcessAuthoringConstants.EVENT_CLICK, this._onSwitchField);
                this.connect(this.textEditor, ProcessAuthoringConstants.EVENT_BLUR, this._onEditorBlur);
                this.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_VIEWMODE, this._previewMode); //$NON-NLS-1$
                this.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_EDITMODE, this._editMode); //$NON-NLS-1$
                
                if (this.newCreated) {
                	this.edit();
                	this.editHandler = this.connect(this.previewArea, ProcessAuthoringConstants.EVENT_CLICK, this._onEdit);
                } else {
                	this.isViewMode() ? this._previewMode() : this._editMode();
                }
                if (dojo.isIE) {
                	this.connect(this.textEditor, "onpropertychange", this._onInput); //$NON-NLS-1$
                } else {
                	this.connect(this.textEditor, "oninput", this._onInput); //$NON-NLS-1$
                }
			} else {
				this._previewMode();
			}
		},
		
		_titleOnChange: function(value) {
			this._setChange();
		},
		
		edit: function() {
			dojo.toggleClass(this.previewArea, "hide", true); //$NON-NLS-1$
			dojo.toggleClass(this.editArea, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.editBar, "hide", true); //$NON-NLS-1$
			dojo.toggleClass(this.saveBar, "hide", false); //$NON-NLS-1$
			this.isEditing = true;
			// show save/cancel button in editing mode
			dojo.toggleClass(this.toobarArea, "hide", false); //$NON-NLS-1$
			
			setTimeout(dojo.hitch(this, function(){
				this.textEditor.focus();
				this.resizeEditor();
				this.controller.resizeEditor();
			}), 100);
		},
		
		_onEdit: function(evt) {
			this.edit();
			dojo.stopEvent(evt);
			this.resizeEditor();			
		},
		
		_onSave: function(evt) {
			this.commitChange();
			dojo.stopEvent(evt);
		},
		
		_onInput: function(evt) {
			this.resizeEditor();
			dojo.stopEvent(evt);
		},

		_onSwitchField: function(e) {
            dojo.stopEvent(e);
            this.controller.switchField(this);
		},
		
		_onEditorBlur: function(e) {
			if ( this.fieldValue !== this.textEditor.value ) {
				this._setChange();
			}
		},		

		resizeEditor: function() {
			if (this.textEditor.scrollHeight + "px" === dojo.style(this.textEditor, "height")) { //$NON-NLS-1$ //$NON-NLS-2$
				return;
			}
			if (this.textEditor.scrollHeight < 100) {
				dojo.style(this.textEditor, "height", "100px"); //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				dojo.style(this.textEditor, "height", this.textEditor.scrollHeight + "px"); //$NON-NLS-1$ //$NON-NLS-2$
			}
			this.controller.resizeEditor();
		},		
		
		commitChange: function() {
			dojo.toggleClass(this.previewArea, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.previewArea, "previewField", !this.isViewMode()); //$NON-NLS-1$
			dojo.toggleClass(this.editArea, "hide", true); //$NON-NLS-1$
			dojo.toggleClass(this.editBar, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.saveBar, "hide", true); //$NON-NLS-1$
			if ( this.fieldValue !== this.textEditor.value ) {
				this.setFieldValue(this.textEditor.value);
				this._setChange();
			}
			
			this.isEditing = false;
			this.richTextCopy = null; //invalidate richtext copy once apply button is clicked
			dojo.toggleClass(this.toobarArea, "hide", true); //$NON-NLS-1$
			
			// If content changed (from rich text field), 
			// e.g. "<a href="http://jazz.net">jazz</a>" changed to "jazz"  
			// then we need to change plain text field in other languages 
			// in working copy.
			if (this.contentChanged) {
				var resourceId;
				var practice;
				if (this.controller.controller.item.root) { //practice
					resourceId = this.controller.controller.item.id; //$NON-NLS-1$
					practice = this.controller.controller.workingCopy.getNodeById(resourceId).practice;
				} else { //practice element
					resourceId = this.controller.controller.item.id + ""; //$NON-NLS-1$
					practice = this.controller.controller.workingCopy.getNodeById(resourceId).node;
				}
				if (practice) {
					for (var lang in practice.languages) {
						var fieldInWorkingCopy = practice.languages[lang].textContent[this.fieldID];
						if (fieldInWorkingCopy && fieldInWorkingCopy["value"] && fieldInWorkingCopy["value"] !== UIHelper.getPlainText(UIHelper.unescapeXML(fieldInWorkingCopy["value"]))) { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
							fieldInWorkingCopy["value"] = UIHelper.getPlainText(UIHelper.unescapeXML(fieldInWorkingCopy["value"])); //$NON-NLS-1$  //$NON-NLS-2$
						}
					}
				}
			}
		},
		
		_onCancel: function(evt) {
			this.cancelEditing();
			dojo.stopEvent(evt);
		},
		
		cancelEditing: function() {
			dojo.toggleClass(this.previewArea, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.previewArea, "previewField", !this.isViewMode()); //$NON-NLS-1$
			dojo.toggleClass(this.editArea, "hide", true); //$NON-NLS-1$
			dojo.toggleClass(this.editBar, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.saveBar, "hide", true); //$NON-NLS-1$
			this.textEditor.value = this.fieldValue;
			this.isEditing = false;
			dojo.toggleClass(this.toobarArea, "hide", true); //$NON-NLS-1$
		},
		
		_onMoveUpButtonClick: function(evt) {
			this.controller.moveUpField(this);
			dojo.stopEvent(evt);
		},
		_onMoveDownButtonClick: function(evt) {
			this.controller.moveDownField(this);
			dojo.stopEvent(evt);
		},
		_onDeleteButtonClick: function(evt) {
			this.controller.removeField(this);
			dojo.stopEvent(evt);
		},
		initialToolbar: function() {
			this.editToolBar = new jazz.ui.SimpleToolbar({});
			this.editBar.appendChild(this.editToolBar.domNode);
			
			this.editToolBar.addButton(this, dojo.hitch(this, this._onMoveUpButtonClick), {
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/up-button.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				label: this.messages.PlainTextField_0
			});
			this.editToolBar.addButton(this, dojo.hitch(this, this._onMoveDownButtonClick), {
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/down-button.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				label: this.messages.PlainTextField_1
			});
			this.editToolBar.addButton(this, dojo.hitch(this, this._onDeleteButtonClick), {
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/delete-button.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				label: this.messages.PlainTextField_3
			});
		},
		_previewMode: function() {
			if (this.isEditing) {
				this.cancelEditing();
			}

			// hide text if it is empty
			var isEmptyText = this._isEmptyText();
			var isEmptyTitle = this._isEmptyTitle();
			if (isEmptyTitle && isEmptyText) {
				dojo.toggleClass(this.fieldArea, "hide", true); //$NON-NLS-1$
			} else {
				dojo.toggleClass(this.domNode, "preview", true); //$NON-NLS-1$
				
				// hide content area if the text is empty
				if (isEmptyText) {
					dojo.toggleClass(this.contentSection, "hide", true); //$NON-NLS-1$
				} else {
					dojo.toggleClass(this.contentSection, "content", false); //$NON-NLS-1$
					dojo.toggleClass(this.contentSection, "contentPreview", true); //$NON-NLS-1$
				}
				// hide title if it is empty
				if (isEmptyTitle) {
					dojo.toggleClass(this.headerSection, "hide", true); //$NON-NLS-1$
				}
			}

			
			//hide save/action action toolbar, edit action toolbar
			dojo.toggleClass(this.editBar, "hide", true); //$NON-NLS-1$
			dojo.toggleClass(this.saveBar, "hide", true); //$NON-NLS-1$
			
			//disable mouse click event response 
			this.titleArea.set("disabled", true); //$NON-NLS-1$
			this.disconnect(this.editHandler);			
		},
		
		_editMode: function() {
			dojo.toggleClass(this.domNode, "preview", false); //$NON-NLS-1$
			//show field Area, header section and content section
			dojo.toggleClass(this.fieldArea, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.headerSection, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.contentSection, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.contentSection, "contentPreview", false); //$NON-NLS-1$
			dojo.toggleClass(this.contentSection, "content", true); //$NON-NLS-1$
			
			dojo.toggleClass(this.editBar, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.saveBar, "hide", true); //$NON-NLS-1$
			this.editHandler = this.connect(this.previewArea, ProcessAuthoringConstants.EVENT_CLICK, this._onEdit);
			dojo.toggleClass(this.previewArea, "previewField", !this.isViewMode()); //$NON-NLS-1$
			this.titleArea.set("disabled", true); //$NON-NLS-1$
			this.titleArea.set("disabled", false); //$NON-NLS-1$
		},
		
		_onMouseOver: function(evt) {
			dojo.toggleClass(this.toobarArea, "hide", false); //$NON-NLS-1$
		},
		
		_onMouseOut: function(evt) {
			if (!this.isEditing) {
				dojo.toggleClass(this.toobarArea, "hide", true); //$NON-NLS-1$
			}
		},
		
		_setChange: function() {
			this.controller._setChange();
		},
		
		doCommit: function() {
			if (this.isEditing) {
				this.commitChange();
			}
		},
		
		getXML: function() {
			// we don't need to generate uuid every time for the unsaved field, 
			// we can simply set a variable to remember it. 
			var rdfID, uuid;
			if(this.fieldID){
				rdfID = " rdf:ID=\"" + this.fieldID + "\" "; //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				uuid = "ID-" + dojox.uuid.generateTimeBasedUuid();  //$NON-NLS-1$
				rdfID = " rdf:ID=\"" + uuid + "\" "; //$NON-NLS-1$ //$NON-NLS-2$
				this.fieldID = uuid;
			}
			var newCreated = this.newCreated ? " newCreated=\"true\"" : ""; //$NON-NLS-1$ //$NON-NLS-2$
			var data = "<field name=\"" + this.name + "\" label=\"" + UIHelper.escapeXML(this.titleArea.get("value")) + "\" type=\"plain-text\" localized=\"true\""  + rdfID + newCreated + ">" + UIHelper.escapeXML(this.getFieldValue()) + "</field>"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
			return data;
		},
		
		getEditing: function() {
			return this.isEditing;
		},
		
		getFieldValue: function() {
			return this.textEditor.value;
		},
		
		setFieldValue: function(value) {
			this.fieldValue = value;
			this.textEditor.value = value;
			this._setPreviewField();
		},
		
		_setPreviewField: function() {
			if ( this._isEmptyText() ) {
            	dojo.html.set(this.previewArea, this.messages.TextField_0);
            	dojo.toggleClass(this.previewArea, "novalueField", true); //$NON-NLS-1$
			} else {
            	dojo.toggleClass(this.previewArea, "novalueField", false); //$NON-NLS-1$
				dojo.html.set(this.previewArea, UIHelper.escapeHTML(this.fieldValue));
			}			
		},
		
		isViewMode: function() {
			return this.controller.isViewMode();
		},
		
		isViewOnly: function() {
			return this.controller.isViewOnly();
		},
		
		isEmpty: function() {
			return this._isEmptyTitle() && this._isEmptyText();
		},
		
		_isEmptyTitle: function() {
			return !this.titleArea.value || dojo.string.trim(this.titleArea.value).lenth == 0;
		},
		
		_isEmptyText: function() {
			if (this.fieldValue) {
				return dojo.string.trim(this.fieldValue).length == 0;
			}
			return true;
		},
		
		uninitialize: function() {
			if (this.editToolBar) {
				this.editToolBar.destroyRecursive();
			}
			if (this.titleArea) {
				this.titleArea.destroyRecursive();
			}
			delete this.controller;
			
			this.inherited(arguments);
		}
	});
})();
