/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeElementLanguageDialog"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dojo.io.iframe"); //$NON-NLS-1$
	dojo.require("dojox.uuid"); //$NON-NLS-1$
	dojo.require("dojox.uuid.generateTimeBasedUuid"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.LanguageDialog"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient;
	var LanguageDialog = com.ibm.team.process.authoring.web.common.ui.internal.editors.LanguageDialog;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeElementLanguageDialog", [LanguageDialog], { //$NON-NLS-1$
		onOk: function(){
			this.okButton.disabled = true;
			var lang = this.languageSelector.options[this.languageSelector.selectedIndex].value;
			var data = this.workingCopy.getPracticeElementLanguageDataById(this.itemId, lang);
			if (data) {
				var doc = UIHelper.parseXmlTextToDOMDocument(data);
				var ETag = this.workingCopy.getPracticeElementLanguageETagById(this.itemId, lang);
				this.controller.reload(doc.documentElement, ETag); //$NON-NLS-1$
				this.dialog.close();
			} else {
				ProcessAuthoringClient.getPracticeElement({
					'url': this.resource + "?lang=" + lang, //$NON-NLS-1$ //$NON-NLS-2$
					'load': dojo.hitch(this, function(data, ioArgs) { //$NON-NLS-1$
						this.controller.reload(data.documentElement, ioArgs.xhr.getResponseHeader("ETag")); //$NON-NLS-1$
						this.dialog.close();
					})
				});
			}
		},
		
		onCreate: function() {
			this.createButton.disabled = true;
			var lang = this.languageSelect.value;
			var exist = false;
			dojo.some(this.languageSelector.options, function(op) {
				if (op.value == lang) {
					exist = true;
					return true;
				}
				return false;
			}, this);
			
			if (exist) {
				alert(this.messages.LanguageDialog_7);
				this.createButton.disabled = false;
			} else {
				ProcessAuthoringClient.createPracticeElementLanguage({
					'resource': this.resource, //$NON-NLS-1$
					'language': lang, //$NON-NLS-1$
					'title': this.title, //$NON-NLS-1$
					'description': this.description, //$NON-NLS-1$
					'load': dojo.hitch(this, function(data, ioArgs) { //$NON-NLS-1$
						this.workingCopy.updateLanguagesById(this.itemId, [lang]);
						var option = new Option(lang, lang);
						this.languageSelector.options.add(option);
						this.okButton.disabled = false;
						this.createButton.disabled = false;
					})
				});
			}
		},
		
		uninitialize: function(){
			this.inherited(arguments);
		}
	});
})();
