/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeListPage"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("jazz.ui.ResourceLink");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper");//$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("jazz.ui.SimpleToolbar"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$	
	dojo.require("jazz.ui.PaginationControl"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ExportDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ImportDialog"); //$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	var ExportDialog = com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ExportDialog;
	var ImportDialog = com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ImportDialog;
	var PaginationControl = jazz.ui.PaginationControl;
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var ResourceLink = jazz.ui.ResourceLink;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var MessageBox = jazz.ui.MessageBox;
	var STATUS_TYPES = MessageBox.STATUS_TYPES;
	var PRACTICES_PER_PAGE = 10;
	var PRACTICE_EDIT_ACTION_PREFIX = "#action=com.ibm.team.process.authoring.editPractice&resource="; //$NON-NLS-1$
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeListPage", //$NON-NLS-1$
 [dijit._Widget, dijit._Templated], {
		lastModified: null,
		editToolBars: null,
		resourceLinks: null,
		paginationControl: null,
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/PracticeListPage.html"), //$NON-NLS-1$ //$NON-NLS-2$
		constructor: function() {
			this.editToolBars = [];
			this.resourceLinks = [];
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
			this._createPracticeIconSrc = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/create-practice_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$ 
			this._importPracticeIconSrc = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/import-practice_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			this.promptMsg = new MessageBox();
			this.messageBox.appendChild(this.promptMsg.domNode);
			this.refresh();
		},
		
		refresh: function() {
			this.clearState();
			this.displayWaitingMessage(this.messages.PracticeListPage_6);
		},
		
		clearState: function() {
			dojo.empty(this.sharedPractices);
			this.promptMsg.hideMessage();
		},
		
		removeMessages: function() {
			this.promptMsg.hideMessage();
		},
		
		showPractices: function() {
			ProcessAuthoringClient.getAllSharedPractices({
				lastModified: this.lastModified,
				load: dojo.hitch(this, function(data) {
					this._getAllPractices(data);
					
					var count;
					if (this.allPractices) {
						count = this.allPractices.length;
					} else {
						count = 0;
					}
					var firstShowUpperBound;
					if (count > PRACTICES_PER_PAGE) {
						firstShowUpperBound = PRACTICES_PER_PAGE;
					} else {
						firstShowUpperBound = count;
					}
					this._showPracticesInRange(0, firstShowUpperBound);
					
					var newPaginationControl = new PaginationControl({
						total: count,
						increment: PRACTICES_PER_PAGE,
						onNextClick: dojo.hitch(this, function(widget, start, end) {
							this._showPracticesInRange(start - 1, end);
						}),
						onPreviousClick: dojo.hitch(this, function(widget, start, end) {
							this._showPracticesInRange(start - 1, end);
						})
					});
					dojo.empty(this.pagingContainer);
					if (this.paginationControl) {
						this.paginationControl.destroyRecursive();
					}
					this.paginationControl = newPaginationControl;
					this.pagingContainer.appendChild(this.paginationControl.domNode);
				}),
				error: dojo.hitch(this, this.error)
			});
			
		},
		
		_getAllPractices: function(practicesListingXML) {
			if (!practicesListingXML) {
				return practicesListingXML;
			}
			var children = practicesListingXML.childNodes;
			var practicesNode = UIHelper.getNode(children, ProcessAuthoringConstants.XMLELEMENT_RDF, ProcessAuthoringConstants.NAMESPACE_RDF); 
			if (practicesNode) {
				var allPracticeNodes = UIHelper.getNodes(practicesNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_PRACTICE_ROOT, ProcessAuthoringConstants.NAMESPACE_JTP);
				this.allPractices = [];
				dojo.forEach(allPracticeNodes, function(practiceNode) {
					var aboutAttribute = UIHelper.getAttributeNode(practiceNode, ProcessAuthoringConstants.XMLATTRIBUTE_ABOUT, ProcessAuthoringConstants.NAMESPACE_RDF);
					var uri = aboutAttribute.value;
					var nameNode = UIHelper.getNode(practiceNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC);
					var name = ""; //$NON-NLS-1$
					if (nameNode && nameNode.firstChild) {
						name = UIHelper.unescapeXML(nameNode.firstChild.data);
					}
					
					var descriptionNode = UIHelper.getNode(practiceNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_DESCRIPTION, ProcessAuthoringConstants.NAMESPACE_DC);
					var description = ""; //$NON-NLS-1$
					if (descriptionNode && descriptionNode.firstChild) {
						description = UIHelper.unescapeXML(descriptionNode.firstChild.data);
					}
					var practice = {};
					practice.uri = uri;
					practice.name = name;
					practice.description = description;
					this.allPractices.push(practice);
				}, this);
				
				if (this.allPractices.length === 0) {
					if (dojo.hasClass(this.noPracticesMessage, "hidden")) {  //$NON-NLS-1$
						dojo.toggleClass(this.noPracticesMessage, "hidden", false); //$NON-NLS-1$
					}
				} else {
					if (!dojo.hasClass(this.noPracticesMessage, "hidden")) {  //$NON-NLS-1$
						dojo.toggleClass(this.noPracticesMessage, "hidden", true); //$NON-NLS-1$
					}
				}
				//sort the practice over all the pages
				this.allPractices = this.allPractices.sort(function(a, b) {
					return a.name.toLowerCase().localeCompare(b.name.toLowerCase());
				});
			} else {
				this.messageBox.appendChild(document.createTextNode(this.messages.PracticeListPage_9));
			}
			return practicesListingXML;
		},
		
		_showPracticesInRange: function(start, end) {
			var practices = this.allPractices.slice(start, end);
			
			dojo.empty(this.sharedPractices);
			var practice_links_array = [];
			dojo.forEach(practices, function(practice) {
				var row = this.createPracticeRow(practice);
				this.sharedPractices.appendChild(row);
			}, this);
			
			this.removeMessages();
		},
		
		createPracticeRow: function(practice) {
			var row = document.createElement("div"); //$NON-NLS-1$
			row.className = "practice"; //$NON-NLS-1$
			var linkDescription = document.createElement("h3"); //$NON-NLS-1$
			var link = document.createElement("a"); //$NON-NLS-1$
			link.appendChild(document.createTextNode(practice.name));
			linkDescription.appendChild(link);
			
			var presentationUri = practice.uri;
			
			link.href = practice.uri;
			var rl = new ResourceLink({
				'presentationUri': presentationUri, //$NON-NLS-1$
				'lazyFetch': true //$NON-NLS-1$
			}, link);
			row.appendChild(linkDescription);
			this.resourceLinks.push(rl);
			var handleKeyNavigateIn = function(e) { //$NON-NLS-1$
				var section = e.target;
				
				while (section && !dojo.hasClass(section, "practice")) { //$NON-NLS-1$
					section = section.parentNode;
				}
				if (section) {
					dojo.toggleClass(section, "selected", true); //$NON-NLS-1$
				}
			};
			
			var handleKeyNavigateOut = function(e) { //$NON-NLS-1$
				var section = e.target;
				
				while (section && !dojo.hasClass(section, "practice")) { //$NON-NLS-1$
					section = section.parentNode;
				}
				if (section) {
					dojo.toggleClass(section, "selected", false); //$NON-NLS-1$
				}
			};
			
			this.connect(link, "onfocus", handleKeyNavigateIn); //$NON-NLS-1$
			this.connect(link, "onblur", handleKeyNavigateOut); //$NON-NLS-1$
			if (practice.description) { //$NON-NLS-1$
				row.appendChild(document.createTextNode(practice.description));
			}
			
			var actionArea = document.createElement("div"); //$NON-NLS-1$
			dojo.addClass(actionArea, "actionToolBar"); //$NON-NLS-1$
			var editToolBar = new jazz.ui.SimpleToolbar({});
			this.editToolBars.push(editToolBar);
			var callback = function(e) {
				dojo.stopEvent(e);
				this.exportPractice(practice);
			};
			var actionButton = editToolBar.addButton(this, callback, {
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/export-practice_co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				label: this.messages.PracticeListPage_14
			});
			this.connect(actionButton.domNode, "onfocus", handleKeyNavigateIn); //$NON-NLS-1$
			this.connect(actionButton.domNode, "onblur", handleKeyNavigateOut); //$NON-NLS-1$
			callback = function(e) {
				dojo.stopEvent(e);
				if (confirm(this.messages.PracticeListPage_8)) {
					this.deletePractice(practice);
				}
			};
			actionButton = editToolBar.addButton(this, callback, {
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/delete-button.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				label: this.messages.PracticeListPage_7
			});
			this.connect(actionButton.domNode, "onfocus", handleKeyNavigateIn); //$NON-NLS-1$
			this.connect(actionButton.domNode, "onblur", handleKeyNavigateOut); //$NON-NLS-1$
			actionArea.appendChild(editToolBar.domNode);
			row.appendChild(actionArea);
			this.connect(row, "onmouseover", dojo.hitch(this, function() { //$NON-NLS-1$
				dojo.toggleClass(row, "selected", true); //$NON-NLS-1$
			}));
			this.connect(row, "onmouseout", dojo.hitch(this, function() { //$NON-NLS-1$
				dojo.toggleClass(row, "selected", false); //$NON-NLS-1$
			}));
			
			return row;
		},
		
		exportPractice: function(practice) {
			var dialog = new ExportDialog({
				resourceUrl: practice.uri,
				message: dojo.string.substitute(this.messages.PracticeListPage_15, [practice.name])
			});
		},
		
		importPractices: function(e) {
			dojo.stopEvent(e);
			var dialog = new ImportDialog({
				isSharedProcessDescriptionImporting: false
			});
			this.connect(dialog, "onSuccess", "handleImportSuccess");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		handleImportSuccess: function(args) {
			this.lastModified = args.lastModified;
			this.refresh();
		},
		
		deletePractice: function(practice) {
			this.displayWaitingMessage(this.messages.PracticeListPage_10);
			ProcessAuthoringClient.deletePractice({
				uri: practice.uri,
				load: dojo.hitch(this, function(data, ioArgs) {
					this.lastModified = ioArgs.xhr.getResponseHeader(ProcessAuthoringConstants.HEADER_LASTMODIFIED);
					this.refresh();
					this.displaySuccessMessage(this.messages.PracticeListPage_11);
				}),
				error: dojo.hitch(this, function(err, ioArgs) {
					if (err.responseText) {
						err.message = err.responseText;
					}
					var licenseWarning = UIHelper.getLicenseWarning(ioArgs);
					err.headerMessage = licenseWarning ? licenseWarning : this.messages.PracticeListPage_12;
					err.errorObject = err;
					this.displayErrorMessage(err);
				})
			});
		},
		
		_getLinkImage: function(projectLink) {
			var img = document.createElement("img"); //$NON-NLS-1$
			var module = "com.ibm.team.process.authoring.web.common"; //$NON-NLS-1$
			img.className = "linkImage"; //$NON-NLS-1$
			img.src = dojo.moduleUrl(module, "graphics/icons/implemented_by_obj.gif"); //$NON-NLS-1$
			return img;
		},
		
		createPractice: function() {
			window.location.href = PRACTICE_EDIT_ACTION_PREFIX + "new"; //$NON-NLS-1$
		},
		
		displayMessage: function(msg, cssClass) {
			if (msg instanceof Error) {
				this.promptMsg.showMessage({
					type: cssClass,
					summary: msg.headerMessage,
					errorObject: msg
				});
			} else {
				this.promptMsg.showMessage({
					type: cssClass,
					summary: msg
				});
			}
		},
		
		displaySuccessMessage: function(msg) {
			this.displayMessage(msg, "OK"); //$NON-NLS-1$
		},
		
		displayErrorMessage: function(msg) {
			this.displayMessage(msg, "ERROR"); //$NON-NLS-1$
		},
		
		displayWaitingMessage: function(msg) {
			this.displayMessage(msg, "INFO"); //$NON-NLS-1$
		},
		
		uninitialize: function() {
			dojo.forEach(this.editToolBars, function(editToolBar){
				editToolBar.destroyRecursive();
			}, this);
			
			dojo.forEach(this.resourceLinks, function(resourceLink){
				resourceLink.destroyRecursive();
			}, this);
			
			if (this.paginationControl) {
				this.paginationControl.destroyRecursive();
			}
			
			if (this.promptMsg) {
				this.promptMsg.destroyRecursive();
			}
			
			this.inherited(arguments);
		},
		
		error: function(error, ioArgs) {
			if (error.responseText) {
				error.message = error.responseText;
			}
			var licenseWarning = UIHelper.getLicenseWarning(ioArgs);
			error.headerMessage = licenseWarning ? licenseWarning : this.messages.PracticeListPage_13;
			error.errorObject = error;
			if (licenseWarning) {
				this.displayMessage(error, "WARNING"); //$NON-NLS-1$
			} else {
				this.displayErrorMessage(error);
			}
		}
	});
	
})();
