/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.frontingapp.ui.internal.editors.ProcessDescriptionEditorContainer"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.frontingapp.ui.internal.editors.ProcessAreaDescriptionEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ImportDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.ResourceLinkPickerJazzDialog"); //$NON-NLS-1$
	dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.contextRoot"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.BootstrapProperties"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$	 
	dojo.requireLocalization("com.ibm.team.process.authoring.web.frontingapp.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	dojo.requireLocalization("jazz.app.internal", "LoginWidgetMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var ImportDialog = com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ImportDialog;
	var ResourceLinkPickerJazzDialog = com.ibm.team.process.authoring.web.common.ui.internal.editors.ResourceLinkPickerJazzDialog;
	var ResourceLink = jazz.ui.ResourceLink;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var OVERVIEW_TABID = "com.ibm.team.process.web.Overview"; //$NON-NLS-1$
	var ProcessAreaDescriptionEditor= com.ibm.team.process.authoring.web.frontingapp.ui.internal.editors.ProcessAreaDescriptionEditor;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var commonMessages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
	
	dojo.declare("com.ibm.team.process.authoring.web.frontingapp.ui.internal.editors.ProcessDescriptionEditorContainer", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.frontingapp", "ui/internal/editors/templates/ProcessDescriptionEditorContainer.html"), //$NON-NLS-1$ //$NON-NLS-2$
		licenseInfo: null,
		fetchError: null, // "popupBlocked" or "cancel"
		hasChange: false,
		saveCallback: null,
		saveAction: null,
		isShared: false,
		isAssociated: false,
		resourceUrl: null,
		ownerUrl: null,
		processAuthoringPracticeUrl: null,
		processAuthoringPracticeElementUrl: null,
		
		constructor: function(args) {
			if (args.editor && args.tabContainer) {
				this.editor = args.editor;
				this.tabContainer = args.tabContainer;
				this.licenseInfo = this.editor.processAuthoringlicenseInfo;
				this.processAuthoringPracticeUrl = this.editor.processAuthoringPracticeUrl;
				this.processAuthoringPracticeElementUrl = this.editor.processAuthoringPracticeElementUrl;
				
				// net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL is the public URI root of current foundation fronting app
				this.ownerUrl = this.getOwnerUrl(net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL);
				this.fetchProcessDescription();
			}
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.frontingapp.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			this._createProcessDescriptionIcon.src = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/create-process-description_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			this._importProcessDescriptionIcon.src = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/import-process-description_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$ 
			this._associateProcessDescriptionIcon.src = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/copyurl-button.gif"); //$NON-NLS-1$ //$NON-NLS-2$ 
			this._dissociateProcessDescriptionIcon.src = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/dis-proc-description_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			this.editorContentPane = new dijit.layout.ContentPane({
				region: "center", //$NON-NLS-1$
				content: "", //$NON-NLS-1$
				onLoad: dojo.hitch(this, function(data){
					if (data && dojo.isObject(data) && data.domNode) {
						this.currentEditor = data;
					} else {
						this.currentEditor = null;
					}
				})
			}, document.createElement("DIV")); //$NON-NLS-1$
						
			this.inherited(arguments);
		},
		
		hideAllLinks: function() {
            dojo.style(this._welcomeSection, "display", "none"); //$NON-NLS-1$ //$NON-NLS-2$
            dojo.style(this._createProcessDescriptionLink, "display", "none"); //$NON-NLS-1$ //$NON-NLS-2$
            dojo.style(this._importProcessDescriptionLink, "display", "none"); //$NON-NLS-1$ //$NON-NLS-2$
            dojo.style(this._associateProcessDescriptionLink, "display", "none"); //$NON-NLS-1$ //$NON-NLS-2$
            dojo.style(this._actionBar, "display", "none"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		clearMessage: function() {
			PlatformUI.getWorkbench().hideMessageArea();
		},
		
		setDirty: function(isDirty, editingProcessDescriptionName) {
			this.hasChange = isDirty;
			this.editingProcessDescriptionName = editingProcessDescriptionName;
			this.tabContainer.setDirty(this.tabContainer.changesPending());
		},
		
		canSave: function() {
			if (this.editingProcessDescriptionName === undefined || (this.editingProcessDescriptionName !== undefined && this.editingProcessDescriptionName) || this.editor.discardPending) {
				return true;
			} else {
				return false;
			}
		},
		
		changesPending: function() {
			return this.hasChange;
		},
		
		// indicate process area editor changes
		containerChangesPending: function() {
			return this.tabContainer.changesPending();
		},
		
		refresh: function() {
			this.saveAction = null;
			this.hasChange = false;
			this.isAssociated = false;
			
			// if the process description editor exists and it is editing UI (rather than creating UI), 
			// then just call editor refresh().
			if (this.processDescriptionEditor && this.resourceUrl) {
				this.processDescriptionEditor.refresh();
				// restore isAssociated if the process description editor has a shared process description.
				if(this.processDescriptionEditor.isShared){
					this.isAssociated = true;
				}
			} else {
				this.fetchProcessDescription();
			}
		},

		displaySuccessMessage: function(msg) {
			this.tabContainer.displaySuccessMessage(msg);
		},
		
		displayErrorMessage: function(msg) {
			this.tabContainer.displayErrorMessage(msg);
		},
		
		displayPendingMessage: function(msg) {
			this.tabContainer.displayPendingMessage(msg);
		},
		
		// unregister process area editor handlers
		unregisterHandlers: function(){
			this.editor._unregisterHandlers();
		},
		
		deactivateTab: function() {
			return true;
		},
		
		activateTab: function() {
			if (this.fetchError) {
				this._showFetchError();
			}
		},
		
		getOwnerUrl: function(contextRoot) {
			if (!this.editor.isNew) {
				if (this.editor.isTeamArea) {
					return dojo.string.substitute(ProcessAuthoringConstants.PROCESSDESCRIPTION_TEAM_AREA_OWNER_TEMPLATE, [contextRoot, this.editor.projectAreaItemId, this.editor.itemId]);
				} else {
					return dojo.string.substitute(ProcessAuthoringConstants.PROCESSDESCRIPTION_PROJECT_AREA_OWNER_TEMPLATE, [contextRoot, this.editor.projectAreaItemId]);
				}
			}
			
			return null;
		},
		
		getOwnerName: function() {
			return this.editor.name.savedValue;
		},
		
		assertOperation: function(operationId){
			if (this.licenseInfo) {
				var splitLicenses = this.licenseInfo.split(";"); //$NON-NLS-1$
				for (var i = 0; i < splitLicenses.length; i++) {
					var licensePair = splitLicenses[i].split(":"); //$NON-NLS-1$
					if (licensePair[0] === operationId) { //$NON-NLS-1$
						return licensePair[1] === "true"; //$NON-NLS-1$
					}
				}
			} else {
				return false;
			}
		},
		
		_setFetchError: function(error, ioArgs) {
			this.fetchError = error;
			this.fetchError.status = ioArgs.xhr.status;
			if (this.fetchError.responseText) {
				this.fetchError.message = this.fetchError.responseText;
				if (this.fetchError.status === ProcessAuthoringConstants.SC_FORBIDDEN) {
					this.fetchError.headerMessage = commonMessages.ProcessDescriptionError_3;
				}
			}
		},
		
		fetchProcessDescription: function(){
			this.fetchError = null;
			this.displayPendingMessage(commonMessages.ProcessDescriptionEditor_23);
			ProcessAuthoringClient.getProcessDescriptionsForOwner({
				ownerUrl: this.ownerUrl,
				viewType: ProcessAuthoringConstants.VIEWTYPE_REFERENCE,
            	load: dojo.hitch(this, function(data, ioArgs) {
					var descriptionsNode = UIHelper.getNode(data.childNodes, ProcessAuthoringConstants.XMLELEMENT_RDF, ProcessAuthoringConstants.NAMESPACE_RDF);
					if (descriptionsNode) {
						var allProcessDescriptionNodes = UIHelper.getNodes(descriptionsNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_PROCESSDESCRIPTION_ROOT, ProcessAuthoringConstants.NAMESPACE_JTP);
						if (allProcessDescriptionNodes && allProcessDescriptionNodes.length > 0) {
							var processDescriptionNode = allProcessDescriptionNodes[0];
							var aboutAttribute = UIHelper.getAttributeNode(processDescriptionNode, ProcessAuthoringConstants.XMLATTRIBUTE_ABOUT, ProcessAuthoringConstants.NAMESPACE_RDF);
							this.resourceUrl = aboutAttribute.value;
							this.populateAuthoringProcessDescription();
						} else {
							// no process description for process area, then check associate process description for process area
							
							var targetUrl = this.ownerUrl;
							// TODO: this needs to be improved, 3 calls (ProcessAuthoringClient.checkAssociateSharedProcessDescriptionForProcessArea,
							// ProcessAuthoringClient.getAssociation, jazz.client.xhrHead) should be reduced to 1.
							// See https://jazz.net/jazz/resource/itemName/com.ibm.team.workitem.WorkItem/166775
							ProcessAuthoringClient.checkAssociateSharedProcessDescriptionForProcessArea({
								targetUrl: targetUrl,
								load: dojo.hitch(this, function(data, ioArgs) {
									var associationUrl = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
									ProcessAuthoringClient.getAssociation({
										url: associationUrl,
										load: dojo.hitch(this, function(data, ioArgs) {
											var docElement = data.documentElement;
											dojo.some(docElement.childNodes, function(node) {
												if (node.nodeType == ProcessConstants.NodeType.ELEMENT) {
													if (UIHelper.isSpecifiedNode(node, "source", ProcessConstants.NAMESPACE_JTP)) { //$NON-NLS-1$
														var sourceUrl = UIHelper.getAttributeNode(node, ProcessConstants.XMLATTRIBUTE_RESOURCE, ProcessConstants.NAMESPACE_RDF).value;
														if (sourceUrl !== null) {
															this.resourceUrl = sourceUrl;
															return true;
														} else {
															return false;
														}
													}
												}
											}, this);
											
											if (this.resourceUrl) {
												jazz.client.xhrHead({
													url: this.resourceUrl,
													headers: {
														Accept: "application/xml" //$NON-NLS-1$
													},
													handleAs: "xml", //$NON-NLS-1$
													load: dojo.hitch(this, function(data, ioArgs) {
														this.isAssociated = true;
														this.populateAuthoringProcessDescription();
													}),
													error: dojo.hitch(this, function(error, ioArgs) {
														this.resourceUrl = null;
														if (ioArgs.xhr.status !== ProcessAuthoringConstants.SC_NOT_FOUND &&
														ioArgs.xhr.status !== ProcessAuthoringConstants.SC_GONE) { //no process description
															this._setFetchError(error, ioArgs);
														}
														this.populateAuthoringProcessDescription();
													})
												});
											} else {
												this.populateAuthoringProcessDescription();
											}
											
										}),
										error: dojo.hitch(this, function(error, ioArgs) {
											this.resourceUrl = null;
											if (ioArgs.xhr.status !== ProcessAuthoringConstants.SC_NOT_FOUND && ioArgs.xhr.status !== ProcessAuthoringConstants.SC_GONE) { // no association
												this._setFetchError(error, ioArgs);
											}
											this.populateAuthoringProcessDescription();
										})
									});
								}),
								error: dojo.hitch(this, function(error, ioArgs) {
									this.resourceUrl = null;
									if (ioArgs.xhr.status !== ProcessAuthoringConstants.SC_NOT_FOUND && ioArgs.xhr.status !== ProcessAuthoringConstants.SC_GONE) { // no association
										this._setFetchError(error, ioArgs);
									}
									this.populateAuthoringProcessDescription();
								})
							});
						}
					}
				}),
            	error: dojo.hitch(this, function(error, ioArgs) {
					this._setFetchError(error, ioArgs);
					this.populateAuthoringProcessDescription();
				})
            });
		},
		
		discardProcessDescription: function(itemId){
			if (this.resourceUrl && !this.isAssociated) {
				ProcessAuthoringClient.deleteProcessDescription({
					uri: this.resourceUrl,
					load: dojo.hitch(this, function(data) {
						this.resourceUrl = null;
						this.hideAllLinks();
						this.showWelcomeSection();
						this.saveCallback();
						this.setDirty(false);
						this.saveAction = null;
					}),
					error: dojo.hitch(this, function(error) {
						if (error.status === ProcessAuthoringConstants.SC_NOT_FOUND) {
							this.resourceUrl = null;
							this.hideAllLinks();
							this.showWelcomeSection();
							this.saveCallback();
							this.setDirty(false);
							this.saveAction = null;
						} else {
							this.handleDiscardProcessDescriptionError(error);
						}
					})
				});
			} else if (this.resourceUrl) {
				var targetUrl = this.ownerUrl; //$NON-NLS-1$
				ProcessAuthoringClient.checkAssociateSharedProcessDescriptionForProcessArea({
					targetUrl: targetUrl,
					load: dojo.hitch(this, function(data, ioArgs) {
						var associationUrl = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
						if (associationUrl) {
							this.updateAssociationForDiscarding(associationUrl, this.resourceUrl);
							this.saveCallback();
							this.saveAction = null;
						}
					}),
					error: dojo.hitch(this, function(error) { //no associated shared process description
						if (error.status == ProcessAuthoringConstants.SC_NOT_FOUND) {
							this.handleUnassociateSuccess();
						} else {
							this.handleDiscardProcessDescriptionError(error);
						}
					})
				});
			}
		},
		
		handleDiscardProcessDescriptionError: function(error) {
			var errObj = {};
			if (!this.isAssociated) {
				errObj.headerMessage = this.messages.ProcessDescriptionEditorContainer_7;
			} else {
				errObj.headerMessage = this.messages.ProcessDescriptionEditorContainer_8;
			}
			if (error.responseText) {
				errObj.message = error.responseText;
			} else if (error.message) {
				errObj.message = error.message;				
			}
			//call AbstractProcessAreaEditor._saveExtensionPageCallback(errorObject);
			this.saveCallback(errObj);
		},
		
		populateAuthoringProcessDescription: function() {
			if(this.fetchError) {
				this.clearMessage();
				this._showFetchError();
				return;
			}
			
			if (this.resourceUrl && this.isAssociated) {
				this.isShared = true;
			} else {
				this.isShared = false;
			}
			
			this.hideAllLinks();
			if (!this.resourceUrl) {
				this.clearMessage();
				this.showWelcomeSection();
			} else {
                this.setupEditor(this.isAssociated ? ProcessAuthoringConstants.DISCARDTYPE_ASSOCIATION : ProcessAuthoringConstants.DISCARDTYPE_OWNER);
			}
		},

		showCreateLink: function() {
			dojo.style(this._createProcessDescriptionLink, "display", ""); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		showImportLink: function() {
			dojo.style(this._importProcessDescriptionLink, "display", ""); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		showAssociateLink: function() {
			if (this.assertOperation(ProcessAuthoringConstants.PROCESS_AUTHORING_READ_SHARED_SUPPORT)) {
				dojo.style(this._associateProcessDescriptionLink, "display", ""); //$NON-NLS-1$ //$NON-NLS-2$
			}
		},
		
		showBackToStartPageLink: function(){
           	dojo.style(this._actionBar, "display", ""); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		onCreateProcessDescription: function(evt) {
			dojo.stopEvent(evt);
			this.hideAllLinks();
			this.saveAction = ProcessAuthoringConstants.UPDATE_ACTION;
			this.setupEditor(ProcessAuthoringConstants.DISCARDTYPE_BACKTOSTART);
		},
		
		onImportProcessDescription: function(evt) {
			dojo.stopEvent(evt);
			this.cleanContentNode();
			this.importPrivateProcessDescription();
			
		},
		
		onAssociateProcessDescription: function(evt) {
			dojo.stopEvent(evt);
			this.saveAction = ProcessAuthoringConstants.ASSOCIATE_ACTION;
			this.cleanContentNode();
			this.associateSharedProcessDescription();
		},
		
		onDiscardProcessDescription: function(evt) {
			dojo.stopEvent(evt);
			this._discardProcessDescription();
		},
		
		_discardProcessDescription: function() {
            if (this.changesPending()) {
            	if (!confirm(this.messages.ProcessDescriptionEditorContainer_12_1)) {
            		return;
            	}
            } else if (!confirm(this.saveAction === ProcessAuthoringConstants.ASSOCIATE_ACTION ? this.messages.ProcessDescriptionEditorContainer_14 : this.messages.ProcessDescriptionEditorContainer_13)) {
            	return;
            }
			this.showPendingDiscardInfo();
			this.hideAllLinks();
			this.saveAction = ProcessAuthoringConstants.DISCARD_ACTION;
			this.setDirty(true);
		},
		
		_backToStart: function() {
            if (this.changesPending()) {
                if (!confirm(this.saveAction === ProcessAuthoringConstants.ASSOCIATE_ACTION ? this.messages.ProcessDescriptionEditorContainer_12_2 : this.messages.ProcessDescriptionEditorContainer_12_1)) {
                	return;
                }
            }
			this.setDirty(false);
			this.hideAllLinks();
			this.showWelcomeSection();
		},
		
		onBackToStartPage:  function(evt) {
			dojo.stopEvent(evt);
			this._backToStart();
		},
		
		onEditorDiscardProcessDescription: function() {
			this._discardProcessDescription();
		},
		
		onEditorBackToStart: function() {
			this._backToStart();
		},
		
		onEditorSaveSuccess: function(savedProcessDescriptionUrl) {
			this.resourceUrl = savedProcessDescriptionUrl;
			this.saveSuccessResponse();
			this.setDirty(false);
			this.hideAllLinks();
		},
		
		handleImportSuccess: function(args) {
			this.setDirty(false);
			this.resourceUrl = args.privateProcessDescriptionUrl;
			this.isAssociated = false;
			this.isImportSucceeded = true;
			this.hideAllLinks();
		},
		
		handleCancelImport: function() {
			this.setDirty(false);
			if (this.isImportSucceeded) {
				this.saveAction = null;
				this.clearMessage();
				this.populateAuthoringProcessDescription();
			}
		},
		
		handleAssociateSuccess: function(associatedProcessDescription) {
			this.setDirty(false);
			if (associatedProcessDescription !== null) {
				this.resourceUrl = associatedProcessDescription;
				this.isAssociated = true;
			}
			
			this.clearMessage();
			this.displayPendingMessage(commonMessages.ProcessDescriptionEditor_23);
			this.populateAuthoringProcessDescription();
			
			this.isAssociateSucceeded = true;
			this.associateDialog.dialog.close();
			this.hideAllLinks();
			this.saveCallback();
		},
		
		handleUnassociateSuccess: function() {
			this.setDirty(false);
			this.resourceUrl = null;
			this.isAssociated = false;
			this.clearMessage();
			this.displayPendingMessage(commonMessages.ProcessDescriptionEditor_23);
			this.populateAuthoringProcessDescription();
		},
		
		showWelcomeSection: function(){
			this.cleanContentNode();
			this.showCreateLink();
			this.showImportLink();
			this.showAssociateLink();
			dojo.style(this._welcomeSection, "display", ""); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		showPendingDiscardInfo: function(){
			this.cleanContentNode();
			var div = document.createElement("div"); //$NON-NLS-1$
            if (this.isAssociated) {
            	div.appendChild(document.createTextNode(this.messages.ProcessDescriptionEditorContainer_6_2));
            } else {
            	div.appendChild(document.createTextNode(this.messages.ProcessDescriptionEditorContainer_6_1));
            }
			this._contentNode.appendChild(div);
		},
		
		_showFetchError: function() {
			if (!this.fetchError) {
				return;
			}
			var msg;
			this.cleanContentNode();
			if (this.fetchError.dojoType == "popupBlocked") { //$NON-NLS-1$
				var div = document.createElement("div"); //$NON-NLS-1$
				var loginWidgetMessages = dojo.i18n.getLocalization("jazz.app.internal", "LoginWidgetMessages"); //$NON-NLS-1$ $NON-NLS-2$
	            div.appendChild(document.createTextNode(loginWidgetMessages.popupBlocked));
				this._contentNode.appendChild(div);
			} else {
				this.displayErrorMessage(this.fetchError);
			}
		},
		
		pendingAssociate: function() {
			this.hideAllLinks();
			this.showBackToStartPageLink();
			this.associateDialog.addCloseButton.disabled = true;
			this.setDirty(true);
			this.associatingProcessDescriptionUrl = this.associateDialog.resourceSelector.options[this.associateDialog.resourceSelector.selectedIndex].resourceUrl;
			this.associatingProcessDescriptionName = this.associateDialog.resourceSelector.options[this.associateDialog.resourceSelector.selectedIndex].text;
			if (this.associatingProcessDescriptionUrl) {
				if (!this.associatingDiv) {
					this.associatingDiv = document.createElement("div"); //$NON-NLS-1$
				} else {
					dojo.empty(this.associatingDiv);
				}
				
				var br = document.createElement("br"); //$NON-NLS-1$
				this.associatingDiv.appendChild(br);
				
				var textSpan = document.createElement("span"); //$NON-NLS-1$
				dojo.addClass(textSpan, "normalContent"); //$NON-NLS-1$
				textSpan.appendChild(document.createTextNode(commonMessages.ProcessDescriptionEditor_15));
				this.associatingDiv.appendChild(textSpan);
				
				var linkSpan = document.createElement("span"); //$NON-NLS-1$
				dojo.addClass(linkSpan, "boldContent"); //$NON-NLS-1$
				var link = document.createElement("a"); //$NON-NLS-1$
				link.href = this.associatingProcessDescriptionUrl;
				link.appendChild(document.createTextNode(this.associatingProcessDescriptionName));
				linkSpan.appendChild(link);
				this.associatingDiv.appendChild(linkSpan);
				
				if (this._resourceLink) {
					this._resourceLink.destroyRecursive();
				}
				this._resourceLink = new ResourceLink({
					'presentationUri': this.associatingProcessDescriptionUrl, //$NON-NLS-1$ //$NON-NLS-2$
					'lazyFetch': true //$NON-NLS-1$
				}, link);
				
				this.cleanContentNode();
			    this._contentNode.appendChild(this.associatingDiv);
			}
			this.associateDialog.dialog.close();
		},
		
		doSave: function(saveCallback) {
			if (this.saveAction === ProcessAuthoringConstants.DISCARD_ACTION) {
				this.saveCallback = saveCallback;
				this.discardProcessDescription(this.editor.itemId);
			} else if (this.saveAction === ProcessAuthoringConstants.ASSOCIATE_ACTION) {
				this.saveCallback = saveCallback;
				this.handleAssociate();
			} else {
				if (this.processDescriptionEditor) {
					this.processDescriptionEditor.save();
				}
				this.saveCallback = saveCallback;
			}
		},
		
		setupEditor: function(discardType) {
			this.cleanContentNode();
			
			var locale;
			if (this.editor.processLocale) {
				locale = this.editor.processLocale
				locale = locale.toLowerCase().replace("_", "-"); //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				locale = "en"; //$NON-NLS-1$
			}


			if(this.processDescriptionEditor){
				this.processDescriptionEditor.destroyRecursive();
				this.processDescriptionEditor = null;
			}
			
			this.processDescriptionEditor = new ProcessAreaDescriptionEditor({
				editorContainer: this,
				discardType: discardType,
				resource: this.resourceUrl,
				ownerURL: this.ownerUrl,
				shared: this.isShared,
				sharedSupport: this.assertOperation(ProcessAuthoringConstants.PROCESS_AUTHORING_READ_SHARED_SUPPORT),
				canWriteShared: this.assertOperation(ProcessAuthoringConstants.PROCESS_AUTHORING_WRITE_SHARED_SUPPORT),
				currentLanguage: locale,
				practiceUrl: this.processAuthoringPracticeUrl,
				practiceElementUrl: this.processAuthoringPracticeElementUrl
			});
			
			this.editorContentPane.set('content', this.processDescriptionEditor); //$NON-NLS-1$
			this._contentNode.appendChild(this.editorContentPane.domNode);
		},
		
		///////////////////////////////////////////////////////////////////////////////////////////
		// Editor Events
		///////////////////////////////////////////////////////////////////////////////////////////
		onEditorNavigate: function(url) {
			//TODO: Need to change to use dojo.hash after 114144 is fixed 
			window.location.href = url;
		},
		
		onEditorDisplayMessage: function(msg, type) {
			this.displayMessage(msg, type);
		},
		
		onEditorLoaded: function() {
			this.clearMessage();
		},
		
		onEditorDirty: function(isDirty, editingProcessDescriptionName) {
			this.setDirty(isDirty, editingProcessDescriptionName);
		},
		
		onEditorSaveError: function(errObject) {
			this.saveErrorResponse(errObject);
		},
			
		///////////////////////////////////////////////////////////////////////////////////////////
		// Override Functions
		///////////////////////////////////////////////////////////////////////////////////////////	
		displayMessage: function(msg, type) {
			if (msg) {
				if (type === "INFO") { //$NON-NLS-1$
					this.displayPendingMessage(msg)
				} else if (type === "OK") { //$NON-NLS-1$
					this.displaySuccessMessage(msg);
				} else {
					this.displayErrorMessage(msg);
				}
			}
		},

		importPrivateProcessDescription: function() {
			var importDialog = new ImportDialog({
				processDescriptionOwnerUrl: this.ownerUrl,
				processDescriptionOwnerName: this.getOwnerName()
			});
			this.connect(importDialog, "onSuccess", "handleImportSuccess");//$NON-NLS-1$ //$NON-NLS-2$
			this.connect(importDialog.dialog, "onClose", "handleCancelImport");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		associateSharedProcessDescription: function() {
			this.associateDialog = new ResourceLinkPickerJazzDialog({
				processDescriptionOwnerName: this.getOwnerName(),
				processDescriptionOwnerUrl: this.ownerUrl,
				associateSharedProcessDescriptionURL: this.resourceUrl,
				dialogTitle: commonMessages.AssociateDialog_0,
				AddCloseButtonLabel: commonMessages.AssociateDialog_1,
				allowMultiple: false,
				resourceGroups: [{
					type: commonMessages.AssociateDialog_2,
					list: []
				}]
			});
			this.connect(this.associateDialog, "_onSelectionChange", dojo.hitch(this, function(e) { //$NON-NLS-1$
				this.associateDialog.addCloseButton.disabled = false;
			}));
			
			this.connect(this.associateDialog, "_onAddClose", "pendingAssociate");//$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.associateDialog, "onCancel", "handleCancelAssociate");//$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.associateDialog.dialog, "onClose", "handleCancelAssociate");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		// TODO: the logic of associating a shared process description with a project area is problematic here. This should be revised as part of
		// 190887: Adopt change in association REST API in web UI
		handleAssociate: function() {
			this.deleteOldAssociateForTargetThenAddNew();
		},
		
		deleteOldAssociateForTargetThenAddNew: function() {
			//check if there is a association for target
			ProcessAuthoringClient.checkAssociateSharedProcessDescriptionForProcessArea({
				targetUrl: this.associateDialog.processDescriptionOwnerUrl,
				load: dojo.hitch(this, function(data, ioArgs) {
					this.oldAssociationURL = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
					ProcessAuthoringClient.getAssociation({
						url: this.oldAssociationURL,
						load: dojo.hitch(this, function(data, ioArgs) {
							var newTargets = [];
							var docElement = data.documentElement;
							dojo.forEach(docElement.childNodes, function(node) {
								if (node.nodeType == ProcessAuthoringConstants.NodeType.ELEMENT) {
									if (UIHelper.isSpecifiedNode(node, "source", ProcessAuthoringConstants.NAMESPACE_JTP)) { //$NON-NLS-1$
										var sourceUrl = UIHelper.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
										if (sourceUrl !== null) {
											this.oldAssociateSharedProcessDescriptionURL = sourceUrl;
										}
									}
									if (UIHelper.isSpecifiedNode(node, "targets", ProcessAuthoringConstants.NAMESPACE_JTP)) { //$NON-NLS-1$
										var targetNodes = UIHelper.getNodes(node.childNodes, "target", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
										dojo.forEach(targetNodes, function(targetNode) {
											var oldTarget = {
												title: null,
												url: null
											};
											oldTarget.title = UIHelper.getAttributeNode(targetNode, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC).value;
											oldTarget.url = UIHelper.getAttributeNode(targetNode, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
											if (oldTarget.url !== this.associateDialog.processDescriptionOwnerUrl) {
												newTargets.push(oldTarget);
											}
										}, this);
									}
								}
							}, this);
							ProcessAuthoringClient.updateAssociation({
								associationURL: this.oldAssociationURL,
								newTargets: newTargets,
								sourceUrl: this.oldAssociateSharedProcessDescriptionURL,
								load: dojo.hitch(this, function(data, ioArgs) {
									this.addNewSharedProcessDescription();
								}),
								error: dojo.hitch(this, function(error) {
									this.saveErrorResponse(error);
								})
							});
						}),
						error: dojo.hitch(this, function(error) {
							this.saveErrorResponse(error);
						})
					});
				}),
				error: dojo.hitch(this, function(error) { //no associate shared process description
					//put association
					this.addNewSharedProcessDescription();
				})
			});
		},
		
		addNewSharedProcessDescription: function() {
			var associatingProcessDescriptionUrl = this.associatingProcessDescriptionUrl;
			ProcessAuthoringClient.checkAssociationForProcessDescription({
				sourceUrl: associatingProcessDescriptionUrl,
				load: dojo.hitch(this, function(data, ioArgs) {
					var associationURL = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
					//put association
					this.updateAssociationForAdding(associationURL, associatingProcessDescriptionUrl);
				}),
				error: dojo.hitch(this, function(error) { //no associate shared process description
					//post association
					ProcessAuthoringClient.createAssociation({
						sourceUrl: associatingProcessDescriptionUrl,
						targetUrl: this.associateDialog.processDescriptionOwnerUrl, //$NON-NLS-1$
						targetName: this.associateDialog.processDescriptionOwnerName,
						load: dojo.hitch(this, function(data, ioArgs) {
							this.handleAssociateSuccess(associatingProcessDescriptionUrl);
						}),
						error: dojo.hitch(this, function(error) {
							this.saveErrorResponse(error);
						})
					});
				})
			});
			return;
		},
		
		updateAssociationForAdding: function(associationURL, associatingProcessDescriptionUrl) {
			ProcessAuthoringClient.getAssociation({
				url: associationURL,
				load: dojo.hitch(this, function(data, ioArgs) {
					var newTargets = [];
					var docElement = data.documentElement;
					dojo.forEach(docElement.childNodes, function(node) {
						if (node.nodeType == ProcessAuthoringConstants.NodeType.ELEMENT) {
							if (UIHelper.isSpecifiedNode(node, "targets", ProcessAuthoringConstants.NAMESPACE_JTP)) { //$NON-NLS-1$
								var targetNodes = UIHelper.getNodes(node.childNodes, "target", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
								dojo.forEach(targetNodes, function(targetNode) {
									var oldTarget = {
										title: null,
										url: null
									};
									oldTarget.title = UIHelper.getAttributeNode(targetNode, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC).value;
									oldTarget.url = UIHelper.getAttributeNode(targetNode, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
									newTargets.push(oldTarget);
								}, this);
							}
						}
					}, this);
					
					newTargets.push({
						title: this.associateDialog.processDescriptionOwnerName,
						url: this.associateDialog.processDescriptionOwnerUrl
					});
					
					ProcessAuthoringClient.updateAssociation({
						associationURL: associationURL,
						newTargets: newTargets,
						sourceUrl: associatingProcessDescriptionUrl,
						load: dojo.hitch(this, function(data, ioArgs) {
							this.handleAssociateSuccess(associatingProcessDescriptionUrl);
						}),
						error: dojo.hitch(this, function(error) {
							this.saveErrorResponse(error);
						})
					});
				}),
				error: dojo.hitch(this, function(error) {
					this.saveErrorResponse(error);
				})
			});
		},
		
		updateAssociationForDiscarding: function(associationURL, associatingProcessDescriptionUrl) {
			ProcessAuthoringClient.getAssociation({
				url: associationURL,
				load: dojo.hitch(this, function(data, ioArgs) {
					var newTargets = [];
					var docElement = data.documentElement;
					dojo.forEach(docElement.childNodes, function(node) {
						if (node.nodeType == ProcessAuthoringConstants.NodeType.ELEMENT) {
							if (UIHelper.isSpecifiedNode(node, "targets", ProcessAuthoringConstants.NAMESPACE_JTP)) { //$NON-NLS-1$
								var targetNodes = UIHelper.getNodes(node.childNodes, "target", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
								dojo.forEach(targetNodes, function(targetNode) {
									var oldTarget = {
										title: null,
										url: null
									};
									oldTarget.title = UIHelper.getAttributeNode(targetNode, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC).value;
									oldTarget.url = UIHelper.getAttributeNode(targetNode, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
									if (oldTarget.url !== this.ownerUrl) {
										newTargets.push(oldTarget);
									}
								}, this);
							}
						}
					}, this);
					
					ProcessAuthoringClient.updateAssociation({
						associationURL: associationURL,
						newTargets: newTargets,
						sourceUrl: associatingProcessDescriptionUrl,
						load: dojo.hitch(this, function(data, ioArgs) {
							this.handleUnassociateSuccess();
						}),
						error: dojo.hitch(this, function(error) {
							this.saveErrorResponse(error);
						})
					});
				}),
				error: dojo.hitch(this, function(error) {
					this.saveErrorResponse(error);
				})
			});
		},
		
		handleCancelAssociate: function() {
			if (this.isAssociateSucceeded && this.isAssociated) {
				this.isAssociateSucceeded = false;
				this.refresh();
			}
		},
		
		saveSuccessResponse: function() {
			if (this.saveCallback) {
				//call AbstractProcessAreaEditor._saveExtensionPageCallback(errorObject);
				this.saveCallback();
				this.saveCallback = null;
			}
		},
		
		saveErrorResponse: function(errorObj) {
			if (this.saveCallback) {
				//call AbstractProcessAreaEditor._saveExtensionPageCallback(errorObject);
				this.saveCallback(errorObj);
				this.saveCallback = null;
			} else {
				this.displayErrorMessage(errorObj);
			}
		},
		
		cleanContentNode: function() {
			if (this.processDescriptionEditor) {
				this.processDescriptionEditor.destroyRecursive();
				this.processDescriptionEditor = null;
			}
			this.editorContentPane.set('content', '');  //$NON-NLS-1$ //$NON-NLS-2$
			dojo.empty(this._contentNode);
		},
		
		uninitialize: function() {
			if (this.processDescriptionEditor) {
				this.processDescriptionEditor.destroyRecursive();
			}
			this.editorContentPane.set('content', '');  //$NON-NLS-1$ //$NON-NLS-2$
			this.inherited(arguments);
		}
		
	});
})();
