/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.Section"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.PlainTextField"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.RichTextField"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.InlineEditor"); //$NON-NLS-1$
	dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$
	dojo.require("jazz.ui.Menu"); //$NON-NLS-1$
	dojo.require("jazz.ui.SimpleToolbar"); //$NON-NLS-1$
	dojo.require("dojox.uuid.generateTimeBasedUuid"); //$NON-NLS-1$
	dojo.require("dojox.uuid.Uuid"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var RichTextField = com.ibm.team.process.authoring.web.common.ui.internal.editors.RichTextField;
	var PlainTextField = com.ibm.team.process.authoring.web.common.ui.internal.editors.PlainTextField;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var InlineEditor = com.ibm.team.process.authoring.web.common.ui.internal.editors.InlineEditor;
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.Section", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/Section.html"), //$NON-NLS-1$ //$NON-NLS-2$
		fields: null,
		controller: null,
		sectionData: null,
		lastField: null,
		editToolBar: null,
		editMenu: null,
		subscriptionHandles: null,
		newCreated: false,
		
		constructor: function(args) {
			this.fields = [];
			this._sectionTwistieOpenIconSrc = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/twistie-open.gif"); //$NON-NLS-1$ //$NON-NLS-2$
						
			if (!args) {
				return;
			}
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			this.inherited(arguments);
			
			this.titleArea = new InlineEditor({
				noValueIndicator: this.messages.Section_7,
				onChange: dojo.hitch(this, this._titleOnChange)
			}, this.titleArea);
			
			if (this.newCreated) {
				this.addNewRichTextField();
			}
			
			if (this.sectionData) {
				this.newCreated = UIHelper.isNewCreated(this.sectionData);
				this.titleArea.set("value", UIHelper.getSectionLabel(this.sectionData)); //$NON-NLS-1$
				this.titleArea.set('disabled', this.isViewMode || this.isViewOnly); //$NON-NLS-1$
				this.sectionID = UIHelper.getNodeId(this.sectionData);
				this.initializeFields();
			}
			
			if (!this.isViewOnly() ) {
                this.initialToolbar();
                this.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_VIEWMODE, this._previewMode); //$NON-NLS-1$
                this.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_EDITMODE, this._editMode); //$NON-NLS-1$
				this.isViewMode() ? this._previewMode() : this._editMode();
			} else {
				this._previewMode();	
			}
		},
		
		initializeFields: function() {
			dojo.forEach(UIHelper.getFields(this.sectionData), function(fieldNode) {
				var field = null;
				if (UIHelper.getFieldType(fieldNode) == ProcessAuthoringConstants.FIELDTYPE_PLAINTEXT) {
					field = new PlainTextField({
						controller: this,
						fieldData: fieldNode
					});
				} else if (UIHelper.getFieldType(fieldNode) == ProcessAuthoringConstants.FIELDTYPE_RICHTEXT) {
					field = new RichTextField({
						controller: this,
						fieldData: fieldNode
					});
				} else {
					return;
				}
				this.addField(field);
			}, this);
		},
		
		isViewMode: function() {
			return this.controller.isViewMode();
		},
		
		isViewOnly: function() {
			return this.controller.isViewOnly();
		},
		
		_onAddButtonClick: function(evt) {
			dojo.stopEvent(evt);
			this.resizeEditor();
		},
		
		resizeEditor: function() {
			this.controller.resizeEditor();
		},
		
		_onDeleteButtonClick: function(evt) {
			this.controller.removeSection(this);
			dojo.stopEvent(evt);
		},
		
		_onMoveUpButtonClick: function(evt) {
			this.controller.moveUpSection(this);
			dojo.stopEvent(evt);
		},
		_onMoveDownButtonClick: function(evt) {
			this.controller.moveDownSection(this);
			dojo.stopEvent(evt);
		},
		_onCollapseButtonClick: function(evt) {
			if (dojo.hasClass(this.contentSection, "hide")) { //$NON-NLS-1$
				this.collapseImage.src = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/twistie-open.gif"); //$NON-NLS-1$  //$NON-NLS-2$
				this.collapseArea.title = this.messages.SectionHTML_0;
			} else {
				this.collapseImage.src = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/twistie-closed.gif"); //$NON-NLS-1$  //$NON-NLS-2$
				this.collapseArea.title = this.messages.SectionHTML_1;
			}
			dojo.toggleClass(this.contentSection, "hide"); //$NON-NLS-1$
			dojo.stopEvent(evt);
			this.resizeEditor();
		},
		
		initialToolbar: function() {
			this.editToolBar = new jazz.ui.SimpleToolbar({});
			this.editBar.appendChild(this.editToolBar.domNode);
			
			this.moveUpButton = this.editToolBar.addButton(this, dojo.hitch(this, this._onMoveUpButtonClick), {
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/up-button.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				label: this.messages.Section_1
			});
			this.moveDownButton = this.editToolBar.addButton(this, dojo.hitch(this, this._onMoveDownButtonClick), {
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/down-button.gif"), //$NON-NLS-1$  //$NON-NLS-2$
				label: this.messages.Section_2
			});
			var node = this.editToolBar.addButton(this, dojo.hitch(this, this._onAddButtonClick), {
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/add-field_co.gif"), //$NON-NLS-1$  //$NON-NLS-2$
				label: this.messages.Section_3
			});
			
			this.editMenu = this.createMenu([node.domNode]);
			this.editToolBar.addButton(this, dojo.hitch(this, this._onDeleteButtonClick), {
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/delete-button.gif"), //$NON-NLS-1$  //$NON-NLS-2$
				label: this.messages.Section_4
			});
			
		},
		
		addField: function(field) {
			this.contentSection.appendChild(field.domNode);
			field.domID = dojo.attr(field.domNode, "id");  //$NON-NLS-1$
			this.fields.push(field);
			this.updateLastFieldStyle(field.domNode);
		},
		
		switchField: function(field) {
            
            if (field instanceof RichTextField) {
            	var newField = new PlainTextField({
            		controller: this,
            		fieldData: field.fieldData
            	});
				
               	//set value in the editor
				newField.newCreated = field.newCreated;
				newField.name = field.name;
				newField.fieldID = field.fieldID;
				newField.titleArea.set("value", field.titleArea.get("value")); //$NON-NLS-1$ //$NON-NLS-2$
				newField.textEditor.value = UIHelper.getPlainText(field.textEditor.getValue(false));
                //set original value
				newField.fieldValue = field.plainTextCopy ? field.plainTextCopy : UIHelper.getPlainText(field.pristineTextHTML);
				//set richtext copy, this can be used while canceling the input in richtext field 
				newField.richTextCopy = field.plainTextCopy ? null : field.pristineTextHTML;
				//set preview value
                newField._setPreviewField();
				
				// content changed
				if (newField.textEditor.value !== field.textEditor.getValue(false)) {
					newField.contentChanged = true;
				}
                newField.edit();
            } else {
                newField = new RichTextField({
                	controller: this,
                	fieldData: field.fieldData
                });
                
				newField.titleArea.set("value", field.titleArea.get("value")); //$NON-NLS-1$ //$NON-NLS-2$
				newField.newCreated = field.newCreated,
				newField.name = field.name;
				newField.fieldID = field.fieldID;
                //textEditor is instantiated in edit(). So need to run it before setting the value
                newField.edit();
               	newField.textEditor.setValue(UIHelper.getRichText(field.getFieldValue()));
                newField.pristineTextHTML = field.richTextCopy? field.richTextCopy : UIHelper.getRichText(field.fieldValue);
				newField.plainTextCopy = field.richTextCopy? null :  field.fieldValue;
                newField._setPreviewField(true);
            }
			
            var fieldNode = dojo.byId(field.domID);
            dojo.place(newField.domNode, fieldNode, "before"); //$NON-NLS-1$
			newField.domID = dojo.attr(newField.domNode, "id");  //$NON-NLS-1$
            this.fields.splice(dojo.indexOf(this.fields, field), 1, newField);
            field.destroyRecursive();
            this.updateLastFieldStyle(newField.domNode);
            this._setChange();
		},
		
		addNewRichTextField: function() {
			var id = 'ID-'+dojox.uuid.generateTimeBasedUuid(); //$NON-NLS-1$
			var field = new RichTextField({
				controller: this,
				newCreated: true,
				name: id
			});
				
			this.addField(field);
			this._setChange();
		},
		
		updateLastFieldStyle: function(fieldNode) {
			if ((this.fields.length > 0)&&(this.contentSection.lastChild == fieldNode)) {
				if (this.lastField) {
					dojo.toggleClass(this.lastField, "lastField", false); //$NON-NLS-1$
				}
				dojo.toggleClass(fieldNode, "lastField", true); //$NON-NLS-1$
				this.lastField = fieldNode;
			}
		},
		
		removeField: function(field) {
			var prev = field.domNode.previousSibling;
			this.fields.splice(dojo.indexOf(this.fields, field), 1);
			field.destroyRecursive();
			this.updateLastFieldStyle(prev);
			this._setChange();
		},
		
		_titleOnChange: function(value) {
			this._setChange();
		},
		
		moveUpField: function(field) {
			var index = dojo.indexOf(this.fields, field);
			if (index !== 0) {
				var prev = field.domNode.previousSibling;
				if (prev && dojo.attr(prev, "dojoattachpoint") === "fieldArea") { //$NON-NLS-1$ //$NON-NLS-2$
					dojo.place(field.domNode, prev, "before"); //$NON-NLS-1$
					var otherField = this.fields[index - 1];
					this.fields[index] = otherField;
					this.fields[index - 1] = field;
					this.updateLastFieldStyle(prev);
					this._setChange();
				}
			}
		},
		
		moveDownField: function(field) {
			var index = dojo.indexOf(this.fields, field);
			if (index !== (this.fields.length - 1)) {
				var next = field.domNode.nextSibling;
				if (next && dojo.attr(next, "dojoattachpoint") === "fieldArea") { //$NON-NLS-1$ //$NON-NLS-2$
					dojo.place(field.domNode, next, "after"); //$NON-NLS-1$
					var otherField = this.fields[index + 1];
					this.fields[index] = otherField;
					this.fields[index + 1] = field;
					this.updateLastFieldStyle(field.domNode);
					this._setChange();
				}
			}
		},
		
		_canHideInPreview: function () {
			if (this.fields.length == 0) {
				return true;
			}
			for (var i = 0; i < this.fields.length; i++) {
				var field = this.fields[i];
				if(!field.isEmpty()) {
					return false;
				}
			}
			return true;
		},
		
		_previewMode: function() {
			// hide this section if it has no visible field
			if (this._canHideInPreview()) {
				dojo.toggleClass(this.sectionArea, "hide", true); //$NON-NLS-1$			
			} else {
				dojo.toggleClass(this.editBar, "hide", true); //$NON-NLS-1$			
				dojo.toggleClass(this.domNode, "preview", true); //$NON-NLS-1$		
	
				// hide section title if it is empty
				if(!this.titleArea.value || dojo.string.trim(this.titleArea.value).lenth == 0) {
					dojo.toggleClass(this.headerSection, "hide", true); //$NON-NLS-1$
				}
			}
			
			this.titleArea.set('disabled', true); //$NON-NLS-1$
		},
		
		_editMode: function() {
			dojo.toggleClass(this.domNode, "preview", false); //$NON-NLS-1$
			dojo.toggleClass(this.headerSection, "hide", false); //$NON-NLS-1$			
			dojo.toggleClass(this.sectionArea, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.editBar, "hide", false); //$NON-NLS-1$
			this.titleArea.set('disabled', false); //$NON-NLS-1$
			this.resizeEditor();			
		},
		
		_onMouseOver: function(evt) {
            if (!this.isViewOnly()) {
            	if (this.getEditing()) {
            		dojo.toggleClass(this.moveUpButton.domNode, "hide", true); //$NON-NLS-1$
            		dojo.toggleClass(this.moveDownButton.domNode, "hide", true); //$NON-NLS-1$
            	} else {
            		dojo.toggleClass(this.moveUpButton.domNode, "hide", false); //$NON-NLS-1$
            		dojo.toggleClass(this.moveDownButton.domNode, "hide", false); //$NON-NLS-1$
            	}
            	
            	dojo.toggleClass(this.toobarArea, "hide", false); //$NON-NLS-1$
            }
		},
		_onMouseOut: function(evt) {
            if (!this.isViewOnly()) {
				dojo.toggleClass(this.toobarArea, "hide", true); //$NON-NLS-1$
			}
		},
		
		_setChange: function() {
			this.controller._setChange();
		},
		
		getXML: function() {
			// we don't need to generate uuid every time for the unsaved section, 
			// we can simply set a variable to remember it. 
			var rdfID, uuid;
			if(this.sectionID){
				rdfID = " rdf:ID=\"" + this.sectionID + "\" "; //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				uuid = "ID-" + dojox.uuid.generateTimeBasedUuid();  //$NON-NLS-1$
				rdfID = " rdf:ID=\"" + uuid + "\" "; //$NON-NLS-1$ //$NON-NLS-2$
				this.sectionID = uuid;
			}
			var newCreated = this.newCreated ? " newCreated=\"true\"" : ""; //$NON-NLS-1$ //$NON-NLS-2$
			var data = "<section label=\"" + UIHelper.escapeXML(this.titleArea.get("value")) + "\"" + rdfID + newCreated + ">"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
			dojo.forEach(this.fields, function(field) {
				data += field.getXML();
			});
			data += "</section>"; //$NON-NLS-1$
			return data;
		},
		
		getEditing: function() {
			var isEditing = false;
			dojo.some(this.fields, function(field) {
				if (field.getEditing()) {
					isEditing = true;
					return true;
				}
				return false;
			});
			return isEditing;
		},
		
		doCommit: function() {
			dojo.forEach(this.fields, function(field) {
				field.doCommit();
			});
		},
		
		createMenu: function(nodes) {
			var menu = new jazz.ui.Menu({
				leftClickToOpen: true,
				targetNodeIds: nodes
			});
			var menuItem1 = new dijit.MenuItem({
				label: this.messages.Section_5,
				iconClass: "plainTextFieldIcon", //$NON-NLS-1$
				onClick: dojo.hitch(this, function() {
					var id = 'ID-'+dojox.uuid.generateTimeBasedUuid(); //$NON-NLS-1$
					var field = new PlainTextField({
							controller: this,
							newCreated: true,
							name: id
					});
					
					this.addField(field);
					this._setChange();
				})
			});
			menu.addChild(menuItem1);
			var menuItem2 = new dijit.MenuItem({
				label: this.messages.Section_6,
				iconClass: "richTextFieldIcon", //$NON-NLS-1$
				onClick: dojo.hitch(this, function() {
					this.addNewRichTextField();
				})
			});
			menu.addChild(menuItem2);
			menu.startup();
			return menu;
		},
				
		uninitialize: function() {
			dojo.forEach(this.fields, function(field) {
				field.destroyRecursive();
			}, this);
			if (this.editToolBar) {
				this.editToolBar.destroyRecursive();
			}
			if (this.editMenu) {
				this.editMenu.destroyRecursive();
			}
			if (this.titleArea) {
				this.titleArea.destroyRecursive();
			}
			delete this.controller;
			this.inherited(arguments);
		}
	});
	
})();
