/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.frontingapp.ui.internal.editors.TemplateButtonHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_templates.AbstractButtonActionHandler"); //$NON-NLS-1$ 
	dojo.require("com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.frontingapp.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	dojo.require("net.jazz.ajax.contextRoot"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var PROCESS_DESCRIPTION_CREATE_ACTION = "#action=com.ibm.team.process.templateAction&actionId=com.ibm.team.process.authoring.manageTemplateDescription&itemName=${0}&ownerURL=${1}"; //$NON-NLS-1$
	var PROCESS_DESCRIPTION_EDIT_ACTION = "#action=com.ibm.team.process.templateAction&actionId=com.ibm.team.process.authoring.manageTemplateDescription&itemName=${0}&resource=${1}"; //$NON-NLS-1$
	dojo.declare("com.ibm.team.process.authoring.web.frontingapp.ui.internal.editors.TemplateButtonHandler", [com.ibm.team.process.web.ui.internal.admin.process_templates.AbstractButtonActionHandler], { //$NON-NLS-1$		
		constructor: function(args) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.frontingapp.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		// open template description editor for the specified template
		doAction: function(){
			var ownerUrl = UIHelper.getProcesTemplateUrl(this.itemId);
			ProcessAuthoringClient.getProcessDescriptionsForOwner({
            	ownerUrl: ownerUrl,
				viewType: ProcessAuthoringConstants.VIEWTYPE_REFERENCE,
            	load: dojo.hitch(this, function(data, ioArgs) {
					var descriptionsNode = UIHelper.getNode(data.childNodes, ProcessAuthoringConstants.XMLELEMENT_RDF, ProcessAuthoringConstants.NAMESPACE_RDF);
					if (descriptionsNode) {
						var allProcessDescriptionNodes = UIHelper.getNodes(descriptionsNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_PROCESSDESCRIPTION_ROOT, ProcessAuthoringConstants.NAMESPACE_JTP);
						if (allProcessDescriptionNodes && allProcessDescriptionNodes.length > 0) {
							var processDescriptionNode = allProcessDescriptionNodes[0];
							var aboutAttribute = UIHelper.getAttributeNode(processDescriptionNode, ProcessAuthoringConstants.XMLATTRIBUTE_ABOUT, ProcessAuthoringConstants.NAMESPACE_RDF);
							var resourceUrl = aboutAttribute.value;
							window.location.href = dojo.string.substitute(PROCESS_DESCRIPTION_EDIT_ACTION, [encodeURIComponent(this.itemName), resourceUrl]);
						} else {
							// No process description for template.
							window.location.href = dojo.string.substitute(PROCESS_DESCRIPTION_CREATE_ACTION, [encodeURIComponent(this.itemName), ownerUrl]);
						}
					}
				}),
            	error: dojo.hitch(this, function(error, ioArgs) {
					alert(dojo.string.substitute(this.messages.TemplateButtonHandler_0, [this.itemName, error.message]));
				})
			});
		}
	});
})();