/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.UploadAttachmentDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dojo.io.iframe"); //$NON-NLS-1$
	dojo.require("dojox.uuid"); //$NON-NLS-1$
	dojo.require("dojox.uuid.generateTimeBasedUuid"); //$NON-NLS-1$
	dojo.require("jazz.ui.Dialog");//$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	dojo.require("com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$

	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var _uploadFileInput_onchange_handle;
	var _uploadFileInput;
	var _okButton_onclick_handle;
	var _newId_onchange_handle;
	var _jsonResponse;
	var _currentRequest;
	var _WIDTH_IN_EM = 50;
	var resource;
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.UploadAttachmentDialog", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/UploadAttachmentDialog.html"),//$NON-NLS-1$ //$NON-NLS-2$ 
		widgetsInTemplate: true,
		constructor: function(args){
			if (!args) {
				args = {};
			}
			this.width = _WIDTH_IN_EM + "em"; //$NON-NLS-1$
			this.uploadId = null;
			var properties = {
				"width": this.width //$NON-NLS-1$
			};
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function(){
			this.dialog = new jazz.ui.Dialog({
				contentNode: this.contentNode,
				primaryTitle: this.messages.UploadAttachmentDialog_0,
				width: this.width,
				destroyContents: true
			});
			this._topText.innerHTML = this.messages.UploadAttachmentDialog_1;
			
			var div = this._uploadInputDiv;
			dojo.empty(div);
			var input1 = document.createElement("input"); //$NON-NLS-1$
			input1.type = "file"; //$NON-NLS-1$
			input1.name = "fileInput";//$NON-NLS-1$
			input1.size = _WIDTH_IN_EM - 5; //size is the width of the input in characters
			this._uploadFileInput = input1;
			this._uploadFileInput_onchange_handle = dojo.connect(this._uploadFileInput, "onchange", this, "_handleDirectoryChange"); //$NON-NLS-1$ //$NON-NLS-2$
			if (!dojo.isIE) {
				// setting focus here causes IE to not show the field, so don't 
				//do it 
				this._uploadFileInput.focus();
			}
			div.appendChild(input1);
			
			try {
				UIHelper.resizeI18NButtons(this.dialogFooter, [this.okButton, this.cancelButton], -1, 3);
			} catch(e) {
				//failed to resize on IE for tooltipDialog, have to catch it. This is logged in workitem 111790
			}
			
			this.connect(this.cancelButton, "onclick", function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				if (_currentRequest) {
					_currentRequest.cancel();
				}
				if (window.stop) {
					window.stop();
				}
				this.dialog.close();
			});
			this._okButton_onclick_handle = this.connect(this.okButton, "onclick", "_onOk"); //$NON-NLS-1$ //$NON-NLS-2$ 
		},
		/**
		 * enable the OK button if the file is a zip
		 * @param e is an event
		 */
		_handleDirectoryChange: function(e){
			if (e) {
				dojo.stopEvent(e);
			}
			
			this._clearStatusMessage();
			var fullPath = this._uploadFileInput.value;
			if (fullPath.length !== 0) {
				var parts = fullPath.split("\\"); //$NON-NLS-1$
				var fileName = parts[parts.length - 1];
				
				// TODO: validate file name extension
				this.okButton.disabled = false;
			}
		},
		_onOk: function(e){
			if (e) {
				dojo.stopEvent(e);
			}
			this._setStatusMessage(this.messages.UploadAttachmentDialog_4);
						
			// create unique id for this upload
			this.uploadId = dojox.uuid.generateTimeBasedUuid();
			var serviceParameter = this.serviceURL.value ? "&service=" + encodeURI(this.serviceURL.value) : ""; //$NON-NLS-1$ //$NON-NLS-2$
            // upload to file service in JTS via proxy in Practice Library, 
			// but use normal way for other cases.
			var uploadUrl;
			if (UIHelper.isPracticeLibraryApp()) {
				uploadUrl = ProcessAuthoringClient.getJtsFileServiceUrl() + "?uploadId=" + this.uploadId + "&practiceURL=" + this.practiceURL + serviceParameter; //$NON-NLS-1$ //$NON-NLS-2$
				uploadUrl = UIHelper.encodeProxiedUri(uploadUrl);
			} else {
				uploadUrl = ProcessAuthoringClient.getFileServiceUrl() +"?uploadId=" + this.uploadId + "&practiceURL=" + this.practiceURL + serviceParameter;  //$NON-NLS-1$ //$NON-NLS-2$
			}
			_currentRequest = dojo.io.iframe.send({
				form: this._uploadForm,
				handleAs: "json", //$NON-NLS-1$
				url: uploadUrl,
				load: dojo.hitch(this, function(response, ioArgs){
					this._handleLoad(response, ioArgs);
				}),
				error: dojo.hitch(this, function(response, ioArgs){
					this._handleErrorOnUpload(response, ioArgs);
				})
			});
			
			this.okButton.disabled = true;
			this.serviceURL.disabled = true;
			this._uploadFileInput.disabled = true;
		},
		
		/**
		 * Handle response when upload is finished.
		 * 
		 * @param {Object} response
		 * @param {Object} ioArgs
		 */
		_handleLoad: function(response, ioArgs){
			var status = response.status;
			var message = response.message;
			var content = response.fileInput;
			var resource = response.fileInputURI;
			var lastModified = response.fileInputLastModified;
			
			if (!resource) {
				this._displayError(message);
				return;
			}
			
			switch (status) {
				case 200:
					//success case - template overwritten
					this.onSuccess(content, resource, lastModified);
					break;
				default:
					this._displayError(message);
					break;
			}
		},
		
		/**
		 * Display the error message and enable file field and OK button.
		 * 
		 * @param {String} message
		 */
		_displayError: function(message) {
			//any other error
			this._setStatusMessage(message, true);
			this._uploadFileInput.disabled = false;
			//enable the OK button so they can fix the problem and try again
			this.okButton.disabled = false;
		},
		
		onSuccess: function(content, resource, lastModified){
			this.dialog.close();
		},
		
		_handleErrorOnUpload: function(response, ioArgs){
			if (!response.dojoType === "cancel") { //$NON-NLS-1$
				clearInterval(this.intervalId);
				this._setStatusMessage(response, true);
			}
		},
		
		_hideFileUploadSection: function(){
			this._clearStatusMessage();
			this._uploadForm.style.display = "none"; //$NON-NLS-1$
			this._progress.domNode.style.display = "none"; //$NON-NLS-1$
		},
		
		_showFileUploadSection: function(){
			this._uploadForm.style.display = "block";//$NON-NLS-1$
		},
		
		_queryError: function(err){
			this._setStatusMessage(err.message, true);
		},
		
		_clearStatusMessage: function(){
			this.status.style.visibility = "hidden";//$NON-NLS-1$
		},
		
		_setStatusMessage: function(msg, isError){
			this.status.style.visibility = "visible";//$NON-NLS-1$
			dojox.xml.parser.replaceChildren(this.status, document.createTextNode(msg));
			this.status.className = isError ? "ErrorStatus" : "NormalStatus";//$NON-NLS-1$ //$NON-NLS-2$
		},

		uninitialize: function(){
			if (this._uploadFileInput_onchange_handle) {
				dojo.disconnect(this._uploadFileInput_onchange_handle);
			}
			if (this._newId_onchange_handle) {
				dojo.disconnect(this._newId_onchange_handle);
			}
			this.inherited(arguments);
		}
	});
})();
