/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.UploadAttachmentPlugin"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dijit._editor._Plugin"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("dojo.string"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.AttachmentPickerDialog"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var AttachmentPickerDialog = com.ibm.team.process.authoring.web.common.ui.internal.editors.AttachmentPickerDialog;
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.UploadAttachmentPlugin", dijit._editor._Plugin, { //$NON-NLS-1$
		// Override _Plugin.useDefaultCommand... processing is handled by this plugin, not by dijit.Editor.
		useDefaultCommand: false,
		htmlTemplate: "<img src=\"${0}\" />", //$NON-NLS-1$
		workingCopy: null,
		
		_initButton: function() {
			// Override _Plugin._initButton() to initialize DropDownButton and TooltipDialog.
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.iconClassPrefix = "processAuthoringEditorIconUpload"; //$NON-NLS-1$
			this.inherited(arguments);
			this.connect(this.button, "onClick", "onClick"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		onClick: function() {
			var attachmentPickerDialog = new AttachmentPickerDialog({workingCopy: this.workingCopy});
			this.connect(attachmentPickerDialog, "onAdd", "onSuccess"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		onSuccess: function(resource) {
			this.editor.execCommand('inserthtml', dojo.string.substitute(this.htmlTemplate, [resource[0].url])); //$NON-NLS-1$
		},
		
		getLabel: function() {
			return this.messages.UploadAttachmentPlugin_0;
		}
	});
})();
