/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.util.ViewletLogin");

/*
 * Imports 
 */
dojo.require("dojo.i18n"); 

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "ViewletLoginMessages");


(function() {

/*
 * Aliases 
 */

	
/*
 * Constants 
 */	

/*
 * Class 
 */
dojo.declare("com.ibm.team.dashboard.web.ui.internal.util.ViewletLogin",
	[dijit._Widget, dijit._Templated], {

	// Properties //----------------------------------------------------------->

	webUIRoot: null,
	statusMessage: "",
	onLogin: null,
	
	// ------------------------------------------------------------------------>
	
	/*
	 * Templates
	 */	
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "ui/internal/templates/util/ViewletLogin.html"),
	
	/*
 	 * @param Object args
 	 * 
 	 * @return ViewletLogin
 	 */
	constructor: function(args) {
		
		// Messages //------------------------------------------------------------->
		
		this.messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "ViewletLoginMessages");
		
		this.webUIRoot = args.webUIRoot;
		this.statusMessage = args.statusMessage;
		
		if (this.webUIRoot) {
			// Log-in message
			this._viewletLoginMessage = dojo.string.substitute(this.messages.viewletLogin, [this.webUIRoot]);
			this._viewletLoginMessage2 = this.messages.viewletLogin2;
		} else {
			// Pop-up blocked message
			this._viewletLoginMessage = this.statusMessage;
			this._viewletLoginMessage2 = this.messages.tryAgain;
		}
		
	},
	
	/*
 	 * @param void
 	 * 
 	 * @return void
 	 * @overrides super
 	 */	
	postCreate: function() {
		// Call super
		this.inherited(arguments);
		
		// TODO: Where does message class come from?

		// Attach log-in handler
		if (this.onLogin) {
			this.connect(this._link, "onclick", dojo.hitch(this, function(event) {
				if (event) {
					dojo.stopEvent(event);
				}
				if (this.onLogin) {
					this.onLogin();
				}
				return true;
			}));
		}
		
	},

	/*
 	 * @param void
 	 * 
 	 * @return void
 	 * @overrides super
 	 */		
	destroy: function() {
		// Call super
		this.inherited(arguments);
	}
	
});

})();
