/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.dashboard.web.ui.internal.util.bindings");

dojo.require("jazz.ensemble.internal.util.bindings");

var bindings = jazz.ensemble.internal.util.bindings;

var NAMESPACES = {
	dc: "http://purl.org/dc/terms/",
	jdb: "http://jazz.net/xmlns/prod/jazz/dashboard/1.0/",
	jw: "http://jazz.net/xmlns/prod/jazz/widget/1.0/",
	rdf: "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
	xml: "http://www.w3.org/XML/1998/namespace"
};
var Property = {
	namespaces: NAMESPACES,
	getName: ["string", "jdb:name", "1"],
	getValue: ["string", "jdb:value", "1"],
	setName: ["string", "jdb:name", "1"],
	setValue: ["string", "jdb:value", "1"]
};
var Dashboard = {
	namespaces: NAMESPACES,
	getAbout: ["string", "@rdf:about", "1"],
	getItemId: ["string", "jdb:itemId", "1"],
	getProcessArea: ["string", "jdb:processArea", "1"],
	getProperties: [Property, "jdb:properties/jdb:Property", "*"],
	getPropertiesParseType: ["string", "jdb:properties/@rdf:parseType", "1"],
	getTitle: ["string", "dc:title", "1"],
	getType: ["string", "dc:type", "1"],
	getRelation: ["string", "dc:relation/@rdf:resource", "1"],
	getPages: [bindings.Page, "jw:pages/jw:Page", "*"],
	getSource: ["string", "dc:source", "1"],
	setProperties: [Property, "jdb:properties/jdb:Property", "*"],
	setPropertiesParseType: ["string", "jdb:properties/@rdf:parseType", "1"],
	setTitle: ["string", "dc:title", "1"]
};

com.ibm.team.dashboard.web.ui.internal.util.bindings = {
	Dashboard: Dashboard,
	Page: bindings.Page
};

})();