/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.wizard.LdapUserValidationDialog"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.form.TextBox"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.wizard", "LdapRealmMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){

dojo.declare("com.ibm.team.repository.web.ui.internal.wizard.LdapUserValidationDialog",  //$NON-NLS-1$
			 [dijit._Widget, dijit._Templated], {
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/wizard/templates/LdapUserValidationDialog.html"), //$NON-NLS-1$ //$NON-NLS-2$
	userid: "",

	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.wizard", "LdapRealmMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	onOk: function(userInfo) {},
	onCancel: function() {},

	postCreate: function() {
		this._dialog = new jazz.ui.Dialog({
			contentNode: this._dialogRoot,
			focusNode: this._userid.domNode,
			primaryTitle: this.messages.dialogTitle,
			width: "30em" //$NON-NLS-1$
		});	
		this.connect(this._okButton, "onclick", "_onOk"); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this._cancelButton, "onclick", "_onCancel"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	_onOk: function() {
		this.onOk({userid: this._userid.value});
		this._dialog.close();
	},

	_onCancel: function() {
		this.onCancel();
		this._dialog.close();
	}
});

})();
