/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.wizard.LicenseAssignmentStep");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.team.repository.web.ui.internal.wizard.LicensePicker");
dojo.require("jazz.ui.wizard.WizardStep");
dojo.require("jazz.ui.wizard.WizardStepHeader");
dojo.require("jazz.ui.MessageBox");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.wizard", "SetupUsersMessages");

(function() {
	
var WizardStep = jazz.ui.wizard.WizardStep;
var WizardStepHeader = jazz.ui.wizard.WizardStepHeader;
var messages;
var PACKAGE_PREFIX = "com.ibm.team.repository.web.ui.internal.wizard.";
var LicensePicker = com.ibm.team.repository.web.ui.internal.wizard.LicensePicker;

dojo.declare(PACKAGE_PREFIX + "LicenseAssignmentStep",  [WizardStep, dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/wizard/templates/LicenseAssignmentStep.html"),
	 
	constructor: function(args) {
		this.messages = messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.wizard", "SetupUsersMessages");
		this.stepTitle = this.messages.licenseAssignmentStepTitle;
	},
	

	postCreate: function() {
		this.header = new WizardStepHeader({stepTitle: this.stepTitle});
		this.stepHeaderArea.appendChild(this.header.domNode);
		this.picker = new LicensePicker( {
			onSuccess: dojo.hitch(this,"success"),
			onError: dojo.hitch(this,"handleError")
		});
		this.licenseSection.appendChild(this.picker.domNode);
		
	},
	
	onFinish: function() {
		this.picker.save();
	},
	
	success: function(response) {
		this.wizard.processFinish();
	},
	
	handleError: function(errorMessage, errorObject) {
		this.header.showMessage({
			type: "ERROR",
			summary: errorMessage,
			errorObject: errorObject
		});
	},	
	
	canFlipToPreviousPage: function(){
		return false;
	},
	
	canFinish: function() {
		return true;
	}

});

})();