/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.wizard.WizardIntro");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.ui.Button");
dojo.require("jazz.ui.wizard.WizardStepHeader");
dojo.require("jazz.ui.wizard.WizardStep");
dojo.require("jazz.ui.StyledBox");
dojo.require("net.jazz.ajax.contextRoot");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.wizard", "WizardIntroMessages");

(function() {
var messages;
var WizardStepHeader = jazz.ui.wizard.WizardStepHeader;
var WizardStep = jazz.ui.wizard.WizardStep;
var TrimStyles = jazz.ui.StyledBox.TrimStyles;

dojo.declare("com.ibm.team.repository.web.ui.internal.wizard.WizardIntro", [WizardStep, dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/wizard/templates/Intro.html"),
	widgetsInTemplate: true,
	innerBoxTrim:  TrimStyles.EDITOR,
	
	constructor: function() {
		this.messages = messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.wizard", "WizardIntroMessages");
		this.stepTitle = messages.stepTitle;
	},

	postCreate: function() {
		var header =  new WizardStepHeader({stepTitle: this.stepTitle});
		this.stepHeaderArea.appendChild(header.domNode);
		this.graphic.src = dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/wizard/images/intro-diagram.png");
	},
	
	focusStep: function() {
		//See if the user was redirected here from the JTS landing page. If so, enable the "Back" link.
		if(document.referrer) {
			var ref = document.referrer;
			if(ref.indexOf(net.jazz.ajax.contextRoot() + "/setup") != -1) {
				this.backButtonURL = document.referrer;
				setTimeout(dojo.hitch(this,function() {
					this.wizard.wizardPreviousButton.disabled = false;	
				}), 100);
			}
		}
	},
	
	onPrevious: function() {
		if(this.backButtonURL) {
			location.href = this.backButtonURL;
		}
	}

});

})();