/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	//template
	
	'wizardPageHeading': "Configure Data Warehouse",
	'wizardPageDescriptionJTS': "The data warehouse is a database used for reporting and analytics. By default, this is a pre-configured database using a JDBC connection. You can either keep this default or choose a different database vendor and/or connection type. If you change the default, you may need to configure some additional properties. Also if you change the default, use the \"Test Connection\" button to verify that the server can successfully communicate with the database using the connection information you provided. Rational Reporting for Development Intelligence (RRDI) does not support Derby; if you plan on using RRDI for reporting, please select an enterprise database vendor.",  
	'wizardPageDescriptionFronting': "The data warehouse is a database used for reporting and analytics. By default, this value is supplied by the Jazz Team Server, and should not be changed for this application. If you change the default, you may need to configure some additional properties. Also if you change the default, use the \"Test Connection\" button to verify that the server can successfully communicate with the database using the connection information you provided.",
	'pleaseNote': "Please Note:",
	'restrictedOptions': "The database vendor options have been restricted based on the installed server license.",  
	'confirmNoWarehouseLabel': "I do not wish to configure the data warehouse at this time.",
	'noWarehouseMessage': "You may proceed with the setup, but reporting functionality may not work until a data warehouse is configured.",
	'step1Label': "Step 1:",
	'step1Title': "Configure Data Warehouse Database Vendor and Connection Type",	
	'vendorLabel': "Database Vendor:",
	'connectionTypeLabel': "Connection Type:",
	'j2eeLabel': "J2EE",
	'jdbcLabel': "JDBC",
	'step2Label': "Step 2:",
	'step2Title': "Configure Data Warehouse Database Connection Properties",
	'restoreLabel': "Restore to Saved",
	'testConnectionLabel': "Test Connection",
	'step3Label': "Step 3:",
	'step3Title': "Create Database Tables",	
	'createTablesButton': "Create Tables",
	
	'DBneedsTables': "CRJAZ1744E The database exists, but is not configured to contain the data warehouse. Use the \"Create Tables\" button in Step 3 to configure the data warehouse for Jazz.",
	'createTablesIntro': "The specified database exists but there are no data warehouse tables present. Please click the \"Create Tables\" button below to create the required tables. Table creation may take a few minutes.",
	'settingsSaved': "Data warehouse settings saved.",
	'creationSuccess': "Data warehouse tables created successfully. Click Next to continue.",
	'creationFail': "CRJAZ1745E An error occurred while creating data warehouse tables. Please try again.",
	'creationProgress': "Data warehouse tables are being created. This may take a few minutes...",
	'tablesExist': "The data warehouse tables already exist.",
	
	'createEtlUserDescriptionJts': "Please use the form below to specify the user information for running the data collection jobs. If the user does not exist in the Jazz Repository it will be created and have the appropriate Client Access License applied. If you are using an LDAP or external user registry this will only create the contributor in the Repository, it will need to match a user defined in your registry.",
	'createEtlUserDescriptionNotJts': "Please use the form below to specify the user information for running the data collection jobs.",
	'createEtlUserLeftBlank': "If left blank, the data collection jobs will use an automatically created OAuth Consumer named 'Jazz Reporting' with a Functional User ID of 'etl_user'.",
	
	'propertyLabel': "Property",
	'valueLabel': "Value",
	'descriptionLabel': "Desription",
	
	'emailLabel': "E-mail Address", 
	'emailDescrption': "Your e-mail address (e.g. 'etl_user@example.com')",
	'userIdLabel': "User ID", 
	'userIdDescrption': "The user ID (e.g. 'etl_user')",
	'passwordLabel': "Password", 
	'passwordDescrption': "Enter a password that you can remember but won't be easy for others to guess.",
	'passwordDescriptionNotJts': "The password you created for the data collection jobs user during JTS setup.",
	'passwordLabel2': "Re-type Password", 
	'passwordDescrption2': "Re-type your password to help prevent typos.",
	'passwordMismatch': "Passwords don't match",
	'clickNext': "  Click 'Next' to continue.",
	
	'completEtlUserForm': "Complete the data collection job user form and press next to continue.",
	'etlUserFormInvalid': "Some property values are invalid. Please correct flagged properties to continue.",
	'etlUserName': "Data Collection User",
	'getSnapshotsError' : "There was an error fetching the data collection job information, data collection job users will not be updated.",
	'updatesStillApplied' : "The Data Collection User update was still applied",
	'updatesNotApplied' : "The Data Collection User update was not applied, please apply the changes manually",
	
	'jdbcLocExample': "Example: ${0}",
		
	// widget

	'reviewAdminLink': "Review the ${0}License Key Management${1} page of the Admin UI for more information.",
	
	'loading': "Loading Database Connection settings...",  
	'testing': "Testing the connection to the database...",  
	'pendingOk': "The configuration has pending changes.  Please test the connection to continue.",  
	'pendingErr': "Some property values are invalid.  Please correct flagged properties to continue.", 
	'pendingWarn': "Please verify properties flagged with warnings.  Test the connection to continue.", 
	'connectedOk': "Database connection is established.  Click Next to continue.",
	'connectedErr': "CRJAZ1568E Database connection could not be established.  Resolve errors to continue.", 
	'connectedWarn': "CRJAZ1569W Database connection was attempted with warnings.  Resolve warnings to continue.", 
	'saveErr': "CRJAZ1572E An error occurred while saving the configuration properties.",
	
	'connectionError': "CRJAZ1570E Error fetching connection status.",
	'applicationOk' : "Data Collection user entered. Press next to continue.",
	'applicationTest' : "Test the connection to continue.",
	'etlUserSameAsAuthenticatedUser' : "The Data Warehouse Collection user cannot be the current user."
})	



