/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	//template
	
	'wizardPageHeading': "Configure Public URI",
	'wizardPageDescription1': "The Public URI is the root URL prefix for the URLs of all stored artifacts.  This Jazz Team Server generates absolute URLs to resources used in stored artifacts, references between related artifacts, in mail notifications, feeds, for copying to the system clipboard, for Web access and for stable resource identification across all applications.",	
	'wizardPageDescription2': "These generated URIs generally must be navigable from any network location from which a user or another application will be accessing the system. Once data is created and stored, these URLs will become persistent within the server. In a limited set of scenarios, the server URL can be changed later via administrative Server Rename commands which preserve internal consistency, but this is a potentially disruptive action given it may be difficult or impossible to correct the stored links into the server from all other applications and systems. Therefore it is important that you choose a public URI that is fully qualified, and likely to remain stable over time. For additional help, please see the ${0}Planning your URIs${1} topic, contact IBM Support, or get help at the Jazz.net community site.",		
	'wizardPageDescription4': "Configure this value in the following format: \"https://<public_hostname><:port>/<context>\"",
	
	'exampleURI': "Example: https://host.my.company.net:9443${0}",
	'publicURI': "Public URI",
	'step1Label': "Step 1:",
	'step1Title': "Configure Public URI",
	'step2Label': "Step 2:",
	'step2Title': "Confirm Public URI", 
	'confirmLabel': "I understand that once the Public URI is set, it cannot be modified except with additional administrative commands and in a limited set of scenarios, which can result in broken links from other applications that do not support changing URLs.",
	'step2warningText': "The Public URI (which includes the fully qualified hostname) <strong>must be chosen carefully</strong> because once it is set, it becomes integral to the data on the server and any data on any other server or application that references it. This is particularly important when configuring a production server. Please review the information on this page and refer to the ${0}Planning your URIs${1} topic for guidance and recommendations on configuring the Public URI.",
	'warningLabel': "WARNING",
	'restoreLabel': "Restore to Saved",
	'testConnectionLabel': "Test Connection",
	'enterURL': "Please enter a Public URI and click \"Next\" to continue.",
	'prefillInvalid': "A default Public URI has been computed automatically based on the URL used to access this wizard.",
	'alreadySet': "The Public URI root has already been set for this server. Click \"Next\" to continue.",
	'okNeedsAgreement': "The configuration test succeeded. You must confirm the Public URI by clicking the checkbox in \"Step 2\".",
	'uriComputedAutomatically': "A default Public URI has been computed automatically based on the URL used to access this wizard. You may need to change this URI if it does not satisfy the requirements described on this page or if you will be accessing the server via a different hostname.",
	'urlCannotBeEmpty': "CRJAZ1786E The Public URI property cannot be empty. Please use the description below to set the correct Public URI for your environment.",
	'appNotRegistered': "This application needs to be registered with a Jazz Team Server to function correctly. To proceed, use the Setup Wizard located on the Jazz Team Server (For example: https://servername.domain.com:9443/jts/setup).",
	'warnChangePublicURI': "CRJAZ1975W You are attempting to change your Public URI. This is <strong>not</strong> recommended. There may be resources stored in the repository and/or other applications which reference the existing Public URI: ${0}. If you change this URI, you may not be able to access these resources."

})	
