/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	'stepTitle': "Register Applications",
	'description': "Use this step to register installed applications with the Jazz Team Server. For simple installations with all applications on the same host, you can accept the defaults and continue.",
	'step1Label': "Step 1:",
	'step1Title': "Verify and Update Discovered Applications",
	'step2Label': "Step 2:",
	'step2Title': "Register Applications",
	'scanComplete': "Scan Complete",
	
	'titleLabel': "Application Instance",
	'typeLabel': "Application Type",
	'srcUriLabel': "Discovery URL",
	'actionsLabel': "Actions",
	'version': "Version",
	'preAuthUserLabel' : "Functional User ID",
	'removeApplication': "Do not register this application.",
	'confirmApplicationDelete': "Are you sure you want to remove this application?",
	'appsDetectedOK': "Applications detected OK. Please review the applications listed below.",
	'appsDetectedError': "CRJAZ1725E An error occurred while scanning the server for installed Applications.",
	'appNameEmpty': "Name cannot be empty.",
	'appUrlEmpty': "Discovery URL cannot be empty.",
	'errorFunctionalAdminNotAllowed': "ADMIN is not allowed to be a functional user.",
	'appsRegisteredOkay': "Applications were successfully registered with this Jazz Team Server. Click Next to continue.",
	'appsRegisteredError': "CRJAZ1726E An error occurred while attempting to register the applications.",
	'getAppsFailed': "CRJAZ1753E An error occurred while attempting to get a list of registered applications.",
	'pendingDetectingApplications': "Please wait while the applications are detected and contacted. This will take a few minutes.",
	'pendingRegistration': "Please wait while the applications are registered. This may take a few minutes.",
	'regComplete': "Registration Complete",
	'regFailed': "Registration Failed. See error message at the top of this page.",
	'noAppsDetected': "No new applications detected. There does not appear to be any unregistered applications in this Jazz Team Server.",
	'newStepsAdded': "Additional step contributions from the newly registered applications have been added to the end of this wizard. Click Next to continue.",
	
	'nameDesc': "Application Name",
	'userDesc': "Create new user or ",
	'urlDesc': "Discovery URL",
	'browse': "Browse",
	'unknown': "Unknown",
	
	'help_appInstance' : "The Application Instance name will appear in the user interface. The name should be unique on this Jazz Team Server and meaningful within your organization.",
	'help_appType' : "This is the type of application that was detected. You may hover over the type to view the application's description.",
	'help_discoveryURI' : "The Discovery URL refers to the Service Contribution Resource (or SCR) of the application.",
	'help_functionalId' : "Associating a functional user ID allows applications to make requests within background activities, such as sending e-mail notifications, without user intervention. For applications added manually, you may enter a new or existing user ID.",
	'loading': "Loading...",
	'locatingSCR': "Please wait while we verify the Discovery URL for this application. If the application was just started for the first time, this could take a few minutes.",
	'addApplication': "Add Application...",
	'removeApp': "Remove Application",
	'skipRegistration': "Click \"Next\" to skip Application Registration and continue on with the wizard.",
	'detectInstructions': "In this first section, the Jazz Team Server will scan its installation directory to discover other Jazz-based applications that may be installed. Once it has completed, you will have the option to modify the detected applications as well as manually add new applications. To begin, click the \"Scan for Installed Applications\" button. If you do not wish to register any applications at this time, you may check the box below to skip this step. You will be able to register applications later if you change your mind.",
	'registerButton': "Register Applications",
	'registerInstructions': "Once you have verified the applications and their URLs in the previous step, you should register the applications with this Jazz Team Server. As part of the registration process, the server will attempt to contact each application and send configuration data to it. This operation may take a few minutes to complete.",
	'verifyInstructions' : "The following applications were detected on the local file system. The Application Instance name will appear in the user interface. A name proposal was generated based on the context root of the application. You can edit the proposal. The name should be unique on this Jazz Team Server and meaningful within your organization. The Discovery URL has been defaulted based on the public URI of this server and the context root of the application. A default functional user ID has been computed for each application. Associating a functional user ID allows applications to make requests within background activities, such as sending e-mail notifications, without user intervention. You can manually add a new application (for example, an application installed on a remote server), or choose not to register an application by clicking the \"X\" icon.",
	'noteLPARequired' : "NOTE: The Lifecycle Project Administration (ADMIN) Application  is required by the Jazz Team Server and must be registered.",
	'errorFetchingDiscovery': "CRJAZ2081E An error occurred while attempting to access the Discovery URL for the application. Please ensure that the application has been installed and provisioned correctly.",
	'errorFetchingAbout': "CRJAZ2080E An error occurred while attempting to access the Application About service listed in the Discovery document for this application. Please ensure that the application has been installed and provisioned correctly.",
	'virtualHostWarning': "If you have configured a virtual host for an application, the virtual hostname must be used in the URL for the application."
})	
