/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	'stepTitle': "Friends", 
	'description': "Use this page to manage friends of this Jazz Team Server. A friend is an application (such as the ones listed on the \"Registered Applications\" page) or another Jazz Team Server to which this Jazz Team Server and its registered applications are allowed to make outbound requests, in order to consume the services provided by the friend.  A consumer key and secret are used for secure communications between the friends. Applications registered with this Jazz Team Server do not need to be configured as friends.",
	'description_app': "Use this page to manage friends of this application. A friend is an application or a Jazz Team Server to which this application is allowed make outbound requests, in order to consume the services provided by the friend.  A consumer key and secret are used for secure communications between the friends.",
	
	'step1Title': "Request Server-to-Server Communication",
	'step1Description': ".  Then you can request a provisional consumer key from that server and store this information in your server's friend list.",

	'step2Title': "Authorize Provisional Key",
	'step2Description': "Once you request a provisional key, this section will display the stored key.",
	
	'requestError': "CRJAZ1577E There was an error connecting to ${0}.  Verify the URL is valid and the server is running.",
	
	'provisionalKey': "Provisional Key: ",
	'keyNeedsAuthorization': "The provisional key you requested needs to be authorized by an administrator on the other server.",
	'authorizationLink': "If you are an administrator on the \"${0}\" server, you can ",
	'grantAccessLink': "Grant access for the provisional key.",
	'keyAuthorized': "The provisional key is authorized and stored in the friends list.  The server will now be able to communicate with ${0}.", 
	'createFriend': "Create Friend",
	'registerButtonText': "Request Access", 
	'propertyLabel': "Property",
	'valueLabel': "Value",
	'descriptionLabel': "Description",
	
	'titleLabel': "Name", 
	'titleDescrption': "Enter a name to identify this entry in the friends list",
	'rootServicesLabel': "Root Services URI", 
	'rootServicesDescription': "The URI for root services on the server you want to add as a friend.",
	'rootServicesFormat': "Format:",
	'serverUriLabel': "Jazz Team Server URI", 
	'serverUriDescrption': "This is the server you want to add as a friend and establish server-to-server communication.  (e.g. 'https://otherJazzServer:9443/jazz/rootservices')",
	'secretLabel': "OAuth Secret", 
	'secretDescrption': "Enter a code phrase to be associated with the new OAuth consumer key from the friend server.",
	'secretLabel2': "Re-type Secret", 
	'secretDescrption2': "Re-type your code phrase to help prevent typos.",
	'secretMismatch': "Secrets don't match",
	'trustedLabel': "Trusted", 
	'trustedDescription': "Trusted consumers will be able to share authorization with other trusted consumers and users will not be prompted for approval to access data.  It is recommended that external web sites or products are considered as untrusted.",

	'correctFields': "Please correct the fields below.",
	'completeFields': "Configure communication to another Jazz Team Server or select Next to continue.", 
	'someFieldsEmpty': "You must fill out all fields. Please try again.",
		
	'postFriendError': "CRJAZ1576E An error occurred while saving a friend to this server.",
	'testFriendError': "CRJAZ1665E An error occurred while trying to access the Rootservices URL that was provided. Please check the URL and try again.",
	'fetchFriendsError': "CRJAZ1574E An error occurred while requesting the friends list on this server.",
	'fetchRootServicesError': "CRJAZ1575E An error occurred while requesting the root services document from server \"${0}\". Please check the URL and try again. ",
	'postNewApplicationError': "CRJAZ1664E An error occurred while attempting to add the new application to the server.",
	'requestKeyError': "CRJAZ1578E An error occurred while requesting an OAuth consumer key from server \"${0}\".", 
	'deleteFriendError': "CRJAZ1573E An error occurred while deleting the friend entry: ${0}",
	'friendsTableHeading': "Friends List", 
	
	'friendsTableDescription_jts': "Use \"Add...\" to add a friend. You will need its location information (Root Services URI) and a code phrase that you wish to use as the authentication secret. Then, request access to the friend. The friend will generate a provisional OAuth consumer key that is stored in the friend entry. Provisional consumer keys need to be authorized by an administrator of the friend application. Once the OAuth consumer key is authorized, this Jazz Team Server and its registered applications will be allowed to send outbound requests to the friend. Because almost all collaboration between friends is bi-directional, when you manually add friend A to a consumer B, you need to also add a friend B to consumer A.",
	'friendsTableDescription_app': "Use \"Add...\" to add a friend. You will need its location information (Root Services URI) and a code phrase that you wish to use as the authentication secret. Then, request access to the friend. The friend will generate a provisional OAuth consumer key that is stored in the friend entry. Provisional consumer keys need to be authorized by an administrator of the friend application. Once the OAuth consumer key is authorized, this application will be allowed to send outbound requests to the friend. Because almost all collaboration between friends is bi-directional, when you manually add friend A to a consumer B, you need to also add a friend B to consumer A.",

	'noFriends': "There are no entries in the server friends list.",
	
	'oAuthDomainLabel': "OAuth Domain",
	'oAuthConsumerKeyLabel': "OAuth Consumer Key", 
	'removeFriendButton': "Remove Friend",
	'confirmDelete': "Are you sure you want to delete this friend entry?", 
	'confirmApplicationDelete': "This will unregister the selected application from this Jazz Team Server. This should only be done to retry a failed setup, or if you wish to permanently remove an existing application. Data previously stored by the application in this Jazz Team Server (e.g. Dashboard resources) will no longer be reachable. Are you sure you want to remove this application and its associated data?",
	'requestingAccess': "Requesting Access...",
	
	// edit friend wizard 
	'editFriend': "Edit Friend",
	'editFriendHeading': "Edit Friend Properties",
	'editFriendDialogTitle': "Edit Friend Properties",
	'confirmEditCancel': "Are you sure you want to exit this editor? Any changes made will be lost. Click Cancel to continue working or OK to exit.",
	
	//edit application wizard
	'editApplicationHeading': "Edit Application Properties",
	'editApplicationDialogTitle': "Edit Application Properties",
	
	'internalLabel': "Internal", 
	'internalNo': "Public",
	
	//registered apps
	'pageTitle': "Registered Applications",
	'internalFriendsTableHeading': "Registered Applications", 
	'registeredAppsDescription': "Use this page to view registered applications or to register new applications. Applications that support automatic configuration should be registered using the Jazz Team Server setup wizard. This is the list of applications registered with the Jazz Team Server. These applications can provide services and can consume services provided by this Jazz Team Server and other registered applications. The Name will appear in user interfaces. It should be unique on this Jazz Team Server and meaningful within your organization. The Discovery URL refers to the discovery service of the application.",
	'internalFriendsTableDescription': "Select \"Add...\" to register a new application with this Jazz Team Server. You will be asked to provide the Name and Discovery URL (if applicable) as well as a code phrase used as a consumer \"secret\". You may also select a pre-authorized functional user ID with the application. This allows applications to make requests within background activities, such as sending e-mail notifications, without user intervention. When registering multiple instances of applications of the same type, the same functional user ID should be used for all instances. Associating a pre-authorized functional user will give the application JazzAdmins permissions on this Jazz Team Server, and should only be allowed for applications you trust.  The Jazz Team Server will automatically generate a consumer key for the application, which can be copied and pasted into the application's configuration (for applications that require manual configuration).",
	'manageLink': "Manage this Application",
	'settings': "Settings",
	'installed': "Installed",
	'applicationID': "Application ID",
	'appTypeLabel': "Application Type",
	'consumerKeyLabel': "Consumer Key", 
	'consumerSecret': "Consumer Secret",
	'preAuthorizedUser': "Functional User ID", 
	'selectUserLinkLabel': "Select User...",
	'browseUserLinkLabel': "Browse...",
	'clearUserLinkLabel': "Clear User...",
	'errorFunctionalAdminNotAllowed': "ADMIN is not allowed to be a functional user.  Please choose a different functional user id.",
	'editApplication': "Edit Application",
	'removeApplication': "Remove Application",
	'addFriendLink': "Add...",
	'addApplicationLink': "Add...",
	'statusLabel': "Status",
	'nameLabel': "Name",
	'versionsLabel': "Version",
	'srcUriLabel': "Discovery URL",
	'applicationNameLabel': "Application Name",
	'addApplicationStepHeader': "Add Application",
	'addFriendStepHeader': "Add Friend",
	'actionsLabel': "Actions",
	'manageLabel': "Manage",
	'unknown': "Unknown",
	'loadingApplications': "Loading Applications...",
	'noAppsYet': "Currently, are no installed applications in this application group. Click ${0} to install a new application.",
	'noFriendsYet': "Currently, this server does not have any friends. Click ${0} to connect to a new friend.",
	'storedProvisionKeyOK': "The Friend has been added and a provisional key has been generated. Please click Next to continue.",
	'registrationComplete': "The application was registered successfully. Note: Some applications require additional configuration before they are ready to use. Please consult the documentation to see if this application requires additional configuration.",
	'registrationCompleteWithSetup': "The application was registered successfully. This application requires additional setup before it is ready to use. Please proceed to the ${0}Application Setup Wizard${1} to finish registration.",
	'savingUpdates': "Saving updates...",
	'errorUpdating': "CRJAZ2083E An error occurred while updating the application.",
	'registeringApplication': "Please wait while the new application is being registered. This may take a few minutes.",
	'errorFetchingAbout': "CRJAZ2082E An error occurred while attempting to access the Application About service listed in the Discovery document for this application. Please ensure that the application has been installed and provisioned correctly.",
	'loadingAbout': "Please wait while we retrieve additional information about this application...",
	
	// Help hover text
	'help_consumerSecret': "A \"secret\" or password used by the Application to establish ownership of the Consumer Key that will be generated for this Application.",
	'help_functionalId': "Associating a functional user ID allows applications to make requests within background activities, such as sending e-mail notifications, without user intervention. You may enter a new or existing user ID, or \"Browse\" the existing users."

})
